#include	<windows.h>
#include	"common.h"
#include	"np2.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"bios.h"
#include	"nevent.h"
#include	"pc_core.h"
#include	"sysport.h"
#include	"dosio.h"
#include	"itfrom.h"
#include	"fdd_mtr.h"
#include	"lio.h"
#include	"fdfmt.h"
#include	"trace.h"

static	BOOL	biosrom = FALSE;
static	BOOL	soundrom = FALSE;

static	BYTE	neccheck[] = "Copyright (C) 1983 by NEC Corporation";

						// 00/05/18 MS-DOS6.2 on PC-9801VX calling proc
static	BYTE	printmain[] = {0x5a, 0x1f, 0xb4, 0x00, 0xcf};

static	BYTE	nosyscode[] = {
			0xeb,0x05,0xbe,0x6f,0x00,0xeb,0x03,0xbe,0x47,0x00,0xb8,0x00,
			0x10,0xbb,0x00,0x80,0x8e,0xd0,0x8b,0xe3,0x8c,0xc8,0x8e,0xd8,
			0xb8,0x00,0xa0,0x8e,0xc0,0xb9,0x00,0x10,0xb8,0x20,0x00,0x33,
			0xff,0xfc,0xf3,0xab,0xb0,0xe1,0xb9,0xe0,0x1f,0xaa,0x47,0xe2,
			0xfc,0x2e,0xad,0x8b,0xf8,0x2e,0xad,0x85,0xc0,0x74,0x0a,0xab,
			0x0a,0xe4,0x74,0xf5,0x83,0xc7,0x02,0xeb,0xf0,0xeb,0xfe,0xac,
			0x07,0x05,0x37,0x05,0x39,0x05,0x46,0x05,0x60,0x05,0x47,0x05,
			0x23,0x05,0x39,0x05,0x2f,0x04,0x72,0x05,0x3b,0x05,0x43,0x05,
			0x48,0x04,0x37,0x04,0x46,0x04,0x2f,0x04,0x40,0x04,0x35,0x04,
			0x24,0x00,0x00,0xae,0x07,0x42,0x00,0x41,0x00,0x53,0x00,0x49,
			0x00,0x43,0x00,0x04,0x4e,0x15,0x2f,0x26,0x30,0x04,0x4b,0x04,
			0x4f,0x20,0x00,0x42,0x00,0x49,0x00,0x4f,0x00,0x53,0x00,0x2e,
			0x00,0x52,0x00,0x4f,0x00,0x4d,0x00,0x04,0x2c,0x29,0x2c,0x2d,
			0x57,0x04,0x47,0x04,0x39,0x00,0x00};

#ifdef __cplusplus
extern "C" {
#endif
	BYTE	itf_bank = 0;
#ifdef __cplusplus
}
#endif

	NP2_SYST	np2sys;

void bios_init(void) {

	int		i;
	FILEH	fh;

	biosrom = FALSE;
	soundrom = FALSE;

	// ܂DISK BASIC悤ɂȂ邩炢񂶂ȂłH
	// BASIC BIOS 8086R[ĥ悤Ɍ邯ǁc
	fh = file_open_c("bios.rom");
	if (fh != (FILEH)-1) {
		if (file_lread(fh, &mem[0x0e8000], 0x18000) == 0x18000) {
			biosrom = TRUE;
		}
		file_close(fh);
	}
	if (!biosrom) {
		CopyMemory(&mem[0x0e8000], nosyscode, sizeof(nosyscode));
	}

	//  Ultima IVŃTEh
	fh = file_open_c("sound.rom");
	if (fh != (FILEH)-1) {
		if (file_read(fh, &mem[0x0cc000], 0x4000) == 0x4000) {
			soundrom = TRUE;
		}
		file_close(fh);
	}
	if (!soundrom) {
		mem[0xcee00] = 1;
		mem[0xcee04] = 0xd2;
		*(WORD *)(&mem[0xcee06]) = 0x0008;
		mem[0xcee08] = 0xcb;
	}

	itf_bank = 0;
	for (i=0; i<0x100; i++) {
		*(WORD *)(&mem[i*4+0]) = 0x003e;
		*(WORD *)(&mem[i*4+2]) = 0xfd00;
	}
	for (i=0; i<0x20; i++) {
		*(WORD *)(&mem[i*4+0]) = i << 1;
		*(WORD *)(&mem[0xfd000+i*2]) = 0xcf90;
	}
	*(WORD *)(&mem[0xfd040]) = 0xcf90;
	*(DWORD *)(&mem[0x1e*4]) = 0xe8000000;

	if (!biosrom) {
		lio_init();
	}

	*(WORD *)(&mem[0xfd800]) = 0xcb90;
	*(WORD *)(&mem[0xfd802]) = 0xcb90;

	for (i=0; i<4; i++) {
		*(WORD *)(&mem[0xfd800 + 0x1aaf + i*2]) = 0x1ab7;
		*(WORD *)(&mem[0xfd800 + 0x1ad7 + i*2]) = 0x1adf;
	}
	CopyMemory(&mem[0xfd800 + 0x1ab7], fdfmt2hd, sizeof(fdfmt2hd));
	CopyMemory(&mem[0xfd800 + 0x1adf], fdfmt2dd, sizeof(fdfmt2dd));

	*(WORD *)(&mem[0xfffe8]) = 0xcb90;
	*(WORD *)(&mem[0xfffec]) = 0xcb90;
	mem[0xffff0] = 0xea;
	*(DWORD *)(&mem[0xffff1]) = 0xfd800000;

#if 1
	CopyMemory(&mem[0x2f8000], itfrom, sizeof(itfrom));
#else
	{
		FILEH	fh;
		fh = file_open_c("itf.bin");
		if (fh != (FILEH)-1) {
			file_read(fh, &mem[0x2f8000], 0x8000);
			file_close(fh);
		}
	}
#endif
	mem[0x2ffff0] = 0xea;
	*(DWORD *)(&mem[0x2ffff1]) = 0xf8000000;

	if (!biosrom) {
		memcpy(&mem[0xe8dd8], neccheck, 0x25);
		memcpy(&mem[0xf538e], itfrom + (*(WORD *)&itfrom[2]), 0x27);
	}

	memcpy(&mem[0xfd04d], printmain, sizeof(printmain));

	MEM_CRT_STS_FLAG = 0x84;
	MEM_EXPMMSZ = 0x08;
	MEM_BIOS_FLAG0 = 0x03;					// 00/05/17 beep tone
	MEM_BIOS_FLAG &= 0x80;
	MEM_BIOS_FLAG |= 0x24;
	MEM_PRXCRT = 0xcf ^ (np2cfg.dipsw[0] >> 7);
 	mem[0x00055c] = 0x03;
	MEM_F2DD_POINTER = 0xfd801ad7;
	MEM_F2HD_POINTER = 0xfd801aaf;

	CopyMemory(&mem[0x0fde00], keytable[0], 0x300);
	bios0x09_init();

	ZeroMemory(&np2sys, sizeof(np2sys));
}

static void bios_reset(void) {

	if (systemport.c & 0x80) {
		if (!(systemport.c & 0x20)) {
												// 00/07/02 dip_sw renewal
			MEM_PRXCRT = 0xcf ^ (np2cfg.dipsw[0] >> 7);
			CPUTYPE = 0;
			MEM_BIOS_FLAG &= ~0x47;
			MEM_BIOS_FLAG |= mem[0xa3fea] & 7;
			if (np2cfg.dipsw[2] & 0x80) {
				CPUTYPE = CPUTYPE_V30;
				MEM_BIOS_FLAG |= 0x40;
			}
		}
		I286_CS = 0x0000;
		I286_IP = 0x04f8;
		I286_DS = 0x0000;
		I286_DX = 0x43d;
		I286_AL = 0x10;
		mem[0x004f8] = 0xee;		// out	dx, al
		mem[0x004f9] = 0xea;		// call	far
		*(DWORD *)(&mem[0x004fa]) = 0xffff0000;
	}
	else {
		I286_SP = *(WORD *)(&mem[0x00404]);
		I286_SS = *(WORD *)(&mem[0x00406]);
	}
}


WORD __fastcall biosfunc(DWORD adrs) {

	if ((itf_bank) && (adrs >= 0xf8000) && (adrs < 0x100000)) {
		I286_IP--;
		nevent.remainclock = -1;
		return(1);
	}
	if ((adrs >= 0xfd000) && (adrs < 0x0fd042)) {
		if (adrs & 1) {
			return(0);
		}
		nevent.remainclock -= 300;
		switch((adrs - 0xfd000) >> 1) {
			case 0x08:
				bios0x08();
				break;

			case 0x09:
				bios0x09();
				break;

			case 0x13:
				bios0x13(0x90);
				break;

			case 0x0a:
			case 0x0b:
			case 0x0c:
			case 0x0d:
			case 0x0e:
			case 0x0f:
				pic_w(0, 0x20);
				break;

			case 0x10:
			case 0x11:
			case 0x12:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
				pic_w(8, 0x20);
				if (!pic[1].isr) {
					pic_w(0, 0x20);
				}
				break;

			case 0x18:
				bios0x18();
				break;

			case 0x1b:
				bios0x1b();
				break;

			case 0x1c:
				bios0x1c();
				break;

			case 0x20:
				if (mtr_curevent) {
					I286_IP--;
					nevent.remainclock = -1;
					I286_IFLAG = I_FLAG;
					pic_irq();
				}
				break;
		}
		return(1);
	}
	if ((adrs >= 0xf9a00) && (adrs < 0x0f9a24)) {
		if (!(adrs & 1)) {
			bios_lio((BYTE)((adrs - 0xf9a00) >> 1));
		}
		return(0);
	}

	// Zbg
	if (adrs == 0xfd800) {
		bios_reset();
		return(1);
	}
	// u[gXgbv
	if (adrs == 0xfd802) {
		if (!bootstrapload()) {
			I286_CS = 0x1fc0;
		}
		else {
			I286_CS = 0xe800;
		}
		I286_IP = 0x0000;
		return(1);
	}
	// u[gXgbv[h
	if ((adrs == 0xfffe8) || (adrs == 0xfffec)) {
		nevent.remainclock -= 2000;
		bootstrapload();
		return(0);
	}
	if (biosrom) {
		return(0);
	}
	I286_IP--;
	nevent.remainclock = -1;
	return(1);
}


I286_OUT itf_ctrl(WORD port, BYTE value) {

	switch(value) {
		case 0x10:
			itf_bank = 1;
			break;
		case 0x12:
			itf_bank = 0;
			break;
	}
}


// --------------------------------------------
static BOOL np2syscmp(char *p) {

	int		len;
	int		pos;

	len = strlen(p);
	if (!len) {
		return(TRUE);
	}
	pos = np2sys.strpos;
	while(len--) {
		if (p[len] != np2sys.substr[pos]) {
			return(TRUE);
		}
		pos--;
		pos &= 0x0f;
	}
	return(FALSE);
}


I286_OUT np2_sys_w(WORD port, BYTE value) {

	np2sys.substr[np2sys.strpos] = value;
	if (!np2syscmp("NP2")) {
		strcpy(np2sys.outstr, "NP2");
		np2sys.outpos = 0;
	}
	else if (!np2syscmp("ver")) {
		strcpy(np2sys.outstr, "A");
		np2sys.outpos = 0;
	}
	else if (!np2syscmp("poweroff")) {
		PostQuitMessage(0);
	}
	np2sys.strpos++;
	np2sys.strpos &= 0x0f;
}

I286_INB np2_sys_r(WORD port) {

	BYTE	ret = 0;

	ret = np2sys.outstr[np2sys.outpos];
	if (ret) {
		np2sys.outpos++;
		np2sys.outpos &= 0x0f;
	}
	return(ret);
}

