#include	<windows.h>
#include	"common.h"
#include	"pc_core.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"gdc_sub.h"
#include	"cgrom.h"
#include	"keyboard.h"
#include	"bios.h"
#include	"crtc.h"
#include	"nevent.h"
#include	"pic.h"
#include	"trace.h"

extern BYTE screenupdate;

typedef struct {
	BYTE	GBON_PTN;
	BYTE	GBBCC;
	BYTE	GBDOTU;
	BYTE	GBDSP;
	DWORD	GBCPC;
	WORD	GBSX1;
	WORD	GBSY1;
	WORD	GBLNG1;
	WORD	GBWDPA;
	WORD	GBRBUF[3];
	WORD	GBSX2;
	WORD	GBSY2;
	WORD	GBMDOT;
	WORD	GBCIR;
	WORD	GBLNG2;
	BYTE	GBMDOTI[8];
	BYTE	GBDTYP;
	BYTE	GBFILL;
} UCW_TABLE;


static WORD keyget(void) {

	WORD	pos;

	if (MEM_KB_COUNT) {
		MEM_KB_COUNT--;
		pos = MEM_KB_BUF_HEAD;
		MEM_KB_BUF_HEAD += 2;
		if (MEM_KB_BUF_HEAD >= 0x522) {
			MEM_KB_BUF_HEAD = 0x502;
		}
		return(*(WORD *)(&mem[pos]));
	}
	return(0xffff);
}


void bios0x18(void) {

	char		buf[34];
	BYTE		*p;
	int			i;
	UCW_TABLE	ucw;
	VECT_TABLE	vect;
	WORD		tmp;
	DWORD		csrw;
	GDCSUB_FUNC	func;

#define	SWAP(a, b) { tmp = (a); (a) = (b); (b) = tmp; }

	switch(I286_AH) {
		case 0x00:						// L[Ef[^̓ǂ݂
			if (MEM_KB_COUNT) {
				I286_IFLAG = 0;
				I286_AX = keyget();
			}
			else {
				I286_IP--;
				nevent.remainclock -= 200;
				I286_IFLAG = I_FLAG;
				pic_irq();
				break;
			}
			break;

   		case 0x01:						// L[Eobt@Ԃ̃ZX
			if (MEM_KB_COUNT) {
				I286_AX = *(WORD *)(&mem[MEM_KB_BUF_HEAD]);
				I286_BH = 1;
			}
			else {
				I286_BH = 0;
			}
			break;

   		case 0x02:						// VtgEL[Ԃ̃ZX
			I286_AL = MEM_SHIFT_STS;
			break;

   		case 0x03:						// L[{[hEC^tFCX̏
			bios0x09_init();
			break;

   		case 0x04:						// L[͏Ԃ̃ZX
			I286_AH = mem[0x00052a + (I286_AL & 0x0f)];
 			break;

   		case 0x05:						// L[̓ZX
			if (MEM_KB_COUNT) {
				I286_AX = keyget();
				I286_BH = 1;
			}
			else {
				I286_BH = 0;
			}
 			break;

   		case 0x0a:						// CRT[h̐ݒ
			MEM_CRT_STS_FLAG = 0x80 | (I286_AL & 0x0f);
			// GDCobt@
			if (gdc.m.cnt) {
				gdc_work(&gdc.m, &gdcs.textdisp);
			}
			gdc_reset(&gdc.m);

			gdc.mode1 &= ~(0x25);
			gdc.mode1 |= 0x08;
			if (I286_AL & 0x02) {
				gdc.mode1 |= 0x04;				// 40
			}
			if (I286_AL & 0x04) {
				gdc.mode1 |= 0x01;				// Agr[g
			}
			if (I286_AL & 0x08) {
				gdc.mode1 |= 0x20;				// R[hANZX
			}
			if (I286_AL & 0x01) {					// 20s
				MEM_CRT_RASTER = 0x13;
				gdc.m.para[GDC_CSRFORM + 0] = 0x13;
				gdc.m.para[GDC_CSRFORM + 1] = 0x00;
				gdc.m.para[GDC_CSRFORM + 2] = 0x9b;
				crtc.reg.pl = 0x1e;
				crtc.reg.bl = 0x11;
			}
			else {									// 25s
				MEM_CRT_RASTER = 0x0f;
				gdc.m.para[GDC_CSRFORM + 0] = 0x0f;
				gdc.m.para[GDC_CSRFORM + 1] = 0x00;
				gdc.m.para[GDC_CSRFORM + 2] = 0x7b;
				crtc.reg.pl = 0x00;
				crtc.reg.bl = 0x0f;
			}
			crtc.reg.cl = 0x10;
			crtc.reg.ssl = 0x00;
			gdcs.textdisp |= GDCSCRN_ALLDRAW2;
			break;

   		case 0x0b:						// CRT[h̃ZX
			I286_AL = MEM_CRT_STS_FLAG;
 			break;

   		case 0x0c:						// eLXgʂ̕\Jn
			if (!(gdcs.textdisp & GDCSCRN_ENABLE)) {
				gdcs.textdisp |= GDCSCRN_ENABLE;
				screenupdate |= 2;
 			}
 			break;

   		case 0x0d:						// eLXgʂ̕\I
			if (gdcs.textdisp & GDCSCRN_ENABLE) {
				gdcs.textdisp &= ~(GDCSCRN_ENABLE);
				screenupdate |= 2;
			}
 			break;

		case 0x0e:						// ̕\̈̐ݒ
			// GDCobt@
			if (gdc.m.cnt) {
				gdc_work(&gdc.m, &gdcs.textdisp);
			}
			gdc_reset(&gdc.m);

			ZeroMemory(&gdc.m.para[GDC_SCROLL], 8);		// 16
			*(WORD *)(&gdc.m.para[GDC_SCROLL]) = (I286_DX >> 1);
			gdcs.textdisp |= GDCSCRN_ALLDRAW2;
			screenupdate |= 2;
 			break;

		case 0x0f:						// ̕\̈̐ݒ
			break;

   		case 0x10:						// J[\^Cv̐ݒ
			// GDCobt@
			if (gdc.m.cnt) {
				gdc_work(&gdc.m, &gdcs.textdisp);
			}
			gdc_reset(&gdc.m);

			gdc.m.para[GDC_CSRFORM + 0] &= 0x7f;
			gdc.m.para[GDC_CSRFORM + 1] &= 0xdf;
			gdc.m.para[GDC_CSRFORM + 1] |= (I286_AL & 1) << 5;
			gdcs.textdisp |= GDCSCRN_ALLDRAW;
 			break;

   		case 0x11:						// J[\̕\Jn
			// GDCobt@
			if (gdc.m.cnt) {
				gdc_work(&gdc.m, &gdcs.textdisp);
			}
			gdc_reset(&gdc.m);

			gdc.m.para[GDC_CSRFORM] |= 0x80;
			gdcs.textdisp |= GDCSCRN_REDRAW;
			break;

   		case 0x12:						// J[\̕\~
			// GDCobt@
			if (gdc.m.cnt) {
				gdc_work(&gdc.m, &gdcs.textdisp);
			}
			gdc_reset(&gdc.m);

			gdc.m.para[GDC_CSRFORM] &= 0x7f;
			gdcs.textdisp |= GDCSCRN_REDRAW;
			break;

   		case 0x13:						// J[\ʒu̐ݒ
			// GDCobt@
			if (gdc.m.cnt) {
				gdc_work(&gdc.m, &gdcs.textdisp);
			}
			gdc_reset(&gdc.m);

			*(WORD *)(&gdc.m.para[GDC_CSRW]) = (I286_DX >> 1);
			gdcs.textdisp |= GDCSCRN_REDRAW;
 			break;

   		case 0x14:						// tHgp^[̓ǂݏo
			switch(I286_DH) {
				case 0x00:			// 8x8
					i286_memword_write(I286_BX, I286_CX, 0x0101);
					i286_memstr_write(I286_BX, I286_CX+2,
										&font[0x82000 + (I286_DL << 3)], 8);
					break;

				case 0x28:			// 8x16 KANJI
				case 0x29:
				case 0x2a:
				case 0x2b:
					i286_memword_write(I286_BX, I286_CX, 0x0102);
					i286_memstr_write(I286_BX, I286_CX+2,
						&font[((I286_DL & 0x7f) << 12)
								+ ((I286_DH - 0x20) << 4)], 16);
					break;

				case 0x80:			// 8x16 ANK
					i286_memword_write(I286_BX, I286_CX, 0x0102);
					i286_memstr_write(I286_BX, I286_CX+2,
									&font[0x80000 + (I286_DL << 4)], 16);
					break;
				default:
					buf[0] = 0x02;
					buf[1] = 0x02;
					p = &font[((I286_DL & 0x7f) << 12)
								+ (((I286_DH - 0x20) & 0x7f) << 4)];
					for (i=1; i<17; i++, p++) {
						buf[i*2+0] = *p;
						buf[i*2+1] = *(p+0x800);
					}
					i286_memstr_write(I286_BX, I286_CX, buf, 34);
					break;
			}
 			break;

 		case 0x15:						// Cgyʒuǂ݂
 			break;

   		case 0x16:						// eLXgVRAM̏
			bios0x18_16(I286_DL, I286_DH);
 			break;

		case 0x17:						// uU[̋N
			break;

		case 0x18:						// uU[̒~
			break;

		case 0x19:						// CgyԂ̏
			break;

   		case 0x1a:						// [U[̒`
			if ((I286_DH & 0x7e) == 0x76) {
				i286_memstr_read(I286_BX, I286_CX+2, buf, 32);
				p = &font[((I286_DL & 0x7f) << 12)
								+ (((I286_DH - 0x20) & 0x7f) << 4)];
				for (i=0; i<16; i++, p++) {
					*p = buf[i*2+0];
					*(p+0x800) = buf[i*2+1];
				}
			}
			break;

		case 0x1b:						// KCGANZX[h̐ݒ
			break;

   		case 0x40:						// OtBbNʂ̕\Jn
			if (!(gdcs.grphdisp & GDCSCRN_ENABLE)) {
				gdcs.grphdisp |= GDCSCRN_ENABLE;
				screenupdate |= 2;
			}
 			break;

   		case 0x41:						// OtBbNʂ̕\I
			if (gdcs.grphdisp & GDCSCRN_ENABLE) {
				gdcs.grphdisp &= ~(GDCSCRN_ENABLE);
				screenupdate |= 2;
			}
 			break;

   		case 0x42:						// \̈̐ݒ
			// GDCobt@
			if (gdc.s.cnt) {
				gdc_work(&gdc.s, &gdcs.grphdisp);
			}
			gdc_reset(&gdc.s);

			ZeroMemory(&gdc.s.para[GDC_SCROLL], 8);
			switch(I286_CH & 0xc0) {
				case 0x40:					// UPPER
					gdc.mode1 |= 0x10;
					gdc.s.para[GDC_CSRFORM] = 1;
					gdc.s.para[GDC_SCROLL+0] = (200*40) & 0xff;
					gdc.s.para[GDC_SCROLL+1] = (200*40) >> 8;
#if 0
					gdc.s.para[GDC_SCROLL+2] = (200 << 4) & 0xff;
					gdc.s.para[GDC_SCROLL+3] = (200 >> 4);
#endif
					break;
				case 0x80:					// LOWER
					gdc.mode1 |= 0x10;
					gdc.s.para[GDC_CSRFORM] = 1;
#if 0
					gdc.s.para[GDC_SCROLL+2] = (200 << 4) & 0xff;
					gdc.s.para[GDC_SCROLL+3] = (200 >> 4);
#endif
					break;
				default:					// ALL
					gdc.mode1 &= ~(0x10);
					gdc.s.para[GDC_CSRFORM] = 0;
#if 0
					gdc.s.para[GDC_SCROLL+2] = (400 << 4) & 0xff;
					gdc.s.para[GDC_SCROLL+3] = (400 >> 4);
#endif
					break;
			}
			gdcs.disp = (I286_CH >> 4) & 1;				// 00/05/23
			gdcs.grphdisp |= GDCSCRN_ALLDRAW2;
			screenupdate |= 2;
 			break;

		case 0x43:						// pbg̐ݒ
			i286_memstr_read(I286_DS, I286_BX, &ucw, sizeof(ucw));
			for (i=8; i--;) {
				setdegitalpal(i, (BYTE)ucw.GBCPC);
				ucw.GBCPC >>= 4;
			}
			gdcs.palchange = GDCSCRN_REDRAW;
			break;

		case 0x47:						// A`̕`
			// GDCobt@
			if (gdc.s.cnt) {
				gdc_work(&gdc.s, &gdcs.grphdisp);
			}
			gdc_reset(&gdc.s);

			i286_memstr_read(I286_DS, I286_BX, &ucw, sizeof(ucw));
			ZeroMemory(&vect, sizeof(vect));
			if (ucw.GBDTYP == 0x01) {
				short dx, dy;
				func = gdcsub_line;
				if ((ucw.GBSX1 > ucw.GBSX2) ||
					((ucw.GBSX1 == ucw.GBSX2) && (ucw.GBSY1 > ucw.GBSY2))) {
					SWAP(ucw.GBSX1, ucw.GBSX2);
				}
				dx = ucw.GBSX2 - ucw.GBSX1;
				dy = ucw.GBSY2 - ucw.GBSY1;
				if (dy > 0) {
					if (dx < dy) {
						vect.ope = 0;
						SWAP(dx, dy);
					}
					else {
						vect.ope = 1;
					}
				}
				else {
					dy = -dy;
					if (dx > dy) {
						vect.ope = 2;
					}
					else {
						vect.ope = 3;
						SWAP(dx, dy);
					}
				}
				vect.DC = dx;
				vect.D1 = dy*2;
				vect.D = vect.D1 - dx;
				vect.D2 = vect.D - dx;
			}
			else if (ucw.GBDTYP == 0x02) {
				func = gdcsub_box;
				if (ucw.GBSX1 > ucw.GBSX2) {
					SWAP(ucw.GBSX1, ucw.GBSX2);
				}
				if (ucw.GBSY1 > ucw.GBSY2) {
					SWAP(ucw.GBSY1, ucw.GBSY2);
				}
				vect.DC = 3;
				vect.D1 = (WORD)-1;
				vect.DM = vect.D2 = ucw.GBSX2 - ucw.GBSX1;
				vect.D = ucw.GBSY2 - ucw.GBSY1;
			}
			else {
				break;
			}
			if ((I286_CH & 0xc0) == 0x40) {
				ucw.GBSY1 += 200;
			}
			csrw = (ucw.GBSY1 * 40) + (ucw.GBSX1 >> 4);
			csrw |= (ucw.GBSX1 & 0xf) << 20;
			if ((I286_CH & 0x30) == 0x30) {
				if (ucw.GBON_PTN & 1) {
					func(0x04000 | csrw, &vect,
									*(WORD *)&ucw.GBMDOTI, GDCOPE_SET);
				}
				else {
					func(0x04000 | csrw, &vect,
									*(WORD *)&ucw.GBMDOTI, GDCOPE_CLEAR);
				}
				if (ucw.GBON_PTN & 2) {
					func(0x08000 | csrw, &vect,
									*(WORD *)&ucw.GBMDOTI, GDCOPE_SET);
				}
				else {
					func(0x08000 | csrw, &vect,
									*(WORD *)&ucw.GBMDOTI, GDCOPE_CLEAR);
				}
				if (ucw.GBON_PTN & 4) {
					func(0x0c000 | csrw, &vect,
									*(WORD *)&ucw.GBMDOTI, GDCOPE_SET);
				}
				else {
					func(0x0c000 | csrw, &vect,
									*(WORD *)&ucw.GBMDOTI, GDCOPE_CLEAR);
				}
			}
			else {
				func(csrw + 0x4000 + ((I286_CH & 0x30) << 10), &vect,
								*(WORD *)&ucw.GBMDOTI, ucw.GBDOTU);
			}
			break;
	}
}


void bios0x18_16(BYTE chr, BYTE atr) {

	DWORD	i;

	for (i=0xa0000; i<0xa2000; i+=2) {
		*(WORD *)(&mem[i]) = (WORD)chr;
	}
	for (; i<0xa3fe0; i+=2) {
		mem[i] = atr;
	}
	gdcs.textdisp |= GDCSCRN_ALLDRAW;
}
