#include	<windows.h>
#include	<time.h>
#include	"common.h"
#include	"np2.h"
#include	"parts.h"


typedef struct {
	WORD	year;
	BYTE	month;
	BYTE	day;
	BYTE	hour;
	BYTE	minute;
	BYTE	second;
	BYTE	weekday;
} CALENDER;

static	CALENDER	dt;
static	BYTE		days[12] = {31, 28, 31, 30, 31, 30,
								31, 31, 30, 31, 30, 31};
static	DWORD		steps;

void calender_inc(void) {

	// 56.4Hzc
	steps += 10;
	if (steps < 564) {
		return;
	}
	steps -= 564;

	if (++dt.second < 60) {
		return;
	}
	dt.second = 0;
	if (++dt.minute < 60) {
		return;
	}
	dt.minute = 0;
	if (++dt.hour < 24) {
		return;
	}
	dt.hour = 0;
	if (dt.month == 2) {
		if (dt.year & 3) {					// QĂȂ
			days[1] = 28;
		}
		else {
			days[1] = 29;
		}
	}
	dt.weekday = (BYTE)((dt.weekday + 1) % 7);
	if (++dt.day < days[dt.month-1]) {
		return;
	}
	dt.day = 1;
	if (++dt.month <= 12) {
		return;
	}
	dt.month = 1;
	dt.year++;
}

void calender_get(BYTE *str) {

	*str++ = AdjustAfterMultiply((BYTE)(dt.year % 100));
	*str++ = (BYTE)((dt.month << 4) + dt.weekday);
	*str++ = AdjustAfterMultiply(dt.day);
	*str++ = AdjustAfterMultiply(dt.hour);
	*str++ = AdjustAfterMultiply(dt.minute);
	*str   = AdjustAfterMultiply(dt.second);
}

void calender_set(BYTE *str) {

	if ((dt.year = 1900 + AdjustBeforeDivision(*str++)) < 1980) {
		dt.year += 100;
	}
	dt.weekday = (BYTE)((*str) & 0x0f);
	dt.month = (BYTE)((*str++) >> 4);
	dt.day = AdjustBeforeDivision(*str++);
	dt.hour = AdjustBeforeDivision(*str++);
	dt.minute = AdjustBeforeDivision(*str++);
	dt.second = AdjustBeforeDivision(*str);
}

void calender_init(void) {

	time_t		ltime;
	struct tm	*nt;

	time(&ltime);
	nt = localtime(&ltime);

	dt.year = nt->tm_year;
	dt.month = nt->tm_mon + 1;
	dt.day = nt->tm_mday;
	dt.hour = nt->tm_hour;
	dt.minute = nt->tm_min;
	dt.second = nt->tm_sec;
	dt.weekday = nt->tm_wday;
	steps = 0;
}
