#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	<ddraw.h>

#include	"common.h"
#include	"resource.h"
#include	"np2.h"
#include	"pc_core.h"
#include	"ddraws.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"ini.h"
#include	"winmouse.h"
#include	"dclock.h"

static	RECT	rect200 = {0, 0, SCREEN_WIDTH, SCREEN_HEIGHT};
static	RECT	rectwin = {0, 0, SCREEN_WIDTH, SCREEN_HEIGHT};
static	RECT	rectdraw1 = {0, 0, SCREEN_WIDTH, 1};
extern	HWND	hWndMain;

static	LPDIRECTDRAW			pDDraw1 = NULL;
static	LPDIRECTDRAW2			pDDraw = NULL;
static	LPDIRECTDRAWSURFACE		pPrimSurf = NULL;
static	LPDIRECTDRAWSURFACE		pBackSurf = NULL;
static	LPDIRECTDRAWSURFACE		pClockSurf = NULL;
static	LPDIRECTDRAWCLIPPER		pClipper = NULL;
static	LPDIRECTDRAWPALETTE		pPalette = NULL;
static	PALETTEENTRY			winpal[256];
static	BYTE					allflash = 0;

static	BYTE	palchanged = 0;
static	BYTE	setscmd = 0;
		BYTE	SCREENMODE = 0;
		BYTE	drawingmode = 0;

		int				np2_palettes = 0;
		PALETTE_TABLE	np2_palette[256];
		BYTE			renewal_line[SCREEN_HEIGHT+4];
		WORD			np2_pal16[256];

		WORD			np2_r16b;
		WORD			np2_r16r;
		WORD			np2_r16g;
		WORD			np2_l16b;
		WORD			np2_l16r;
		WORD			np2_l16g;

		BYTE			np2_tram[0x40000];
		BYTE			np2_vram[2][0x40000];

extern	int				winx, winy;
static	int				winw = 640;
static	int				winh = 400;

__inline void fillrenewalline(DWORD value) {

	int		cnt = SCREEN_HEIGHT / 4;
	DWORD	*p = (DWORD *)renewal_line;
	while(cnt--) {
		*p++ |= value;
	}
}

void np2_initwindowsize(WORD width, WORD height) {

	RECT	rectWindow, rectClient;
	int		scx, scy;

	GetWindowRect(hWndMain, &rectWindow);
	GetClientRect(hWndMain, &rectClient);
	winw = width + (rectWindow.right - rectWindow.left)
					- (rectClient.right - rectClient.left);
	winh = height + (rectWindow.bottom - rectWindow.top)
					- (rectClient.bottom - rectClient.top);

	scx = GetSystemMetrics(SM_CXSCREEN);
	scy = GetSystemMetrics(SM_CYSCREEN);

	if (scx < winw) {
		INIT_RENEWAL
			winx = (scx - winw) / 2;
	}
	else if (winx < 0) {
		INIT_RENEWAL
			winx = 0;
	}
	else if ((winx + winw) > scx) {
		INIT_RENEWAL
			winx = scx - winw;
	}
	if (scy < winh) {
		INIT_RENEWAL
			winy = (scy - winh) / 2;
	}
	else if (winy < 0) {
		INIT_RENEWAL
			winy = 0;
	}
	else if ((winy + winh) > scy) {
		INIT_RENEWAL
			winy = scy - winh;
	}
}



BYTE np2_setscreenmode(BYTE mode) {

	BYTE	ret = FALSE;

	if (mode & SCMD_SETWINDOWED) {
		if (!(SCREENMODE & SCMD_WINDOWED)) {
			setscmd |= SCMD_SETWINDOWED;
			ret = TRUE;
		}
	}
	else if (mode & SCMD_SETFULLSCREEN) {
		if (!(SCREENMODE & SCMD_FULLSCRN)) {
			setscmd &= (~SCMD_SETWINDOWED);
			ret = TRUE;
		}
	}
	if (mode & SCMD_SET256) {
		if (!(SCREENMODE & SCMD_USEPAL)) {
			setscmd |= SCMD_SET256;
			ret = TRUE;
		}
	}
	else if (mode & SCMD_SET65536) {
		if (!(SCREENMODE & SCMD_NONPAL)) {
			setscmd &= (~SCMD_SET256);
			ret = TRUE;
		}
	}
	if (mode & SCMD_SETNORMAL) {
		if ((setscmd ^ mode) & 0xc0) {
			setscmd = (setscmd & 0x1f) | (mode & 0xe0);
			if (setscmd & SCMD_SETWINDOWED) {
				ret = TRUE;
			}
		}
	}
	return(ret);
}


void np2_windowstats(void) {

	DWORD	winstyle, winstyleex;
	HMENU	hmenu = GetMenu(hWndMain);

	winstyle = GetWindowLong(hWndMain, GWL_STYLE);
	winstyleex = GetWindowLong(hWndMain, GWL_EXSTYLE);
	if (setscmd & SCMD_SETWINDOWED) {
		winstyle = (winstyle | WS_CAPTION | WS_OVERLAPPED | WS_SYSMENU)
																& ~WS_POPUP;
		winstyleex &= ~WS_EX_TOPMOST;
		SetWindowLong(hWndMain, GWL_STYLE, winstyle);
		SetWindowLong(hWndMain, GWL_EXSTYLE, winstyleex);

		if (setscmd & SCMD_SETNORMAL) {
			setscmd ^= SCMD_SETNORMAL;
			if (!(setscmd & 0xc0)) {
				SetRect(&rectwin, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
			}
			else {
				SetRect(&rectwin, 0, 0, SCREEN_HEIGHT, SCREEN_WIDTH);
			}
			np2_initwindowsize((WORD)rectwin.right, (WORD)rectwin.bottom);
		}
		MoveWindow(hWndMain, winx, winy, winw, winh, TRUE);

		CheckMenuItem(hmenu, IDM_WINDOW, MF_CHECKED);
		CheckMenuItem(hmenu, IDM_FULLSCREEN, MF_UNCHECKED);
	}
	else {
		winstyle = (winstyle | WS_POPUP)
						& (~(WS_CAPTION | WS_OVERLAPPED | WS_SYSMENU));
		winstyleex |= WS_EX_TOPMOST;
		SetWindowLong(hWndMain, GWL_STYLE, winstyle);
		SetWindowLong(hWndMain, GWL_EXSTYLE, winstyleex);
		CheckMenuItem(hmenu, IDM_WINDOW, MF_UNCHECKED);
		CheckMenuItem(hmenu, IDM_FULLSCREEN, MF_CHECKED);
	}
}


void np2_wincenter(void) {

	INIT_RENEWAL
		winx = (GetSystemMetrics(SM_CXSCREEN) - winw) / 2;
		winy = (GetSystemMetrics(SM_CYSCREEN) - winh) / 2;
	if (winx < 0) {
		winx = 0;
	}
	if (winy < 0) {
		winy = 0;
	}
	MoveWindow(hWndMain, winx, winy, winw, winh, TRUE);
}


void ddraws_init(void) {

	ZeroMemory(np2_tram, sizeof(np2_tram));
	ZeroMemory(np2_vram, sizeof(np2_vram));
	ZeroMemory(np2_palette, sizeof(np2_palette));
	np2_palettes = 0;
	allflash = 1;
	fillrenewalline(0x80808080);
}

WORD ddraw16bitpal(PALETTE_TABLE pal) {

	return(((pal.b.red >> np2_r16r) << np2_l16r) |
			((pal.b.green >> np2_r16g) << np2_l16g) |
			((pal.b.blue >> np2_r16b) << np2_l16b));
}


void change_palette(int setpals) {

	int		i;

	if (SCREENMODE & SCMD_USEPAL) {
		palchanged = 1;
	}
	else {
		if ((SCREENMODE & SCMD_COLORMASK) == SCMD_COLOR16) {
			for (i=0; i<setpals; i++) {
				np2_pal16[i] =
						((np2_palette[i].b.red >> np2_r16r) << np2_l16r) |
						((np2_palette[i].b.green >> np2_r16g) << np2_l16g) |
						((np2_palette[i].b.blue >> np2_r16b) << np2_l16b);
			}
		}
		fillrenewalline(0x80808080);
	}
}


static void palette_init(void) {

	BYTE	i;
	HDC 	hdc = GetDC(hWndMain);

	GetSystemPaletteEntries(hdc, 0, 256, winpal);
	ReleaseDC(hWndMain, hdc);

	for (i=0; i<4; i++) {
		*(DWORD *)(&winpal[i+START_PALORG]) = dclockcolor[i];
		winpal[i+START_PALORG].peFlags = PC_RESERVED | PC_NOCOLLAPSE;
	}
	for (i=0; i<TOTAL_PALS; i++) {
		winpal[i+START_PAL].peFlags = PC_RESERVED | PC_NOCOLLAPSE;
	}
//	reflesh_palette();
	pDDraw->CreatePalette(DDPCAPS_8BIT, winpal, &pPalette, 0);
	pPrimSurf->SetPalette(pPalette);
	palchanged = 0;
}


static void palette_set(void) {

	int		i;

	if ((pPalette != NULL) && (np2_palettes)) {
		for (i=0; i<np2_palettes; i++) {
			winpal[i+START_PAL].peRed = np2_palette[i].b.red;
			winpal[i+START_PAL].peBlue = np2_palette[i].b.blue;
			winpal[i+START_PAL].peGreen = np2_palette[i].b.green;
		}
		pPalette->SetEntries(0, START_PAL, np2_palettes, &winpal[START_PAL]);
	}
}


void clearblankarea(void) {

	DDBLTFX		ddbf;
	RECT		fill1rect = {0, 0, FULLSCREEN_WIDTH, FULLSCREEN_POSY};
	RECT		fill2rect = {0, FULLSCREEN_HEIGHT - FULLSCREEN_POSY,
								FULLSCREEN_WIDTH, FULLSCREEN_HEIGHT};

	ZeroMemory(&ddbf, sizeof(ddbf));
	ddbf.dwSize = sizeof(ddbf);
	ddbf.dwFillColor = 0;
	pPrimSurf->Blt(&fill1rect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
	pPrimSurf->Blt(&fill2rect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
	dclock_redraw();
}

static void make16bit(WORD *shlcnt, WORD *shrcnt, DWORD bitmap) {

	WORD	bit = 1;
	WORD	cnt;

	for (cnt=0; (cnt<16) && (!(bitmap & bit)); cnt++, bit<<=1) ;
	*shlcnt = cnt;
	for (cnt=8; (cnt) && (bitmap & bit); cnt--, bit<<=1) ;
	*shrcnt = cnt;
}


int np2_InitDirectDraw(void) {

	DDSURFACEDESC	ddsd;
	DDPIXELFORMAT	ddpf;
	int				bitcolor;

	pDDraw1 = NULL;
	pDDraw = NULL;
	pPrimSurf = NULL;
	pBackSurf = NULL;
	pClockSurf = NULL;
	pClipper = NULL;
	pPalette = NULL;
	palchanged = 0;
	SCREENMODE = 0;

	if (DirectDrawCreate(NULL, &pDDraw1, NULL) != DD_OK) {
		return(FAILURE);
	}
	pDDraw1->QueryInterface(IID_IDirectDraw2, (void **)&pDDraw);

	if (setscmd & SCMD_SETWINDOWED) {
		pDDraw->SetCooperativeLevel(hWndMain, DDSCL_NORMAL);

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

		if (pDDraw->CreateSurface(&ddsd, &pPrimSurf, NULL) != DD_OK) {
			return(FAILURE);
		}

		pDDraw->CreateClipper(0, &pClipper, NULL);
		pClipper->SetHWnd(0, hWndMain);
		pPrimSurf->SetClipper(pClipper);

		ZeroMemory(&ddpf, sizeof(ddpf));
		ddpf.dwSize = sizeof(DDPIXELFORMAT);
		if (DD_OK != pPrimSurf->GetPixelFormat(&ddpf)) {
			return(FAILURE);
		}

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
		ddsd.dwWidth = rectwin.right;
		ddsd.dwHeight = rectwin.bottom;

		if (pDDraw->CreateSurface(&ddsd, &pBackSurf, NULL) != DD_OK) {
			return(FAILURE);
		}
		if (ddpf.dwRGBBitCount == 8) {
			SCREENMODE |= SCMD_WINDOW8;
			palette_init();
		}
		else if (ddpf.dwRGBBitCount == 16) {
			SCREENMODE |= SCMD_WINDOW16;
			make16bit(&np2_l16b, &np2_r16b, ddpf.dwBBitMask);
			make16bit(&np2_l16r, &np2_r16r, ddpf.dwRBitMask);
			make16bit(&np2_l16g, &np2_r16g, ddpf.dwGBitMask);
//			reflesh_palette();
		}
		else if (ddpf.dwRGBBitCount == 24) {
			SCREENMODE |= SCMD_WINDOW24;
//			reflesh_palette();
		}
		else if (ddpf.dwRGBBitCount == 32) {
			SCREENMODE |= SCMD_WINDOW32;
//			reflesh_palette();
		}
		else {
			return(FAILURE);
		}
	}
	else {
		pDDraw->SetCooperativeLevel(hWndMain,
					DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
		if (setscmd & SCMD_SET256) {
			bitcolor = 8;
		}
		else {
			bitcolor = 16;
		}
		if (pDDraw->SetDisplayMode(FULLSCREEN_WIDTH, FULLSCREEN_HEIGHT,
												bitcolor, 0, 0) != DD_OK) {
			return(FAILURE);
		}
		pDDraw->CreateClipper(0, &pClipper, NULL);
		pClipper->SetHWnd(0, hWndMain);

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
		if (pDDraw->CreateSurface(&ddsd, &pPrimSurf, NULL) != DD_OK) {
			return(FAILURE);
		}
		clearblankarea();

		ZeroMemory(&ddpf, sizeof(ddpf));
		ddpf.dwSize = sizeof(DDPIXELFORMAT);
		if (pPrimSurf->GetPixelFormat(&ddpf) != DD_OK) {
			return(FAILURE);
		}

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
		ddsd.dwWidth = FULLSCREEN_WIDTH;
		ddsd.dwHeight = SCREEN_HEIGHT;
		if (pDDraw->CreateSurface(&ddsd, &pBackSurf, NULL) != DD_OK) {
			return(FAILURE);
		}
		if (bitcolor == 8) {
			SCREENMODE |= SCMD_FSCREEN8;
			palette_init();
#if 1
			ZeroMemory(&ddsd, sizeof(ddsd));
			ddsd.dwSize = sizeof(ddsd);
			ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
			ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
			ddsd.dwWidth = DCLOCK_X;
			ddsd.dwHeight = DCLOCK_Y;
			if (pDDraw->CreateSurface(&ddsd, &pClockSurf, NULL) != DD_OK) {
				pClockSurf = NULL;
			}
#endif
		}
		else {
			SCREENMODE |= SCMD_FSCREEN16;
			change_palette(np2_palettes);
			make16bit(&np2_l16b, &np2_r16b, ddpf.dwBBitMask);
			make16bit(&np2_l16r, &np2_r16r, ddpf.dwRBitMask);
			make16bit(&np2_l16g, &np2_r16g, ddpf.dwGBitMask);
//			reflesh_palette();
		}
	}
	return(SUCCESS);
}


void np2_TermDirectDraw(void) {

	if ((SCREENMODE & SCMD_FULLSCRN) && (pDDraw)) {
//		pDDraw->RestoreDisplayMode();
		pDDraw->SetCooperativeLevel(hWndMain, DDSCL_NORMAL);
	}
	RELEASE(pClockSurf);
	RELEASE(pBackSurf);
	RELEASE(pPalette);
	RELEASE(pClipper);
	RELEASE(pPrimSurf);
	RELEASE(pDDraw);
	RELEASE(pDDraw1);
}

void change_drawlines(DWORD lines) {

	if (lines > SCREEN_HEIGHT) {
		lines = SCREEN_HEIGHT;
	}
	rect200.bottom = lines;
	allflash = 1;
}

void clearblanklines(DWORD posx, DWORD posy) {

	DDBLTFX		ddbf;
	RECT		fillrect;

	fillrect.left = posx;
	fillrect.top = posy + rect200.bottom;
	fillrect.right = posx + SCREEN_WIDTH;
	fillrect.bottom = posy + SCREEN_HEIGHT;

	ZeroMemory(&ddbf, sizeof(ddbf));
	ddbf.dwSize = sizeof(ddbf);
	ddbf.dwFillColor = 0;
	pPrimSurf->Blt(&fillrect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
}

	DDSURFACEDESC	destscrn;

// -------------------------------------------------------------------- normal

LABEL void __fastcall drawplane1(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdr_lp1:		mov		eax, [esi]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						loop	x1win8bppdr_lp1
						pop		edi
						pop		esi
x1win8bppdr_ed:			add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						loop	x1win16bppdr_lp1
						pop		edi
						pop		esi
x1win16bppdr_ed:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						loop	x1win24bppdr_lp1
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
x1win24bppdr_ed:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						loop	x1win32bppdr_lp1
						pop		edi
						pop		esi
x1win32bppdr_ed:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH / 4
x1win8bppdr_lp1:		mov		eax, [esi]
						or		eax, [ecx]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		ecx, 4
						add		edi, 4
						dec		ebp
						jne		x1win8bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
x1win8bppdr_ed:			add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						inc		ecx
						add		edi, 2
						dec		ebp
						jne		x1win16bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
x1win16bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH - 1
x1win24bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 3
						dec		ebp
						jne		x1win24bppdr_lp1
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
						pop		ecx
x1win24bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 4
						dec		ebp
						jne		x1win32bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
x1win32bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplane1sk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdr_lp1:		mov		eax, [esi]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						loop	x1win8bppdr_lp1
						pop		edi
						pop		esi
x1win8bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		eax, (0x01010101 * START_EXT)
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdr_lp2:		mov		[edi], eax
						add		edi, 4
						loop	x1win8bppdr_lp2
						pop		edi
x1win8bppdr_dned:		add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						loop	x1win16bppdr_lp1
						pop		edi
						pop		esi
x1win16bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ax, word ptr np2_pal16[USE_PALS * 2]
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp2:		mov		[edi], ax
						add		edi, 2
						loop	x1win16bppdr_lp2
						pop		edi
x1win16bppdr_dned:		add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						loop	x1win24bppdr_lp1
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
x1win24bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		eax, dword ptr np2_palette[USE_PALS * 4]
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdr_lp2:		mov		[edi], eax
						add		edi, 3
						loop	x1win24bppdr_lp2
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
x1win24bppdr_dned:		add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						loop	x1win32bppdr_lp1
						pop		edi
						pop		esi
x1win32bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		eax, dword ptr np2_palette[USE_PALS * 4]
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp2:		mov		[edi], eax
						add		edi, 4
						loop	x1win32bppdr_lp2
						pop		edi
x1win32bppdr_dned:		add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanetxtsk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdr_lp1:		mov		eax, [esi]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						loop	x1win8bppdr_lp1
						pop		edi
						pop		esi
x1win8bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdr_lp2:		mov		eax, [esi]
						shr		eax, 4
						add		eax, (0x01010101 * START_EXT)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						loop	x1win8bppdr_lp2
						pop		edi
						pop		esi
x1win8bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						loop	x1win16bppdr_lp1
						pop		edi
						pop		esi
x1win16bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		ax, word ptr np2_pal16[eax*2 + USE_PALS*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						loop	x1win16bppdr_lp2
						pop		edi
						pop		esi
x1win16bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						loop	x1win24bppdr_lp1
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
x1win24bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						loop	x1win24bppdr_lp2
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
x1win24bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						loop	x1win32bppdr_lp1
						pop		edi
						pop		esi
x1win32bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						loop	x1win32bppdr_lp2
						pop		edi
						pop		esi
x1win32bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1sk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH / 4
x1win8bppdr_lp1:		mov		eax, [esi]
						or		eax, [ecx]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		ecx, 4
						add		edi, 4
						dec		ebp
						jne		x1win8bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
x1win8bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH / 4
x1win8bppdr_lp2:		mov		eax, [esi]
						shr		eax, 4
						add		eax, (0x01010101 * START_EXT)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						dec		ebp
						jne		x1win8bppdr_lp2
						pop		edi
						pop		esi
x1win8bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						inc		ecx
						add		edi, 2
						dec		ebp
						jne		x1win16bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
x1win16bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						add		eax, USE_PALS
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						dec		ebp
						jne		x1win16bppdr_lp2
						pop		edi
						pop		esi
x1win16bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH - 1
x1win24bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 3
						dec		ebp
						jne		x1win24bppdr_lp1
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
						pop		ecx
x1win24bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH - 1
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						add		eax, USE_PALS
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 3
						dec		ebp
						jne		x1win24bppdr_lp2
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						add		eax, USE_PALS
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
x1win24bppdr_dned:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 4
						dec		ebp
						jne		x1win32bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
x1win32bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						add		eax, USE_PALS
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						dec		ebp
						jne		x1win32bppdr_lp2
						pop		edi
						pop		esi
x1win32bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}

LABEL void __fastcall drawplane1ex(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdr_lp1:		mov		eax, [esi]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						loop	x1win8bppdr_lp1
						pop		edi
						pop		esi
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win8bppdr_dnst
x1win8bppdr_uped:		inc		ebx
						add		edi, destscrn.lPitch
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
x1win8bppdr_dnst:		and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdr_lp2:		mov		eax, [esi]
						add		eax, (0x01010101 * START_EXT2)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						loop	x1win8bppdr_lp2
						pop		edi
						pop		esi
x1win8bppdr_dned:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						loop	x1win16bppdr_lp1
						pop		edi
						pop		esi
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win16bppdr_dnst
x1win16bppdr_uped:		add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
x1win16bppdr_dnst:		and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2 + EXT2_PAL*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						loop	x1win16bppdr_lp2
						pop		edi
						pop		esi
x1win16bppdr_dned:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						loop	x1win24bppdr_lp1
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win24bppdr_dnst
x1win24bppdr_uped:		add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_ed
x1win24bppdr_dnst:		and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4 + EXT2_PAL*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						loop	x1win24bppdr_lp2
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4 + EXT2_PAL*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
x1win24bppdr_ed:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp1:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						loop	x1win32bppdr_lp1
						pop		edi
						pop		esi
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win32bppdr_dnst
x1win32bppdr_uped:		add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
x1win32bppdr_dnst:		and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4 + EXT2_PAL*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						loop	x1win32bppdr_lp2
						pop		edi
						pop		esi
x1win32bppdr_dned:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1ex(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH / 4
x1win8bppdr_lp1:		mov		eax, [esi]
						or		eax, [ecx]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		ecx, 4
						add		edi, 4
						dec		ebp
						jne		x1win8bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
						add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win8bppdr_dnst
x1win8bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
x1win8bppdr_dnst:		and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win8bppdr_lp2:		mov		al, byte ptr [esi]
						shr		al, 4
						jne		x1win8bppdr_stp
						mov		al, byte ptr [ecx]
						add		al, EXT_PALS
x1win8bppdr_stp:		add		al, START_EXT
						mov		[edi], al
						inc		esi
						inc		ecx
						inc		edi
						dec		ebp
						jne		x1win8bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win8bppdr_dned:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						inc		ecx
						add		edi, 2
						dec		ebp
						jne		x1win16bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
						add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win16bppdr_dnst
x1win16bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
x1win16bppdr_dnst:		and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						jne		x1win16bppdr_stp
						movzx	eax, byte ptr [ecx]
						add		eax, EXT_PALS
x1win16bppdr_stp:		mov		ax, word ptr np2_pal16[eax*2 + USE_PALS*2]
						mov		[edi], ax
						inc		esi
						inc		ecx
						add		edi, 2
						dec		ebp
						jne		x1win16bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win16bppdr_dned:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH - 1
x1win24bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 3
						dec		ebp
						jne		x1win24bppdr_lp1
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
						pop		ecx
						add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win24bppdr_dnst
x1win24bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
x1win24bppdr_dnst:		and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH - 1
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						jne		x1win24bppdr_stp
						movzx	eax, byte ptr [ecx]
						add		eax, EXT_PALS
x1win24bppdr_stp:		mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 3
						dec		ebp
						jne		x1win24bppdr_lp2
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						jne		x1win24bppdr_stp2
						movzx	eax, byte ptr [ecx]
						add		eax, EXT_PALS
x1win24bppdr_stp2:		mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], ax
						pop		edi
						pop		esi
						pop		ecx
x1win24bppdr_dned:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp1:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 4
						dec		ebp
						jne		x1win32bppdr_lp1
						pop		edi
						pop		esi
						pop		ecx
						add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						jmp		x1win32bppdr_dnst
x1win32bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
x1win32bppdr_dnst:		and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						jne		x1win32bppdr_stp
						movzx	eax, byte ptr [ecx]
						add		eax, EXT_PALS
x1win32bppdr_stp:		mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 4
						dec		ebp
						jne		x1win32bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win32bppdr_dned:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}

// ---------------------------------------------------------------------- left

LABEL void __fastcall drawplane1l(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_ed
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win8bppdr_lp1:		dec		esi
						mov		al, byte ptr [esi]
						add		al, START_PAL
						mov		[edi], al
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp1
						pop		edi
x1win8bppdr_ed:			add		esi, SCREEN_WIDTH
						inc		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_ed
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win16bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp1
						pop		edi
x1win16bppdr_ed:		add		esi, SCREEN_WIDTH
						add		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_ed
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win24bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp1
						pop		edi
x1win24bppdr_ed:		add		esi, SCREEN_WIDTH
						add		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_ed
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win32bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp1
						pop		edi
x1win32bppdr_ed:		add		esi, SCREEN_WIDTH
						add		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1l(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_ed
						and		renewal_line[ebx], dh
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win8bppdr_lp1:		dec		esi
						dec		ecx
						mov		al, [esi]
						or		al, [ecx]
						add		al, START_PAL
						mov		[edi], al
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win8bppdr_lp1
						pop		edi
x1win8bppdr_ed:			add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						inc		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_ed
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win16bppdr_lp1:		dec		esi
						dec		ecx
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win16bppdr_lp1
						pop		edi
x1win16bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_ed
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win24bppdr_lp1:		dec		esi
						dec		ecx
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win24bppdr_lp1
						pop		edi
x1win24bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_ed
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win32bppdr_lp1:		dec		esi
						dec		ecx
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win32bppdr_lp1
						pop		edi
x1win32bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplane1lsk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win8bppdr_lp1:		dec		esi
						mov		al, byte ptr [esi]
						add		al, START_PAL
						mov		[edi], al
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp1
						pop		edi
x1win8bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						inc		edi
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		al, START_EXT
						mov		ecx, SCREEN_WIDTH
x1win8bppdr_lp2:		mov		[edi], al
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp2
						pop		edi
x1win8bppdr_dned:		inc		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win16bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp1
						pop		edi
x1win16bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, 2
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ax, word ptr np2_pal16[USE_PALS * 2]
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp2:		mov		[edi], ax
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp2
						pop		edi
x1win16bppdr_dned:		add		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win24bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp1
						pop		edi
x1win24bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, 3
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win24bppdr_lp2:		mov		eax, dword ptr np2_palette[USE_PALS * 4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp2
						pop		edi
x1win24bppdr_dned:		add		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win32bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp1
						pop		edi
x1win32bppdr_uped:		add		esi, (SCREEN_WIDTH * 2)
						add		edi, 4
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		eax, dword ptr np2_palette[USE_PALS * 4]
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp2:		mov		[edi], eax
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp2
						pop		edi
x1win32bppdr_dned:		add		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanetxtlsk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win8bppdr_lp1:		dec		esi
						mov		al, byte ptr [esi]
						add		al, START_PAL
						mov		[edi], al
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp1
						pop		edi
x1win8bppdr_uped:		add		esi, SCREEN_WIDTH
						inc		edi
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win8bppdr_lp2:		dec		esi
						mov		al, byte ptr [esi]
						shr		al, 4
						add		al, START_EXT
						mov		[edi], al
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp2
						pop		edi
x1win8bppdr_dned:		add		esi, SCREEN_WIDTH
						inc		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win16bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp1
						pop		edi
x1win16bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, 2
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win16bppdr_lp2:		dec		esi
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		ax, word ptr np2_pal16[eax*2 + USE_PALS*2]
						mov		[edi], ax
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp2
						pop		edi
x1win16bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win24bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp1
						pop		edi
x1win24bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, 3
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win24bppdr_lp2:		dec		esi
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp2
						pop		edi
x1win24bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win32bppdr_lp1:		dec		esi
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp1
						pop		edi
x1win32bppdr_uped:		add		esi, SCREEN_WIDTH
						add		edi, 4
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
						add		esi, ecx
x1win32bppdr_lp2:		dec		esi
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], eax
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp2
						pop		edi
x1win32bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1lsk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
draw_color8:			test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win8bppdr_lp1:		dec		esi
						dec		ecx
						mov		al, [esi]
						or		al, [ecx]
						add		al, START_PAL
						mov		[edi], al
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win8bppdr_lp1
						pop		edi
x1win8bppdr_uped:		add		esi, SCREEN_WIDTH * 2
						add		ecx, (SCREEN_WIDTH * 2)
						inc		edi
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
x1win8bppdr_lp2:		dec		esi
						mov		al, [esi]
						shr		al, 4
						add		al, START_EXT
						mov		[edi], al
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win8bppdr_lp2
						pop		edi
x1win8bppdr_dned:		add		esi, SCREEN_WIDTH
						inc		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color8
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win16bppdr_lp1:		dec		esi
						dec		ecx
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win16bppdr_lp1
						pop		edi
x1win16bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, 2
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
x1win16bppdr_lp2:		dec		esi
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						add		eax, USE_PALS
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win16bppdr_lp2
						pop		edi
x1win16bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win24bppdr_lp1:		dec		esi
						dec		ecx
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win24bppdr_lp1
						pop		edi
x1win24bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, 3
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
x1win24bppdr_lp2:		dec		esi
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						add		eax, USE_PALS
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win24bppdr_lp2
						pop		edi
x1win24bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
						add		ecx, ebp
x1win32bppdr_lp1:		dec		esi
						dec		ecx
						movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win32bppdr_lp1
						pop		edi
x1win32bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH * 2)
						add		edi, 4
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ebp, SCREEN_WIDTH
						add		esi, ebp
x1win32bppdr_lp2:		dec		esi
						movzx	eax, byte ptr [esi]
						shr		eax, 4
						add		eax, USE_PALS
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win32bppdr_lp2
						pop		edi
x1win32bppdr_dned:		add		esi, SCREEN_WIDTH
						add		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}

// --------------------------------------------------------------------- right

LABEL void __fastcall drawplane1r(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
						add		edi, (SCREEN_HEIGHT - 1)
x1win8bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win8bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win8bppdr_lp2:		mov		al, byte ptr [esi]
						add		al, START_PAL
						mov		[edi], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp2
						pop		edi
						pop		esi
x1win8bppdr_ed:			add		esi, SCREEN_WIDTH
						dec		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win8bppdr_lp1
						jmp		draw_color_ed

draw_color16:			add		edi, (SCREEN_HEIGHT - 1) * 2
x1win16bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win16bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp2
						pop		edi
						pop		esi
x1win16bppdr_ed:		add		esi, SCREEN_WIDTH
						sub		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win16bppdr_lp1
						jmp		draw_color_ed

draw_color24:			add		edi, (SCREEN_HEIGHT - 1) * 3
x1win24bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win24bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp2
						pop		edi
						pop		esi
x1win24bppdr_ed:		add		esi, SCREEN_WIDTH
						sub		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win24bppdr_lp1
						jmp		draw_color_ed

draw_color32:			add		edi, (SCREEN_HEIGHT - 1) * 4
x1win32bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win32bppdr_ed
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp2
						pop		edi
						pop		esi
x1win32bppdr_ed:		add		esi, SCREEN_WIDTH
						sub		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win32bppdr_lp1

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1r(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
						add		edi, SCREEN_HEIGHT-1
x1win8bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win8bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win8bppdr_lp2:		mov		al, [esi]
						or		al, [ecx]
						add		al, START_PAL
						mov		[edi], al
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win8bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win8bppdr_ed:			add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						dec		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win8bppdr_lp1
						jmp		draw_color_ed

draw_color16:			add		edi, (SCREEN_HEIGHT - 1) * 2
x1win16bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win16bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win16bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win16bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						sub		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win16bppdr_lp1
						jmp		draw_color_ed

draw_color24:			add		edi, (SCREEN_HEIGHT - 1) * 3
x1win24bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win24bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win24bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win24bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						sub		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win24bppdr_lp1
						jmp		draw_color_ed

draw_color32:			add		edi, (SCREEN_HEIGHT - 1) * 4
x1win32bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win32bppdr_ed
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win32bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win32bppdr_ed:		add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						sub		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win32bppdr_lp1

draw_color_ed:	popad
				ret
		}
}

LABEL void __fastcall drawplane1rsk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
						add		edi, (SCREEN_HEIGHT - 1)
x1win8bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win8bppdr_lp2:		mov		al, byte ptr [esi]
						add		al, START_PAL
						mov		[edi], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp2
						pop		edi
						pop		esi
x1win8bppdr_uped:		add		esi, (SCREEN_WIDTH*2)
						dec		edi
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		al, START_EXT
						mov		ecx, SCREEN_WIDTH
x1win8bppdr_lp3:		mov		[edi], al
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp3
						pop		edi
x1win8bppdr_dned:		dec		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win8bppdr_lp1
						jmp		draw_color_ed

draw_color16:			add		edi, (SCREEN_HEIGHT - 1) * 2
x1win16bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp2
						pop		edi
						pop		esi
x1win16bppdr_uped:		add		esi, (SCREEN_WIDTH*2)
						sub		edi, 2
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ax, word ptr np2_pal16[USE_PALS*2]
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp3:		mov		[edi], ax
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp3
						pop		edi
x1win16bppdr_dned:		sub		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win16bppdr_lp1
						jmp		draw_color_ed

draw_color24:			add		edi, (SCREEN_HEIGHT - 1) * 3
x1win24bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp2
						pop		edi
						pop		esi
x1win24bppdr_uped:		add		esi, (SCREEN_WIDTH*2)
						sub		edi, 3
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win24bppdr_lp3:		mov		eax, dword ptr np2_palette[USE_PALS*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp3
						pop		edi
x1win24bppdr_dned:		sub		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win24bppdr_lp1
						jmp		draw_color_ed

draw_color32:			add		edi, (SCREEN_HEIGHT - 1) * 4
x1win32bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp2
						pop		edi
						pop		esi
x1win32bppdr_uped:		add		esi, (SCREEN_WIDTH*2)
						sub		edi, 4
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	edi
						mov		eax, dword ptr np2_palette[USE_PALS*4]
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp3:		mov		[edi], eax
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp3
						pop		edi
x1win32bppdr_dned:		sub		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win32bppdr_lp1

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanetxtrsk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
						add		edi, (SCREEN_HEIGHT - 1)
x1win8bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win8bppdr_lp2:		mov		al, byte ptr [esi]
						add		al, START_PAL
						mov		[edi], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp2
						pop		edi
						pop		esi
x1win8bppdr_uped:		add		esi, SCREEN_WIDTH
						dec		edi
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win8bppdr_lp3:		mov		al, byte ptr [esi]
						shr		al, 4
						add		al, START_EXT
						mov		[edi], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win8bppdr_lp3
						pop		edi
						pop		esi
x1win8bppdr_dned:		add		esi, SCREEN_WIDTH
						dec		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win8bppdr_lp1
						jmp		draw_color_ed

draw_color16:			add		edi, (SCREEN_HEIGHT - 1) * 2
x1win16bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp2
						pop		edi
						pop		esi
x1win16bppdr_uped:		add		esi, SCREEN_WIDTH
						sub		edi, 2
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdr_lp3:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		ax, word ptr np2_pal16[eax*2 + USE_PALS*2]
						mov		[edi], ax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win16bppdr_lp3
						pop		edi
						pop		esi
x1win16bppdr_dned:		add		esi, SCREEN_WIDTH
						sub		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win16bppdr_lp1
						jmp		draw_color_ed

draw_color24:			add		edi, (SCREEN_HEIGHT - 1) * 3
x1win24bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp2
						pop		edi
						pop		esi
x1win24bppdr_uped:		add		esi, SCREEN_WIDTH
						sub		edi, 3
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win24bppdr_lp3:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win24bppdr_lp3
						pop		edi
						pop		esi
x1win24bppdr_dned:		add		esi, SCREEN_WIDTH
						sub		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win24bppdr_lp1
						jmp		draw_color_ed

draw_color32:			add		edi, (SCREEN_HEIGHT - 1) * 4
x1win32bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp2
						pop		edi
						pop		esi
x1win32bppdr_uped:		add		esi, SCREEN_WIDTH
						sub		edi, 4
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdr_lp3:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4+USE_PALS*4]
						mov		[edi], eax
						inc		esi
						add		edi, destscrn.lPitch
						loop	x1win32bppdr_lp3
						pop		edi
						pop		esi
x1win32bppdr_dned:		add		esi, SCREEN_WIDTH
						sub		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win32bppdr_lp1

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1rsk(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
						add		edi, SCREEN_HEIGHT-1
x1win8bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win8bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win8bppdr_lp2:		mov		al, [esi]
						or		al, [ecx]
						add		al, START_PAL
						mov		[edi], al
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win8bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win8bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH*2)
						dec		edi
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win8bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win8bppdr_lp3:		mov		al, [esi]
						shr		al, 4
						add		al, START_EXT
						mov		[edi], al
						inc		esi
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win8bppdr_lp3
						pop		edi
						pop		esi
x1win8bppdr_dned:		add		esi, SCREEN_WIDTH
						dec		edi
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win8bppdr_lp1
						jmp		draw_color_ed

draw_color16:			add		edi, (SCREEN_HEIGHT - 1) * 2
x1win16bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win16bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win16bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win16bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH*2)
						sub		edi, 2
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win16bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdr_lp3:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		ax, word ptr np2_pal16[eax*2 + USE_PALS*2]
						mov		[edi], ax
						inc		esi
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win16bppdr_lp3
						pop		edi
						pop		esi
x1win16bppdr_dned:		add		esi, SCREEN_WIDTH
						sub		edi, 2
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win16bppdr_lp1
						jmp		draw_color_ed

draw_color24:			add		edi, (SCREEN_HEIGHT - 1) * 3
x1win24bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win24bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win24bppdr_lp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win24bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win24bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH*2)
						sub		edi, 3
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win24bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win24bppdr_lp3:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], ax
						shr		eax, 16
						mov		[edi+2], al
						inc		esi
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win24bppdr_lp3
						pop		edi
						pop		esi
x1win24bppdr_dned:		add		esi, SCREEN_WIDTH
						sub		edi, 3
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win24bppdr_lp1
						jmp		draw_color_ed

draw_color32:			add		edi, (SCREEN_HEIGHT - 1) * 4
x1win32bppdr_lp1:		test	renewal_line[ebx], dl
						je		x1win32bppdr_uped
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win32bppdr_lp2
						pop		edi
						pop		esi
						pop		ecx
x1win32bppdr_uped:		add		esi, SCREEN_WIDTH
						add		ecx, (SCREEN_WIDTH*2)
						sub		edi, 4
						inc		ebx
						test	renewal_line[ebx], dl
						je		x1win32bppdr_dned
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdr_lp3:		movzx	eax, byte ptr [esi]
						shr		eax, 4
						mov		eax, dword ptr np2_palette[eax*4 + USE_PALS*4]
						mov		[edi], eax
						inc		esi
						add		edi, destscrn.lPitch
						dec		ebp
						jne		x1win32bppdr_lp3
						pop		edi
						pop		esi
x1win32bppdr_dned:		add		esi, SCREEN_WIDTH
						sub		edi, 4
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win32bppdr_lp1

draw_color_ed:	popad
				ret
		}
}

// ---------------------------------------------------------------------------

void scrn_draws(int redraw) {

	BYTE	bit = 0;

	if (redraw) {
		fillrenewalline(0x80808080);
	}

	if (gdcs.textdisp & 0x80) {
		bit |= 4;
	}
	if (gdcs.grphdisp & 0x80) {
		bit |= (1 << gdcs.disp);
	}

	if (bit) {
		ZeroMemory(&destscrn, sizeof(destscrn));
		destscrn.dwSize = sizeof(destscrn);
		if (pBackSurf->Lock(NULL, &destscrn, DDLOCK_WAIT, NULL) == DD_OK) {
			if ((SCREENMODE & SCMD_FULLSCRN) || (!(setscmd & 0xc0))) {
				if (!(gdc.mode1 & 0x10)) {
					switch(bit & 7) {					// XLbvC
						case 1:
							drawplane1(np2_vram[0], 0x81);
							break;
						case 2:
							drawplane1(np2_vram[1], 0x82);
							break;
						case 4:
							drawplane1(np2_tram, 0x84);
							break;
						case 5:
							drawplanet1(np2_vram[0], 0x85);
							break;
						case 6:
							drawplanet1(np2_vram[1], 0x86);
							break;
					}
				}
				else if (!np2cfg.skipline) {
					switch(bit & 7) {					// XLbvCL
						case 1:
							drawplane1sk(np2_vram[0], 0x81);
							break;
						case 2:
							drawplane1sk(np2_vram[1], 0x82);
							break;
						case 4:
							drawplanetxtsk(np2_tram, 0x84);
							break;
						case 5:
							drawplanet1sk(np2_vram[0], 0x85);
							break;
						case 6:
							drawplanet1sk(np2_vram[1], 0x86);
							break;
					}
				}
				else {
					switch(bit & 7) {					// XLbvCg
						case 1:
							drawplane1ex(np2_vram[0], 0x81);
							break;
						case 2:
							drawplane1ex(np2_vram[1], 0x82);
							break;
						case 4:
							drawplanetxtsk(np2_tram, 0x84);
							break;
						case 5:
							drawplanet1ex(np2_vram[0], 0x85);
							break;
						case 6:
							drawplanet1ex(np2_vram[1], 0x86);
							break;
					}
				}
			}
			else if (setscmd & 0x80) {
				if (!(gdc.mode1 & 0x10)) {
					switch(bit & 7) {
						case 1:
							drawplane1r(np2_vram[0], 0x81);
							break;
						case 2:
							drawplane1r(np2_vram[1], 0x82);
							break;
						case 4:
							drawplane1r(np2_tram, 0x84);
							break;
						case 5:
							drawplanet1r(np2_vram[0], 0x85);
							break;
						case 6:
							drawplanet1r(np2_vram[1], 0x86);
							break;
					}
				}
				else {
					switch(bit & 7) {
						case 1:
							drawplane1rsk(np2_vram[0], 0x81);
							break;
						case 2:
							drawplane1rsk(np2_vram[1], 0x82);
							break;
						case 4:
							drawplanetxtrsk(np2_tram, 0x84);
							break;
						case 5:
							drawplanet1rsk(np2_vram[0], 0x85);
							break;
						case 6:
							drawplanet1rsk(np2_vram[1], 0x86);
							break;
					}
				}
			}
			else {
				if (!(gdc.mode1 & 0x10)) {
					switch(bit & 7) {
						case 1:
							drawplane1l(np2_vram[0], 0x81);
							break;
						case 2:
							drawplane1l(np2_vram[1], 0x82);
							break;
						case 4:
							drawplane1l(np2_tram, 0x84);
							break;
						case 5:
							drawplanet1l(np2_vram[0], 0x85);
							break;
						case 6:
							drawplanet1l(np2_vram[1], 0x86);
							break;
					}
				}
				else {
					switch(bit & 7) {
						case 1:
							drawplane1lsk(np2_vram[0], 0x81);
							break;
						case 2:
							drawplane1lsk(np2_vram[1], 0x82);
							break;
						case 4:
							drawplanetxtlsk(np2_tram, 0x84);
							break;
						case 5:
							drawplanet1lsk(np2_vram[0], 0x85);
							break;
						case 6:
							drawplanet1lsk(np2_vram[1], 0x86);
							break;
					}
				}
			}
			pBackSurf->Unlock(NULL);
		}
	}
	else {
		DDBLTFX		ddbf;
		ZeroMemory(&ddbf, sizeof(ddbf));
		ddbf.dwSize = sizeof(ddbf);
		if (SCREENMODE & SCMD_FULLSCRN) {
			pBackSurf->Blt(&rect200, NULL, NULL, DDBLT_COLORFILL, &ddbf);
		}
		else {
			pBackSurf->Blt(&rectwin, NULL, NULL, DDBLT_COLORFILL, &ddbf);
		}
	}
}



void scrn_drawall(void) {

	POINT	pt;
	RECT	rectDst;

	if (SCREENMODE & SCMD_USEPAL) {
		if (palchanged) {
			palchanged = 0;
			palette_set();
		}
	}
	if (pBackSurf != NULL) {
		if (SCREENMODE & SCMD_FULLSCRN) {
			if (pPrimSurf->BltFast(0, FULLSCREEN_POSY, pBackSurf,
							&rect200, DDBLTFAST_WAIT) == DDERR_SURFACELOST) {
				pPrimSurf->Restore();
				pBackSurf->Restore();
			}
			if (allflash) {
				allflash = 0;
				clearblanklines(0, FULLSCREEN_POSY);
			}
		}
		else {
			pt.x = 0;
			pt.y = 0;
			ClientToScreen(hWndMain, &pt);
			SetRect(&rectDst, pt.x, pt.y, pt.x + rectwin.right,
								pt.y + rectwin.bottom);
			if (pPrimSurf->Blt(&rectDst, pBackSurf, &rectwin,
									DDBLT_WAIT, NULL) == DDERR_SURFACELOST) {
				pPrimSurf->Restore();
				pBackSurf->Restore();
			}
#if 0
			if (allflash) {
				allflash = 0;
//				clearblanklines(pt.x, pt.y);
			}
#endif
		}
	}
}

BYTE scrn_restore(void) {

	if (pBackSurf->IsLost() == DDERR_SURFACELOST) {
		pBackSurf->Restore();
		allflash = 1;
		fillrenewalline(0x80808080);
		return(1);
	}
	return(0);
}

void scrn_palette(void) {

	if (pPalette) {
		pPrimSurf->SetPalette(pPalette);
	}
}


void mx_topwinui(void) {

	mouse_running(MOUSE_STOP);
	if (!(SCREENMODE & SCMD_WINDOWED)) {
#if 1
		pDDraw->FlipToGDISurface();
#endif
		pPrimSurf->SetClipper(pClipper);
	}
}

void mx_clearwinui(void) {

	if (!(SCREENMODE & SCMD_WINDOWED)) {
		pPrimSurf->SetClipper(0);
		clearblankarea();
	}
	mouse_running(MOUSE_CONT);
}


void ddraws_redraw(void) {

	allflash = 1;
	palchanged = 1;
	palettes(1);
	scrn_draws(1);
	scrn_drawall();
}




static RECT rectclk = {0, 0, DCLOCK_X, DCLOCK_Y};

void dispclock(void) {

static DWORD count = 0;
static DWORD count2 = 0;
static BYTE cnt[4];
	DDSURFACEDESC	dest;

	if ((pClockSurf) && (dclock_disp())) {
		dclock_make();
		ZeroMemory(&dest, sizeof(dest));
		dest.dwSize = sizeof(dest);
		if (pClockSurf->Lock(NULL, &dest, DDLOCK_WAIT, NULL) == DD_OK) {
			dclock_out(dest.lpSurface, dest.lPitch);
			pClockSurf->Unlock(NULL);
		}
		if (pPrimSurf->BltFast(640 - DCLOCK_X - 4, 480 - DCLOCK_Y - 8,
				pClockSurf, &rectclk, DDBLTFAST_WAIT) == DDERR_SURFACELOST) {
			pPrimSurf->Restore();
			pClockSurf->Restore();
		}
		dclock_cntdown(np2cfg.DRAW_SKIP);
	}
}
