#include	<windows.h>
#include	<windowsx.h>
#include	<commctrl.h>
#include	"resource.h"
#include	"common.h"
#include	"np2.h"
#include	"dialog.h"
#include	"ini.h"
#include	"dosio.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"midi.h"
#include	"menu.h"
#include	"musicgen.h"
#include	"ddraws.h"
#include	"trace.h"

	int		sound_renewals = 0;

#define	GETCHECK(a,b) ((Button_GetCheck(GetDlgItem(a, b)))?1:0)
#define	AVE(a, b)	((a+b)/2)

static char *basecstr[2] = {"2.4576MHz", "1.9968MHz"};
static char *mulstr[10] = {"1","2","4","5","6","8","10","12","16","20"};
static char notused[] = "gp";
static char other[] = "̑";

// --------------------------------------------------------------------------

static void SetClock(HWND hWnd) {

	DWORD	dval;
	char	work[32];

	Edit_GetText(GetDlgItem(hWnd, IDC_BASECLOCK), work, 32);
	if (work[0] == '1') {
		dval = PCBASECLOCK20 / 100;
	}
	else {
		dval = PCBASECLOCK25 / 100;
	}
	Edit_GetText(GetDlgItem(hWnd, IDC_MULTIPLE), work, 32);
	dval *= (DWORD)ex_a2i(work, 1, 32);
	wsprintf(work, "%2u.%04u", dval / 10000, dval % 10000);
	SetDlgItemText(hWnd, IDC_CLOCKMSG, work);
}


LRESULT CALLBACK CfgDialogProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

#define	WORKSIZE		128

		char	work[WORKSIZE];
		int		i, midimodmax;
		BYTE	bval;
		WORD	wval;
		DWORD	dval;
		char	*p;
static	int		mimpifilechange = 0;
static	char	mimpifile[MAX_PATH];

	switch (msg) {
		case WM_INITDIALOG:
			for (i=0; i<2; i++) {
				SendMessage(GetDlgItem(hWnd, IDC_BASECLOCK),
						CB_INSERTSTRING, (WPARAM)i, (LPARAM)basecstr[i]);
			}
			if (np2cfg.baseclock >= AVE(PCBASECLOCK25, PCBASECLOCK20)) {
				SendMessage(GetDlgItem(hWnd, IDC_BASECLOCK),
								CB_SETCURSEL, (WPARAM)0, (LPARAM)0);
			}
			else {
				SendMessage(GetDlgItem(hWnd, IDC_BASECLOCK),
								CB_SETCURSEL, (WPARAM)1, (LPARAM)0);
			}

			for (i=0; i<10; i++) {
				SendMessage(GetDlgItem(hWnd, IDC_MULTIPLE),
						CB_INSERTSTRING, (WPARAM)i, (LPARAM)mulstr[i]);
			}
			wsprintf(work, "%u", np2cfg.multiple);
			Edit_SetText(GetDlgItem(hWnd, IDC_MULTIPLE), work);

			if (np2cfg.samplingrate < AVE(11025, 22050)) {
				Button_SetCheck(GetDlgItem(hWnd, IDC_RATE11), TRUE);
			}
			else if (np2cfg.samplingrate < AVE(22050, 44100)) {
				Button_SetCheck(GetDlgItem(hWnd, IDC_RATE22), TRUE);
			}
			else {
				Button_SetCheck(GetDlgItem(hWnd, IDC_RATE44), TRUE);
			}

			wsprintf(work, "%u", np2cfg.delayms);
			Edit_SetText(GetDlgItem(hWnd, IDC_SOUNDBUF), work);

			SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE),
					CB_INSERTSTRING, (WPARAM)0, (LPARAM)notused);
			midimodmax = MIDI_modules();
			for (i=0; i<midimodmax; i++) {
				SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE),
					CB_INSERTSTRING, (WPARAM)i+1, 
					(LPARAM)MIDI_num2module(i+1));
			}
			SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE), CB_INSERTSTRING,
									(WPARAM)midimodmax+1, (LPARAM)other);
			Button_SetCheck(GetDlgItem(hWnd, IDC_MIDIRESET), np2cfg.MIDIRESET);
			if (np2cfg.MIDIMODULE <= midimodmax) {
				SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE), CB_SETCURSEL,
									(WPARAM)np2cfg.MIDIMODULE, (LPARAM)0);
			}
			else {
				SendMessage(GetDlgItem(hWnd, IDC_MIDIMODULE), CB_SETCURSEL,
									(WPARAM)(midimodmax+1), (LPARAM)0);
			}
			mimpifilechange = 0;
			strcpy(mimpifile, mimpideffile);
			SetDlgItemText(hWnd, IDC_MIMPIFILENAME, getFileName(mimpifile));
			SetClock(hWnd);
			SetFocus(GetDlgItem(hWnd, IDC_BASECLOCK));
			return(FALSE);

		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					Edit_GetText(GetDlgItem(hWnd, IDC_BASECLOCK),
													work, WORKSIZE);
					if (work[0] == '1') {
						dval = PCBASECLOCK20;
					}
					else {
						dval = PCBASECLOCK25;
					}
					if (dval != np2cfg.baseclock) {
						INIT_RENEWAL np2cfg.baseclock = dval;
					}

					Edit_GetText(GetDlgItem(hWnd, IDC_MULTIPLE),
													work, WORKSIZE);
					if ((dval = (DWORD)ex_a2i(work, 1, 32))
											!= np2cfg.multiple) {
						INIT_RENEWAL np2cfg.multiple = dval;
					}

					if (GETCHECK(hWnd, IDC_RATE11)) {
						wval = 11025;
					}
					else if (GETCHECK(hWnd, IDC_RATE22)) {
						wval = 22050;
					}
					else {
						wval = 44100;
					}
					if (wval != np2cfg.samplingrate) {
						sound_renewals = 1;
						INIT_RENEWAL np2cfg.samplingrate = wval;
					}

					Edit_GetText(GetDlgItem(hWnd, IDC_SOUNDBUF),
													work, WORKSIZE);
					if ((wval = (WORD)ex_a2i(work, 100, 1000))
											!= np2cfg.delayms) {
						sound_renewals = 1;
						INIT_RENEWAL np2cfg.delayms = wval;
					}

					Edit_GetText(GetDlgItem(hWnd, IDC_MIDIMODULE),
													work, WORKSIZE);
					if (!strcmp(work, notused)) {
						bval = MIDINUM_NOTUSED;
					}
					else {
						bval = MIDI_module2num(work);
					}
					if (bval != np2cfg.MIDIMODULE) {
						INIT_RENEWAL np2cfg.MIDIMODULE = bval;
					}

					bval = GETCHECK(hWnd, IDC_MIDIRESET);
					if (bval != np2cfg.MIDIRESET) {
						INIT_RENEWAL np2cfg.MIDIRESET = bval;
					}

					if (mimpifilechange) {
						INIT_RENEWAL;
						strcpy(mimpideffile, mimpifile);
						if (MIDI_SetMimpiMap(mimpifile)) {
							MIDI_EnableMimpiDef(FALSE);
							xmenu_setmimpidef(0x00);
						}
						else {
							xmenu_setmimpidef(0x80);
						}
					}
					EndDialog(hWnd, IDOK);
					break;

				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;

				case IDC_BASECLOCK:
				case IDC_MULTIPLE:
					SetClock(hWnd);
					return(FALSE);

				case IDC_MIMPISELECT:
					p = filenameselect(mimpifile, "MIMPI DEF̧قJ",
									"MIMPI DEF file(*.def)\0*.def\0", "def");
					mimpifilechange = 1;
					if (p) {
						strcpy(mimpifile, p);
						SetDlgItemText(hWnd, IDC_MIMPIFILENAME,
															getFileName(p));
					}
					else {
						strcpy(mimpifile, "");
						SetDlgItemText(hWnd, IDC_MIMPIFILENAME, "");
					}
					return(FALSE);

				default:
					return(FALSE);
			}
			break;

		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
			break;

		default:
			return(FALSE);
	}
	return(TRUE);
}

// --------------------------------------------------------------------------

LRESULT CALLBACK AboutDialogProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

	switch (msg) {
		case WM_INITDIALOG:
//			SetWindowText(hWnd, "About...");
			SetFocus(GetDlgItem(hWnd, IDOK));
			return(FALSE);
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				default:
					return(FALSE);
			}
		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDOK, 0);
			break;
		default:
			return(FALSE);
	}
	return(TRUE);
}

// --------------------------------------------------------------------------

static void set14setstr(HWND hWnd, int stritem, int value) {

	char	work[32];
	wsprintf(work, "%d", value);
	SetDlgItemText(hWnd, stritem, work);
}

static void set14tbminit(HWND hWnd, int tbmitem, int stritem, int item) {

	SendDlgItemMessage(hWnd, tbmitem, TBM_SETRANGE, TRUE, MAKELONG(0, 15));
	SendDlgItemMessage(hWnd, tbmitem, TBM_SETPOS, TRUE,
											np2cfg.vol14[item] & 0x0f);
	set14setstr(hWnd, stritem, np2cfg.vol14[item] & 0x0f);
}

static void set14tbmpos(HWND hWnd, int tbmitem, int stritem) {

	BYTE	ret;

	ret = SendDlgItemMessage(hWnd, tbmitem, TBM_GETPOS, 0, 0) & 0x0f;
	set14setstr(hWnd, stritem, ret);
}

LRESULT CALLBACK Mixer14DlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

	switch (msg) {
		case WM_INITDIALOG:
			set14tbminit(hWnd, IDC_VOLF1, IDC_VOLF1STR, 0);
			set14tbminit(hWnd, IDC_VOLF2, IDC_VOLF2STR, 1);
			set14tbminit(hWnd, IDC_VOLF4, IDC_VOLF4STR, 2);
			set14tbminit(hWnd, IDC_VOLF8, IDC_VOLF8STR, 3);
			set14tbminit(hWnd, IDC_VOLF16, IDC_VOLF16STR, 4);
			SetFocus(GetDlgItem(hWnd, IDC_VOLF1));
			return(FALSE);

		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					INIT_RENEWAL
						np2cfg.vol14[0] = SendDlgItemMessage(hWnd, IDC_VOLF1,
													TBM_GETPOS, 0, 0) & 0x0f;
						np2cfg.vol14[1] = SendDlgItemMessage(hWnd, IDC_VOLF2,
													TBM_GETPOS, 0, 0) & 0x0f;
						np2cfg.vol14[2] = SendDlgItemMessage(hWnd, IDC_VOLF4,
													TBM_GETPOS, 0, 0) & 0x0f;
						np2cfg.vol14[3] = SendDlgItemMessage(hWnd, IDC_VOLF8,
													TBM_GETPOS, 0, 0) & 0x0f;
						np2cfg.vol14[4] = SendDlgItemMessage(hWnd, IDC_VOLF16,
													TBM_GETPOS, 0, 0) & 0x0f;
					musicgen_setvol();
					EndDialog(hWnd, IDOK);
					break;

				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;

				default:
					return(FALSE);
			}
			break;

		case WM_HSCROLL:
			switch(GetDlgCtrlID((HWND)lp)) {
				case IDC_VOLF1:
					set14tbmpos(hWnd, IDC_VOLF1, IDC_VOLF1STR);
					break;
				case IDC_VOLF2:
					set14tbmpos(hWnd, IDC_VOLF2, IDC_VOLF2STR);
					break;
				case IDC_VOLF4:
					set14tbmpos(hWnd, IDC_VOLF4, IDC_VOLF4STR);
					break;
				case IDC_VOLF8:
					set14tbmpos(hWnd, IDC_VOLF8, IDC_VOLF8STR);
					break;
				case IDC_VOLF16:
					set14tbmpos(hWnd, IDC_VOLF16, IDC_VOLF16STR);
					break;
				default:
					return(FALSE);
			}
			break;

		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
			break;

		default:
			return(FALSE);
	}
	return(TRUE);
}

// --------------------------------------------------------------------------

LRESULT CALLBACK ScroptDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

	char	work[32];
	WORD	ret;
	BYTE	b;
	int		renewal;

	switch (msg) {
		case WM_INITDIALOG:
			Button_SetCheck(GetDlgItem(hWnd, IDC_LCD), np2cfg.LCD_MODE & 1);
			Button_Enable(GetDlgItem(hWnd, IDC_LCDX), np2cfg.LCD_MODE & 1);
			Button_SetCheck(GetDlgItem(hWnd, IDC_LCDX), np2cfg.LCD_MODE & 2);

			Button_SetCheck(GetDlgItem(hWnd, IDC_SKIPLINE), np2cfg.skipline);
			SendDlgItemMessage(hWnd, IDC_SKIPLIGHT, TBM_SETRANGE, TRUE,
											MAKELONG(0, 256));
			SendDlgItemMessage(hWnd, IDC_SKIPLIGHT, TBM_SETPOS, TRUE,
											np2cfg.skiplight);
			wsprintf(work, "%d", np2cfg.skiplight);
			SetDlgItemText(hWnd, IDC_LIGHTSTR, work);
			SetFocus(GetDlgItem(hWnd, IDC_LCD));
			return(FALSE);

		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					renewal = 0;
					b = GETCHECK(hWnd, IDC_LCD) |
						(GETCHECK(hWnd, IDC_LCDX) << 1);
					if (np2cfg.LCD_MODE != b) {
						np2cfg.LCD_MODE = b;
						renewal = 1;
					}
					b = GETCHECK(hWnd, IDC_SKIPLINE);
					if (np2cfg.skipline != b) {
						np2cfg.skipline = b;
						renewal = 1;
					}
					if ((ret = (WORD)SendDlgItemMessage(hWnd, IDC_SKIPLIGHT,
												TBM_GETPOS, 0, 0)) > 256) {
						ret = 256;
					}
					if (np2cfg.skiplight != ret) {
						np2cfg.skiplight = ret;
						renewal = 1;
					}
					if (renewal) {
						INIT_RENEWAL;
						ddraws_redraw();
					}
					EndDialog(hWnd, IDOK);
					break;

				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;

				case IDC_LCD:
					Button_Enable(GetDlgItem(hWnd, IDC_LCDX),
											GETCHECK(hWnd, IDC_LCD));
					return(FALSE);

				default:
					return(FALSE);
			}
			break;

		case WM_HSCROLL:
			switch(GetDlgCtrlID((HWND)lp)) {
				case IDC_SKIPLIGHT:
					ret = (WORD)SendDlgItemMessage(hWnd, IDC_SKIPLIGHT,
													TBM_GETPOS, 0, 0);
					wsprintf(work, "%d", ret);
					SetDlgItemText(hWnd, IDC_LIGHTSTR, work);
					break;
				default:
					return(FALSE);
			}
			break;

		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
			break;

		default:
			return(FALSE);
	}
	return(TRUE);
}
