// tbs[fBXN̑}ؗp̃uba

#include	<windows.h>
#include	<windowsx.h>

#include	"resource.h"
#include	"np2.h"
#include	"pc_core.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"dosio.h"
#include	"ini.h"
#include	"menu.h"
#include	"bios.h"
#include	"ddraws.h"
#include	"dsound3.h"
#include	"fdc.h"
#include	"fddfile.h"
#include	"diskdrv.h"

extern	HWND	hWndMain;



typedef struct {
	int		index;
	char	*str;
} FILTER_T;

static	FILTER_T	fdd_filter = {
					3,	"D88 image files (*.D88;*.D98)\0"					\
										"*.d88;*.88d;*.d98;*.98d\0"			\
						"Normal disk images (*.XDF;*.HDM;*.DUP;*.2HD)\0"	\
										"*.xdf;*.hdm;*.dup;*.2hd;*.tfd\0"	\
						"All supported Files\0"								\
										"*.d88;*.88d;*.d98;*.98d;"			\
										"*.xdf;*.hdm;*.dup;*.2hd;*.tfd\0"	\
						"All files (*.*)\0*.*\0\0"};

#if 1
static	FILTER_T	hdd_filter = {
					3,	"T98 harddisk image files (*.THD)\0"				\
										"*.thd\0"							\
						"Anex86 harddisk image files (*.HDI)\0"				\
										"*.hdi\0"							\
						"All supported Files\0"								\
										"*.thd;*.hdi\0\0"};
#else
static	FILTER_T	hdd_filter = {
					3,	"Virtual98 harddisk image files (*.HDD)\0"			\
										"*.hdd\0"							\
						"T98 harddisk image files (*.THD)\0"				\
										"*.thd\0"							\
						"All supported Files\0"								\
										"*.thd;*.hdd\0\0"};
#endif




static LPSTR fileselect(LPSTR defname, LPSTR deffolder, FILTER_T *filter) {

		OPENFILENAME	ofn;
		BOOL			r;
static	char			pathname[MAX_PATH];
static	char			filename[MAX_PATH] = "";

	if ((defname == NULL) || (defname[0] == '\0')) {
		defname = deffolder;
	}
	strcpy(pathname, defname);
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = filter->str;
	ofn.nFilterIndex = filter->index;
	ofn.lpstrFile = pathname;
	ofn.lpstrFileTitle = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST;
	ofn.lpstrDefExt = "d88";
	ofn.lpstrTitle = "ҰނJ";

	DSound_Stop();
	mx_topwinui();
	r = GetOpenFileName(&ofn);
	mx_clearwinui();
	DSound_Play();
	if (!r) {
		return(NULL);
	}

	INIT_RENEWAL
		strcpy(deffolder, pathname);
	return(pathname);
}


void makecaption(BYTE flg, long khz) {

static	char	title[1024] = "";
static	char	clock[64] = "";

	char	work[1024+64+2];

	if (flg & 1) {
		strcpy(title, np2cfg.titles);
		if (fdd_diskready(0)) {
			strcat(title, "  FDD1:");
			strcat(title, getFileName(fdd_diskname(0)));
		}
		if (fdd_diskready(1)) {
			strcat(title, "  FDD2:");
			strcat(title, getFileName(fdd_diskname(1)));
		}
	}
	if (flg & 2) {
		if (khz) {
			wsprintf(clock, " - %2u.%03uMHz", (khz / 1000), (khz % 1000));
		}
		else {
			clock[0] = '\0';
		}
	}
	strcpy(work, title);
	strcat(work, clock);
	SetWindowText(hWndMain, work);
}

// ----------------------------------------------------------------- Hard disk

void diskdrv_changehdd(BYTE drv) {

	LPSTR	p;

	if (drv < 2) {
		p = fileselect(hd_name[drv], hddfolder, &hdd_filter);
		if (p) {
			mx_strncpy(hd_name[drv], p, MAX_PATH);
		}
	}
}

void diskdrv_ejecthdd(BYTE drv) {

	if (drv < 2) {
		INIT_RENEWAL hd_name[drv][0] = '\0';
	}
}

// --------------------------------------------------------------- Floppy disk

#define	DISK_DELAY	30			// (0.6sec)

static	int		diskdrv_delay[4];
static	char	diskdrv_fname[4][MAX_PATH];

void diskdrv_changefdd(BYTE drv) {

	char	*p;

	if (drv < 4) {
		p = fileselect(fdd_diskname(drv), fddfolder, &fdd_filter);
		if (p) {
			diskdrv_ejectfdd(drv);
			diskdrv_delay[drv] = DISK_DELAY;
			strcpy(diskdrv_fname[drv], p);
		}
	}
}

void diskdrv_ejectfdd(BYTE drv) {

	if (drv < 4) {
		fdd_eject(drv);
		diskdrv_delay[drv] = 0;
		diskdrv_fname[drv][0] = '\0';
		fdc.stat[drv] = FDCRLT_IC0 | FDCRLT_IC1 | FDCRLT_NR | drv;
		fdc_interrupt();
	}
	makecaption(1, 0);
}


void diskdrv_callbackfdd(void) {

	BYTE	drv;

	for (drv=0; drv<4; drv++) {
		if (diskdrv_delay[drv]) {
			diskdrv_delay[drv]--;
			if ((!diskdrv_delay[drv]) && (diskdrv_fname[drv][0])) {
				fdd_set(drv, diskdrv_fname[drv]);
				diskdrv_fname[drv][0] = '\0';
				fdc.stat[drv] = FDCRLT_IC0 | FDCRLT_IC1 | drv;
				fdc_interrupt();
				makecaption(1, 0);
			}
		}
	}
}

