#include	<windows.h>
#include	"common.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"gdc_sub.h"
#include	"nevent.h"
#include	"trace.h"

	GDC_TABLE	gdc;
extern BYTE screenupdate;

#ifdef __cplusplus
extern "C" {
#endif
	GDCS_TABLE	gdcs;
#ifdef __cplusplus
}
#endif


void setdegitalpal(int color, BYTE value) {

	int		i;

	for (i=0; i<2; i++, color|=8) {
		gdc.pal[0][color].p.blue = ((value & GDC_DEGBBIT)?0xff:0);
		gdc.pal[0][color].p.red = ((value & GDC_DEGRBIT)?0xff:0);
		gdc.pal[0][color].p.green = ((value & GDC_DEGGBIT)?0xff:0);
	}
}

void gdc_paletteinit(void) {

	BYTE	c;

	for (c=0; c<8; c++) {
		gdc.pal[0][c+0].p.blue = ((c&1)?0xff:0);
		gdc.pal[0][c+8].p.blue = ((c&1)?0xff:0);
		gdc.pal[1][c+0].p.blue = ((c&1)?0xff:0);
		gdc.pal[1][c+8].p.blue = ((c&1)?0x88:0);

		gdc.pal[0][c+0].p.red = ((c&2)?0xff:0);
		gdc.pal[0][c+8].p.red = ((c&2)?0xff:0);
		gdc.pal[1][c+0].p.red = ((c&2)?0xff:0);
		gdc.pal[1][c+8].p.red = ((c&2)?0x88:0);

		gdc.pal[0][c+0].p.green = ((c&4)?0xff:0);
		gdc.pal[0][c+8].p.green = ((c&4)?0xff:0);
		gdc.pal[1][c+0].p.green = ((c&4)?0xff:0);
		gdc.pal[1][c+8].p.green = ((c&4)?0x88:0);
	}
	gdcs.palchange = GDCSCRN_REDRAW;
}

// --------------------------------------------------------------------------

void gdc_init(void) {

	ZeroMemory(&gdc, sizeof(gdc));
	ZeroMemory(&gdcs, sizeof(gdcs));

	gdc.mode1 = 0x98;

	gdc.m.para[GDC_CSRFORM + 0] = 0x0f;
	gdc.m.para[GDC_CSRFORM + 1] = 0xc0;
	gdc.m.para[GDC_CSRFORM + 2] = 0x7b;

	gdc.s.para[GDC_SYNC + 0] = 0x10;
	gdc.s.para[GDC_SYNC + 1] = 0x4e;
	gdc.s.para[GDC_SYNC + 2] = 0x07;
	gdc.s.para[GDC_SYNC + 3] = 0x25;
	gdc.s.para[GDC_SYNC + 4] = 0x07;
	gdc.s.para[GDC_SYNC + 5] = 0x07;
	gdc.s.para[GDC_SYNC + 6] = 0x90;
	gdc.s.para[GDC_SYNC + 7] = 0x65;

	gdc.s.para[GDC_CSRFORM] = 1;
	gdc.s.para[GDC_PITCH] = 40;

	gdc_paletteinit();

	gdcs.textdisp = GDCSCRN_ENABLE | GDCSCRN_ALLDRAW2;
	gdcs.grphdisp = GDCSCRN_ALLDRAW2;
}


I286_OUT gdc_master_w(WORD port, BYTE value) {

	BYTE	bit;

	switch(port & 0x0f) {
		case 0x00:
			if (gdc.m.cnt < GDCCMD_MAX) {
				gdc.m.fifo[gdc.m.cnt++] = value;
			}
			break;

		case 0x02:
			if (gdc.m.cnt < GDCCMD_MAX) {
				gdc.m.fifo[gdc.m.cnt++] = 0x100 | value;
			}
			break;

		case 0x04:
			gdc.vsyncint = 1;
			break;

		case 0x08:
			if (!(value & 0xf0)) {
				bit = 1 << ((value >> 1) & 7);
				if (value & 1) {
					gdc.mode1 |= bit;
				}
				else {
					gdc.mode1 &= ~bit;
				}
				if (bit & (0x01 | 0x04 | 0x10)) {
					gdcs.grphdisp |= GDCSCRN_ALLDRAW2;
				}
				else if (bit == 0x80) {
					if (value & 1) {
						if (!(gdcs.textdisp & GDCSCRN_ENABLE)) {
							gdcs.textdisp |= GDCSCRN_ENABLE | GDCSCRN_ALLDRAW;
							screenupdate |= 2;
						}
					}
					else {
						if (gdcs.textdisp & GDCSCRN_ENABLE) {
							gdcs.textdisp &= ~GDCSCRN_ENABLE;
							screenupdate |= 2;
						}
					}
				}
				gdcs.msw_accessable = gdc.mode1 & 0x40;
			}
			break;

		case 0x0a:
			if (!(value & 0xf8)) {
				bit = 1 << ((value >> 1) & 3);
				if (value & 1) {
					gdc.mode2 |= bit;
				}
				else {
					gdc.mode2 &= ~bit;
				}
				if (bit == 1) {
					gdc.analog = value & 1;
					gdcs.palchange = GDCSCRN_REDRAW;
				}
			}
			break;
	}
}


I286_INB gdc_master_r(WORD port) {

	BYTE	ret;

	switch(port & 0x0f) {
		case 0x00:
			ret = 0x80 | gdc.vsync;
			if (!gdc.vsync) {
				long remain = nevent_getremain(NEVENT_FLAMES);
				if (remain >= 0) {
					remain /= pc.multiple;
					if ((remain % pc.raster) < (pc.hsync)) {
						ret |= 0x40;
					}
				}
			}
			if (gdc.m.snd) {
				ret |= 0x01;
			}
			if (gdc.m.cnt >= GDCCMD_MAX) {
				ret |= 0x02;
			}
			if (!gdc.m.cnt) {
				ret |= 0x04;
			}
			else {
				gdc_work(&gdc.m, &gdcs.textdisp);
			}
			return(ret);

		case 0x02:
			if (gdc.m.snd) {
				gdc.m.snd--;
				return(gdc.m.para[gdc.m.ptr++]);
			}
			break;

		case 0x08:
			return(gdc.mode1);

		case 0x0a:
			return(gdc.mode2);
	}
	return(0xff);
}


I286_OUT gdc_slave_w(WORD port, BYTE value) {

	TRACEOUT(port, value);

	switch(port & 0x0f) {
		case 0x00:
			if (gdc.s.cnt < GDCCMD_MAX) {
				gdc.s.fifo[gdc.s.cnt++] = value;
			}
			break;

		case 0x02:
			if (gdc.s.cnt < GDCCMD_MAX) {
				gdc.s.fifo[gdc.s.cnt++] = 0x100 | value;
			}
			break;

		case 0x04:
			gdcs.disp = value & 1;
			screenupdate |= 2;
			break;

		case 0x06:
			gdcs.access = value & 1;
			break;

		case 0x08:
			if (gdc.analog) {
				gdc.palnum = value & 0x0f;
			}
			else {
				gdcs.palchange = GDCSCRN_REDRAW;
				setdegitalpal(3, value >> 4);
				setdegitalpal(7, value);
			}
			break;

		case 0x0a:
			gdcs.palchange = GDCSCRN_REDRAW;
			if (gdc.analog) {
				gdc.pal[1][gdc.palnum].b[GDC_GREEN] = (value & 0x0f) * 0x11;
			}
			else {
				setdegitalpal(1, value >> 4);
				setdegitalpal(5, value);
			}
			break;

		case 0x0c:
			gdcs.palchange = GDCSCRN_REDRAW;
			if (gdc.analog) {
				gdc.pal[1][gdc.palnum].b[GDC_RED] = (value & 0x0f) * 0x11;
			}
			else {
				setdegitalpal(2, value >> 4);
				setdegitalpal(6, value);
			}
			break;

		case 0x0e:
			gdcs.palchange = GDCSCRN_REDRAW;
			if (gdc.analog) {
				gdc.pal[1][gdc.palnum].b[GDC_BLUE] = (value & 0x0f) * 0x11;
			}
			else {
				setdegitalpal(0, value >> 4);
				setdegitalpal(4, value);
			}
			break;
	}
}


I286_INB gdc_slave_r(WORD port) {

	BYTE	ret;

	TRACEIN(port);

	switch(port & 0x0f) {
		case 0x00:
			ret = 0x80 | gdc.vsync;
			if (!gdc.vsync) {
				long remain = nevent_getremain(NEVENT_FLAMES);
				if (remain >= 0) {
					remain /= pc.multiple;
					if ((remain % pc.raster) < (pc.hsync)) {
						ret |= 0x40;
					}
				}
			}
			if (gdc.s.snd) {
				ret |= 0x01;
			}
			if (gdc.s.cnt >= GDCCMD_MAX) {
				ret |= 0x02;
			}
			if (!gdc.s.cnt) {
				ret |= 0x04;
			}
			else {
				gdc_work(&gdc.s, &gdcs.grphdisp);
			}
			return(ret);

		case 0x02:
			if (gdc.s.snd) {
				gdc.s.snd--;
				return(gdc.s.para[gdc.s.ptr++]);
			}
			break;

		case 0x04:
			return(gdcs.disp);

		case 0x06:
			return(gdcs.access);
	}
	return(0xff);
}

static void vectdraw(void) {

	if (gdc.s.para[GDC_VECTW] & 0x8) {
		gdcsub_line(*(DWORD *)(&gdc.s.para[GDC_CSRW]),
					(VECT_TABLE *)(&gdc.s.para[GDC_VECTW]),
					*(WORD *)(&gdc.s.para[GDC_TEXTW]),
					gdc.s.para[GDC_WRITE]);
	}
	if (gdc.s.para[GDC_VECTW] & 0x20) {
		gdcsub_circle(*(DWORD *)(&gdc.s.para[GDC_CSRW]),
					(VECT_TABLE *)(&gdc.s.para[GDC_VECTW]),
					*(WORD *)(&gdc.s.para[GDC_TEXTW]),
					gdc.s.para[GDC_WRITE]);
	}
	if (gdc.s.para[GDC_VECTW] & 0x40) {
		gdcsub_box(*(DWORD *)(&gdc.s.para[GDC_CSRW]),
					(VECT_TABLE *)(&gdc.s.para[GDC_VECTW]),
					*(WORD *)(&gdc.s.para[GDC_TEXTW]),
					gdc.s.para[GDC_WRITE]);
	}
}


void gdc_work(GDCDATA_TABLE *item, BYTE *dispflag) {

	WORD	i;
	BYTE	data;

	for (i=0; i<item->cnt; i++) {
		data = item->fifo[i] & 0xff;
		if (item->fifo[i] & 0xff00) {
			if ((data & 0x60) == 0x20) {
				item->para[GDC_WRITE] = data;
			}
			switch(data) {
				case CMD_START_:
				case CMD_START:
				case CMD_SYNC_ON:
					(*dispflag) |= GDCSCRN_ENABLE | GDCSCRN_ALLDRAW2;
					break;
				case CMD_STOP:
				case CMD_SYNC_OFF:
					(*dispflag) &= (~GDCSCRN_ENABLE);
					(*dispflag) |= GDCSCRN_ALLDRAW2;
					break;
				case CMD_VECTE:
					if (item == &gdc.s) {
						vectdraw();
					}
					break;
			}
			item->ptr = gdc_cmd[data].pos;
			item->rcv = gdc_cmd[data].outdatas;
			item->snd = gdc_cmd[data].indatas;
			if (item->snd) {
				switch(item->ptr) {
					case GDC_CSRR:
						item->para[GDC_CSRR+0] = item->para[GDC_CSRW+0];
						item->para[GDC_CSRR+1] = item->para[GDC_CSRW+1];
						item->para[GDC_CSRR+2] = item->para[GDC_CSRW+2] & 3;
						item->para[GDC_CSRR+3] = 0;
						item->para[GDC_CSRR+4] = 0;
						break;
				}
			}
		}
		else if (item->rcv) {
			(item->rcv)--;
			item->para[item->ptr] = data;
			(item->ptr)++;
			(*dispflag) |= GDCSCRN_ALLDRAW2;
		}
	}
	item->cnt = 0;
}


// BIOSƂŘMɃZbg
void gdc_reset(GDCDATA_TABLE *item) {

	item->rcv = 0;
	item->snd = 0;
}
