#define	GDCCMD_MAX	32

typedef struct {
	BYTE	para[256];
	WORD	fifo[GDCCMD_MAX];
	WORD	cnt;
	BYTE	ptr;
	BYTE	rcv;
	BYTE	snd;
	BYTE	reserved;
} GDCDATA_TABLE;

typedef union {
	struct {
		BYTE	blue;
		BYTE	green;
		BYTE	red;
		BYTE	flag;
	}	p;
	BYTE	b[4];
	DWORD	d;
} GDC_PALETTE;

typedef struct {
	GDCDATA_TABLE	m;
	GDCDATA_TABLE	s;
	BYTE			mode1;
	BYTE			mode2;
	BYTE			vsync;
	BYTE			vsyncint;
	int				analog;
	int				palnum;
	GDC_PALETTE		pal[2][16];
} GDC_TABLE;

typedef struct {
	BYTE	access;
	BYTE	disp;
	BYTE	textdisp;
	BYTE	msw_accessable;
	BYTE	grphdisp;
	BYTE	palchange;
} GDCS_TABLE;

extern	GDC_TABLE	gdc;

#ifdef __cplusplus
extern "C" {
#endif
extern	GDCS_TABLE	gdcs;
#ifdef __cplusplus
}
#endif

#define	GDC_BLUE		0
#define	GDC_RED			2
#define	GDC_GREEN		1
#define	GDC_DEGBBIT		0x01
#define	GDC_DEGRBIT		0x02
#define	GDC_DEGGBIT		0x04

#define	GDCSCRN_ENABLE		0x80
#define	GDCSCRN_ALLDRAW		0x04
#define	GDCSCRN_REDRAW		0x01
#define	GDCSCRN_ALLDRAW2	0x0c
#define	GDCSCRN_REDRAW2		0x03
#define	GDCSCRN_MAKE		(GDCSCRN_ALLDRAW | GDCSCRN_REDRAW)

void setdegitalpal(int color, BYTE value);

void gdc_init(void);

I286_OUT gdc_master_w(WORD port, BYTE value);
I286_INB gdc_master_r(WORD port);
I286_OUT gdc_slave_w(WORD port, BYTE value);
I286_INB gdc_slave_r(WORD port);

void gdc_work(GDCDATA_TABLE *item, BYTE *dispflag);
void gdc_reset(GDCDATA_TABLE *item);
void gdc_paletteinit(void);
