#define	I286CLOCK(clock)												\
				__asm {	sub		nevent.remainclock, clock			}
#define	I286CLOCKDEC													\
				__asm {	inc		nevent.remainclock					}

#define	FLAG_LOAD														\
				__asm {	mov		ah, I286_FLAGL						}	\
				__asm {	sahf										}

#define	CFLAG_LOAD														\
				__asm {	bt		I286_FLAG, 0						}

#define	FLAG_STORE														\
				__asm {	lahf										}	\
				__asm {	mov		I286_FLAGL, ah						}

#define	FLAG_STORE0														\
				__asm {	lahf										}	\
				__asm {	mov		I286_FLAGL, ah						}	\
				__asm {	and		I286_FLAG, not O_FLAG				}

#define	FLAG_STORE_OF													\
				__asm {	lahf										}	\
				__asm {	mov		I286_FLAGL, ah						}	\
				__asm {	seto	ah									}	\
				__asm {	shl		ah, 3								}	\
				__asm {	and		I286_FLAG, not O_FLAG				}	\
				__asm {	or		I286_FLAGH, ah						}

#define	FLAG_STORE_NC													\
				__asm {	clc											}	\
				__asm {	lahf										}	\
				__asm {	seto	bl									}	\
				__asm {	shl		bl, 3								}	\
				__asm {	and		I286_FLAG, 0f701h					}	\
				__asm {	or		I286_FLAGL, ah						}	\
				__asm {	or		I286_FLAGH, bl						}

#define	FLAG_STORE_OC													\
				__asm {	seto	bh									}	\
				__asm {	setc	bl									}	\
				__asm {	shl		bh, 3								}	\
				__asm {	and		I286_FLAG, not (O_FLAG or C_FLAG)	}	\
				__asm {	or		I286_FLAG, bx						}

#define	GET_PCBYTE														\
				__asm {	lea		ecx, [ebp + esi]					}	\
				__asm {	inc		si									}	\
				__asm {	call	i286_memoryread						}

#define	GET_PCWORD														\
				__asm {	lea		ecx, [ebp + esi]					}	\
				__asm {	add		si, 2								}	\
				__asm {	call	i286_memoryread_w					}	\

#define	REGPUSH1(reg)													\
				__asm {	mov		dx, reg								}	\
				__asm {	sub		I286_SP, 2							}	\
				__asm {	movzx	ecx, I286_SP						}	\
				__asm {	add		ecx, SS_BASE						}	\
				__asm {	jmp		i286_memorywrite_w					}

#define	REGPOP(reg)														\
				__asm {	movzx	ecx, I286_SP						}	\
				__asm {	add		ecx, SS_BASE						}	\
				__asm {	call	i286_memoryread_w					}	\
				__asm {	mov		reg, ax								}	\
				__asm {	add		I286_SP, 2							}

#define	LOAD_I286FLAG(reg)												\
				__asm {	mov		reg, I286_FLAG						}	\
				__asm {	and		reg, not I_FLAG						}	\
				__asm {	or		reg, I286_IFLAG						}

#define INT_NUM(vect)													\
				__asm {	mov		edi, SS_BASE						}	\
				__asm {	movzx	ebx, I286_SP						}	\
				__asm {	sub		bx, 2								}	\
				__asm {	lea		ecx, [edi + ebx]					}	\
				LOAD_I286FLAG(dx)										\
				__asm {	mov		I286_IFLAG, 0						}	\
				__asm { call	i286_memorywrite_w					}	\
				__asm {	sub		bx, 2								}	\
				__asm {	lea		ecx, [edi + ebx]					}	\
				__asm {	mov		dx, I286_CS							}	\
				__asm {	call	i286_memorywrite_w					}	\
				__asm {	sub		bx, 2								}	\
				__asm {	mov		I286_SP, bx							}	\
				__asm {	lea		ecx, [edi + ebx]					}	\
				__asm {	mov		dx, si								}	\
				__asm {	mov		eax, dword ptr I286_MEM[vect*4]		}	\
				__asm {	mov		si, ax								}	\
				__asm {	shr		eax, 16								}	\
				__asm {	mov		I286_CS, ax							}	\
				__asm {	shl		eax, 4								}	\
				__asm {	mov		CS_BASE, eax						}	\
				__asm {	mov		ebp, eax							}	\
				__asm {	jmp		i286_memorywrite_w					}

#define V30INT_NUM(vect)												\
				__asm {	mov		edi, SS_BASE						}	\
				__asm {	movzx	ebx, I286_SP						}	\
				__asm {	sub		bx, 2								}	\
				__asm {	lea		ecx, [edi + ebx]					}	\
				LOAD_I286FLAG(dx)										\
				__asm {	or		dh, 0f0h							}	\
				__asm {	mov		I286_IFLAG, 0						}	\
				__asm { call	i286_memorywrite_w					}	\
				__asm {	sub		bx, 2								}	\
				__asm {	lea		ecx, [edi + ebx]					}	\
				__asm {	mov		dx, I286_CS							}	\
				__asm {	call	i286_memorywrite_w					}	\
				__asm {	sub		bx, 2								}	\
				__asm {	mov		I286_SP, bx							}	\
				__asm {	lea		ecx, [edi + ebx]					}	\
				__asm {	mov		dx, si								}	\
				__asm {	mov		eax, dword ptr I286_MEM[vect*4]		}	\
				__asm {	mov		si, ax								}	\
				__asm {	shr		eax, 16								}	\
				__asm {	mov		I286_CS, ax							}	\
				__asm {	shl		eax, 4								}	\
				__asm {	mov		CS_BASE, eax						}	\
				__asm {	mov		ebp, eax							}	\
				__asm {	jmp		i286_memorywrite_w					}

#define	STRING_DIR														\
				__asm {	xor		ax, ax								}	\
				__asm {	test	I286_FLAG, D_FLAG					}	\
				__asm {	setz	al									}	\
				__asm {	add		al, al								}	\
				__asm {	dec		ax									}

#define	STRING_DIRx2													\
				__asm {	xor		ax, ax								}	\
				__asm {	test	I286_FLAG, D_FLAG					}	\
				__asm {	setz	al									}	\
				__asm {	shl		ax, 2								}	\
				__asm {	sub		ax, 2								}
