#include	<windows.h>
#include	"common.h"
#include	"nevent.h"
#include	"i286.h"
#include	"i286cts.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"i286.mcr"
#include	"i286ea.mcr"

	DTR_TABLE	GDTR;
	DTR_TABLE	IDTR;
	WORD		MSW;


I286 _sgdt(void) {

		__asm {
				cmp		al, 0c0h
				jnc		register_eareg16
				I286CLOCK(11)
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				lea		ecx, [edi + ebx]
				mov		dx, word ptr GDTR
				call	i286_memorywrite_w
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, word ptr (GDTR+2)
				call	i286_memorywrite_w
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, word ptr (GDTR+4)
				jmp		i286_memorywrite_w
		register_eareg16:
				INT_NUM(6)
		}
}


I286 _sidt(void) {

		__asm {
				cmp		al, 0c0h
				jnc		register_eareg16
				I286CLOCK(12)
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				lea		ecx, [edi + ebx]
				mov		dx, word ptr IDTR
				call	i286_memorywrite_w
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, word ptr (IDTR+2)
				call	i286_memorywrite_w
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, word ptr (IDTR+4)
				jmp		i286_memorywrite_w
		register_eareg16:
				INT_NUM(6)
		}
}


I286 _lgdt(void) {

		__asm {
				cmp		al, 0c0h
				jnc		register_eareg16
				I286CLOCK(11)
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		word ptr GDTR, ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		word ptr (GDTR+2), ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		word ptr (GDTR+4), ax
				ret
		register_eareg16:
				INT_NUM(6)
		}
}


I286 _lidt(void) {

		__asm {
				cmp		al, 0c0h
				jnc		register_eareg16
				I286CLOCK(12)
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		word ptr IDTR, ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		word ptr (IDTR+2), ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		word ptr (IDTR+4), ax
				ret
		register_eareg16:
				INT_NUM(6)
		}
}


I286 _smsw(void) {

		__asm {
				PREPART_EA16(3)
					mov		dx, MSW
					mov		word ptr I286_REG[eax*2], dx
					ret
				MEMORY_EA16(6)
					mov		ax, MSW
					mov		word ptr I286_MEM[ecx], ax
					ret
				extmem_eareg16:
					mov		dx, MSW
					jmp		i286_memorywrite_w
		}
}


I286 _lmsw(void) {

		__asm {
				PREPART_EA16(2)
					mov		ax, word ptr I286_REG[eax*2]
					and		ax, 0ch
					mov		MSW, ax
					ret
				MEMORY_EA16(3)
					mov		ax, word ptr I286_MEM[ecx]
					and		ax, 0ch
					mov		MSW, ax
					ret
				EXTMEM_EA16
					and		ax, 0ch
					mov		MSW, ax
					ret
		}
}


void (*cts1_table[])(void) = {
			_sgdt,				_sidt,
			_lgdt,				_lidt,
			_smsw,				_smsw,
			_lmsw,				_lmsw};


I286EXT _cts(void) {

		__asm {
				GET_PCBYTE
				cmp		al, 0
				je		realmodeint6rm
				dec		al
				je		i286_cts1
				sub		al, 2
				jnc		realmodeint6
realmodeint6rm:	GET_PCBYTE
				cmp		al, 0c0h
				jnc		realmodeint6
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
realmodeint6:	I286CLOCK(20)
				INT_NUM(6)

i286_cts1:		GET_PCBYTE
				mov		edi, eax
				shr		edi, 1
				and		edi, 7*4
				jmp		cts1_table[edi]
		}
}

