#include	<windows.h>
#include	<windowsx.h>
#include	<io.h>

#include	"np2.h"
#include	"iobridge.h"
#include	"dosio.h"
#include	"bios.h"
#include	"pc_core.h"
#include	"midi.h"
#include	"milstr.h"

#define		CFGLEN		(MAX_PATH + 32)

		BYTE	init_flag = 0;

		char	ini_title[]		= "NekoProjectII";

static	char	cfgWINPOSX[]	= "WindposX";
static	char	cfgWINPOSY[]	= "WindposY";
static	char	cfgFDDDIR[]		= "FDfolder";
static	char	cfgHDDDIR[]		= "HDfolder";
static	char	cfgBMPDIR[]		= "bmap_Dir";
static	char	cfgCLOCKBASE[]	= "clk_base";
static	char	cfgCLOCKMUL[]	= "clk_mult";
static	char	cfgDIPSWITCH[]	= "DIPswtch";
static	char	cfgMEMSWITCH[]	= "MEMswtch";
static	char	cfgBOARD14V[]	= "SND14VOL";
static	char	cfgSNDBOARD[]	= "SNDboard";
static	char	cfgBEEP_VOL[]	= "BEEP_vol";
static	char	cfgSAMPLINGRT[]	= "SampleHz";
static	char	cfgDELAY[]		= "Latencys";
static	char	cfgMSRAPID[]	= "MS_RAPID";
static	char	cfgBTNRAPID[]	= "btnRAPID";
static	char	cfgBTNMODE[]	= "btn_MODE";
static	char	cfgNOWAIT[]		= "s_NOWAIT";
static	char	cfgFRAMES[]		= "SkpFrame";
static	char	cfgDISPSYNC[]	= "DispSync";
static	char	cfgJOYSTICK[]	= "Joystick";
static	char	cfgMOUSE[]		= "Mouse_sw";
static	char	cfgDISPCLK[]	= "DspClock";
static	char	cfgWINSNAP[]	= "Win_Snap";
static	char	cfgMIDIMOD[]	= "MIDI_mod";
static	char	cfgMIDIRST[]	= "MIDI_rst";
static	char	cfgMIMPIDEF[]	= "MIMPIdef";
static	char	cfgSEEKSND[]	= "Seek_Snd";
static	char	cfgSEEKVOL[]	= "Seek_Vol";

static	char	cfgITF[]		= "ITF_WORK";

static	char	cfgHDDFILE[]	= "HDD%1dFILE";
static	char	cfgREMOVABLE[]	= "Removabl";

static	char	cfgLCDMODE[]	= "LCD_MODE";
static	char	cfgLCDBG[]		= "BG_COLOR";
static	char	cfgLCDFG[]		= "FG_COLOR";

static	char	cfgSKIPLINE[]	= "skipline";
static	char	cfgSKIPLIGHT[]	= "skplight";

static	char	cfgKEYBOARD[]	= "keyboard";
static	char	cfgF12COPY[]	= "F12_COPY";

static	char	cfgCLOCKX[]		= "clocknow";
static	char	cfgCLOCKFNT[]	= "clockfnt";
static	char	cfgCLOCKCL1[]	= "clock_up";
static	char	cfgCLOCKCL2[]	= "clock_dn";

static	char	cfgTITLE[]		= "np2title";
static	char	cfgWINID[]		= "np2winid";


extern	int		winx;
extern	int		winy;
		char	fddfolder[MAX_PATH] = "";
		char	hddfolder[MAX_PATH] = "";
		char	bmpfilefolder[MAX_PATH] = "";
		char	mimpideffile[MAX_PATH] = "";

static char *makeHEX(long para, BYTE length) {

static	char	hexstrtmp[9];
		char	*p;
		char	c;

	if (length >= 8) {
		length = 8;
	}
	p = hexstrtmp + length;
	*p = '\0';
	while(length--) {
		p--;
		c = (char)(para & 0x0f);
		if (c < 10) {
			*p = c + '0';
		}
		else {
			*p = c + '7';			//	'7' = 'A' - 10;
		}
		para >>= 4;
	}
	return(p);
}


static long solveHEX(char *str) {

	long	ret;
	int		i;
	char	c;

	ret = 0;
	for (i=0; i<8; i++) {
		c = *str++;
		if ((c >= '0') && (c <= '9')) {
			c -= '0';
		}
		else if ((c >= 'A') && (c <= 'F')) {
			c -= '7';
		}
		else if ((c >= 'a') && (c <= 'f')) {
			c -= 'W';
		}
		else {
			break;
		}
		ret <<= 4;
		ret += (long)c;
	}
	return(ret);
}


static char *makeBOOL(BYTE value) {

	if (value) {
		return("true");
	}
	return("false");
}


BYTE solveBOOL(LPSTR str) {

	if ((!Aacmp(str, "TRUE")) || (!Aacmp(str, "ON")) ||
		(!Aacmp(str, "+")) || (!Aacmp(str, "1")) ||
		(!Aacmp(str, "ENABLE"))) {
		return(1);
	}
	return(0);
}


void initload(void) {

	char	initfile[MAX_PATH + 5];
	char	cfgstr[CFGLEN];
	int		i;
	char	*arg[8];
	int		args;

	init_flag = 0;

	strcpy(initfile, __argv[0]);
	cutExtName(initfile);
	strcat(initfile, ".ini");

	GetPrivateProfileString(ini_title, cfgTITLE, np2cfg.titles,
							np2cfg.titles, sizeof(np2cfg.titles), initfile);
	GetPrivateProfileString(ini_title, cfgWINID, "NP2",
										cfgstr, CFGLEN, initfile);
	for (i=0; i<3; i++) {
		if (((cfgstr[i] >= '0') && (cfgstr[i] < '9')) ||
			((cfgstr[i] >= 'A') && (cfgstr[i] < 'Z')) ||
			((cfgstr[i] >= 'a') && (cfgstr[i] < 'z'))) {
				np2cfg.winid[i] = cfgstr[i];
		}
	}

	winx = GetPrivateProfileInt(ini_title, cfgWINPOSX,
										CW_USEDEFAULT, initfile);
	winy = GetPrivateProfileInt(ini_title, cfgWINPOSY,
										CW_USEDEFAULT, initfile);

	// 00/06/25
	GetPrivateProfileString(ini_title, cfgKEYBOARD, "",
										cfgstr, CFGLEN, initfile);
	if ((!milstr_extendcmp(cfgstr, "PC98")) ||
		(!milstr_cmpA(cfgstr, "98"))) {
		np2cfg.KEYBOARD = 1;
	}
	else if ((!milstr_extendcmp(cfgstr, "DOS")) ||
		(!milstr_cmpA(cfgstr, "PCAT")) ||
		(!milstr_cmpA(cfgstr, "AT"))) {
		np2cfg.KEYBOARD = 0;
	}

	GetPrivateProfileString(ini_title, cfgFDDDIR, "",
							fddfolder, MAX_PATH, initfile);
	GetPrivateProfileString(ini_title, cfgHDDDIR, "",
							hddfolder, MAX_PATH, initfile);
	GetPrivateProfileString(ini_title, cfgBMPDIR, "",
							bmpfilefolder, MAX_PATH, initfile);
	GetPrivateProfileString(ini_title, cfgMIMPIDEF, "",
							mimpideffile, MAX_PATH, initfile);

	for (i=0; i<2; i++) {
		wsprintf(cfgstr, cfgHDDFILE, i+1);
		GetPrivateProfileString(ini_title, cfgstr, "",
							hd_name[i], MAX_PATH, initfile);
	}
	np2cfg.REMOVEHD = (BYTE)((GetPrivateProfileInt(ini_title,
										cfgREMOVABLE, 1, initfile) - 1) & 1);

	np2cfg.baseclock = (DWORD)GetPrivateProfileInt(
						ini_title, cfgCLOCKBASE, PCBASECLOCK25, initfile);
	np2cfg.multiple = (DWORD)GetPrivateProfileInt(
								ini_title, cfgCLOCKMUL, 2, initfile);

	GetPrivateProfileString(ini_title, cfgDIPSWITCH, "",
										cfgstr, CFGLEN, initfile);
	args = milstr_getarg(cfgstr, arg, 3);
	if (args == 3) {
		for (i=0; i<args; i++) {
			np2cfg.dipsw[i] = (BYTE)solveHEX(arg[i]);
		}
	}
	GetPrivateProfileString(ini_title, cfgMEMSWITCH, "",
										cfgstr, CFGLEN, initfile);
	args = milstr_getarg(cfgstr, arg, 8);
	if (args == 8) {
		for (i=0; i<args; i++) {
			np2cfg.memsw[i] = (BYTE)solveHEX(arg[i]);
		}
	}

	GetPrivateProfileString(ini_title, cfgBOARD14V, "",
										cfgstr, CFGLEN, initfile);
	args = milstr_getarg(cfgstr, arg, 5);
	if (args == 5) {
		for (i=0; i<args; i++) {
			np2cfg.vol14[i] = (BYTE)(solveHEX(arg[i]) & 0x0f);
		}
	}

	np2cfg.SOUND_SW = (BYTE)(GetPrivateProfileInt(ini_title, cfgSNDBOARD,
														4, initfile) & 0x0f);
	np2cfg.BEEP_VOL = (BYTE)(GetPrivateProfileInt(ini_title, cfgBEEP_VOL,
														3, initfile) & 3);

	np2cfg.samplingrate = (WORD)GetPrivateProfileInt(
								ini_title, cfgSAMPLINGRT, 22050, initfile);
	np2cfg.delayms = (WORD)GetPrivateProfileInt(
								ini_title, cfgDELAY, 1000, initfile);

	GetPrivateProfileString(ini_title, cfgBTNRAPID, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.BTN_RAPID = solveBOOL(cfgstr);
	GetPrivateProfileString(ini_title, cfgBTNMODE, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.BTN_MODE = solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgMSRAPID, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.MOUSERAPID = solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgNOWAIT, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.NOWAIT = solveBOOL(cfgstr);
	np2cfg.DRAW_SKIP = (BYTE)GetPrivateProfileInt(ini_title, cfgFRAMES,
															1, initfile);
	GetPrivateProfileString(ini_title, cfgDISPSYNC, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.DISPSYNC = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgSEEKSND, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.MOTOR = solveBOOL(cfgstr);
	if ((np2cfg.MOTORVOL = (BYTE)GetPrivateProfileInt(ini_title, cfgSEEKVOL,
												80, initfile)) > 100) {
		np2cfg.MOTORVOL = 100;
	}

	GetPrivateProfileString(ini_title, cfgJOYSTICK, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.JOYSTICK = (BYTE)solveBOOL(cfgstr);
	GetPrivateProfileString(ini_title, cfgMOUSE, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.MOUSE_SW = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgWINSNAP, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.WINSNAP = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgDISPCLK, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.DISPCLK = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgMIDIMOD, "",
										cfgstr, CFGLEN, initfile);
	np2cfg.MIDIMODULE = MIDI_module2num(cfgstr);
	GetPrivateProfileString(ini_title, cfgMIDIRST, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.MIDIRESET = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, "I286SAVE", "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.I286SAVE = (BYTE)solveBOOL(cfgstr);

	GetPrivateProfileString(ini_title, cfgITF, "1",
										cfgstr, CFGLEN, initfile);
	np2cfg.ITF_WORK = (BYTE)solveBOOL(cfgstr);

	np2cfg.LCD_MODE = (BYTE)GetPrivateProfileInt(ini_title, cfgLCDMODE,
														0, initfile) & 3;
	GetPrivateProfileString(ini_title, cfgLCDBG, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.BG_COLOR = solveHEX(cfgstr) & 0xffffff;
	GetPrivateProfileString(ini_title, cfgLCDFG, "ffffff",
										cfgstr, CFGLEN, initfile);
	np2cfg.FG_COLOR = solveHEX(cfgstr) & 0xffffff;

	GetPrivateProfileString(ini_title, cfgSKIPLINE, "0",
										cfgstr, CFGLEN, initfile);
	np2cfg.skipline = (BYTE)solveBOOL(cfgstr);
	np2cfg.skiplight = (WORD)GetPrivateProfileInt(ini_title, cfgSKIPLIGHT,
														0x40, initfile);

	np2cfg.clockx = (BYTE)GetPrivateProfileInt(ini_title, cfgCLOCKX,
															0, initfile);
	np2cfg.clockfnt = (BYTE)GetPrivateProfileInt(ini_title, cfgCLOCKFNT,
															0, initfile);
	GetPrivateProfileString(ini_title, cfgCLOCKCL1, "ffffff",
										cfgstr, CFGLEN, initfile);
	np2cfg.clockcolor1 = solveHEX(cfgstr) & 0xffffff;
	GetPrivateProfileString(ini_title, cfgCLOCKCL2, "6abfff",
										cfgstr, CFGLEN, initfile);
	np2cfg.clockcolor2 = solveHEX(cfgstr) & 0xffffff;

	np2cfg.F12COPY = (BYTE)GetPrivateProfileInt(ini_title, cfgF12COPY,
															0, initfile);
}


void initsave(void) {

	char	initfile[MAX_PATH + 5];
	char	cfgstr[CFGLEN];
	int		i;

	if (!init_flag) {
		return;
	}

	strcpy(initfile, __argv[0]);
	cutExtName(initfile);
	strcat(initfile, ".ini");

	wsprintf(cfgstr, "%d", winx);
	WritePrivateProfileString(ini_title, cfgWINPOSX, cfgstr, initfile);
	wsprintf(cfgstr, "%d", winy);
	WritePrivateProfileString(ini_title, cfgWINPOSY, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgFDDDIR,
										fddfolder, initfile);
	WritePrivateProfileString(ini_title, cfgHDDDIR,
										hddfolder, initfile);
	WritePrivateProfileString(ini_title, cfgBMPDIR,
										bmpfilefolder, initfile);
	WritePrivateProfileString(ini_title, cfgMIMPIDEF,
										mimpideffile, initfile);

	for (i=0; i<2; i++) {
		wsprintf(cfgstr, cfgHDDFILE, i+1);
		WritePrivateProfileString(ini_title, cfgstr,
										hd_name[i], initfile);
	}
	wsprintf(cfgstr, "%u", np2cfg.REMOVEHD + 1);
	WritePrivateProfileString(ini_title, cfgREMOVABLE, cfgstr, initfile);

	wsprintf(cfgstr, "%u", np2cfg.baseclock);
	WritePrivateProfileString(ini_title, cfgCLOCKBASE, cfgstr, initfile);
	wsprintf(cfgstr, "%u", np2cfg.multiple);
	WritePrivateProfileString(ini_title, cfgCLOCKMUL, cfgstr, initfile);

	for (i=0; i<3; i++) {
		wsprintf(&cfgstr[i*3], "%02x ", np2cfg.dipsw[i]);
	}
	cfgstr[3*3-1] = '\0';
	WritePrivateProfileString(ini_title, cfgDIPSWITCH, cfgstr, initfile);
	for (i=0; i<8; i++) {
		wsprintf(&cfgstr[i*3], "%02x ", np2cfg.memsw[i]);
	}
	cfgstr[8*3-1] = '\0';
	WritePrivateProfileString(ini_title, cfgMEMSWITCH, cfgstr, initfile);
	for (i=0; i<5; i++) {
		wsprintf(&cfgstr[i*3], "%02x ", np2cfg.vol14[i] & 0x0f);
	}
	cfgstr[5*3-1] = '\0';
	WritePrivateProfileString(ini_title, cfgBOARD14V, cfgstr, initfile);

	wsprintf(cfgstr, "%u", np2cfg.SOUND_SW & 0x0f);
	WritePrivateProfileString(ini_title, cfgSNDBOARD, cfgstr, initfile);
	wsprintf(cfgstr, "%u", np2cfg.BEEP_VOL & 3);
	WritePrivateProfileString(ini_title, cfgBEEP_VOL, cfgstr, initfile);

	wsprintf(cfgstr, "%u", np2cfg.samplingrate);
	WritePrivateProfileString(ini_title, cfgSAMPLINGRT, cfgstr, initfile);
	wsprintf(cfgstr, "%u", np2cfg.delayms);
	WritePrivateProfileString(ini_title, cfgDELAY, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgBTNRAPID,
									makeBOOL(np2cfg.BTN_RAPID), initfile);
	WritePrivateProfileString(ini_title, cfgBTNMODE,
									makeBOOL(np2cfg.BTN_MODE), initfile);

	WritePrivateProfileString(ini_title, cfgMSRAPID,
									makeBOOL(np2cfg.MOUSERAPID), initfile);

	WritePrivateProfileString(ini_title, cfgNOWAIT,
									makeBOOL(np2cfg.NOWAIT), initfile);
	wsprintf(cfgstr, "%u", np2cfg.DRAW_SKIP);
	WritePrivateProfileString(ini_title, cfgFRAMES, cfgstr, initfile);
	WritePrivateProfileString(ini_title, cfgDISPSYNC,
									makeBOOL(np2cfg.DISPSYNC & 1), initfile);

	WritePrivateProfileString(ini_title, cfgJOYSTICK,
									makeBOOL(np2cfg.JOYSTICK & 1), initfile);
	WritePrivateProfileString(ini_title, cfgMOUSE,
									makeBOOL(np2cfg.MOUSE_SW & 1), initfile);

	WritePrivateProfileString(ini_title, cfgSEEKSND,
									makeBOOL(np2cfg.MOTOR), initfile);
	wsprintf(cfgstr, "%u", np2cfg.MOTORVOL);
	WritePrivateProfileString(ini_title, cfgSEEKVOL, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgDISPCLK,
									makeBOOL(np2cfg.DISPCLK & 1), initfile);

	WritePrivateProfileString(ini_title, cfgMIDIMOD,
							MIDI_num2module(np2cfg.MIDIMODULE), initfile);
	WritePrivateProfileString(ini_title, cfgMIDIRST,
									makeBOOL(np2cfg.MIDIRESET & 1), initfile);

	wsprintf(cfgstr, "%u", np2cfg.LCD_MODE);
	WritePrivateProfileString(ini_title, cfgLCDMODE, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgSKIPLINE,
									makeBOOL(np2cfg.skipline & 1), initfile);
	wsprintf(cfgstr, "%u", np2cfg.skiplight);
	WritePrivateProfileString(ini_title, cfgSKIPLIGHT, cfgstr, initfile);

	wsprintf(cfgstr, "%u", np2cfg.clockx);
	WritePrivateProfileString(ini_title, cfgCLOCKX, cfgstr, initfile);
	wsprintf(cfgstr, "%u", np2cfg.clockfnt);
	WritePrivateProfileString(ini_title, cfgCLOCKFNT, cfgstr, initfile);

	WritePrivateProfileString(ini_title, cfgWINSNAP,
									makeBOOL(np2cfg.WINSNAP & 1), initfile);

	wsprintf(cfgstr, "%d", np2cfg.F12COPY);
	WritePrivateProfileString(ini_title, cfgF12COPY, cfgstr, initfile);
}

