#include	<windows.h>
#include	"common.h"
#include	"i286.h"
#include	"iobridge.h"
#include	"itimer.h"
#include	"fmboard.h"
#include	"pic.h"
#include	"cgrom.h"
#include	"crtc.h"
#include	"emm.h"
#include	"keyboard.h"
#include	"gdc.h"
#include	"mouseif.h"
#include	"nevent.h"
#include	"sysport.h"
#include	"trace.h"
#include	"midi.h"
#include	"printif.h"
#include	"dipsw.h"
#include	"fdc.h"
#include	"dmac.h"
#include	"fdd_2d.h"

extern I286_OUT itf_ctrl(WORD port, BYTE value);
extern I286_OUT np2_sys_w(WORD port, BYTE value);
extern I286_INB np2_sys_r(WORD port);

// uba
BYTE __fastcall i286_in(WORD port) {

	if ((port & 0xfff1) == 0xa460) {				// PC-9801-86
		return(soundboard.pcm_r(port));
	}
	else if ((port & 0x0ef9) == 0x0088) {
		return(soundboard.fm_r(port));
	}
	else if (((port & 0xfffb) == 0x3fdb) ||			// PD8253-5
			((port & 0x0cf1) == 0x0071)) {
		return(itimer_r(port));
	}
	else if ((port & 0x0cf1) == 0x0000) {			// PD71059C
		return(pic_r(port));
	}
	else if ((port & 0x0cf1) == 0x00a1) {			// CG-ROM
		return(cgrom_r(port));
	}
	else if ((port & 0x0cf1) == 0x0070) {			// PD7220A
		return(crtc_r(port));
	}
	else if ((port & 0x0cf1) == 0x00a0) {
		return(gdc_slave_r(port));
	}
	else if ((port & 0x0cf1) == 0x0060) {
		return(gdc_master_r(port));
	}
	else if ((port & 0x0cf9) == 0x0031) {
		return(systemport_r(port));
	}
	else if ((port & 0x0cf9) == 0x0040) {
		return(printif_r(port));
	}
	else if ((port & 0x0cfd) == 0x0041) {			// PD8251A
		return(keyboard_r(port));
	}
	else if ((port & 0xfff9) == 0x7fd9) {			// 8255A
		return(mouseif_r(port));
	}
	else if ((port & 0xfff1) == 0xe0d0) {			// MPU-98II
		return(mpu98ii_r(port));
	}
	else if ((port & 0xfff1) == 0x08e1) {			// EMM
		return(emm_r(port));
	}
	else if ((port & 0xf0ff) == 0x801e) {
		return(dipsw_r(port));
	}
	else if ((port & 0xfff1) == 0x0090) {
		return(fdc_r(port));
	}
	else if ((port & 0xfff9) == 0x00C8) {
		return(fdc2dd_r(port));
	}
	else if ((port & 0x0ce1) == 0x0001) {
		return(dmac_r(port));
	}
	else if ((port & 0x0cf1) == 0x0021) {
		return(dmabank_r(port));
	}
	else if ((port & 0x00f9) == 0x51) {
		return(fdd320_r(port));
	}
	else if ((port & 0x0fff) == 0x7ef) {
		return(np2_sys_r(port));
	}
	else if ((port & 0xfff0) == cs4231.port) {
		return(cs4231_r(port));
	}
	else if ((port & 0xfff1) == 0x0c20) {
		return(cs4231p_r(port));
	}
	TRACEIN(port);
	return(0xff);
}

WORD __fastcall i286_in_w(WORD port) {

	return(0xff00 | i286_in(port));
}

void __fastcall i286_out(WORD port, BYTE value) {

	if ((port & 0xfff1) == 0xa460) {				// PC-9801-86
		soundboard.pcm_w(port, value);
	}
	else if ((port & 0x0ef9) == 0x0088) {
		soundboard.fm_w(port, value);
	}
	else if (port == 0x5f) {						// wait port
		nevent.remainclock -= 20;
	}
	else if (((port & 0xfffb) == 0x3fdb) ||			// PD8253-5
			((port & 0x0cf1) == 0x0071)) {
		itimer_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0000) {			// PD71059C
		pic_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x00a1) {			// CG-ROM
		cgrom_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0070) {			// PD7220A
		crtc_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x00a0) {
		gdc_slave_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0060) {
		gdc_master_w(port, value);
	}
	else if ((port & 0x0cf9) == 0x0031) {
		systemport_w(port, value);
	}
	else if ((port & 0x0cf9) == 0x0040) {
		printif_w(port, value);
	}
	else if ((port & 0x0cfd) == 0x0041) {			// PD8251A
		keyboard_w(port, value);
	}
	else if ((port & 0xfff9) == 0x7fd9) {			// 8255A
		mouseif_w(port, value);
	}
	else if (port == 0xbfdb) {
		mousetiming_w(port, value);
	}
	else if ((port & 0xfffd) == 0xe0d0) {			// MPU-98II
		mpu98ii_w(port, value);
	}
	else if ((port & 0xfff1) == 0x08e1) {			// EMM
		emm_w(port, value);
	}
	else if ((port & 0xf0ff) == 0x801e) {
		dipsw_w(port, value);
	}
	else if ((port & 0xfff1) == 0x0090) {
		fdc_w(port, value);
	}
	else if ((port & 0xfff9) == 0x00c8) {
		fdc2dd_w(port, value);
	}
	else if ((port & 0x0ce1) == 0x0001) {
		dmac_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0021) {
		dmabank_w(port, value);
	}
	else if (port == 0x043d) {
		itf_ctrl(port, value);
	}
	else if ((port & 0x00f9) == 0x51) {
		fdd320_w(port, value);
	}
	else if ((port & 0x0fff) == 0x7ef) {
		np2_sys_w(port, value);
	}
	else if ((port & 0xfff0) == cs4231.port) {
		cs4231_w(port, value);
	}
	else if ((port & 0xfff1) == 0x0c20) {
		cs4231p_w(port, value);
	}

#ifdef TRACE
	else if (port == 0xffff) {
		trace_sw = value;
	}
	else {
		TRACEOUT(port, value);
	}
#endif
}

void __fastcall i286_out_w(WORD port, WORD value) {

	i286_out(port, (BYTE)value);
}

