#include	<windows.h>
#include	"common.h"
#include	"pc_core.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"gdc_sub.h"
#include	"crtc.h"
#include	"makegrph.h"
#include	"lio.h"

BYTE lio_gscreen(void) {

	GSCREEN_TABLE	data;
	LIO_SCRN		scrn;
	BOOL			screenmodechange = FALSE;
	BYTE			bit;
	int				disp;

	i286_memstr_read(I286_DS, I286_BX, &data, sizeof(data));
	if (data.mode == 0xff) {
		data.mode = lio.gscreen.mode;
	}
	else if (data.mode != lio.gscreen.mode) {
		screenmodechange = TRUE;
	}
	if (data.sw == 0xff) {
		data.sw = lio.gscreen.mode;
	}
	if (data.act == 0xff) {
		if (screenmodechange) {
			data.act = 0;
		}
		else {
			data.act = lio.gscreen.act;
		}
	}
	if (data.disp == 0xff) {
		if (screenmodechange) {
			data.disp = 1;
		}
		else {
			data.disp = lio.gscreen.disp;
		}
	}

	if (data.mode >= 0x04) {
		return(5);
	}
	if (data.sw >= 0x04) {
		return(5);
	}
	if (lio.gcolor1.palmode != 2) {
		bit = 3;
	}
	else {
		bit = 4;
	}
	switch(data.mode) {
		case 0:
			if (data.act >= 4) {
				return(5);
			}
			scrn.top = (data.act & 1) * 16000;
			scrn.lines = 200;
			scrn.bank = data.act >> 1;
			scrn.plane = 0x80;
			break;

		case 1:
			disp = data.act / bit;
			if (disp >= 4) {
				return(5);
			}
			scrn.top = (disp & 1) * 16000;
			scrn.lines = 200;
			scrn.bank = disp >> 1;
			scrn.plane = data.act % bit;
			break;

		case 2:
			disp = data.act / bit;
			if (disp >= 2) {
				return(5);
			}
			scrn.top = 0;
			scrn.lines = 400;
			scrn.bank = disp;
			scrn.plane = data.act % bit;
			break;

		case 3:
			if (data.act >= 2) {
				return(5);
			}
			scrn.top = 0;
			scrn.lines = 400;
			scrn.bank = (data.act >> 1);
			scrn.plane = 0x80;
			break;
	}
	lio.scrn = scrn;
	lio_makeviewmask();
	return(0);
}

