typedef struct {
	BYTE	mode;
	BYTE	sw;
	BYTE	act;
	BYTE	disp;
} GSCREEN_TABLE;

typedef struct {
	short	x1;
	short	y1;
	short	x2;
	short	y2;
	BYTE	vdraw_bg;
	BYTE	vdraw_ln;
} GVIEW_TABLE;

typedef struct {
	BYTE	palmax;					// command dummy
	BYTE	bgcolor;
	BYTE	bdcolor;
	BYTE	fgcolor;
	BYTE	palmode;
} GCOLOR1_TABLE;

typedef struct {
	BYTE	pal;
	BYTE	color1;
	BYTE	color2;
} GCOLOR2_TABLE;

typedef struct {
	short	x;
	short	y;
	BYTE	pal;
} GPSET_TABLE;

typedef struct {
	short	x1;
	short	y1;
	short	x2;
	short	y2;
	BYTE	pal;
	BYTE	type;
	BYTE	sw;
	BYTE	style_l;
	BYTE	style_h;
	BYTE	patleng;
	WORD	off;
	WORD	seg;
} GLINE_TABLE;

typedef struct {
	short	x;
	short	y;
	WORD	off;
	WORD	seg;
	WORD	leng;
	BYTE	mode;
	BYTE	colsw;
	BYTE	fgcolor;
	BYTE	bgcolor;
} GPUT1_TABLE;

// -------------------------

typedef struct {
	WORD	top;
	WORD	lines;
	BYTE	bank;
	BYTE	plane;
} LIO_SCRN;


typedef struct {
	short	x1;
	short	y1;
	short	x2;
	short	y2;
	BYTE	degcol[8];

	LIO_SCRN		scrn;
	GSCREEN_TABLE	gscreen;
	GVIEW_TABLE		gview;
	GCOLOR1_TABLE	gcolor1;
} LIO_TABLE;

extern LIO_TABLE lio;

void lio_init(void);
void bios_lio(BYTE cmd);

void lio_makeviewmask(void);
void lio_pset(short x, short y, BYTE pal);
void lio_line(short x1, short x2, short y, BYTE pal);

BYTE lio_ginit(void);
BYTE lio_gscreen(void);
BYTE lio_gview(void);
BYTE lio_gcolor1(void);
BYTE lio_gcolor2(void);
BYTE lio_gcls(void);
BYTE lio_gpset(void);
BYTE lio_gline(void);
BYTE lio_gcircle(void);
BYTE lio_gpaint1(void);
BYTE lio_gpaint2(void);
BYTE lio_gget(void);
BYTE lio_gput1(void);
BYTE lio_gput2(void);
BYTE lio_groll(void);
BYTE lio_gpoint2(void);
BYTE lio_gcopy(void);
