#include	<windows.h>
#include	"common.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"makegrph.h"
#include	"ddraws.h"

#ifdef __cplusplus
extern "C" {
#endif
BYTE	vramupdate[0x8000];
#ifdef __cplusplus
}
#endif

static	DWORD	grph_table[4*256*2];

void makegrph_init(void) {

	int		i, j;
	BYTE	bit;
	DWORD	tmp = 0;								// vc++4.2

	for (i=0; i<256; i++) {
		for (bit=1; bit<0x10; bit<<=1) {
			tmp <<= 8;
			if (i & bit) {
				tmp++;
			}
		}
		for (j=0; j<4; j++, tmp<<=1) {
			grph_table[j*512+i*2+1] = tmp;
		}
		for (; bit; bit<<=1) {
			tmp <<= 8;
			if (i & bit) {
				tmp++;
			}
		}
		for (j=0; j<4; j++, tmp<<=1) {
			grph_table[j*512+i*2+0] = tmp;
		}
	}
}

#if 0

void __fastcall makegrph(int page, int alldraw) {

	int		i, j;
	int		x, y;
	int		ad1;
	BYTE	*p, *q;
	WORD	sad;
	WORD	last_sad;
	WORD	GRP_SL;
	BYTE	GRP_LR;
	BYTE	bit;
	int		ymax;

	p = &mem[page * 0x200000 + 0x0a8000];
	q = np2_vram[page];
	bit = 1 << page;
	if (alldraw) {
		for (i=0; i<0x8000; i++) {
			vramupdate[i] |= bit;
		}
	}

	ymax = (*(WORD *)(&gdc.s.para[GDC_SYNC + 6])) & 0x3ff;
	if ((!ymax) || (ymax > GRPHYMAX)) {
		ymax = GRPHYMAX;
	}

	GRP_LR = gdc.s.para[GDC_CSRFORM] & 0x1f;

	ad1 = 0;
	y = 0;
	for (i=0; i<2; i++) {
		sad = ((*(WORD *)(&gdc.s.para[GDC_SCROLL+i*4])) << 1) & 0x7fff;
		GRP_SL = ((*(WORD *)(&gdc.s.para[GDC_SCROLL+i*4+2])) >> 4) & 0x3ff;
		if (!GRP_SL) {
			GRP_SL = 1024;
		}
		while(GRP_SL--) {
			last_sad = sad;
			for (j=0; y<ymax && j<=GRP_LR; j++) {
				sad = last_sad;
				if ((y & 1) && (gdc.mode1 & 0x10)) {
					if (alldraw) {
						renewal_line[y] |= bit;
						ZeroMemory(q + ad1, 640);
					}
					ad1 += 640;
					sad = (sad + 80) & 0x7fff;
				}
				else {
					for (x=0; x<80; x++) {
						if (vramupdate[sad] & bit) {
							renewal_line[y] |= bit;
							*(DWORD *)(&q[ad1]) =
									(grph_table[p[sad+0x00000]*2+0] << 0) |
									(grph_table[p[sad+0x08000]*2+0] << 1) |
									(grph_table[p[sad+0x10000]*2+0] << 2) |
									(grph_table[p[sad+0x38000]*2+0] << 3);
							*(DWORD *)(&q[ad1+4]) =
									(grph_table[p[sad+0x00000]*2+1] << 0) |
									(grph_table[p[sad+0x08000]*2+1] << 1) |
									(grph_table[p[sad+0x10000]*2+1] << 2) |
									(grph_table[p[sad+0x38000]*2+1] << 3);
						}
						sad = (sad + 1) & 0x7fff;
						ad1 += 8;
					}
				}
				y++;
			}
		}
	}

	if (alldraw) {
		for (; y<GRPHYMAX; y++) {
			renewal_line[y] |= bit;
			ZeroMemory(&q[ad1], 640);
			ad1 += 640;
		}
	}

	for (i=0; i<0x8000; i++) {
		vramupdate[i] &= ~bit;
	}
}

#else

static	DWORD	GRP_LR;
static	DWORD	GMAXLINE;
static	DWORD	LINE_WIDTH;
static	BYTE	DISPPAGE;
static	BYTE	ALL_DRAWFLAG;

LABEL void __fastcall makegrph(int page, int alldraw) {

		__asm {
				pushad
				and		ecx, 1
				mov		edi, ecx
				shl		edi, 18
				add		edi, offset np2_vram

				inc		cl
				mov		DISPPAGE, cl
				mov		ALL_DRAWFLAG, dl
				mov		ch, cl
				xor		eax, eax
				mov		ax, cx
				shl		eax, 16
				mov		ax, cx

				cmp		dl, 0
				je		calc_maxline
				mov		ecx, 2000h
				mov		ebx, offset vramupdate
dirtyfill_lp:	or		[ebx], eax
				add		ebx, 4
				loop	dirtyfill_lp

calc_maxline:	push	eax
				movzx	eax, word ptr (gdc.s.para[GDC_SYNC + 6])
				and		eax, 003ffh
				je		calc1_maxline
				cmp		eax, GRPHYMAX
				jbe		calc2_maxline
calc1_maxline:	mov		eax, GRPHYMAX
calc2_maxline:	mov		GMAXLINE, eax
				movzx	eax, gdc.s.para[GDC_CSRFORM]
				and		eax, 0x1f
				mov		GRP_LR, eax
				movzx	eax, gdc.s.para[GDC_PITCH]
				add		eax, eax
				mov		LINE_WIDTH, eax

				xor		ebx, ebx
draw_lp:		movzx	esi, word ptr (gdc.s.para[GDC_SCROLL+0+0])
				movzx	ecx, word ptr (gdc.s.para[GDC_SCROLL+0+2])
				call	grphputlines
				movzx	esi, word ptr (gdc.s.para[GDC_SCROLL+4+0])
				movzx	ecx, word ptr (gdc.s.para[GDC_SCROLL+4+2])
				push	offset draw_lp

grphputlines:		and		esi, 3fffh
					add		esi, esi
					shr		ecx, 4
					and		ecx, 03ffh
					jne		grphlineput_lp
					mov		ecx, 0400h
grphlineput_lp:		push	ecx
					mov		ecx, GRP_LR
grphline1_lp:		test	bl, 1
					je		grph_putline
					test	gdc.mode1, 10h
					je		grph_putline
													// 00/07/12
#if 1												// ̎ɃXLbvC
					add		edi, 640				// 𔽉f̂Łc
					cmp		ALL_DRAWFLAG, 0
					jne		skipline_disp
					jmp		putline_end
skipline_disp:		mov		al, DISPPAGE
					or		renewal_line[ebx], al
					jmp		putline_end
#else
					cmp		ALL_DRAWFLAG, 0
					jne		skipline_disp
					add		edi, 640
					jmp		putline_end
skipline_disp:		xor		eax, eax
					mov		ebp, 640/4
skipline_lp:		mov		[edi], eax
					add		edi, 4
					dec		ebp
					jne		skipline_lp
					mov		al, DISPPAGE
					or		renewal_line[ebx], al
					jmp		putline_end
#endif
grph_putline:		push	esi
					push	ecx
					mov		ebp, 80
					cmp		DISPPAGE, 1
					jne		bank1_linelp
bank0_linelp:		test	vramupdate[esi], 1
					je		bank0_nodirty
					or		renewal_line[ebx], 1
					movzx	edx, byte ptr mem[esi + 0x0a8000]
					mov		eax, grph_table[edx*8+0*0x800+0]
					mov		ecx, grph_table[edx*8+0*0x800+4]
					movzx	edx, byte ptr mem[esi + 0x0b0000]
					or		eax, grph_table[edx*8+1*0x800+0]
					or		ecx, grph_table[edx*8+1*0x800+4]
					movzx	edx, byte ptr mem[esi + 0x0b8000]
					or		eax, grph_table[edx*8+2*0x800+0]
					or		ecx, grph_table[edx*8+2*0x800+4]
					movzx	edx, byte ptr mem[esi + 0x0e0000]
					or		eax, grph_table[edx*8+3*0x800+0]
					or		ecx, grph_table[edx*8+3*0x800+4]
					mov		[edi], eax
					mov		[edi+4], ecx
bank0_nodirty:		inc		esi
					and		esi, 07fffh
					add		edi, 8
					dec		ebp
					jne		bank0_linelp
					jmp		bankputend
bank1_linelp:		test	vramupdate[esi], 2
					je		bank1_nodirty
					or		renewal_line[ebx], 2
					movzx	edx, byte ptr mem[esi + 0x2a8000]
					mov		eax, grph_table[edx*8+0*0x800+0]
					mov		ecx, grph_table[edx*8+0*0x800+4]
					movzx	edx, byte ptr mem[esi + 0x2b0000]
					or		eax, grph_table[edx*8+1*0x800+0]
					or		ecx, grph_table[edx*8+1*0x800+4]
					movzx	edx, byte ptr mem[esi + 0x2b8000]
					or		eax, grph_table[edx*8+2*0x800+0]
					or		ecx, grph_table[edx*8+2*0x800+4]
					movzx	edx, byte ptr mem[esi + 0x2e0000]
					or		eax, grph_table[edx*8+3*0x800+0]
					or		ecx, grph_table[edx*8+3*0x800+4]
					mov		[edi], eax
					mov		[edi+4], ecx
bank1_nodirty:		inc		esi
					and		esi, 07fffh
					add		edi, 8
					dec		ebp
					jne		bank1_linelp
bankputend:			pop		ecx
					pop		esi

putline_end:		inc		ebx
					cmp		ebx, GMAXLINE
					jnc		grph_break
					dec		ecx
					jns		grphline1_lp
					add		esi, LINE_WIDTH
					and		esi, 7fffh
					pop		ecx
					dec		ecx
					jne		grphlineput_lp
					ret

grph_break:		add		esp, 8
				pop		edx
				cmp		ALL_DRAWFLAG, 0
				je		deldirty

				cmp		ebx, GRPHYMAX
				jae		deldirty
				xor		eax, eax
bottomfill0_lp:	or		renewal_line[ebx], dl
				mov		ecx, 640/4
bottomfill1_lp:	mov		[edi], eax
				add		edi, 4
				loop	bottomfill1_lp
				inc		ebx
				cmp		ebx, GRPHYMAX
				jb		bottomfill0_lp

deldirty:		mov		ecx, 2000h
				mov		ebx, offset vramupdate
				not		edx
deldirty_lp:	and		[ebx], edx
				add		ebx, 4
				loop	deldirty_lp
				popad
				ret
		}
}
#endif
