#include	<windows.h>
#include	"common.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"crtc.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"maketext.h"
#include	"ddraws.h"
#include	"cgrom.h"

#ifdef __cplusplus
extern "C" {
#endif
	BYTE	tramupdate[0x1000];
#ifdef __cplusplus
}
#endif

static	DWORD	text_table[512];
static	DWORD	text_tblx2[512][2];
static	int		cur_dispbak = 0;
static	WORD	lastcursolepos = 0;

void maketext_reset(void) {

	cur_dispbak = 0;
}

void maketext_init(void) {

	int		i, j;
	BYTE	bit;

	ZeroMemory(text_table, sizeof(text_table));
	for (i=0; i<8; i++) {
		for (j=0; j<16; j++) {
			for (bit=1; bit<0x10; bit<<=1) {
				text_table[i*16+j] <<= 8;
				text_table[i*16+j+128] <<= 8;
				if (j & bit) {
					text_table[i*16+j] |= (i+1) << 4;
				}
				else {
					text_table[i*16+j+128] |= (i+1) << 4;
				}
			}
		}
	}
	for (i=0; i<256; i++) {
		text_table[i+256] = text_table[i ^ 0x80];
	}
	for (i=0; i<512; i++) {
		text_tblx2[i][0] = (text_table[i] & 0x000000ff);
		text_tblx2[i][0] |= (text_table[i] & 0x0000ffff) << 8;
		text_tblx2[i][0] |= (text_table[i] & 0x0000ff00) << 16;
		text_tblx2[i][1] = (text_table[i] & 0x00ff0000) >> 16;
		text_tblx2[i][1] |= (text_table[i] & 0xffff0000) >> 8;
		text_tblx2[i][1] |= (text_table[i] & 0xff000000);
	}
}

void maketext(int text_renewal, int cur_disp) {

	BYTE	TEXT_LR = gdc.m.para[GDC_CSRFORM] & 0x1f;
	short	TEXT_PL = crtc.reg.pl;
	short	TEXT_BL = crtc.reg.bl + 1;
	short	TEXT_CL = crtc.reg.cl;
	short	TEXT_SUR = crtc.reg.sur;
	short	TEXT_SDR = -1;
	WORD	esi = (*(WORD *)(&gdc.m.para[GDC_SCROLL])) & 0xfff;
	WORD	edi = 0;
	short	lines;
	short 	topline;
	BYTE	LRcnt = 0;
	DWORD	bitmap[TEXTXMAX];
	WORD	color[TEXTXMAX];
	BYTE	curx[TEXTXMAX+1];
	WORD	kanji1st = 0;
	BYTE	kanji2nd = 0;
	int		x, y;
	short	nowline = 0;
	int		fntline = 0;
	BYTE	fbwork;
	int		new_flag = 0;
	int		cur_line = -1;
	BYTE	kc;
	int		linecnt = 0;
	short	wait1 = 0;
	short	wait2 = 0;
	BYTE	*q = np2_tram;
	BYTE	line_effect;

	if (!(gdc.m.para[GDC_CSRFORM] & 0x80)) {
		cur_disp = 0;
	}
	else if (gdc.m.para[GDC_CSRFORM+1] & 0x20) {
		cur_disp = 1;
	}
	if ((cur_dispbak != cur_disp) ||
		(lastcursolepos != *(WORD *)(&gdc.m.para[GDC_CSRW]))) {
		if ((cur_dispbak) && (lastcursolepos < 0x1000)) {
			tramupdate[lastcursolepos] = 1;
		}
		cur_dispbak = cur_disp;
		lastcursolepos = *(WORD *)(&gdc.m.para[GDC_CSRW]);
		if ((cur_dispbak) && (lastcursolepos < 0x1000)) {
			tramupdate[lastcursolepos] = 1;
		}
	}

	if (TEXT_CL > 16) {
		TEXT_CL = 16;
	}
	if (TEXT_PL >= 16) {
		topline = TEXT_PL - 32;
		lines = TEXT_BL;
	}
	else {
		topline = TEXT_PL;
		if ((lines = TEXT_BL - topline) <= 0) {
			lines += 32;							// ␳
		}
	}
	nowline = topline;

	if (!TEXT_SUR) {
		wait2 = crtc.reg.ssl;
		TEXT_SDR = crtc.reg.sdr + 1;
	}
	else {
		TEXT_SUR = 32 - TEXT_SUR;
	}

	for (y=0; y<TEXTYMAX;) {
		if (!wait1) {
			if (LRcnt-- == 0) {
				LRcnt = TEXT_LR;
				new_flag = text_renewal;
				cur_line = -1;
				line_effect = 0;
				if (!new_flag) {
					edi = esi;
					for (x=0; x<TEXTXMAX; x++) {
						if (tramupdate[edi]) {
							new_flag = 1;
							break;
						}
						edi = (edi + 1) & 0xfff;
					}
				}
				if (new_flag) {
					edi = esi;
					kanji1st = 0;
					kanji2nd = 0;
					for (x=0; x<TEXTXMAX; x++) {
						if (edi == *(WORD *)(&gdc.m.para[GDC_CSRW])) {
							cur_line = x;
						}
						curx[x] = mem[0xa2000 + edi*2] & 0x1f;
						line_effect |= curx[x];
						color[x] = (mem[0xa2000 + edi*2] >> 1) & 0x70;
						if (curx[x] & 0x4) {
							color[x] |= 0x80;
						}
						if (kanji2nd) {
							kanji2nd = 0;
							bitmap[x] = bitmap[x-1] + 0x800;
							curx[x-1] |= 0x80;
						}
						else if (mem[0xa0001 + edi*2] == 0) {
							kanji1st = 0;
							if (gdc.mode1 & 8) {
								bitmap[x] = 0x80000 +
											(mem[0xa0000 + edi*2] << 4);
								if (curx[x] & 0x10) {
									if (gdc.mode1 & 1) {
										curx[x] &= ~(0x10);
										bitmap[x] += 0x1000;
									}
								}
							}
							else {
								bitmap[x] = 0x82000 + 
											(mem[0xa0000 + edi*2] << 3);
								if (curx[x] & 0x10) {
									if (gdc.mode1 & 1) {
										curx[x] &= ~(0x10);
										bitmap[x] += 0x800;
									}
								}
							}
						}
						else {
							bitmap[x] =
								(((*(WORD *)(&mem[0xa0000 + edi*2])) & 0x7f7f)
									<< 4) | kanji1st;
							kc = mem[0xa0000 + edi*2] & 0x7e;
							if (kc == 0x56) {
								if ((kanji1st) &&
									(bitmap[x] == (bitmap[x-1] + 0x800))) {
									curx[x-1] |= 0x80;
								}
								kanji1st ^= 0x800;
							}
							else {
								kanji1st = 0;
								if ((kc < 0x08) || (kc >= 0x0c)) {
									kanji2nd = 1;
								}
							}
						}
						if (!(mem[0xa2000 + edi*2] & 1)) {
							bitmap[x] = 0;
						}
						edi = (edi+1) & 0x0fff;
					}
					if (!cur_disp) {
						cur_line = -1;
					}
				}
				esi = (esi + 80) & 0x0fff;
			}
		}
		else {
			wait1--;
		}

		if ((!TEXT_SDR) && (nowline >= topline + crtc.reg.ssl)) {
			nowline = topline;
			TEXT_SDR--;
			wait1 = crtc.reg.ssl;
		}

		if (!wait2) {
			if (new_flag) {
				renewal_line[y] |= 4;
				if (cur_line >= 0) {
					if ((nowline >= (gdc.m.para[GDC_CSRFORM+1] & 0x1f)) &&
						(nowline <= (gdc.m.para[GDC_CSRFORM+2] >> 3))) {
						color[cur_line] |= 256;
					}
					else {
						color[cur_line] &= ~(256);
					}
				}
				if ((nowline >= 0) && (nowline < TEXT_CL)) {
					if (gdc.mode1 & 8) {
						fntline = nowline & 0x0f;
					}
					else {
						fntline = (nowline >> 1) & 0x07;
					}
					for (x=0; x<TEXTXMAX; x++) {
						fbwork = font[bitmap[x] + fntline];
						*(DWORD *)q = text_table[color[x]+(fbwork>>4)];
						*(DWORD *)(q+4) = text_table[color[x]+(fbwork&0xf)];
						q += 8;
					}
				}
				else {
					for (x=0; x<(TEXTXMAX); x++) {
						*(DWORD *)q = text_table[color[x]];
						*(DWORD *)(q+4) = text_table[color[x]];
						q += 8;
					}
				}
				if ((line_effect & 8) &&
					((nowline + 1) == lines)) {		// A_[Cʒu
					q -= TEXTXMAX * 8;
					q += 4;
					for (x=0; x<(TEXTXMAX-1); x++) {
						if (curx[x] & 8) {
							*(DWORD *)q = text_table[(color[x] & 0x70) | 0x0f];
							*(DWORD *)(q+4) = text_table[(color[x+1] & 0x70)
																	| 0x0f];
						}
						q += 8;
					}
					if (curx[TEXTXMAX-1] & 8) {
						*(DWORD *)q = text_table[(color[TEXTXMAX-1] & 0x70)
																	| 0x0f];
					}
					q += 4;
				}
			}
			else {
				q += TEXTXMAX * 8;
			}
			y++;
		}
		else {
			wait2--;
		}

		nowline++;
		if ((TEXT_SDR) && (nowline >= lines)) {
			nowline = topline;
			TEXT_SDR--;
			if (++linecnt == TEXT_SUR) {
				wait2 = crtc.reg.ssl;
				TEXT_SDR = crtc.reg.sdr + 1;
			}
		}
	}
	ZeroMemory(tramupdate, sizeof(tramupdate));
}


void maketext40(int text_renewal, int cur_disp) {

	BYTE	TEXT_LR = gdc.m.para[GDC_CSRFORM] & 0x1f;
	short	TEXT_PL = crtc.reg.pl;
	short	TEXT_BL = crtc.reg.bl + 1;
	short	TEXT_CL = crtc.reg.cl;
	short	TEXT_SUR = crtc.reg.sur;
	short	TEXT_SDR = -1;
	WORD	esi = (*(WORD *)(&gdc.m.para[GDC_SCROLL])) & 0xfff;
	WORD	edi = 0;
	short	lines;
	short 	topline;
	BYTE	LRcnt = 0;
	DWORD	bitmap[TEXTXMAX];
	WORD	color[TEXTXMAX];
	BYTE	curx[TEXTXMAX+1];
	WORD	kanji1st = 0;
	BYTE	kanji2nd = 0;
	int		x, y;
	short	nowline = 0;
	int		fntline = 0;
	BYTE	fbwork;
	int		new_flag = 0;
	int		cur_line = -1;
	BYTE	kc;
	int		linecnt = 0;
	short	wait1 = 0;
	short	wait2 = 0;
	BYTE	*q = np2_tram;
	BYTE	line_effect;

	if (!(gdc.m.para[GDC_CSRFORM] & 0x80)) {
		cur_disp = 0;
	}
	else if (gdc.m.para[GDC_CSRFORM+1] & 0x20) {
		cur_disp = 1;
	}
	if ((cur_dispbak != cur_disp) ||
		(lastcursolepos != *(WORD *)(&gdc.m.para[GDC_CSRW]))) {
		if ((cur_dispbak) && (lastcursolepos < 0x1000)) {
			tramupdate[lastcursolepos] = 1;
		}
		cur_dispbak = cur_disp;
		lastcursolepos = *(WORD *)(&gdc.m.para[GDC_CSRW]);
		if ((cur_dispbak) && (lastcursolepos < 0x1000)) {
			tramupdate[lastcursolepos] = 1;
		}
	}

	if (TEXT_CL > 16) {
		TEXT_CL = 16;
	}
	if (TEXT_PL >= 16) {
		topline = TEXT_PL - 32;
		lines = TEXT_BL;
	}
	else {
		topline = TEXT_PL;
		if ((lines = TEXT_BL - topline) <= 0) {
			lines += 32;							// ␳
		}
	}
	nowline = topline;

	if (!TEXT_SUR) {
		wait2 = crtc.reg.ssl;
		TEXT_SDR = crtc.reg.sdr + 1;
	}
	else {
		TEXT_SUR = 32 - TEXT_SUR;
	}

	for (y=0; y<TEXTYMAX;) {
		if (!wait1) {
			if (LRcnt-- == 0) {
				LRcnt = TEXT_LR;
				new_flag = text_renewal;
				cur_line = -1;
				line_effect = 0;
				if (!new_flag) {
					edi = esi;
					for (x=0; x<TEXTXMAX; x++) {
						if (tramupdate[edi]) {
							new_flag = 1;
							break;
						}
						edi = (edi + 1) & 0xfff;
					}
				}
				if (new_flag) {
					edi = esi;
					kanji1st = 0;
					kanji2nd = 0;
					for (x=0; x<(TEXTXMAX/2); x++) {
						if (edi == *(WORD *)(&gdc.m.para[GDC_CSRW])) {
							cur_line = x;
						}
						curx[x] = mem[0xa2000 + edi*2] & 0x1f;
						line_effect |= curx[x];
						color[x] = (mem[0xa2000 + edi*2] >> 1) & 0x70;
						if (curx[x] & 0x4) {
							color[x] += 0x80;
						}
						if (kanji2nd) {
							kanji2nd = 0;
							bitmap[x] = bitmap[x-1] + 0x800;
							curx[x-1] |= 0x80;
						}
						else if (mem[0xa0001 + edi*2] == 0) {
							kanji1st = 0;
							if (gdc.mode1 & 8) {
								bitmap[x] = 0x80000 +
											(mem[0xa0000 + edi*2] << 4);
								if (curx[x] & 0x10) {
									if (gdc.mode1 & 1) {
										curx[x] &= ~(0x10);
										bitmap[x] += 0x1000;
									}
								}
							}
							else {
								bitmap[x] = 0x82000 + 
											(mem[0xa0000 + edi*2] << 3);
								if (curx[x] & 0x10) {
									if (gdc.mode1 & 1) {
										curx[x] &= ~(0x10);
										bitmap[x] += 0x800;
									}
								}
							}
						}
						else {
							bitmap[x] =
								(((*(WORD *)(&mem[0xa0000 + edi*2])) & 0x7f7f)
									<< 4) | kanji1st;
							kc = mem[0xa0000 + edi*2] & 0x7e;
							if (kc == 0x56) {
								if ((kanji1st) &&
									(bitmap[x] == (bitmap[x-1] + 0x800))) {
									curx[x-1] |= 0x80;
								}
								kanji1st ^= 0x800;
							}
							else {
								kanji1st = 0;
								if ((kc < 0x08) || (kc >= 0x0c)) {
									kanji2nd = 1;
								}
							}
						}
						if (!(mem[0xa2000 + edi*2] & 1)) {
							bitmap[x] = 0;
						}
						edi = (edi+2) & 0x0fff;
					}
					if (!cur_disp) {
						cur_line = -1;
					}
				}
				esi = (esi + 80) & 0x0fff;
			}
		}
		else {
			wait1--;
		}

		if ((!TEXT_SDR) && (nowline >= topline + crtc.reg.ssl)) {
			nowline = topline;
			TEXT_SDR--;
			wait1 = crtc.reg.ssl;
		}

		if (!wait2) {
			if (new_flag) {
				renewal_line[y] |= 4;
				if (cur_line >= 0) {
					if ((nowline >= (gdc.m.para[GDC_CSRFORM+1] & 0x1f)) &&
						(nowline <= (gdc.m.para[GDC_CSRFORM+2] >> 3))) {
						color[cur_line] |= 256;
					}
					else {
						color[cur_line] &= ~(256);
					}
				}
				if ((nowline >= 0) && (nowline < TEXT_CL)) {
					if (gdc.mode1 & 8) {
						fntline = nowline & 0x0f;
					}
					else {
						fntline = (nowline >> 1) & 0x07;
					}
					for (x=0; x<(TEXTXMAX/2); x++) {
						fbwork = font[bitmap[x] + fntline];
						*(DWORD *)(q+ 0) = text_tblx2[color[x] +
															(fbwork>>4)][0];
						*(DWORD *)(q+ 4) = text_tblx2[color[x] +
															(fbwork>>4)][1];
						*(DWORD *)(q+ 8) = text_tblx2[color[x] +
															(fbwork&0xf)][0];
						*(DWORD *)(q+12) = text_tblx2[color[x] +
															(fbwork&0xf)][1];
						q += 16;
					}
				}
				else {
					for (x=0; x<(TEXTXMAX/2); x++) {
						*(DWORD *)q = text_table[color[x]];
						*(DWORD *)(q+4) = text_table[color[x]];
						*(DWORD *)(q+8) = text_table[color[x]];
						*(DWORD *)(q+12) = text_table[color[x]];
						q += 16;
					}
				}
				if ((line_effect & 8) &&
					((nowline + 1) == lines)) {		// A_[Cʒu
					q -= TEXTXMAX * 8;
					q += 4;
					for (x=0; x<((TEXTXMAX/2)-1); x++) {
						if (curx[x] & 8) {
							*(DWORD *)q = text_table[(color[x] & 0x70)
																	| 0x0f];
							*(DWORD *)(q+4) = text_table[(color[x] & 0x70)
																	| 0x0f];
							*(DWORD *)(q+8) = text_table[(color[x] & 0x70)
																	| 0x0f];
							*(DWORD *)(q+12) = text_table[(color[x+1] & 0x70)
																	| 0x0f];
						}
						q += 16;
					}
					if (curx[(TEXTXMAX/2)-1] & 8) {
						*(DWORD *)q = text_table[(color[TEXTXMAX-1] & 0x70)
																	| 0x0f];
						*(DWORD *)(q+4) = text_table[(color[TEXTXMAX-1] & 0x70)
																	| 0x0f];
						*(DWORD *)(q+8) = text_table[(color[TEXTXMAX-1] & 0x70)
																	| 0x0f];
					}
					q += 12;
				}
			}
			else {
				q += TEXTXMAX * 8;
			}
			y++;
		}
		else {
			wait2--;
		}

		nowline++;
		if ((TEXT_SDR) && (nowline >= lines)) {
			nowline = topline;
			TEXT_SDR--;
			if (++linecnt == TEXT_SUR) {
				wait2 = crtc.reg.ssl;
				TEXT_SDR = crtc.reg.sdr + 1;
			}
		}
	}
	ZeroMemory(tramupdate, sizeof(tramupdate));
}

