#include	<windows.h>
#include	<windowsx.h>

#include	"resource.h"
#include	"np2.h"
#include	"pc_core.h"
#include	"dosio.h"
#include	"ini.h"
#include	"menu.h"
#include	"bios.h"
#include	"ddraws.h"
#include	"dsound3.h"
#include	"fddfile.h"

extern	HWND	hWndMain;


#define	MFCHECK(a) ((a)?MF_CHECKED:MF_UNCHECKED)


LPSTR savefileselect(LPSTR filter, LPSTR defname, LPSTR ext, LPSTR title) {

		OPENFILENAME	ofn;
		BOOL			r;
static	char			pathname[MAX_PATH+16];
static	char			filename[MAX_PATH];
		int				i;
		char			*p;

	ZeroMemory(&ofn, sizeof(OPENFILENAME));

	strcpy(pathname, bmpfilefolder);
	cutFileName(pathname);
	p = pathname + strlen(pathname);
	for (i=0; i<10000; i++) {
		wsprintf(filename, defname, i);
		strcpy(p, filename);
		if (file_attr(pathname) == -1) {
			break;
		}
	}
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = filter;
	ofn.lpstrFile = pathname;
	ofn.lpstrFileTitle = filename;
	ofn.nFilterIndex = 1;
	ofn.nMaxFile = MAX_PATH;
	ofn.nMaxFileTitle = sizeof(filename);
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = ext;
	ofn.lpstrTitle = title;

	DSound_Stop();
	mx_topwinui();
	r = GetSaveFileName(&ofn);
	mx_clearwinui();
	DSound_Play();
	if (!r) {
		return(NULL);
	}
	INIT_RENEWAL
		strcpy(bmpfilefolder, pathname);
	return(pathname);
}

LPSTR filenameselect(LPSTR fname, char *title, char *search, char *ext) {

		OPENFILENAME	ofn;
		BOOL			r;
static	char			pathname[MAX_PATH];
static	char			filename[MAX_PATH] = "";

	if ((fname == NULL) || (fname[0] == '\0')) {
		fname = "";
	}
	strcpy(pathname, fname);
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter = search;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = pathname;
	ofn.lpstrFileTitle = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST;
	ofn.lpstrDefExt = ext;
	ofn.lpstrTitle = title;

	r = GetOpenFileName(&ofn);
	if (!r) {
		return(NULL);
	}
	return(pathname);
}

// -------------------------------------------------------------------------

void disable_windowmenu(void) {

	HMENU	hmenu = GetMenu(hWndMain);

	EnableMenuItem(hmenu, IDM_WINDOW, MF_GRAYED);
	EnableMenuItem(hmenu, IDM_FULLSCREEN, MF_GRAYED);
}


void xmenu_setsound(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.SOUND_SW = value & 0x0f;
	CheckMenuItem(hmenu, IDM_NOSOUND, MFCHECK(np2cfg.SOUND_SW == 0));
	CheckMenuItem(hmenu, IDM_PC9801_14, MFCHECK(np2cfg.SOUND_SW & 1));
	CheckMenuItem(hmenu, IDM_PC9801_26K, MFCHECK(np2cfg.SOUND_SW & 2));
	CheckMenuItem(hmenu, IDM_PC9801_86, MFCHECK(np2cfg.SOUND_SW & 4));
	CheckMenuItem(hmenu, IDM_PC9801_118, MFCHECK(np2cfg.SOUND_SW & 8));
}

void xmenu_setbeepvol(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.BEEP_VOL = value & 3;
	CheckMenuItem(hmenu, IDM_BEEPOFF, MFCHECK(np2cfg.BEEP_VOL == 0));
	CheckMenuItem(hmenu, IDM_BEEPLOW, MFCHECK(np2cfg.BEEP_VOL == 1));
	CheckMenuItem(hmenu, IDM_BEEPMID, MFCHECK(np2cfg.BEEP_VOL == 2));
	CheckMenuItem(hmenu, IDM_BEEPHIGH, MFCHECK(np2cfg.BEEP_VOL == 3));
}

void xmenu_setkey(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	if (value >= 3) {
		value = 0;
	}
	np2cfg.KEY_MODE = value;
	CheckMenuItem(hmenu, IDM_KEY, MFCHECK(value == 0));
	CheckMenuItem(hmenu, IDM_JOY1, MFCHECK(value == 1));
	CheckMenuItem(hmenu, IDM_JOY2, MFCHECK(value == 2));
}

void xmenu_setbtnrapid(BYTE value) {

	np2cfg.BTN_RAPID = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_RAPID, MFCHECK(np2cfg.BTN_RAPID));
}

void xmenu_setbtnmode(BYTE value) {

	np2cfg.BTN_MODE = value & 1;
	CheckMenuItem(GetMenu(hWndMain), IDM_JOYX, MFCHECK(np2cfg.BTN_MODE));
}

void xmenu_setmsrapid(BYTE value) {

	np2cfg.MOUSERAPID = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_MSRAPID, MFCHECK(np2cfg.MOUSERAPID));
}

void xmenu_setwaitflg(BYTE value) {

	np2cfg.NOWAIT = value & 1;
	CheckMenuItem(GetMenu(hWndMain), IDM_NOWAIT, MFCHECK(np2cfg.NOWAIT));
}

void xmenu_setflame(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.DRAW_SKIP = value;
	CheckMenuItem(hmenu, IDM_60FPS, MFCHECK(value == 1));
	CheckMenuItem(hmenu, IDM_30FPS, MFCHECK(value == 2));
	CheckMenuItem(hmenu, IDM_20FPS, MFCHECK(value == 3));
	CheckMenuItem(hmenu, IDM_15FPS, MFCHECK(value == 4));
}

void xmenu_setjoystick(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.JOYSTICK &= 0x80;
	np2cfg.JOYSTICK |= (value & 0x7f);

	if (value & 2) {
		EnableMenuItem(hmenu, IDM_JOYSTICK, MF_GRAYED);
	}
	else {
		CheckMenuItem(hmenu, IDM_JOYSTICK, MFCHECK(value & 1));
	}
}

void xmenu_setdispclk(BYTE value) {

	value &= 1;
	np2cfg.DISPCLK = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_DISPCLOCK, MFCHECK(value));
	makecaption(2, 0);
	if (value) {
		workclock_reset();
	}
}

void xmenu_setdispmode(BYTE value) {

	value &= 1;
	np2cfg.DISPSYNC = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_DISPSYNC, MFCHECK(value));
}

void xmenu_setmouse(BYTE value) {

	value &= 1;
	np2cfg.MOUSE_SW = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_MOUSE, MFCHECK(value));
}

void xmenu_setmotorflg(BYTE value) {

	np2cfg.MOTOR = value & 1;
	CheckMenuItem(GetMenu(hWndMain), IDM_SEEKSND, MFCHECK(np2cfg.MOTOR));
}

void xmenu_setwinsnap(BYTE value) {

	value &= 1;
	np2cfg.WINSNAP = value;
	CheckMenuItem(GetSystemMenu(hWndMain, FALSE),
									IDM_SNAPENABLE, MFCHECK(value));
}

void xmenu_seti286save(BYTE value) {

	if (!value) {
		EnableMenuItem(GetMenu(hWndMain), IDM_I286SAVE, MF_GRAYED);
	}
}

void xmenu_setmimpidef(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.MIMPIDEF = value;
	if (!(value & 0x80)) {
		EnableMenuItem(hmenu, IDM_MIMPIFILE, MF_ENABLED);
		CheckMenuItem(hmenu, IDM_MIMPIFILE, MFCHECK(value & 1));
	}
	else {
		EnableMenuItem(hmenu, IDM_MIMPIFILE, MF_GRAYED);
		CheckMenuItem(hmenu, IDM_MIMPIFILE, MF_UNCHECKED);
	}
}

void xmenu_setroltate(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	CheckMenuItem(hmenu, IDM_ROLNORMAL, MFCHECK(value == 0));
	CheckMenuItem(hmenu, IDM_ROLLEFT, MFCHECK(value == 1));
	CheckMenuItem(hmenu, IDM_ROLRIGHT, MFCHECK(value == 2));
}

void xmenu_s98logging(BYTE value) {

	CheckMenuItem(GetMenu(hWndMain), IDM_S98LOGGING, MFCHECK(value));
}

void xmenu_setxshift(BYTE value) {

	HMENU	hmenu = GetMenu(hWndMain);

	np2cfg.XSHIFT = value;
	CheckMenuItem(hmenu, IDM_XSHIFT, MFCHECK(value & 1));
	CheckMenuItem(hmenu, IDM_XCTRL, MFCHECK(value & 2));
	CheckMenuItem(hmenu, IDM_XGRPH, MFCHECK(value & 4));
}

void xmenu_setf12copy(BYTE value) {

	if (value >= 3) {
		value = 0;
	}
	np2cfg.F12COPY = value;
	CheckMenuItem(GetMenu(hWndMain), IDM_F12MOUSE, MFCHECK(value == 0));
	CheckMenuItem(GetMenu(hWndMain), IDM_F12COPY, MFCHECK(value == 1));
	CheckMenuItem(GetMenu(hWndMain), IDM_F12STOP, MFCHECK(value == 2));
}
