#include	<windows.h>
#include	"common.h"
#include	"np2.h"
#include	"iobridge.h"
#include	"nevent.h"
#include	"winmouse.h"
#include	"mouseif.h"
#include	"pc_core.h"
#include	"pic.h"

	MOUSE_TABLE		mouseif;


void mouseint(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		pic_setirq(0x0d);
		nevent_set(NEVENT_MOUSE, pc.mouseclock << mouseif.timing,
												mouseint, NEVENT_RELATIVE);
	}
}

static void setportc(BYTE value) {

	if ((value & 0x80) && (!(mouseif.portc & 0x80))) {
		mouse_posget(&mouseif.latch_x, &mouseif.latch_y, 1);
		if (mouseif.latch_x > 127) {
			mouseif.latch_x = 127;
		}
		else if (mouseif.latch_x < -128) {
			mouseif.latch_x = -128;
		}
		if (mouseif.latch_y > 127) {
			mouseif.latch_y = 127;
		}
		else if (mouseif.latch_y < -128) {
			mouseif.latch_y = -128;
		}
	}
	if ((value ^ mouseif.portc) & 0x10) {
		if (value & 0x10) {
			nevent_reset(NEVENT_MOUSE);
			nevent_waitreset(NEVENT_MOUSE);
		}
		else {
			if (!nevent_iswork(NEVENT_MOUSE)) {
				nevent_set(NEVENT_MOUSE, pc.mouseclock << mouseif.timing,
												mouseint, NEVENT_ABSOLUTE);
			}
		}
	}
	mouseif.portc = value;
}



void mouseif_init(void) {

	ZeroMemory(&mouseif, sizeof(mouseif));
	mouseif.mode = 0x93;
#if 1
	mouseif.portc = 0x10;
#else
	nevent_set(NEVENT_MOUSE, pc.mouseclock << mouseif.timing,
												mouseint, NEVENT_ABSOLUTE);
#endif
}


I286_OUT mouseif_w(WORD port, BYTE value) {

	switch(port & 0x7) {
		case 0x05:
			setportc(value);
			break;

		case 0x07:
			mouseif.mode = value;
			if (!(value & 0xf0)) {
				if (value & 1) {
					setportc(mouseif.portc | (1 << (value >> 1)));
				}
				else {
					setportc(mouseif.portc & (~(1 << (value >> 1))));
				}
			}
			break;
	}
}

I286_INB mouseif_r(WORD port) {

	short	x, y;
	BYTE	ret;

	switch(port & 0x7) {
		case 0x01:
			ret = mouse_posget(&x, &y, 0) & 0xf0;
			if (np2cfg.MOUSERAPID) {
				DWORD nowclock = nevent.clock + nevent.baseclock
											- nevent.remainclock;
				if ((nowclock - mouseif.rapidclock) >= 8192) {
					mouseif.rapidclock = nowclock;
					mouseif.rapid ^= 0xa0;
				}
				ret |= mouseif.rapid;
			}
			ret |= 0x40;
			if (mouseif.portc & 0x80) {
				x = mouseif.latch_x;
				y = mouseif.latch_y;
			}
			if (mouseif.portc & 0x40) {
				x = y;
			}
			if (!(mouseif.portc & 0x20)) {
				ret |= x & 0x0f;
			}
			else {
				ret |= (x >> 4) & 0x0f;
			}
			return(ret);

		case 0x03:
			return(0x20);

		case 0x05:								// 00/06/04
			ret = mouseif.portc;
			if (mouseif.mode & 8) {
				ret &= 0x1f;					// 00/06/08
			}
			if (mouseif.mode & 1) {
				ret &= 0xf0;
				ret |= 0x08;
				ret |= (np2cfg.dipsw[2] >> 5) & 0x04;
				ret |= ((~np2cfg.dipsw[0]) >> 4) & 0x03;
			}
			return(ret);
	}
	return(0xff);
}

I286_OUT mousetiming_w(WORD port, BYTE value) {

	mouseif.timing = value & 3;
}
