#include	<windows.h>
#include	"common.h"
#include	"nevent.h"

NEVENT_TABLE	nevent;


void nevent_init(void) {

	// ׂĂZbg
	ZeroMemory(&nevent, sizeof(NEVENT_TABLE));
}


void nevent_get1stevent(void) {

	// ŒZ̃Cxg̃NbNZbg
	if (nevent.readyevents) {
		nevent.baseclock = nevent.item[nevent.level[0]].clock;
	}
	else {
		// CxgȂꍇ̃NbNZbg
		nevent.baseclock = NEVENT_MAXCLOCK;
	}

	// JE^փZbg
	nevent.remainclock = nevent.baseclock;
}


static void nevent_execute(void) {

	int			i;
	int			eventnum = 0;
	DWORD		curid;
	NEVENT_ITEM	*item;

	for (i=0; i<nevent.waitevents; i++) {
		curid = nevent.waitevent[i];
		item = &nevent.item[curid];

		// R[obN̎s
		if (item->proc != NULL) {
			item->proc(item);

			// Ɏz̃Cxg̃`FbN
			if (item->flag & NEVENT_WAIT) {
				nevent.waitevent[eventnum++] = curid;
			}
		}
		else {
			item->flag &= ~(NEVENT_WAIT);
		}
		item->flag &= ~(NEVENT_SETEVENT);
	}
	nevent.waitevents = eventnum;
}


void nevent_progress(void) {

	int			i;
	int			eventnum = 0;
	DWORD		curid;
	NEVENT_ITEM	*item;
	long		nextbase = NEVENT_MAXCLOCK;

	// sNbN
	long	clock = nevent.baseclock - nevent.remainclock;

	nevent.clock += clock;
	for (i=0; i<nevent.readyevents; i++) {
		curid = nevent.level[i];
		item = &nevent.item[curid];
		item->clock -= clock;
		if (item->clock > 0) {
			// Cxg҂
			nevent.level[eventnum++] = curid;
			if (nextbase >= item->clock) {
				nextbase = item->clock;
			}
		}
		else {
			// Cxg
			if (!(item->flag & (NEVENT_SETEVENT | NEVENT_WAIT))) {
				nevent.waitevent[nevent.waitevents++] = curid;
			}
			item->flag |= NEVENT_SETEVENT;
			item->flag &= ~(NEVENT_ENABLE);
		}
	}
	nevent.readyevents = eventnum;
	nevent.remainclock = nevent.baseclock = nextbase;
	nevent_execute();
}


void nevent_reset(int id) {

	int			i;

	// ݐisĂCxg
	for (i=0; i<nevent.readyevents; i++) {
		if (nevent.level[i] == id) {
			break;
		}
	}

	// Cxg݂͑H
	if (i < nevent.readyevents) {

		// ݂Ă
		nevent.readyevents--;
		for (; i<nevent.readyevents; i++) {
			nevent.level[i] = nevent.level[i+1];
		}
	}
}

void nevent_waitreset(int id) {

	int			i;

	// ݐisĂCxg
	for (i=0; i<nevent.waitevents; i++) {
		if (nevent.waitevent[i] == id) {
			break;
		}
	}

	// Cxg݂͑H
	if (i < nevent.waitevents) {

		// ݂Ă
		nevent.waitevents--;
		for (; i<nevent.waitevents; i++) {
			nevent.waitevent[i] = nevent.waitevent[i+1];
		}
	}
}


void nevent_set(int id, long eventclock, void *proc, BOOL absolute) {

	int			i;
	int			eventid;
	long		clock;
	NEVENT_ITEM	*item;

	clock = nevent.baseclock - nevent.remainclock;
	item = &nevent.item[id];
	item->proc = (void (*)(void *))proc;
	item->flag = 0;
	if (absolute) {
		item->clock = eventclock + clock;
	}
	else {
		item->clock += eventclock;
	}
	if (item->clock < clock) {
		item->clock = clock;
	}

	// Cxg̍폜
	nevent_reset(id);

	// Cxg̑}ʒǔ
	for (eventid=0; eventid<nevent.readyevents; eventid++) {
		if (item->clock < nevent.item[nevent.level[eventid]].clock) {
			break;
		}
	}

	// Cxg̑}
	for (i=nevent.readyevents; --i>=eventid;) {
		nevent.level[i+1] = nevent.level[i];
	}
	nevent.level[eventid] = id;
	nevent.readyevents++;

	// ŒZCxg...
	if (eventid == 0) {
		clock = nevent.baseclock - item->clock;
		nevent.baseclock -= clock;
		nevent.remainclock -= clock;
	}
}


BOOL nevent_iswork(int id) {

	int			i;

	// ݐisĂCxg
	for (i=0; i<nevent.readyevents; i++) {
		if (nevent.level[i] == id) {
			return(TRUE);
		}
	}
	return(FALSE);
}


long nevent_getremain(int id) {

	int			i;

	// ݐisĂCxg
	for (i=0; i<nevent.readyevents; i++) {
		if (nevent.level[i] == id) {
			return(nevent.item[id].clock -
								(nevent.baseclock - nevent.remainclock));
		}
	}
	return(-1);
}


void nevent_forceexit(void) {

	if (nevent.remainclock > 0) {
		nevent.baseclock -= nevent.remainclock;
		nevent.remainclock = 0;
	}
}
