#include	<windows.h>
#include	<windowsx.h>
#include	<string.h>
#include	"resource.h"
#include	"np2.h"
#include	"ini.h"
#include	"dosio.h"
#include	"fdd_d88.h"
#include	"milstr.h"

extern	HWND		hWndMain;
extern	HINSTANCE	hInst;

#define	DISKLABELLEN	16

static	int		make2hd = 1;
static	char	disklabel[DISKLABELLEN+2];
static	int		hddsize;

static char *hddsizestr[5] = {"20", "41", "65", "80", "128"};
static BYTE hdddiskboot[] = {
			0xb8,0x00,0x10,0xbb,0x00,0x80,0x8e,0xd0,0x8b,0xe3,0x8c,0xc8,
			0x8e,0xd8,0xb8,0x00,0xa0,0x8e,0xc0,0xb9,0x00,0x10,0xb8,0x20,
			0x00,0x33,0xff,0xfc,0xf3,0xab,0xb0,0xe1,0xb9,0xe0,0x1f,0xaa,
			0x47,0xe2,0xfc,0xbe,0x44,0x00,0x33,0xff,0xe8,0x08,0x00,0xbf,
			0xa0,0x00,0xe8,0x02,0x00,0xeb,0xfe,0x2e,0xad,0x85,0xc0,0x74,
			0x06,0xab,0x83,0xc7,0x02,0xeb,0xf4,0xc3,0x04,0x33,0x04,0x4e,
			0x05,0x4f,0x01,0x3c,0x05,0x49,0x05,0x47,0x05,0x23,0x05,0x39,
			0x05,0x2f,0x05,0x24,0x05,0x61,0x01,0x3c,0x05,0x38,0x04,0x4f,
			0x05,0x55,0x05,0x29,0x01,0x3c,0x05,0x5e,0x05,0x43,0x05,0x48,
			0x04,0x35,0x04,0x6c,0x04,0x46,0x04,0x24,0x04,0x5e,0x04,0x3b,
			0x04,0x73,0x01,0x25,0x00,0x00,0x05,0x47,0x05,0x23,0x05,0x39,
			0x05,0x2f,0x05,0x24,0x05,0x61,0x01,0x3c,0x05,0x38,0x04,0x72,
			0x21,0x5e,0x26,0x7e,0x18,0x65,0x01,0x24,0x05,0x6a,0x05,0x3b,
			0x05,0x43,0x05,0x48,0x04,0x37,0x04,0x46,0x12,0x3c,0x04,0x35,
			0x04,0x24,0x01,0x25,0x00,0x00};

static LPSTR newdiskselect(void) {

		OPENFILENAME	ofn;
		BOOL			r;
static	char			pathname[MAX_PATH+16];
static	char			filename[MAX_PATH];

	ZeroMemory(&ofn, sizeof(OPENFILENAME));

	strcpy(pathname, fddfolder);
	cutFileName(pathname);
	strcat(pathname, "newdisk");
	strcpy(filename, "");

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWndMain;
	ofn.lpstrFilter =	"D88 image files (*.D88;*.88D)\0"				\
											"*.d88;*.88d\0"				\
						"T98 harddisk image files (*.THD)\0"			\
											"*.thd\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = pathname;
	ofn.lpstrFileTitle = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.nMaxFileTitle = sizeof(filename);
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "d88";
	ofn.lpstrTitle = "VKfBXNC[W";

	r = GetSaveFileName(&ofn);

	if (!r) {
		return(NULL);
	}
#if 0
	INIT_RENEWAL
		strcpy(fileselectfolder, pathname);
#endif
	return(pathname);
}



LRESULT CALLBACK NewdiskDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

	switch (msg) {
		case WM_INITDIALOG:
			if (make2hd) {
				Button_SetCheck(GetDlgItem(hWnd, IDC_MAKE2HD), TRUE);
			}
			else {
				Button_SetCheck(GetDlgItem(hWnd, IDC_MAKE2DD), TRUE);
			}
			SetFocus(GetDlgItem(hWnd, IDC_DISKLABEL));
			return(FALSE);
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					Edit_GetText(GetDlgItem(hWnd, IDC_DISKLABEL),
											disklabel, DISKLABELLEN+1);
					disklabel[DISKLABELLEN] = '\0';
					if (kanji1st(disklabel, DISKLABELLEN - 1)) {
						disklabel[DISKLABELLEN-1] = '\0';
					}
					make2hd = Button_GetCheck(GetDlgItem(hWnd, IDC_MAKE2HD));
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				default:
					return(FALSE);
			}
			break;
		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
			break;
		default:
			return(FALSE);
	}
	return(TRUE);
}


LRESULT CALLBACK NewHddDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp) {

	int		i;
	char	work[32];

	switch (msg) {
		case WM_INITDIALOG:
			for (i=0; i<(sizeof(hddsizestr)/sizeof(char *)); i++) {
				SendMessage(GetDlgItem(hWnd, IDC_HDDSIZE),
						CB_INSERTSTRING, (WPARAM)i, (LPARAM)hddsizestr[i]);
			}
			SetFocus(GetDlgItem(hWnd, IDC_HDDSIZE));
			return(FALSE);
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					Edit_GetText(GetDlgItem(hWnd, IDC_HDDSIZE),
													work, sizeof(work));
					hddsize = (WORD)ex_a2i(work, 0, 512);
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				default:
					return(FALSE);
			}
			break;
		case WM_CLOSE:
			PostMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
			break;
		default:
			return(FALSE);
	}
	return(TRUE);
}

// ---------------------------------------------------------------------

void newdisk(HWND hWnd) {

	D88_HEADER	d88head;
	FILEH		fh;
	LPSTR		filename;
	char		work[256];
	WORD		size;

	filename = newdiskselect();
	if (filename == NULL) {
		return;
	}
	if (!milstr_cmpA(milstr_getext(filename), "THD")) {
		hddsize = 0;
		if ((DialogBox(hInst, MAKEINTRESOURCE(IDD_NEWHDDDISK),
					hWnd, (DLGPROC)NewHddDlgProc) != IDOK) ||
			(hddsize < 5) || (hddsize > 256)) {
			return;
		}
		if ((fh = file_create(filename)) != (FILEH)-1) {
			ZeroMemory(work, 256);
			*(WORD *)(work) = hddsize*15;
			file_write(fh, work, 256);
			file_write(fh, hdddiskboot, sizeof(hdddiskboot));
			ZeroMemory(work, 256);
			size = 0x400 - sizeof(hdddiskboot);
			while(size) {
				if (size >= 256) {
					file_write(fh, work, 256);
					size -= 256;
				}
				else {
					file_write(fh, work, size);
					break;
				}
			}
			file_close(fh);
		}
	}
	else {
		if (DialogBox(hInst, MAKEINTRESOURCE(IDD_NEWDISK),
					hWnd, (DLGPROC)NewdiskDlgProc) != IDOK) {
			return;
		}
		ZeroMemory(&d88head, sizeof(D88_HEADER));
		d88head.fd_size = sizeof(D88_HEADER);
		strcpy((char *)d88head.fd_name, disklabel);

		if (make2hd) {
			d88head.fd_type = 0x20;
		}
		else {
			d88head.fd_type = 0x10;
		}
		if ((fh = file_create(filename)) != (FILEH)-1) {
			file_write(fh, &d88head, sizeof(D88_HEADER));
			file_close(fh);
		}
	}
}
