#include	<windows.h>
#include	"common.h"
#include	"resource.h"
#include	"np2.h"
#include	"ddraws.h"
#include	"ddrawbmp.h"
#include	"dosio.h"
#include	"dsound3.h"
#include	"winloc.h"
#include	"winmouse.h"
#include	"timing.h"
#include	"iobridge.h"
#include	"keyboard.h"
#include	"pc_core.h"
#include	"ini.h"
#include	"menu.h"
#include	"bios.h"
#include	"joystick.h"
#include	"trace.h"
#include	"dialog.h"
#include	"nevent.h"
#include	"midi.h"
#include	"fddfile.h"
#include	"diskdrv.h"
#include	"newdisk.h"
#include	"s98.h"
#include	"dclock.h"

static	char		szClassName[] = "NP2-MainWindow";
		HWND		hWndMain;
		HINSTANCE	hInst;
		int			winx, winy;
		NP2_CFG		np2cfg = {
						"Neko Project II", "NP2",
						PCBASECLOCK25, 2,
						{0x3e, 0x63, 0x7a},
						{0x48, 0x05, 0x0c, 0x00, 0x01, 0x00, 0x00, 0x6E},
						{0x0c, 0x08, 0x0c, 0x06, 0x03, 0x00},
						0, 4, 0, 2, 22050, 800, 0, 0, 0, 1, 0, 0, 0, 0, 1,
						1, 80, 3, 1, 1, 0, 0x000000, 0xffffff,
						0, 0, 0, 0xff, 0, 0, 0, 0, 0x40,
						0, 0, 0xffffff, 0x6abfff};

		WORD		framecnt = 0;
static	int			np2opening = 1;


BYTE changescreen(BYTE mode) {

	DSound_Stop();
	if (np2_setscreenmode(mode)) {
		mouse_running(MOUSE_STOP);
		np2_TermDirectDraw();
		np2_windowstats();
		if (np2_InitDirectDraw()) {
			disable_windowmenu();
			np2_setscreenmode(SCMD_XORWINDOWED);
			np2_windowstats();
			if (np2_InitDirectDraw()) {
				return(FAILURE);
			}
		}
		ddraws_redraw();
		mouse_running(MOUSE_CONT);
	}
	DSound_Play();
	return(SUCCESS);
}


// --------------------------------------------------------------------------

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {

	PAINTSTRUCT	ps;
	RECT		rc;
	HDC			hdc;

	switch (msg) {
#if 0
		case WM_CREATE:
			DragAcceptFiles(hWnd, TRUE);
			break;
#endif
		case WM_SYSCOMMAND:
			switch(wParam) {
				case IDM_SCREENCENTER:
					if (SCREENMODE & SCMD_WINDOWED) {
						np2_wincenter();
					}
					break;
				case IDM_SNAPENABLE:
					INIT_RENEWAL xmenu_setwinsnap(np2cfg.WINSNAP ^ 1);
					break;
#ifdef TRACE
				case IDM_TRACEONOFF:
					trace_sw ^= 1;
					CheckMenuItem(GetSystemMenu(hWndMain, FALSE),
									IDM_TRACEONOFF, 
									(trace_sw?MF_CHECKED:MF_UNCHECKED));
					break;
#endif
				case IDM_MEMORYDUMP:
					{
						FILEH	fh;
						int		i;
						if ((fh = file_create_c("memory.bin")) != (FILEH)-1) {
							for (i=0; i<34; i++) {
								file_write(fh, mem + i*0x8000, 0x8000);
							}
							file_close(fh);
						}
					}
					break;

				default:
					return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDM_RESET:
					if (np2_getmemsw()) {
						INIT_RENEWAL;
					}
					np2_reset();
					break;

				case IDM_CONFIG:
					DSound_Stop();
					mx_topwinui();
					DialogBox(hInst, MAKEINTRESOURCE(IDD_CONFIG),
									hWnd, (DLGPROC)CfgDialogProc);
					mx_clearwinui();
					DSound_Play();
					break;

				case IDM_NEWDISK:
					DSound_Stop();
					mx_topwinui();
					newdisk(hWnd);
					mx_clearwinui();
					DSound_Play();
					break;

				case IDM_EXIT:
					SendMessage(hWnd, WM_CLOSE, 0, 0L);
					break;

				case IDM_FDD1OPEN:
					diskdrv_changefdd(0);
					break;
				case IDM_FDD1EJECT:
					diskdrv_ejectfdd(0);
					break;
				case IDM_FDD2OPEN:
					diskdrv_changefdd(1);
					break;
				case IDM_FDD2EJECT:
					diskdrv_ejectfdd(1);
					break;

				case IDM_HDD1OPEN:
					diskdrv_changehdd(np2cfg.REMOVEHD);
					break;
				case IDM_HDD1EJECT:
					diskdrv_ejecthdd(np2cfg.REMOVEHD);
					break;

				case IDM_WINDOW:
					if (changescreen(SCMD_SETWINDOWED)) {
						PostQuitMessage(0);
					}
					break;
				case IDM_FULLSCREEN:
					if (changescreen(SCMD_SETFULLSCREEN)) {
						PostQuitMessage(0);
					}
					break;

				case IDM_ROLNORMAL:
					xmenu_setroltate(0);
					changescreen(SCMD_SETNORMAL);
					break;

				case IDM_ROLLEFT:
					xmenu_setroltate(1);
					changescreen(SCMD_SETLEFT);
					break;

				case IDM_ROLRIGHT:
					xmenu_setroltate(2);
					changescreen(SCMD_SETRIGHT);
					break;

				case IDM_NOWAIT:
					INIT_RENEWAL xmenu_setwaitflg(np2cfg.NOWAIT ^ 1);
					break;
				case IDM_60FPS:
					INIT_RENEWAL xmenu_setflame(1);
					break;
				case IDM_30FPS:
					INIT_RENEWAL xmenu_setflame(2);
					break;
				case IDM_20FPS:
					INIT_RENEWAL xmenu_setflame(3);
					break;
				case IDM_15FPS:
					INIT_RENEWAL xmenu_setflame(4);
					break;
				case IDM_DISPSYNC:
					INIT_RENEWAL xmenu_setdispmode(np2cfg.DISPSYNC ^ 1);
					break;
				case IDM_SCREENOPT:
					DSound_Stop();
					mx_topwinui();
					DialogBox(hInst, MAKEINTRESOURCE(IDD_SCREENOPT),
									hWnd, (DLGPROC)ScroptDlgProc);
					mx_clearwinui();
					DSound_Play();
					break;

				case IDM_KEY:
					xmenu_setkey(0);
					break;
				case IDM_JOY1:
					xmenu_setkey(1);
					break;
				case IDM_JOY2:
					xmenu_setkey(2);
					break;
				case IDM_XSHIFT:
					xmenu_setxshift(np2cfg.XSHIFT ^ 1);
					keyboard_forcerelease(0x70);
					break;
				case IDM_XCTRL:
					xmenu_setxshift(np2cfg.XSHIFT ^ 2);
					keyboard_forcerelease(0x74);
					break;
				case IDM_XGRPH:
					xmenu_setxshift(np2cfg.XSHIFT ^ 4);
					keyboard_forcerelease(0x73);
					break;
				case IDM_F12MOUSE:
					INIT_RENEWAL xmenu_setf12copy(0);
					winkey_resetcopyhelp();
					break;
				case IDM_F12COPY:
					INIT_RENEWAL xmenu_setf12copy(1);
					winkey_resetcopyhelp();
					break;
				case IDM_F12STOP:
					INIT_RENEWAL xmenu_setf12copy(2);
					winkey_resetcopyhelp();
					break;

				case IDM_BEEPOFF:
					INIT_RENEWAL xmenu_setbeepvol(0);
					break;
				case IDM_BEEPLOW:
					INIT_RENEWAL xmenu_setbeepvol(1);
					break;
				case IDM_BEEPMID:
					INIT_RENEWAL xmenu_setbeepvol(2);
					break;
				case IDM_BEEPHIGH:
					INIT_RENEWAL xmenu_setbeepvol(3);
					break;

				case IDM_NOSOUND:
					INIT_RENEWAL xmenu_setsound(0);
					break;
				case IDM_PC9801_14:
					INIT_RENEWAL xmenu_setsound(1);
					break;
				case IDM_PC9801_26K:
					INIT_RENEWAL xmenu_setsound((np2cfg.SOUND_SW & 0x6) ^ 2);
					break;
				case IDM_PC9801_86:
					INIT_RENEWAL xmenu_setsound((np2cfg.SOUND_SW & 0x6) ^ 4);
					break;
				case IDM_PC9801_118:
					INIT_RENEWAL xmenu_setsound(8);
					break;

				case IDM_MIXER14:
					DSound_Stop();
					mx_topwinui();
					DialogBox(hInst, MAKEINTRESOURCE(IDD_MIXER14),
									hWnd, (DLGPROC)Mixer14DlgProc);
					mx_clearwinui();
					DSound_Play();
					break;

				case IDM_SEEKSND:
					INIT_RENEWAL xmenu_setmotorflg(np2cfg.MOTOR ^ 1);
					break;

				case IDM_JOYSTICK:
					INIT_RENEWAL xmenu_setjoystick(np2cfg.JOYSTICK ^ 1);
					break;
				case IDM_MOUSE:
					mouse_running(MOUSE_XOR);
					INIT_RENEWAL xmenu_setmouse(np2cfg.MOUSE_SW ^ 1);
					break;

				case IDM_MIDIPANIC:
					MIDI_AllToneOff();
					break;
				case IDM_MIMPIFILE:
					if (!(np2cfg.MIMPIDEF & 0x80)) {
						xmenu_setmimpidef(MIDI_EnableMimpiDef(
												(~np2cfg.MIMPIDEF) & 1));
					}
					break;
				case IDM_BMPSAVE:
					bmpsave();
					break;

				case IDM_S98LOGGING:
					xmenu_s98logging(S98_logging());
					break;
				case IDM_DISPCLOCK:
					INIT_RENEWAL xmenu_setdispclk(np2cfg.DISPCLK ^ 1);
					break;
				case IDM_JOYX:
					INIT_RENEWAL xmenu_setbtnmode(np2cfg.BTN_MODE ^ 1);
					break;
				case IDM_RAPID:
					INIT_RENEWAL xmenu_setbtnrapid(np2cfg.BTN_RAPID ^ 1);
					break;
				case IDM_MSRAPID:
					INIT_RENEWAL xmenu_setmsrapid(np2cfg.MOUSERAPID ^ 1);
					break;
				case IDM_I286SAVE:
					debug_status();
					break;

				case IDM_ABOUT:
					DSound_Stop();
					mx_topwinui();
					DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUT),
									hWnd, (DLGPROC)AboutDialogProc);
					mx_clearwinui();
					DSound_Play();
					break;
			}
			break;
		case WM_ACTIVATE:
			if (LOWORD(wParam) != WA_INACTIVE) {
				scrn_drawall();
				mouse_running(MOUSE_CONT_M);
			}
			else {
				mouse_running(MOUSE_STOP_M);
			}
			break;

		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			if (np2opening) {

			    HDC			hmdc;
			    HBITMAP		hbmp;
			    BITMAP		bmp;
			    HINSTANCE	hinst;

			    hinst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    			hbmp = LoadBitmap(hinst, "NP2BMP");
			    GetObject(hbmp, sizeof(BITMAP), &bmp);
			    hmdc = CreateCompatibleDC(hdc);
			    SelectObject(hmdc, hbmp);
			    BitBlt(hdc, (SCREEN_WIDTH - 252) / 2,
			    			(SCREEN_HEIGHT - 28) / 2,
							bmp.bmWidth, bmp.bmHeight, hmdc, 0, 0, SRCCOPY);
			    DeleteDC(hmdc);
	    		DeleteObject(hbmp);
			}
			else {
				scrn_drawall();
			}
			EndPaint(hWnd, &ps);
			break;

		case WM_QUERYNEWPALETTE:
			scrn_palette();
			break;

		case WM_MOVE:
			if (SCREENMODE & SCMD_WINDOWED) {
				GetWindowRect(hWnd, &rc);
				INIT_RENEWAL
					winx = rc.left;
					winy = rc.top;
			}
			break;

		case WM_ENTERMENULOOP:
			DSound_Stop();
			mx_topwinui();
			if (!(SCREENMODE & SCMD_WINDOWED)) {
				DrawMenuBar(hWnd);
			}
			break;
		case WM_EXITMENULOOP:
			mx_clearwinui();
			DSound_Play();
			break;
		case WM_ENTERSIZEMOVE:
			DSound_Stop();
			mouse_running(MOUSE_STOP);
			win_movingstart();
			break;
		case WM_EXITSIZEMOVE:
			mouse_running(MOUSE_CONT);
			DSound_Play();
			break;
		case WM_MOVING:
			if (np2cfg.WINSNAP) {
				win_movingproc((RECT *)lParam);
			}
			break;

		case WM_KEYDOWN:
			if (wParam == VK_F11) {
				return(DefWindowProc(hWnd, WM_SYSKEYDOWN, VK_F10, lParam));
			}
			if ((wParam == VK_F12) && (!np2cfg.F12COPY)) {
				mouse_running(MOUSE_XOR);
				INIT_RENEWAL xmenu_setmouse(np2cfg.MOUSE_SW ^ 1);
			}
			else {
				winkeydown106(wParam, lParam);
			}
			break;
		case WM_KEYUP:
			if (wParam == VK_F11) {
				return(DefWindowProc(hWnd, WM_SYSKEYUP, VK_F10, lParam));
			}
			if ((wParam != VK_F12) || (np2cfg.F12COPY)) {
				winkeyup106(wParam, lParam);
			}
			break;

		case WM_SYSKEYDOWN:
			winkeydown106(wParam, lParam);
			break;

		case WM_SYSKEYUP:
			winkeyup106(wParam, lParam);
			break;

		case WM_LBUTTONDOWN:
			if (!mouse_btn(MOUSE_LEFTDOWN)) {
				if (SCREENMODE & SCMD_FULLSCRN) {
					POINT	p;
					if ((GetCursorPos(&p)) && (p.y >= 466)) {
						INIT_RENEWAL np2cfg.clockx++;
						dclock_reset();
					}
				}
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
		case WM_LBUTTONUP:
			if (!mouse_btn(MOUSE_LEFTUP)) {
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
		case WM_RBUTTONDOWN:
			if (!mouse_btn(MOUSE_RIGHTDOWN)) {
				if (SCREENMODE & SCMD_FULLSCRN) {
					POINT	p;
					if ((GetCursorPos(&p)) && (p.y >= 466) &&
												(np2cfg.clockx)) {
						INIT_RENEWAL np2cfg.clockfnt++;
						dclock_reset();
					}
				}
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;
		case WM_RBUTTONUP:
			if (!mouse_btn(MOUSE_RIGHTUP)) {
				return(DefWindowProc(hWnd, msg, wParam, lParam));
			}
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return(0L);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
										LPSTR lpszCmdLine, int nCmdShow) {
	WNDCLASS	np2;
	MSG			msg;
	HMENU		hMenu;
	HWND		hwndorg;

	dosio_init();
	file_setcd(__argv[0]);
	initload();

	memcpy(szClassName, np2cfg.winid, 3);

	if ((hwndorg = FindWindow(szClassName, NULL)) != NULL) {
		ShowWindow(hwndorg, SW_RESTORE);
		SetForegroundWindow(hwndorg);
		dosio_term();
		return(FALSE);
	}

	hInst = hInstance;
	TRACE_START();

	if (np2cfg.KEYBOARD >= 1) {
		if (!(GetKeyboardType(1) & 0x0d00)) {
			np2cfg.KEYBOARD = 0;				// PC-AT
		}
	}
	winkeyinit106();

	if (!hPreInst) {
		np2.style = CS_BYTEALIGNCLIENT | CS_HREDRAW | CS_VREDRAW;
		np2.lpfnWndProc = WndProc;
		np2.cbClsExtra = 0;
		np2.cbWndExtra = 0;
		np2.hInstance = hInstance;
		np2.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
		np2.hCursor = LoadCursor(NULL, IDC_ARROW);
		np2.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
		np2.lpszMenuName = MAKEINTRESOURCE(IDM_MAIN);
		np2.lpszClassName = szClassName;
		if (!RegisterClass(&np2)) {
			return(FALSE);
		}
	}

	hWndMain = CreateWindowEx(0,
						szClassName, np2cfg.titles,
						WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION |
						WS_MINIMIZEBOX,
						CW_USEDEFAULT, CW_USEDEFAULT,
						SCREEN_WIDTH, SCREEN_HEIGHT,
						NULL, NULL, hInstance, NULL);

	np2_initwindowsize(SCREEN_WIDTH, SCREEN_HEIGHT);

	makecaption(3, 0);

	xmenu_setsound(np2cfg.SOUND_SW);
	xmenu_setbeepvol(np2cfg.BEEP_VOL);
	xmenu_setkey(0);
	xmenu_setbtnrapid(np2cfg.BTN_RAPID);
	xmenu_setbtnmode(np2cfg.BTN_MODE);
	xmenu_setmsrapid(np2cfg.MOUSERAPID);
	xmenu_setwaitflg(np2cfg.NOWAIT);
	xmenu_setflame(np2cfg.DRAW_SKIP);
	xmenu_setdispmode(np2cfg.DISPSYNC);
	xmenu_setjoystick(np2cfg.JOYSTICK);
	xmenu_setdispclk(np2cfg.DISPCLK);
	xmenu_seti286save(np2cfg.I286SAVE);
	xmenu_setmotorflg(np2cfg.MOTOR);
	xmenu_setroltate(0);
	xmenu_setxshift(0);
	xmenu_setf12copy(np2cfg.F12COPY);

	xmenu_setmouse(np2cfg.MOUSE_SW);
	if (np2cfg.MOUSE_SW) {
		mouse_running(MOUSE_ON);
	}

	np2_setscreenmode(SCMD_SETWINDOWED);
	np2_windowstats();
	ShowWindow(hWndMain, nCmdShow);
	UpdateWindow(hWndMain);

	hMenu = GetSystemMenu(hWndMain, FALSE);
	InsertMenu(hMenu, 0, MF_BYPOSITION | MF_STRING, IDM_SCREENCENTER,
							"Z^O(&X)");
	InsertMenu(hMenu, 1, MF_BYPOSITION | MF_STRING, IDM_SNAPENABLE,
							"Xibv(&S)");
	InsertMenu(hMenu, 2, MF_BYPOSITION | MF_SEPARATOR, 0, NULL);
#ifdef TRACE
	InsertMenu(hMenu, 2, MF_BYPOSITION | MF_STRING, IDM_TRACEONOFF,
							"g[X");
#endif
	if (np2cfg.I286SAVE) {
		InsertMenu(hMenu, 2, MF_BYPOSITION | MF_STRING, IDM_MEMORYDUMP,
							"_v");
	}
	DrawMenuBar(hWndMain);

	xmenu_setwinsnap(np2cfg.WINSNAP);

	dclock_init();

	np2_setscreenmode(SCMD_SET256);
	ddraws_init();
	if (np2_InitDirectDraw()) {
		np2_TermDirectDraw();
		disable_windowmenu();
		np2_setscreenmode(SCMD_SETFULLSCREEN);
		np2_windowstats();
		if (np2_InitDirectDraw()) {
			np2_TermDirectDraw();
			MessageBox(hWndMain, "Couldn't create DirectDraw Object",
													np2cfg.titles, MB_OK);
			return(FALSE);
		}
	}

	if (np2cfg.samplingrate) {
		DirectSound3_Init();
		dx3_WaveInit();
		dx3_WaveCreate("fddseek.wav", 0, np2cfg.MOTORVOL);
		dx3_WaveCreate("fddseek1.wav", 1, np2cfg.MOTORVOL);
	}

	INIT_RESET

	joy_init();
	np2_init();
	S98init();

	if (MIDI_SetMimpiMap(mimpideffile)) {
		xmenu_setmimpidef(0);
	}
	else {
		xmenu_setmimpidef(0x80);
	}

	ddraws_redraw();

	np2_reset();

	np2opening = 0;
	while(1) {
		if (PeekMessage(&msg, 0, 0, 0, PM_NOREMOVE)) {
			if (!GetMessage(&msg, NULL, 0, 0)) {
				break;
			}
			if ((msg.message != WM_SYSKEYDOWN) &&
				(msg.message != WM_SYSKEYUP)) {
				TranslateMessage(&msg);
			}
			DispatchMessage(&msg);
		}
		else {
			if (framecnt) {
				framecnt--;
				joy_flash();
				mouse_callback();
				np2_exec();
				diskdrv_callbackfdd();
			}
			else {
				if ((timing_getcount() >= np2cfg.DRAW_SKIP) ||
													(np2cfg.NOWAIT)) {
					timing_setcount(0);
					framecnt = np2cfg.DRAW_SKIP;
					if (!framecnt) {
						framecnt = 1;
					}
				}
				if (np2cfg.DISPCLK) {
					long khz = workclock_khz();
					if (khz >= 0) {
						makecaption(2, khz);
					}
				}
			}
		}
	}

	if (np2_getmemsw()) {
		INIT_RENEWAL;
	}

	mouse_running(MOUSE_OFF);
	S98trash();
	np2_term();

	dx3_WaveAllTerm();
	DirectSound3_Term();
	np2_TermDirectDraw();
	initsave();

	TRACE_END();
	dosio_term();

	return(msg.wParam);
}

