#include	<windows.h>
#include	"common.h"
#include	"np2.h"
#include	"pc_core.h"
#include	"i286.h"
#include	"memory.h"
#include	"ddraws.h"
#include	"dsound3.h"
#include	"nevent.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"gdc_sub.h"
#include	"crtc.h"
#include	"emm.h"
#include	"fmboard.h"
#include	"beep.h"
#include	"mouseif.h"
#include	"cgrom.h"
#include	"bios.h"
#include	"maketext.h"
#include	"makegrph.h"
#include	"timing.h"
#include	"dosio.h"
#include	"keyboard.h"
#include	"itimer.h"
#include	"sysport.h"
#include	"dialog.h"
#include	"midi.h"
#include	"fddfile.h"
#include	"printif.h"
#include	"fdd_mtr.h"
#include	"fdc.h"
#include	"dmac.h"
#include	"calender.h"
#include	"dclock.h"

#include	"trace.h"

	PCCORE_TABLE	pc = {	PCBASECLOCK25,
							4,
							4 * PCBASECLOCK25,
							4 * PCBASECLOCK25 * 50 / 3104,
							4 * PCBASECLOCK25 * 5 / 3104,
							4 * PCBASECLOCK25 / 120,
							4 * PCBASECLOCK25 / 200,
							4 * PCBASECLOCK25 / 100,
							4 * PCBASECLOCK25 / 1920,
							4 * PCBASECLOCK25 / 3125,
							100, 20,
							0};

									// on=0, off=1
	BYTE	dip_default[3] = {0x3e, 0x63, 0x7a};
	BYTE	msw_default[8] = {0x48, 0x05, 0x04, 0x00, 0x01, 0x00, 0x00, 0x6E};


typedef struct {
	BYTE	timing;
	BYTE	disp;
} CURSOLE_TABLE;

	CURSOLE_TABLE	cursole;

	BYTE	screenupdate = 3;
	int		screendispflag = 1;

#ifdef __cplusplus
extern "C" {
#endif
	BYTE	mem[0x300000];
#ifdef __cplusplus
}
#endif

static struct {
	DWORD	tick;
	DWORD	clock;
} worklast;


void workclock_reset(void) {

	worklast.tick = GetTickCount();
	worklast.clock = nevent.clock;
}

long workclock_khz(void) {

	long	ret;
	DWORD	tick = GetTickCount();

	if ((tick - worklast.tick) < 2000) {
		return(-1);
	}
	ret = (nevent.clock - worklast.clock) / (tick - worklast.tick);
	worklast.tick = tick;
	worklast.clock = nevent.clock;
	return(ret);
}


void setpcclock(DWORD base, DWORD multiple) {

	if (base >= ((PCBASECLOCK25 + PCBASECLOCK20) / 2)) {
		pc.baseclock = PCBASECLOCK25;			// 2.5MHz
		pc.cpumode = 0;
		pc.raster = 100;
		pc.hsync = 20;
		MEM_BIOS_FLAG &= 0x7f;
	}
	else {
		pc.baseclock = PCBASECLOCK20;			// 2.0MHz
		pc.cpumode = CPUMODE_8MHz;
		MEM_BIOS_FLAG |= 0x80;
		pc.raster = 80;
		pc.hsync = 16;
	}
	if (multiple == 0) {
		multiple = 1;
	}
	else if (multiple > 32) {
		multiple = 32;
	}

	pc.multiple = multiple;
	pc.realclock = pc.baseclock * multiple;
	pc.dispclock = pc.realclock * 50 / 3104;
	pc.vsyncclock = pc.realclock * 5 / 3104;
	pc.mouseclock = pc.realclock / 120;
	pc.dsoundclock = pc.realclock / 200;
	pc.dsoundclock2 = pc.realclock / 100;
	pc.keyboardclock = pc.realclock / 1920;
	pc.midiclock = pc.realclock / 3125;
}


static int lcdpal_a[27] = {
					 0, 1, 2, 3, 5, 2, 4, 4, 6, 7, 9, 2,11,13, 2, 4, 4, 6, 8,
					 8,10, 8, 8,10,12,12,14};
static PALETTE_TABLE lcdpal[15];

static void lcdinit(void) {

	int		i;

	for (i=0; i<15; i++) {
		lcdpal[i].b.blue = (BYTE)
			((((np2cfg.FG_COLOR >> 0) & 0x0000ff) * i + 
			((np2cfg.BG_COLOR >> 0) & 0x0000ff) * (14-i)) / 14);
		lcdpal[i].b.green = (BYTE)
			((((np2cfg.FG_COLOR >> 8) & 0x0000ff) * i + 
			((np2cfg.BG_COLOR >> 8) & 0x0000ff) * (14-i)) / 14);
		lcdpal[i].b.red = (BYTE)
			((((np2cfg.FG_COLOR >> 16) & 0x0000ff) * i + 
			((np2cfg.BG_COLOR >> 16) & 0x0000ff) * (14-i)) / 14);
		lcdpal[i].b.flag = 0;
	}
}




void palettes(BYTE textpalset) {

	int				i, j, c;
	int				cpal;
	PALETTE_TABLE	p;

	np2_palettes = TOTAL_PALS;

	if (!(np2cfg.LCD_MODE & 1)) {
		for (i=0; i<16; i++) {
			np2_palette[i].d = gdc.pal[gdc.analog][i].d;
		}
		if (!textpalset) {
			cpal = 0x10;
		}
		else {
			np2_palette[0x90].d = 0;
			for (i=0; i<8; i++) {
				p.b.flag = 0;
				p.b.blue = ((i&1)?0xff:0x00);
				p.b.green = ((i&4)?0xff:0x00);
				p.b.red = ((i&2)?0xff:0x00);
				for (j=0; j<16; j++) {
					np2_palette[i*16+j+16].d = p.d;
				}
				np2_palette[i+0x91].d = p.d;
			}
			cpal = 0x99;
		}
		if (np2cfg.skipline) {
			for (i=0; i<16; i++) {
				np2_palette[i+EXT2_PAL].b.red =
					(BYTE)((np2cfg.skiplight * np2_palette[i].b.red) >> 8);
				np2_palette[i+EXT2_PAL].b.green =
					(BYTE)((np2cfg.skiplight * np2_palette[i].b.green) >> 8);
				np2_palette[i+EXT2_PAL].b.blue =
					(BYTE)((np2cfg.skiplight * np2_palette[i].b.blue) >> 8);
			}
			np2_palette[USE_PALS].d = np2_palette[EXT2_PAL].d;
			cpal = TOTAL_PALS;
		}
	}
	else {
		if (gdc.analog) {
			for (i=0; i<16; i++) {
				j = 0;
				if (gdc.pal[1][i].p.green >= 0x44) {
					j += 9;
					if (gdc.pal[1][i].p.green >= 0xbb) {
						j += 9;
					}
				}
				if (gdc.pal[1][i].p.red >= 0x44) {
					j += 3;
					if (gdc.pal[1][i].p.red >= 0xbb) {
						j += 3;
					}
				}
				if (gdc.pal[1][i].p.blue >= 0x44) {
					j++;
					if (gdc.pal[1][i].p.blue >= 0xbb) {
						j++;
					}
				}
				c = lcdpal_a[j];
				if (np2cfg.LCD_MODE & 2) {
					c = 14 - c;
				}
				np2_palette[i].d = lcdpal[c].d;
			}
		}
		else {
			for (i=0; i<8; i++) {
				c = ((gdc.pal[0][i].p.blue >> 6) & 2) |
					((gdc.pal[0][i].p.red >> 5) & 4) |
					((gdc.pal[0][i].p.green >> 4) & 8);
				if (np2cfg.LCD_MODE & 2) {
					c = 14 - c;
				}
				np2_palette[i].d = lcdpal[c].d;
				np2_palette[i+8].d = lcdpal[c].d;
			}
		}
		if (textpalset) {
			for (i=0; i<8; i++) {
				c = i * 2;
				if (np2cfg.LCD_MODE & 2) {
					c = 14 - c;
				}
				for (j=0; j<16; j++) {
					np2_palette[i*16+j+16].d = lcdpal[c].d;
				}
				np2_palette[i+0x91].d = lcdpal[c].d;
			}
		}
		if (!(np2cfg.LCD_MODE & 2)) {
			np2_palette[0x90].d = lcdpal[0].d;
		}
		else {
			np2_palette[0x90].d = lcdpal[14].d;
		}
		if (!np2cfg.skipline) {
			cpal = 0x99;
		}
		else {
			for (i=0; i<16; i++) {
				np2_palette[i+EXT2_PAL].b.red =
					(BYTE)(((np2cfg.skiplight * np2_palette[i].b.red) +
							((256 - np2cfg.skiplight) *
										np2_palette[0x90].b.red)) >> 8);
				np2_palette[i+EXT2_PAL].b.green =
					(BYTE)(((np2cfg.skiplight * np2_palette[i].b.green) +
							((256 - np2cfg.skiplight) *
										np2_palette[0x90].b.green)) >> 8);
				np2_palette[i+EXT2_PAL].b.blue =
					(BYTE)(((np2cfg.skiplight * np2_palette[i].b.blue) +
							((256 - np2cfg.skiplight) *
										np2_palette[0x90].b.blue)) >> 8);
			}
			cpal = TOTAL_PALS;
		}
	}
	change_palette(cpal);
}

// --------------------------------------------------------------------------

static void sound_init(void) {

	DSound_Init(np2cfg.samplingrate, np2cfg.delayms);
	FM_inittable();
	PSG_inittable();
	rhythm_init();
	pcm86init();
	beep_init();
	DSound_Play();
}

static void sound_term(void) {

	DSound_Stop();
	rhythm_term();
	DSound_Cleanup();
}


void np2_init(void) {

	loadfont();
	lcdinit();
	maketext_init();
	makegrph_init();
	gdcsub_init();
	bios0x1b_init();
	fddfile_init();

	sound_init();
	MIDI_Init();
}

void np2_term(void) {

	fdd_eject(0);
	fdd_eject(1);
	fdd_eject(2);
	fdd_eject(3);

	MIDI_Cleanup();
	bios0x1b_allclose();
	sound_term();
}


BOOL np2_getmemsw(void) {

	int		i;
	BOOL	ret = FALSE;

	for (i=0; i<8; i++) {
		if (np2cfg.memsw[i] != mem[0xa3fe2 + i*4]) {
			np2cfg.memsw[i] = mem[0xa3fe2 + i*4];
			ret = TRUE;
		}
	}
	return(ret);
}

void np2_reset(void) {

	int		i;

	ZeroMemory(mem, sizeof(mem));
	ZeroMemory(&cursole, sizeof(cursole));
	i286reset();
	CPUTYPE = 0;
	if (np2cfg.dipsw[2] & 0x80) {
		CPUTYPE = CPUTYPE_V30;
	}

	//XCb`
	for (i=0; i<8; i++) {
		mem[0xa3fe2 + i*4] = np2cfg.memsw[i];
	}

	bios0x18_16(0x20, 0xe1);

	if (sound_renewals) {
		sound_renewals = 0;
		sound_term();
		sound_init();
	}

	soundboard_reset(np2cfg.SOUND_SW);

	bios_init();
	nowkeystat2biosbuf();
	setpcclock(np2cfg.baseclock, np2cfg.multiple);
	nevent_init();
	cgrom_init();
	gdc_init();
	itimer_init();
	timing_init();
	pic_init();
	emm_init();
	crtc_init();
	mouseif_init();
	keyboard_init();
	systemport_init();
	mpu98ii_init();
	printif_init();
	fddmtr_init();
	fdc_init();
	dmac_init();
	calender_init();
	palettes(1);

	bios0x1b_hddreopen();
//	bootstrapload();

	MIDI_moduleset(np2cfg.MIDIMODULE);
	if (np2cfg.MIDIRESET) {
		MIDI_Reset();
	}
	workclock_reset();

	DSound_ResetSample();
	DSound_Send();

	if (np2cfg.ITF_WORK) {
		CS_BASE = 0xffff0;
		I286_CS = 0xffff;
		I286_IP = 0x0000;
	}
	else {
		for (i=0; i<8; i++) {
			mem[0xa3fe2 + i*4] = msw_default[i];
		}
		CS_BASE = 0xfd800;
		I286_CS = 0xfd80;
		I286_IP = 0x0002;
	}
}


static void drawscreen(void) {

extern	WORD	framecnt;
		BYTE	timing;

	cursole.timing++;
	if (!framecnt) {
		if (gdcs.textdisp & GDCSCRN_ENABLE) {
			timing = ((*(WORD *)(&gdc.m.para[GDC_CSRFORM+1])) >> 5) & 0x3e;
			if (!timing) {
				timing = 0x40;
			}
			if (cursole.timing >= timing) {
				cursole.timing = 0;
				cursole.disp ^= 1;
				gdcs.textdisp |= 1;
			}
			if (gdcs.textdisp & GDCSCRN_MAKE) {
				if (!(gdc.mode1 & 0x4)) {
					maketext(gdcs.textdisp & GDCSCRN_ALLDRAW, cursole.disp);
				}
				else {
					maketext40(gdcs.textdisp & GDCSCRN_ALLDRAW, cursole.disp);
				}
				gdcs.textdisp &= ~GDCSCRN_MAKE;
				screenupdate |= 1;
			}
		}
		if (gdcs.palchange) {
			gdcs.palchange = 0;
			palettes(0);
			screenupdate |= 1;
		}
		if (gdcs.grphdisp & GDCSCRN_ENABLE) {
			if (!gdcs.disp) {
				if (gdcs.grphdisp & GDCSCRN_MAKE) {
					makegrph(0, gdcs.grphdisp & GDCSCRN_ALLDRAW);
					gdcs.grphdisp &= ~GDCSCRN_MAKE;
					screenupdate |= 1;
				}
			}
			else {
				if (gdcs.grphdisp & (GDCSCRN_MAKE << 1)) {
					makegrph(1, gdcs.grphdisp & (GDCSCRN_ALLDRAW << 1));
					gdcs.grphdisp &= ~(GDCSCRN_MAKE << 1);
					screenupdate |= 1;
				}
			}
		}
		if (screenupdate) {
			scrn_draws(screenupdate & 2);
			scrn_drawall();
			screenupdate = 0;
		}
#if 1
		{
			extern void dispclock(void);
			dispclock();
		}
#endif
	}
}


void screendisp(NEVENT_ITEM *item) {

	gdc_work(&gdc.s, &gdcs.grphdisp);
	gdc.vsync = 0;
	screendispflag = 0;
	if (!np2cfg.DISPCLK) {
		drawscreen();
	}
}

void screenvsync(NEVENT_ITEM *item) {

	gdc_work(&gdc.m, &gdcs.textdisp);
	gdc.vsync = 0x20;
	if (gdc.vsyncint) {
		gdc.vsyncint = 0;
		pic_setirq(2);
	}
	nevent_set(NEVENT_FLAMES, pc.vsyncclock, screendisp, NEVENT_RELATIVE);
	if (np2cfg.DISPCLK) {
		drawscreen();
	}
}

void np2_exec(void) {

static WORD	cs = 0;
static WORD	ip = 0;

	DSound_Send();
	gdc.vsync = 0;
	screendispflag = 1;
	nevent_set(NEVENT_FLAMES, pc.dispclock, screenvsync, NEVENT_RELATIVE);

	while(screendispflag) {
		pic_irq();
		nevent_get1stevent();
#ifndef TRACE
		if (!dma.working) {
			i286();
		}
		else {
			i286withdma();
		}
#else
		while(nevent.remainclock > 0) {
			TRACE1();
#if 0
			if (i286_memword_read(I286_CS, I286_IP) == 0x21cd) {
				cs = I286_CS;
				ip = I286_IP;
				TRACE_("int21", I286_AH);
			}
#endif
			i286_step();
		}
#endif
		nevent_progress();
	}
	calender_inc();
}

