#include	<windows.h>

#include	"common.h"
#include	"np2.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"fmboard.h"
#include	"beep.h"
#include	"s98.h"

static void __fastcall makesounds(void *buf, int length) {

	FM_update(buf, length);
	PSG_update(buf, &psg_1, length);
	rhythm_update(buf, length);
	cs4231_update(buf, length);
	beep_update(buf, length);
}

void ymf_init(void) {

	FM_reset();
	PSG_reset(&psg_1);
	PSG_reset(&psg_2);
	rhythm_reset();
	cs4231_reset();
	FMCH[3].stereo = 1;
	FMCH[4].stereo = 1;
	FMCH[5].stereo = 1;
}

static I286_OUT ymf_w(WORD port, BYTE value) {

	switch(port & 0x307) {
		case 0x100:
			opn.opnreg = value;
			break;

		case 0x102:
			S98_put(NORMAL2608, opn.opnreg, value);
			if (opn.opnreg < 0x10) {
				if (opn.opnreg != 0x0e) {
					*((BYTE *)(&psg_1.reg) + opn.opnreg) = value;
					DSound_Send0();
					PSG_setregister(&psg_1, opn.opnreg);
				}
			}
			else {
				if (opn.opnreg < 0x20) {
					rhythm_setregister(opn.opnreg, value);
				}
				else if (opn.opnreg < 0x30) {
					if (opn.opnreg == 0x28) {
						if ((value & 0x0f) < 3) {
							DSound_Send0();
							FM_keyon(value & 0x0f, value);
						}
						else if (((value & 0x0f) != 3) &&
								((value & 0x0f) < 7)) {
							DSound_Send0();
							FM_keyon((value & 0x07) - 1, value);
						}
					}
					else {
						FMBOARD_setregister(opn.opnreg, value);
					}
				}
				else if (opn.opnreg < 0xc0) {
					DSound_Send0();
					FM_setregister(opn.opnreg, value, 0);
				}
				opn.reg[opn.opnreg] = value;
			}
			break;

		case 0x104:
			opn.extreg = value;
			break;

		case 0x106:
			S98_put(EXTEND2608, opn.extreg, value);
			opn.reg[opn.extreg + 0x100] = value;
			if (opn.extreg >= 0x30) {
				DSound_Send0();
				FM_setregister(opn.extreg, value, 3);
			}
			else {
				if (opn.extreg == 0x10) {
					if (!(value & 0x80)) {
						opn.adpcmmask = ~(value & 0x1c);
					}
				}
			}
			break;
	}
}

static I286_INB ymf_r(WORD port) {

	switch(port & 0x307) {
		case 0x100:
			return(fmtimer.status);

		case 0x102:
			if (opn.opnreg == 0x0e) {
				return(PSG_getjoyport(&psg_1));
			}
			else if (opn.opnreg < 0x10) {
				return(*(((BYTE *)(&psg_1.reg)) + opn.opnreg));
			}
			return(opn.reg[opn.opnreg]);

		case 0x104:
			if (opn.extend) {
				return(fmtimer.status & 3);
			}
			break;

		case 0x106:
			if (opn.extend) {
				return(opn.reg[opn.opnreg]);
			}
			break;
	}
	return(0xff);
}

static void extendchannel(BYTE enable) {

	int		i;

	opn.extend = enable;
	if (enable) {
		opn.channels = 6;
	}
	else {
		opn.channels = 3;
	}
	for (i=0; i<3; i++) {
		FMCH[i].stereo = enable;
		FM_setalgorithm(&FMCH[i]);
	}
}


static I286_OUT pcm86_118w(WORD port, BYTE val) {

	if (port == 0xa460) {
		pcm86.extfunc = val;
		extendchannel(val & 1);
	}
}

static I286_INB pcm86_118r(WORD port) {

	if (port == 0xa460) {
		return(0x80 | (pcm86.extfunc & 1));
	}
	return(0xff);
}


SOUNDBOARDS BOARD118 = {
				ymf_w,
				ymf_r,
				pcm86_118w,
				pcm86_118r,
				makesounds,
				extendchannel};

