#include	<windows.h>

#include	"common.h"
#include	"np2.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"fmboard.h"
#include	"beep.h"
#include	"musicgen.h"
#include	"itimer.h"
#include	"nevent.h"
#include	"pic.h"

// #include	"trace.h"

	BOARD14_T	board14 = {0x0300, 0x200, 0x300, 0x100, 0x080};

	MUSICGEN	musicgen;
	MUSICPSG	musicpsg[8];

extern	BYTE	psg14_rate;

static DWORD psgkeys[] = {
			0,	0x051B, 0x0569, 0x05BB, 0x0613, 0x066F, 0x06D1,
				0x0739, 0x07A7, 0x081B, 0x0897, 0x091A, 0x09A4, 0,0,0,
			0,	0x0A37, 0x0AD3, 0x0B77, 0x0C26, 0x0CDF, 0x0DA3,
				0x0E72, 0x0F4E, 0x1037, 0x112E, 0x1234, 0x1349, 0,0,0,
			0,	0x146E, 0x15A6, 0x16EF, 0x184C, 0x19BE, 0x1B46,
				0x1CE5, 0x1E9D, 0x206F, 0x225D, 0x2468, 0x2692, 0,0,0,
			0,	0x28DD, 0x2B4C, 0x2DDF, 0x3099, 0x337D, 0x368D,
				0x39CB, 0x3D3B, 0x40DF, 0x44BA, 0x48D1, 0x4D25, 0x51BB, 0,0};


#define	MUSICGEN_MAKE													\
			__asm {	xor		eax, eax								}	\
			__asm {	or		ebx, 30000h								}	\
	musicgen_chlp:														\
			__asm {	shr		ebx, 1									}	\
			__asm {	jnc		musicgen_ched							}	\
			__asm {	mov		ebp, [esi]MUSICPSG.mpsg_freq			}	\
			__asm {	or		ebp, ebp								}	\
			__asm {	je		musicgen_ched							}	\
			__asm {	mov		edi, [esi]MUSICPSG.mpsg_sound_cnt		}	\
			__asm {	mov		bh, 4									}	\
	musicgen_cheflp:													\
			__asm {	add		edi, ebp								}	\
			__asm {	test	edi, 10000h								}	\
			__asm {	jne		musicgen_chefms							}	\
			__asm {	add		eax, board14.center						}	\
			__asm {	jmp		musicgen_chefed							}	\
	musicgen_chefms:													\
			__asm {	sub		eax, board14.center						}	\
	musicgen_chefed:													\
			__asm {	dec		bh										}	\
			__asm {	jne		musicgen_cheflp							}	\
			__asm {	mov		[esi]MUSICPSG.mpsg_sound_cnt, edi		}	\
	musicgen_ched:														\
			__asm {	add		esi, (type MUSICPSG)					}	\
			__asm {	test	ebx, 10000h								}	\
			__asm {	jne		musicgen_chlp							}

#define	MUSICGEN_FEETMAKE(bitvalue, vol, n)								\
			__asm {	test	edi, bitvalue							}	\
			__asm {	jne		musicgen##n##_##vol##ms					}	\
			__asm {	add		eax, board14.##vol##					}	\
			__asm {	jmp		musicgen##n##_##vol##ed					}	\
	musicgen##n##_##vol##ms:											\
			__asm {	sub		eax, board14.##vol##					}	\
	musicgen##n##_##vol##ed:

#define	MUSICGEN_MAKE3(n)												\
			__asm {	xor		eax, eax								}	\
			__asm {	or		ebx, 70000h								}	\
	musicgen##n##_chlp:													\
			__asm {	shr		ebx, 1									}	\
			__asm {	jnc		musicgen##n##_ched						}	\
			__asm {	mov		ebp, [esi]MUSICPSG.mpsg_freq			}	\
			__asm {	or		ebp, ebp								}	\
			__asm {	je		musicgen##n##_ched						}	\
			__asm {	mov		edi, [esi]MUSICPSG.mpsg_sound_cnt		}	\
			__asm {	mov		bh, 4									}	\
	musicgen##n##_cheflp:												\
			__asm {	add		edi, ebp								}	\
			MUSICGEN_FEETMAKE(10000h, f2, n)							\
			MUSICGEN_FEETMAKE(20000h, f4, n)							\
			MUSICGEN_FEETMAKE(40000h, f8, n)							\
			MUSICGEN_FEETMAKE(80000h, f16, n)							\
			__asm {	dec		bh										}	\
			__asm {	jne		musicgen##n##_cheflp					}	\
			__asm {	mov		[esi]MUSICPSG.mpsg_sound_cnt, edi		}	\
	musicgen##n##_ched:													\
			__asm {	add		esi, (type MUSICPSG)					}	\
			__asm {	test	ebx, 10000h								}	\
			__asm {	jne		musicgen##n##_chlp						}



static LABEL void __fastcall makesounds(void *buf, int length) {

	__asm {
				cmp		edx, 0
				je		nosoundmakes
				pushad
	mpsgmake_lp:
				movzx	ebx, musicgen.mask
				mov		esi, offset musicpsg
				MUSICGEN_MAKE
				mov		[ecx], eax
				mov		[ecx+4], eax
				MUSICGEN_MAKE3(1)
				add		[ecx], eax
				MUSICGEN_MAKE3(2)
				add		[ecx+4], eax
				add		ecx, 8
				dec		edx
				jne		mpsgmake_lp
				popad
				call 	beep_update
		nosoundmakes:
				ret
	}
}


void musicgenint(NEVENT_ITEM *item);

static void setmusicgenevent(BOOL absolute) {

	DWORD	cnt;

	if (itimer.value[3].w > 8) {					// Ȃ
		cnt = pc.multiple * itimer.value[3].w;
	}
	else {
		cnt = pc.multiple << 16;
	}
	nevent_set(NEVENT_MUSICGEN, cnt, musicgenint, absolute);
}


void musicgenint(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		if ((itimer.mode[3] & 0x0c) == 0x04) {
			// [gWFl[^
			setmusicgenevent(NEVENT_RELATIVE);
		}
	}
	pic_setirq(0x0c);
}

// ------------------------------------------------------------------------

void musicgen_setvol(void) {

	int		i;
	DWORD	*p = (DWORD *)(&board14);

	for (i=0; i<5; i++) {
		*p++ = (np2cfg.vol14[i] & 0x0f) << 6;
	}
}

void musicgen_reset(void) {

	ZeroMemory(&musicgen, sizeof(musicgen));
	ZeroMemory(musicpsg, sizeof(musicpsg));
	musicgen_setvol();
}

static I286_OUT musicgen_w(WORD port, BYTE value) {

//	TRACEOUT(port, value);

	switch(port & 0x107) {
		case 0x000:
			musicgen.porta = value;
			break;

		case 0x002:
			musicgen.portb = value;
			break;

		case 0x004:
			if (value & 0x80) {
				if (!(musicgen.portc & 0x80)) {
					musicgen.sync = 1;
					musicgen.ch = 0;
				}
				else if (musicgen.sync) {
					musicgen.sync = 0;
					DSound_Send0();
					musicpsg[musicgen.ch].mpsg_freq
									= psgkeys[value & 0x3f] / psg14_rate;
				}
				else if ((!(value & 0x40)) && (musicgen.portc & 0x40)) {
					musicgen.sync = 1;
					musicgen.ch = (musicgen.ch + 1) & 7;
				}
			}
			musicgen.portc = value;
			break;

		case 0x100:
		case 0x102:
			DSound_Send0();
			musicgen.mask = value;
			break;

		case 0x104:
			itimer_setcount(3, value);
			setmusicgenevent(NEVENT_ABSOLUTE);
			break;

		case 0x106:
			itimer_setflag(3, value);
			break;
	}
}

static I286_INB musicgen_r(WORD port) {

//	TRACEIN(port);

	switch(port & 0x107) {
		case 0x000:
			return(musicgen.porta);
		case 0x002:
			return(musicgen.portb);
		case 0x004:
			return(musicgen.portc);

		case 0x006:
			return(0x08);

		case 0x100:
		case 0x102:
			return(musicgen.mask);

		case 0x104:
			return(itimer_getcount(3));

		case 0x106:
			return(0x40);					// INT-5
			break;
	}
	return(0xff);
}


SOUNDBOARDS BOARD14 = {
				musicgen_w,
				musicgen_r,
				sound_dummyout,
				sound_dummyin,
				makesounds,
				NULL};

