#include	<windows.h>

#include	"common.h"
#include	"np2.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"fmboard.h"
#include	"beep.h"
#include	"s98.h"

static void __fastcall makesounds(void *buf, int length) {

	FM_update(buf, length);
	PSG_update(buf, &psg_1, length);
	PSG_update(buf, &psg_2, length);
	rhythm_update(buf, length);
	PCM86_update(buf, length);
	beep_update(buf, length);
	FMCH[6].stereo = 1;
	FMCH[7].stereo = 1;
	FMCH[8].stereo = 1;
}


void opnx2_init(void) {

	FM_reset();
	PSG_reset(&psg_1);
	PSG_reset(&psg_2);
	rhythm_reset();
	opn.channels = 6;
}

static I286_OUT opnx2_w(WORD port, BYTE value) {

	switch(port & 0x307) {
		case 0x000:
			opn.lowreg = value;
			break;

		case 0x002:
			if (opn.lowreg < 0x10) {
				if (opn.lowreg != 0x0e) {
					*(((BYTE *)(&psg_1.reg)) + opn.lowreg) = value;
					DSound_Send0();
					PSG_setregister(&psg_1, opn.lowreg);
				}
			}
			else {
				if (opn.lowreg < 0x30) {
					if (opn.lowreg == 0x28) {
						if ((value & 0x0f) < 3) {
							DSound_Send0();
							FM_keyon(value & 0x0f, value);
						}
					}
					else {
						FMBOARD_setregister(opn.lowreg, value);
						if (opn.lowreg == 0x27) {
							FMCH[2].extop = value & 0xc0;
						}
					}
				}
				else if (opn.lowreg < 0xc0) {
					DSound_Send0();
					FM_setregister(opn.lowreg, value, 0);
				}
				opn.reg[opn.lowreg + 0x200] = value;
			}
			break;

		case 0x100:
			opn.opnreg = value;
			break;

		case 0x102:
			S98_put(NORMAL2608, opn.opnreg, value);
			if (opn.opnreg < 0x10) {
				if (opn.opnreg != 0x0e) {
					*((BYTE *)(&psg_2.reg) + opn.opnreg) = value;
					DSound_Send0();
					PSG_setregister(&psg_2, opn.opnreg);
				}
			}
			else {
				if (opn.opnreg < 0x20) {
					rhythm_setregister(opn.opnreg, value);
				}
				else if (opn.opnreg < 0x30) {
					if (opn.opnreg == 0x28) {
						if ((value & 0x0f) < 3) {
							DSound_Send0();
							FM_keyon((value & 0x0f)+3, value);
						}
						else if (((value & 0x0f) != 3) &&
								((value & 0x0f) < 7)) {
							DSound_Send0();
							FM_keyon((value & 0x0f)+2, value);
						}
					}
					else {
						FMBOARD_setregister(opn.opnreg, value);
						if (opn.opnreg == 0x27) {
							FMCH[5].extop = value & 0xc0;
						}
					}
				}
				else if (opn.opnreg < 0xc0) {
					DSound_Send0();
					FM_setregister(opn.opnreg, value, 3);
				}
				opn.reg[opn.opnreg] = value;
			}
			break;

		case 0x104:
			opn.extreg = value;
			break;

		case 0x106:
			S98_put(EXTEND2608, opn.extreg, value);
			opn.reg[opn.extreg + 0x100] = value;
			if (opn.extreg >= 0x30) {
				DSound_Send0();
				FM_setregister(opn.extreg, value, 6);
			}
			else {
				if (opn.extreg == 0x10) {
					if (!(value & 0x80)) {
						opn.adpcmmask = ~(value & 0x1c);
					}
				}
			}
			break;
	}
}

static I286_INB opnx2_r(WORD port) {

	switch(port & 0x307) {

		case 0x000:
			return(fmtimer.status);

		case 0x002:
			if (opn.lowreg == 0x0e) {
				return(0xff);
			}
			if (opn.lowreg < 0x10) {
				return(*(((BYTE *)(&psg_1.reg)) + opn.lowreg));
			}
			break;

		case 0x100:
			return(fmtimer.status);

		case 0x102:
			if (opn.opnreg == 0x0e) {
				return(PSG_getjoyport(&psg_2));
			}
			else if (opn.opnreg < 0x10) {
				return(*(((BYTE *)(&psg_2.reg)) + opn.opnreg));
			}
			return(opn.reg[opn.opnreg]);

		case 0x104:
			if (opn.extend) {
				return((fmtimer.status & 3) | (opn.adpcmmask & 8));
			}
			break;

		case 0x106:
			if (opn.extend) {
				return(opn.reg[opn.opnreg]);
			}
			break;
	}
	return(0xff);
}

static void extendchannel(BYTE enable) {

	int		i;

	opn.extend = enable;
	if (enable) {
		opn.channels = 9;
	}
	else {
		opn.channels = 6;
	}
	for (i=3; i<6; i++) {
		FMCH[i].stereo = enable;
		FM_setalgorithm(&FMCH[i]);
	}
}

SOUNDBOARDS BOARDx2 = {
				opnx2_w,
				opnx2_r,
				pcm86_w,
				pcm86_r,
				makesounds,
				extendchannel};

