#include	<windows.h>
#include	"np2.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"fmboard.h"
#include	"musicgen.h"
#include	"pic.h"
#include	"nevent.h"

	FMTIMER_T	fmtimer;

	OPN_T	opn;
	PSG_T	psg_1;
	PSG_T	psg_2;

static void set_fmtimeraevent(BOOL absolute);
static void set_fmtimerbevent(BOOL absolute);

static void fmport_a(NEVENT_ITEM *item) {

	BOOL	intreq = FALSE;

	if (item->flag & NEVENT_SETEVENT) {
		if (fmtimer.reg & 0x01) {
			fmtimer.status |= 0x01;
		}
		if (fmtimer.reg & 0x04) {
			intreq = TRUE;
		}
		else if (pcm86.fifo & 0x20) {
			DSound_Send0();
			if (pcm86.bufsize < pcm86.fifosize) {
				intreq = TRUE;
			}
		}
		if (intreq) {
			pcm86.write = 1;
			pic_setirq(0x0c);
		}
		if (fmtimer.reg & 0x10) {
			set_fmtimeraevent(NEVENT_RELATIVE);
		}
	}
}

static void fmport_b(NEVENT_ITEM *item) {

	BOOL	intreq = FALSE;

	if (item->flag & NEVENT_SETEVENT) {
		if (fmtimer.reg & 0x02) {
			fmtimer.status |= 0x02;
		}
		if (fmtimer.reg & 0x08) {
			intreq = TRUE;
		}
		else if (pcm86.fifo & 0x20) {
			DSound_Send0();
			if (pcm86.bufsize < pcm86.fifosize) {
				intreq = TRUE;
			}
		}
		if (intreq) {
			pcm86.write = 1;
			pic_setirq(0x0c);
		}
		if (fmtimer.reg & 0x20) {
			set_fmtimerbevent(NEVENT_RELATIVE);
		}
	}
}

static void set_fmtimeraevent(BOOL absolute) {

	long l = 18 * (1024 - fmtimer.timera);

	if (pc.cpumode & CPUMODE_8MHz) {		// 4MHz
		l = (l * 1248 / 625) * pc.multiple;
	}
	else {									// 5MHz
		l = (l * 1536 / 625) * pc.multiple;
	}
	nevent_set(NEVENT_FMTIMERA, l, fmport_a, absolute);
}

static void set_fmtimerbevent(BOOL absolute) {

	long l = 288 * (256 - fmtimer.timerb);

	if (pc.cpumode & CPUMODE_8MHz) {		// 4MHz
		l = (l * 1248 / 625) * pc.multiple;
	}
	else {									// 5MHz
		l = (l * 1536 / 625) * pc.multiple;
	}
	nevent_set(NEVENT_FMTIMERB, l, fmport_b, absolute);
}


void FMBOARD_setregister(BYTE reg, BYTE value) {

	switch(reg) {
		case 0x24:
			fmtimer.timera = (value << 2) + (fmtimer.timera & 3);
			break;

		case 0x25:
			fmtimer.timera = (fmtimer.timera & 0x3fc) + (value & 3);
			break;

		case 0x26:
			fmtimer.timerb = value;
			break;

		case 0x27:
			fmtimer.reg = value;
			fmtimer.status &= ~((value & 0x30) >> 4);
			if ((value & 0x10) &&
				(!nevent_iswork(NEVENT_FMTIMERA))) {
				set_fmtimeraevent(NEVENT_ABSOLUTE);
			}
			if ((value & 0x20) &&
				(!nevent_iswork(NEVENT_FMTIMERB))) {
				set_fmtimerbevent(NEVENT_ABSOLUTE);
			}
			break;
	}
}

// --------------------------------------------------------------------------

SOUNDBOARDS soundboard = {
				sound_dummyout,
				sound_dummyin,
				sound_dummyout,
				sound_dummyin,
				makebeeponly,
				NULL};

void soundboard_init(void) {
}

void soundboard_trash(void) {
}

void soundboard_reset(BYTE num) {

	cs4231_disable();
	switch(num) {
		case 1:
			soundboard = BOARD14;
			musicgen_reset();
			break;

		case 2:
			soundboard = BOARD26K;
			opn_init();
			break;

		case 4:
			soundboard = BOARD86;
			opna_init();
			break;

		case 6:
			soundboard = BOARDx2;
			opnx2_init();
			break;

		case 8:
			soundboard = BOARD118;
			ymf_init();
			break;

		default:
			soundboard = BOARDNONE;
			break;
	}
}


