#include	<windows.h>
#include	"common.h"
#include	"iobridge.h"
#include	"fmboard.h"

extern	FM_CH	FMCH[];
extern	WORD	env_curve[];
extern	long	envtable[];
extern	short	sintable[];

extern	long	feedback2;
extern	long	feedback3;
extern	long	feedback4;

extern	long	outdl;
extern	long	outdc;
extern	long	outdr;

static	DWORD	makeremain;

#define	SUPPORT_PUCHINOISE

#define	OP_OUT															\
			__asm {	add		eax, [edi]FM_SLOT.freq_cnt				}	\
			__asm {	shr		eax, (FREQ_BITS-SIN_BITS - 1)			}	\
			__asm {	and		eax, (SIN_ENT - 1) * 2					}	\
			__asm {	movsx	eax, word ptr sintable[eax]				}	\
			__asm {	imul	envtable[edx*4]							}	\
			__asm {	sar		eax, (ENVTBL_BIT+SINTBL_BIT-TL_BITS)	}


#define	calc_envlope(n)													\
			__asm {	mov		eax, [edi]FM_SLOT.freq_inc				}	\
			__asm {	add		[edi]FM_SLOT.freq_cnt, eax				}	\
			__asm {	mov		eax, [edi]FM_SLOT.env_cnt				}	\
			__asm {	add		eax, [edi]FM_SLOT.env_inc				}	\
			__asm {	cmp		eax, [edi]FM_SLOT.env_end				}	\
			__asm {	jae		calc_newenv##n##						}	\
envret##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_cnt, eax				}	\
			__asm {	shr		eax, ENV_BITS							}	\
			__asm {	movzx	edx, word ptr [edi]FM_SLOT.totallevel	}	\
			__asm {	sub		dx, env_curve[eax*2]					}


#define	setenvlopmode(n)												\
			__asm {	mov		dl, [edi]FM_SLOT.env_mode				}	\
			__asm {	dec		dl										}	\
			__asm {	je		SETRR_##n##								}	\
			__asm {	dec		dl										}	\
			__asm {	je		SETD2_##n##								}	\
			__asm {	dec		dl										}	\
			__asm {	je		SETD1_##n##								}	\
			__asm {	dec		dl										}	\
			__asm {	jne		envret##n##								}	\
			__asm {	mov		[edi]FM_SLOT.env_mode, EM_DECAY1		}	\
			__asm {	mov		eax, [edi]FM_SLOT.decaylevel			}	\
			__asm {	mov		[edi]FM_SLOT.env_end, eax				}	\
			__asm {	mov		eax, [edi]FM_SLOT.env_inc_decay1		}	\
			__asm {	mov		[edi]FM_SLOT.env_inc, eax				}	\
			__asm {	mov		eax, EC_DECAY							}	\
			__asm {	jmp		envret##n##								}	\
SETD1_##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_mode, EM_DECAY2		}	\
			__asm {	mov		[edi]FM_SLOT.env_end, EC_OFF			}	\
			__asm {	mov		eax, [edi]FM_SLOT.env_inc_decay2		}	\
			__asm {	mov		[edi]FM_SLOT.env_inc, eax				}	\
			__asm {	mov		eax, [edi]FM_SLOT.decaylevel			}	\
			__asm {	jmp		envret##n##								}	\
SETRR_##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_mode, EM_OFF			}	\
SETD2_##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_end, EC_OFF + 1		}	\
			__asm {	mov		[edi]FM_SLOT.env_inc, 0					}	\
			__asm {	mov		eax, EC_OFF								}	\
			__asm {	jmp		envret##n##								}


// make OSC DATA  stereo 16bit
LABEL void __fastcall FM_update(void *buf, int buflength) {

	__asm {
				cmp		edx, 0
				je		opnanoupdate

				mov		makeremain, edx

				pushad
				mov		ebp, ecx

oscout_loop:	xor		eax, eax
				mov		outdl, eax
				mov		outdc, eax
				mov		outdr, eax

				mov		ch, opn.channels
				mov		edi, offset FMCH
calc_channel_lp:
				xor		eax, eax
				mov		feedback2, eax
				mov		feedback3, eax
				mov		feedback4, eax
				mov		esi, edi
				calc_envlope(1)						// slot1 calculate
				jl		calc_slot3
				mov		cl, [esi]FM_CH.feedback
				or		cl, cl
				je		notcalc_feed
				mov		eax, [esi]FM_CH.op1fb		// with feedback
				mov		ebx, eax
				shr		eax, cl
				OP_OUT
				mov		[esi]FM_CH.op1fb, eax
				add		eax, ebx
				sar		eax, 1
				jmp		ch_algchk
notcalc_feed:	xor		eax, eax					// without feedback
				OP_OUT
ch_algchk:		cmp		[esi]FM_CH.algorhythm, 5
				jne		calcch_an5
				mov		feedback2, eax				// case ALG == 5
				mov		feedback3, eax
				mov		feedback4, eax
				jmp		calc_slot3
calcch_an5:		mov		ebx, [esi]FM_CH.connect1	// case ALG != 5
				add		[ebx], eax
calc_slot3:		add		edi, (type FM_SLOT)			// slot3 calculate
				calc_envlope(2)
				jl		calc_slot2
				mov		eax, feedback2
				OP_OUT
				mov		ebx, [esi]FM_CH.connect2
				add		[ebx], eax
calc_slot2:		add		edi, (type FM_SLOT)			// slot2 calculate
				calc_envlope(3)
				jl		calc_slot4
				mov		eax, feedback3
				OP_OUT
				mov		ebx, [esi]FM_CH.connect3
				add		[ebx], eax
calc_slot4:		add		edi, (type FM_SLOT)			// slot4 calculate
				calc_envlope(4)
				jl		calc_slot_end
				mov		eax, feedback4
				OP_OUT
				mov		ebx, [esi]FM_CH.connect4
				add		[ebx], eax

calc_slot_end:	add		edi, (type FM_CH) - (type FM_SLOT)*3
				dec		ch
				jne		calc_channel_lp

				mov		eax, outdc
				mov		edx, eax
				add		eax, outdl
				add		edx, outdr
				sar		eax, (OPM_OUTSB+1)
				sar		edx, (OPM_OUTSB+1)
				mov		[ebp], eax
				mov		[ebp+4], edx
				add		ebp, 8
				dec		makeremain
				jne		oscout_loop

				popad
opnanoupdate:
				ret

calc_newenv1:	setenvlopmode(1)
calc_newenv3:	setenvlopmode(3)
calc_newenv2:	setenvlopmode(2)
calc_newenv4:	setenvlopmode(4)
	}
}

