#include	<windows.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<stdarg.h>
#include	<math.h>
#include	"common.h"
#include	"np2.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"fmboard.h"
#include	"pic.h"
#include	"nevent.h"
#include	"memory.h"
#include	"pc_core.h"
#include	"joystick.h"
#include	"keyboard.h"
#include	"s98.h"

		FM_CH		FMCH[MAXCHANNEL];

extern	long	detunetable[8][32];
extern	long	attacktable[94];
extern	long	decaytable[94];
extern	WORD	env_curve[];
extern	WORD	detune2table[];
extern	long	decayleveltable[];
extern	BYTE	multipletable[];
extern	long	nulltable[];

		long	outdl;
		long	outdc;
		long	outdr;
		long	feedback2;
		long	feedback3;
		long	feedback4;

extern	double	opmbaserate;

static int extendslot[4] = {2, 3, 1, 0};
static int fmslot[4] = {0, 2, 1, 3};

void FM_keyon(int ch, BYTE value) {

	int		i;
	BYTE	b;
	FM_SLOT	*SLOT = &FMCH[ch].SLOT[0];

	for (i=0,b=0x10; i<4; i++,b<<=1,SLOT++) {
		if (value & b) {							// keyon
			if (SLOT->env_mode <= EM_RELEASE) {
				SLOT->freq_cnt = 0;
				if (i == SLOT1) {
					FMCH[ch].op1fb = 0;
				}
				SLOT->env_mode = EM_ATTACK;
				SLOT->env_inc = SLOT->env_inc_attack;
				SLOT->env_cnt = EC_ATTACK;
				SLOT->env_end = EC_DECAY;
			}
		}
		else {										// keyoff
			if (SLOT->env_mode > EM_RELEASE) {
				SLOT->env_mode = EM_RELEASE;
				if (!(SLOT->env_cnt & EC_DECAY)) {
					SLOT->env_cnt = ((long)env_curve[SLOT->env_cnt >> \
											ENV_BITS] << ENV_BITS) + EC_DECAY;
				}
				SLOT->env_end = EC_OFF;
				SLOT->env_inc = SLOT->env_inc_release;
			}
		}
	}
}

void FM_setalgorithm(FM_CH *CH) {

	long	*outd;

	outd = &outdc;
	if (CH->stereo) {
		switch(CH->pan & 0xc0) {
			case 0x80:
				outd = &outdl;
				break;
			case 0x40:
				outd = &outdr;
				break;
		}
	}

	switch(CH->algorhythm) {
		case 0:
			CH->connect1 = &feedback2;
			CH->connect2 = &feedback3;
			CH->connect3 = &feedback4;
			break;
		case 1:
			CH->connect1 = &feedback3;
			CH->connect2 = &feedback3;
			CH->connect3 = &feedback4;
			break;
		case 2:
			CH->connect1 = &feedback4;
			CH->connect2 = &feedback3;
			CH->connect3 = &feedback4;
			break;
		case 3:
			CH->connect1 = &feedback2;
			CH->connect2 = &feedback4;
			CH->connect3 = &feedback4;
			break;
		case 4:
			CH->connect1 = &feedback2;
			CH->connect2 = outd;
			CH->connect3 = &feedback4;
			break;
		case 5:
			CH->connect1 = 0;
			CH->connect2 = outd;
			CH->connect3 = outd;
			break;
		case 6:
			CH->connect1 = &feedback2;
			CH->connect2 = outd;
			CH->connect3 = outd;
			break;
		default:
			CH->connect1 = outd;
			CH->connect2 = outd;
			CH->connect3 = outd;
	}
	CH->connect4 = outd;
}


static void set_dt1_mul(FM_SLOT *SLOT, BYTE value) {

	SLOT->multiple = multipletable[value&0x0f];
	SLOT->detune1 = detunetable[(value>>4)&7];
}


static void set_tl(FM_SLOT *SLOT, BYTE value) {

	SLOT->totallevel = ((~value) & 0x007f) << (EVC_BITS - 7);
}


static void set_ks_ar(FM_SLOT *SLOT, BYTE value) {

	SLOT->keyscale = (BYTE)(((~value)>>6)&3);
	SLOT->attack = (value&=0x1f) ? &attacktable[value<<1] : nulltable;
	SLOT->env_inc_attack = SLOT->attack[SLOT->envraito];
	if (SLOT->env_mode == EM_ATTACK) {
		SLOT->env_inc = SLOT->env_inc_attack;
	}
}


static void set_d1r(FM_SLOT *SLOT, BYTE value) {

	SLOT->decay1 = (value&=0x1f) ? &decaytable[value<<1] : nulltable;
	SLOT->env_inc_decay1 = SLOT->decay1[SLOT->envraito];
	if (SLOT->env_mode == EM_DECAY1) {
		SLOT->env_inc = SLOT->env_inc_decay1;
	}
}


static void set_dt2_d2r(FM_SLOT *SLOT, BYTE value) {

//	SLOT->detune2 = detune2table[value>>6];			// OPNɂ͖^^;
	SLOT->decay2 = (value&=0x1f) ? &decaytable[value<<1] : nulltable;
	SLOT->env_inc_decay2 = SLOT->decay2[SLOT->envraito];
	if (SLOT->env_mode == EM_DECAY2) {
		SLOT->env_inc = SLOT->env_inc_decay2;
	}
}


static void set_d1l_rr(FM_SLOT *SLOT, BYTE value) {

	SLOT->decaylevel = decayleveltable[(value>>4)];
	SLOT->release = &decaytable[((value&0x0f)<<2)|2];
	SLOT->env_inc_release = SLOT->release[SLOT->envraito];
	if (SLOT->env_mode == EM_RELEASE) {
		SLOT->env_inc = SLOT->env_inc_release;
#if 1
		if (value == 0xff) {
			SLOT->env_mode = EM_OFF;
			SLOT->env_cnt = EC_OFF;
			SLOT->env_end = EC_OFF+1;
			SLOT->env_inc = 0;
		}
#endif
	}
}

static void FMchannleupdate(FM_CH *CH) {

	int		i;
	WORD	fc = CH->keynote[0];
	BYTE	kc = CH->kcode[0];
	BYTE	evr;
	FM_SLOT	*SLOT;
	int		s;

	SLOT = &CH->SLOT[0];
	if (!(CH->extop)) {
		for (i=0; i<4; i++, SLOT++) {
			SLOT->freq_inc = (fc + SLOT->detune1[kc]) * SLOT->multiple;
			evr = (BYTE)(kc >> SLOT->keyscale);
			if (SLOT->envraito != evr) {
				SLOT->envraito = evr;
				SLOT->env_inc_attack = SLOT->attack[evr];
				SLOT->env_inc_decay1 = SLOT->decay1[evr];
				SLOT->env_inc_decay2 = SLOT->decay2[evr];
				SLOT->env_inc_release = SLOT->release[evr];
			}
		}
	}
	else {
		for (i=0; i<4; i++, SLOT++) {
			s = extendslot[i];
			SLOT->freq_inc = (CH->keynote[s] + SLOT->detune1[CH->kcode[s]])
														* SLOT->multiple;
			evr = (BYTE)(CH->kcode[s] >> SLOT->keyscale);
			if (SLOT->envraito != evr) {
				SLOT->envraito = evr;
				SLOT->env_inc_attack = SLOT->attack[evr];
				SLOT->env_inc_decay1 = SLOT->decay1[evr];
				SLOT->env_inc_decay2 = SLOT->decay2[evr];
				SLOT->env_inc_release = SLOT->release[evr];
			}
		}
	}
}

//-----------------------------------------------------------------------------

void FM_reset(void) {

	int		i, j;

	ZeroMemory(&opn, sizeof(opn));
	ZeroMemory(FMCH, sizeof(FMCH));
	opn.channels = 3;
	opn.adpcmmask = (BYTE)~(0x1c);
	opn.reg[0xff] = 0x01;

	for(i=0; i<MAXCHANNEL; i++) {
		FMCH[i].keynote[0] = 0;
		for(j=0; j<4; j++) {
			FMCH[i].SLOT[j].env_mode = EM_OFF;
			FMCH[i].SLOT[j].env_cnt = EC_OFF;
			FMCH[i].SLOT[j].env_end = EC_OFF+1;
			FMCH[i].SLOT[j].env_inc = 0;

			FMCH[i].SLOT[j].detune1 = detunetable[0];
			FMCH[i].SLOT[j].attack = nulltable;
			FMCH[i].SLOT[j].decay1 = nulltable;
			FMCH[i].SLOT[j].decay2 = nulltable;
			FMCH[i].SLOT[j].release = &decaytable[0];
		}
	}
	for (i=0x30; i<0xc0; i++) {
		opn.reg[i] = 0xff;
		opn.reg[i+0x100] = 0xff;
		opn.reg[i+0x200] = 0xff;
		FM_setregister(i, 0xff, 0);
		FM_setregister(i, 0xff, 3);
		FM_setregister(i, 0xff, 6);
	}
}

static	char	OPN_FKTABLE[16] = {0,0,0,0,0,0,0,1,2,3,3,3,3,3,3,3};

void FM_setregister(BYTE reg, BYTE value, BYTE ch) {

	BYTE	c;
	FM_CH	*CH;
	FM_SLOT	*SLOT;
	WORD	fn;
	BYTE	blk;

	if ((c = reg & 3) == 3) {
		return;
	}
	c += ch;
	CH = &FMCH[c];
	SLOT = &CH->SLOT[fmslot[(reg >> 2) & 3]];
	if (reg < 0xa0) {
		switch(reg & 0xf0) {
			case 0x30:					// DT1 MUL
				set_dt1_mul(SLOT, value);
				FMchannleupdate(CH);
				break;
			case 0x40:					// TL
				set_tl(SLOT, value);
				break;
			case 0x50:					// KS AR
				set_ks_ar(SLOT, value);
				FMchannleupdate(CH);
				break;
			case 0x60:					// D1R
				set_d1r(SLOT, value);
				break;
			case 0x70:					// DT2 D2R
				set_dt2_d2r(SLOT, value);
				FMchannleupdate(CH);
				break;
			case 0x80:					// D1L RR
				set_d1l_rr(SLOT, value);
				break;
		}
	}
	else {
		switch(reg & 0xfc) {
			case 0xa0:
				blk = CH->keyfunc[0] >> 3;
				fn = (WORD)(((CH->keyfunc[0] & 7) << 8) + value);
				CH->kcode[0] = (blk << 2) | OPN_FKTABLE[fn >> 7];
				CH->keynote[0] = (WORD)((double)fn * 55556 * opmbaserate
													/ (1L << (22-blk)));
				FMchannleupdate(CH);
				break;

			case 0xa4:
				CH->keyfunc[0] = value & 0x3f;
				break;

			case 0xa8:
				CH = &FMCH[ch+2];
				blk = CH->keyfunc[1+(reg&3)] >> 3;
				fn = (WORD)(((CH->keyfunc[1+(reg&3)] & 7) << 8) + value);
				CH->kcode[1+(reg&3)] = (blk << 2) | OPN_FKTABLE[fn >> 7];
				CH->keynote[1+(reg&3)] = (WORD)((double)fn * 55556
										* opmbaserate / (1L << (22-blk)));
				FMchannleupdate(CH);
				break;

			case 0xac:
				FMCH[ch+2].keyfunc[1+(reg&3)] = value & 0x3f;
				break;

			case 0xb0:
				CH->algorhythm = (BYTE)(value&7);
				CH->feedback = (BYTE)((8-((value>>3)&7))&7);
									// case 0: ret(0) / other ret(8-fb)
				FM_setalgorithm(CH);
				break;

			case 0xb4:
				CH->pan = (BYTE)(value & 0xc0);
				FM_setalgorithm(CH);
				break;
		}
	}
}
