#include	<windows.h>
#include	<stdio.h>
#include	"common.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"dosio.h"
#include	"fmboard.h"
#include	"trace.h"

	PCM86_TABLE		pcm86;

//									44  33  22  16  11  08  05  04
const	BYTE	p86rate_tbl[] = {   32, 24, 16, 12,  8,  6,  4,  3};

void pcm86init(void) {

	ZeroMemory(&pcm86, sizeof(pcm86));
	pcm86.step = 32 * pcm86_rate;
}

I286_INB pcm86_r(WORD port) {

	BYTE	ret = 0;

	TRACEIN(port);

	switch(port) {
		case 0xa460:
			ret = 0x40 | (pcm86.extfunc & 1);
			break;

		case 0xa466:
			DSound_Send0();
			ret = pcm86.lrclock & 1;
			if (pcm86.bufsize >= 0x8000U) {		// obt@t
				ret |= 0x80;
			}
			else if (!pcm86.bufsize) {			// obt@O
				ret |= 0x40;
			}
			break;
		case 0xa468:							// FIFO
			ret = pcm86.fifo & (~0x10);
			if ((pcm86.write) && (pcm86.fifo & 0x20)) {
				pcm86.write = 0;
				DSound_Send0();
				if (pcm86.bufsize < pcm86.fifosize) {
					ret |= 0x10;
				}
			}
			break;
		case 0xa46a:							// D/A
			ret = pcm86.dactrl;
			break;
#if 0
		case 0xa46c:							// FIFOf[^
			break;
#endif
	}
	return(ret);
}


I286_OUT pcm86_w(WORD port, BYTE val) {

	TRACEOUT(port, val);

	switch(port) {
		case 0xa460:
			pcm86.extfunc = val;
			if (soundboard.extendchannel) {
				soundboard.extendchannel(val & 1);
			}
			break;
#if 0
		case 0xa466:								// {[ݒ
			break;
#endif
		case 0xa468:								// FIFOݒ
			if ((!(pcm86.fifo & 8)) && (val & 8)) {
				pcm86.readpos = 0;				// obt@Zbg
				pcm86.bufsize = 0;
				pcm86.count = 0;
				pcm86.lrclock = 0;
			}
			pcm86.step = p86rate_tbl[val & 7] * pcm86_rate;
			pcm86.fifo = val & (~0x10);
			pcm86.write = 1;
			break;
		case 0xa46a:								// D/Aݒ
			if (pcm86.fifo & 0x20) {
				pcm86.fifosize = (WORD)(val) << 7;
			}
			else {
				pcm86.dactrl = val;
			}
			break;
		case 0xa46c:							// FIFOf[^
			if (pcm86.bufsize < 0x8000U) {
				pcm86.buffer[(pcm86.readpos + pcm86.bufsize) & 0x7fff] = val;
				pcm86.bufsize++;
				pcm86.write = 1;
				if (pcm86.dactrl & 0x40) {
					pcm86.lrclock ^= 1;
				}
				else {
					pcm86.lrclock ^= 2;
					if (!(pcm86.lrclock & 2)) {
						pcm86.lrclock ^= 1;
					}
				}
			}
			break;
	}
}


LABEL void __fastcall PCM86_update(void *buf, int buflength) {

		__asm {
				cmp		edx, 0
				je		pcm86_end
				cmp		pcm86.fifo, 0
				jns		pcm86_end						// FIFO͓삵ĂȂ

				pushad
				mov		edi, ecx
				mov		bh, pcm86.dactrl
				test	bh, 30h
				je		pcm86_end2
				mov		cx, pcm86.bufsize
				movzx	esi, pcm86.readpos
				mov		bl, pcm86.count
				mov		ebp, 7fffh

				test	bh, 40h
				jne		pcm86_8bit

				test	bh, 20h
				je		pcm16bit_right
				test	bh, 10h
				je		pcm16bit_left

				// 16bit stereo out
				cmp		cx, 4
				jc		pcm86_end2
p86st16lp:		mov		ah, pcm86.buffer[esi]
				inc		esi
				and		esi, ebp
				mov		al, pcm86.buffer[esi]
				inc		esi
				and		esi, ebp
				cwde
				sar		eax, 1
				add		[edi], eax
				mov		ah, pcm86.buffer[esi]
				inc		esi
				and		esi, ebp
				mov		al, pcm86.buffer[esi]
				sub		esi, 3
				and		esi, ebp
				cwde
				sar		eax, 1
				add		[edi+4], eax
				add		edi, 8

				add		bl, pcm86.step
				cmp		bl, 32
				jc		p86st16incd
p86st16inc:		sub		cx, 4
				jc		p86st16lped2
				add		esi, 4
				and		esi, ebp
				sub		bl, 32
				cmp		bl, 32
				jnc		p86st16inc

p86st16incd:	dec		edx
				je		p86st16lped
				cmp		cx, 4
				jnc		p86st16lp

p86st16lped2:	and		cx, 3
p86st16lped:	mov		pcm86.readpos, si
				mov		pcm86.bufsize, cx
				mov		pcm86.count, bl
pcm86_end2:		popad
pcm86_end:		ret


				// 16bit mono out
pcm16bit_right:	add		edi, 4
pcm16bit_left:	cmp		cx, 2
				jc		p86mn16end
p86mn16lp:		mov		ah, pcm86.buffer[esi]
				inc		esi
				and		esi, ebp
				mov		al, pcm86.buffer[esi]
				dec		esi
				and		esi, ebp
				cwde
				sar		eax, 1
				add		[edi], eax
				add		edi, 8

				add		bl, pcm86.step
				cmp		bl, 32
				jc		p86mn16incd
				xor		eax, eax
				mov		al, bl
				shr		eax, 4
				and		eax, 0feh
				sub		cx, ax
				jc		p86mn16lped2
				add		esi, eax
				and		esi, ebp
				and		bl, 1fh
p86mn16incd:	dec		edx
				je		p86mn16lped
				cmp		cx, 2
				jnc		p86mn16lp
p86mn16lped2:	and		cx, 1
p86mn16lped:	mov		pcm86.readpos, si
				mov		pcm86.bufsize, cx
				mov		pcm86.count, bl
p86mn16end:		popad
				ret



pcm86_8bit:		test	bh, 20h
				je		pcm8bit_right
				test	bh, 10h
				je		pcm8bit_left

				// 8bit stereo out
				cmp		cx, 2
				jc		p86st8end
p86st8lp:		xor		eax, eax
				mov		ah, pcm86.buffer[esi]
				inc		esi
				and		esi, ebp
				cwde
				sar		eax, 1
				add		[edi], eax
				xor		eax, eax
				mov		ah, pcm86.buffer[esi]
				dec		esi
				and		esi, ebp
				cwde
				sar		eax, 1
				add		[edi+4], eax
				add		edi, 8

				add		bl, pcm86.step
				cmp		bl, 32
				jc		p86st8incd
p86st8inc:		sub		cx, 2
				jc		p86st8lped2
				add		esi, 2
				and		esi, ebp
				sub		bl, 32
				cmp		bl, 32
				jnc		p86st8inc

p86st8incd:		dec		edx
				je		p86st8lped
				cmp		cx, 2
				jnc		p86st8lp
p86st8lped2:	and		cx, 1
p86st8lped:		mov		pcm86.readpos, si
				mov		pcm86.bufsize, cx
				mov		pcm86.count, bl
p86st8end:		popad
				ret


				// 8bit mono out
pcm8bit_right:	add		edi, 4
pcm8bit_left:	cmp		cx, 0
				je		p86mn8end
p86mn8lp:		mov		ah, pcm86.buffer[esi]
				cwde
				sar		eax, 1
				add		[edi], eax
				add		edi, 8

				add		bl, pcm86.step
				cmp		bl, 32
				jc		p86mn8incd
				xor		eax, eax
				mov		al, bl
				shr		eax, 5
				sub		cx, ax
				jc		p86mn8lped2
				add		esi, eax
				and		esi, ebp
				and		bl, 1fh
p86mn8incd:		dec		edx
				je		p86mn8lped
				cmp		cx, 1
				jnc		p86mn8lp
p86mn8lped2:	mov		cx, 0
p86mn8lped:		mov		pcm86.readpos, si
				mov		pcm86.bufsize, cx
				mov		pcm86.count, bl
p86mn8end:		popad
				ret
		}
}


