#include	<windows.h>
#include	"common.h"
#include	"np2.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"fmboard.h"
#include	"pic.h"
#include	"nevent.h"
#include	"memory.h"
#include	"pc_core.h"
#include	"joystick.h"
#include	"keyboard.h"
#include	"s98.h"

static	BYTE	psgenv_pat[16] = {
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONECYCLE,
					PSGENV_ONESHOT,
					0,
					PSGENV_ONESHOT | PSGENV_LASTON,
					PSGENV_ONECYCLE | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC | PSGENV_LASTON,
					PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC};

//-----------------------------------------------------------------------------

static BYTE psginittbl[0x10] =
				{0, 0, 0, 0, 0, 0, 0, 0xbf, 0, 0, 0, 0, 0, 0, 0xff, 0xff};

void PSG_reset(PSG_T *psg) {

	BYTE	i;

	CopyMemory(&(psg->reg), psginittbl, sizeof(psginittbl));
	for (i=0; i<0x0e; i++) {
		PSG_setregister(psg, i);
	}
}


void PSG_setregister(PSG_T *psg, BYTE reg) {

	switch(reg) {
		case 0: case 1:
			if ((psg->reg.tune1 & 0xfff) > 9) {
				psg->psgtone[0].psgtone_freq =
							(WORD)(psg_base / (psg->reg.tune1 & 0xfff));
			}
			else {
				psg->psgtone[0].psgtone_freq = 0;
			}
			break;
		case 2: case 3:
			if ((psg->reg.tune2 & 0xfff) > 9) {
				psg->psgtone[1].psgtone_freq =
							(WORD)(psg_base / (psg->reg.tune2 & 0xfff));
			}
			else {
				psg->psgtone[1].psgtone_freq = 0;
			}
			break;
		case 4: case 5:
			if ((psg->reg.tune3 & 0xfff) > 9) {
				psg->psgtone[2].psgtone_freq =
							(WORD)(psg_base / (psg->reg.tune3 & 0xfff));
			}
			else {
				psg->psgtone[2].psgtone_freq = 0;
			}
			break;
		case 6:
			{
				int		i;
				int		value;
				int		freq;

				if ((value = psg->reg.noise & 0x1f) == 0) {
					value = 1;
				}
				else {
					value <<= 1;
				}
				for (i=0; i<16; i++) {
					value++;
					if ((freq = (psg_base >> 1) / value) > 0xffffL) {
						freq = 0xffffL;
					}
					psg->psgnoise.psgnoise_table[i] = (WORD)freq;
				}
				psg->psgnoise.psgnoise_freq = psg->psgnoise.psgnoise_table[0];
			}
			break;

		case 7:
			psg->psg_mixer = ~psg->reg.mixer;
			break;

		case 8:
			if (psg->reg.vol1 & 0x10) {
				psg->psgtone[0].psgtone_volp = &(psg->psgenv_vol);
			}
			else {
				psg->reg.vol1 &= 0xf;
				psg->psgtone[0].psgtone_volp = &(psg->reg.vol1);
			}
			psg->psgtone[0].psgtone_puchi = psg_puchidec;
			break;
		case 9:
			if (psg->reg.vol2 & 0x10) {
				psg->psgtone[1].psgtone_volp = &(psg->psgenv_vol);
			}
			else {
				psg->reg.vol2 &= 0xf;
				psg->psgtone[1].psgtone_volp = &(psg->reg.vol2);
			}
			psg->psgtone[1].psgtone_puchi = psg_puchidec;
			break;
		case 10:
			if (psg->reg.vol3 & 0x10) {
				psg->psgtone[2].psgtone_volp = &(psg->psgenv_vol);
			}
			else {
				psg->reg.vol3 &= 0xf;
				psg->psgtone[2].psgtone_volp = &(psg->reg.vol3);
			}
			psg->psgtone[2].psgtone_puchi = psg_puchidec;
			break;
		case 11: case 12:
			if ((psg->psgenv_max =
					(WORD)(opna_rate * psg->reg.envtime / 125000L)) == 0) {
				psg->psgenv_max = 1;
			}
			break;
		case 13:
			psg->psgenv_mod = psgenv_pat[psg->reg.env & 0x0f];
			psg->psgenv_volcnt = 16;
			psg->psgenv_cnt = 1;
			break;
	}
}


BYTE PSG_getjoyport(PSG_T *psg) {

static	BYTE	rapids = 0;
		BYTE	ret = 0xff;

	if (!(psg->reg.io2 & 0x40)) {
		ret &= joy_getflag();
		if (np2cfg.KEY_MODE == 1) {
			ret &= joykey();
		}
	}
	else {
		if (np2cfg.KEY_MODE == 2) {
			ret &= joykey();
		}
	}
	if (np2cfg.BTN_RAPID) {
		rapids ^= 0x60;
		ret |= rapids;
	}
	if (np2cfg.BTN_MODE) {
		BYTE bit1 = (ret & 0x40) >> 1;
		BYTE bit2 = (ret & 0x20) << 1;
		ret = (ret & (~0x60)) | bit1 | bit2;
	}
	return(ret);
}

