#include	<windows.h>
#include	"common.h"
#include	"nevent.h"
#include	"i286.h"
#include	"i286s.h"
#include	"i286rep.h"
#include	"i286cts.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"i286.mcr"
#include	"i286ea.mcr"
#include	"pic.h"
#include	"pc_core.h"
#include	"bios.h"
#include	"dmac.h"

	I286REGS	i286r;
	I286STAT	i286s;

	BYTE	iflags[256] = {					// Z_FLAG, S_FLAG, P_FLAG
			0x44, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x04, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x04, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x04, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x04, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x04, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x04, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x00, 0x04, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04,
			0x04, 0x00, 0x00, 0x04, 0x00, 0x04, 0x04, 0x00,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x84, 0x80, 0x80, 0x84, 0x80, 0x84, 0x84, 0x80,
			0x80, 0x84, 0x84, 0x80, 0x84, 0x80, 0x80, 0x84};


#define		I286IRQCHECKTERM								\
				__asm {	mov		I286_IP, si				}	\
				__asm {	call	pic_irq					}	\
				__asm {	movzx	ebp, I286_CS			}	\
				__asm {	shl		ebp, 4					}	\
				__asm {	mov		CS_BASE, ebp			}	\
				__asm {	movzx	esi, I286_IP			}	\
				__asm {	ret								}

void (*i286op[])(void);
void (*i286op_repe[])(void);
void (*i286op_repne[])(void);
void (*v30op[])(void);
void (*v30op_repe[])(void);
void (*v30op_repne[])(void);


void i286reset(void) {

	ZeroMemory(&i286r, sizeof(i286r));
	ZeroMemory(&i286s, sizeof(i286s));
	I286_CS = 0x1fc0;
	CS_BASE = 0x1fc00;
	ZeroMemory(&GDTR, sizeof(GDTR));
	ZeroMemory(&IDTR, sizeof(IDTR));
	MSW = 0;
}

LABEL void i286(void) {

	__asm {									// 00/05/19 NT5
				pushad
				mov		ebp, CS_BASE
				movzx	esi, I286_IP
				test	CPUTYPE, CPUTYPE_V30
				jne		v30mnlp
i286mnlp:		GET_PCBYTE
				and		eax, 00ffh
				call	i286op[eax*4]
				cmp		nevent.remainclock, 0
				jg		i286mnlp
				mov		I286_IP, si
				popad
				ret
v30mnlp:		GET_PCBYTE
				and		eax, 00ffh
				call	v30op[eax*4]
				cmp		nevent.remainclock, 0
				jg		v30mnlp
				mov		I286_IP, si
				popad
				ret
	}
}

LABEL void i286withdma(void) {

	__asm {									// 00/05/19 NT5
				pushad
				mov		ebp, CS_BASE
				movzx	esi, I286_IP
				test	CPUTYPE, CPUTYPE_V30
				jne		v30mnlp
i286mnlp:		GET_PCBYTE
				and		eax, 00ffh
				call	i286op[eax*4]
				call	dma_proc
				cmp		nevent.remainclock, 0
				jg		i286mnlp
				mov		I286_IP, si
				popad
				ret
v30mnlp:		GET_PCBYTE
				and		eax, 00ffh
				call	v30op[eax*4]
				call	dma_proc
				cmp		nevent.remainclock, 0
				jg		v30mnlp
				mov		I286_IP, si
				popad
				ret
	}
}



LABEL void i286_step(void) {

	__asm {									// 00/05/19 NT5
				pushad
				mov		ebp, CS_BASE
				movzx	esi, I286_IP
				test	CPUTYPE, CPUTYPE_V30
				jne		v30mnstp
				GET_PCBYTE
				and		eax, 00ffh
				call	i286op[eax*4]
				mov		I286_IP, si
				call	dma_proc
				popad
				ret

v30mnstp:		GET_PCBYTE
				and		eax, 00ffh
				call	v30op[eax*4]
				mov		I286_IP, si
				call	dma_proc
				popad
				ret
	}
}

LABEL void __fastcall i286_interrupt(BYTE vect) {

	__asm {
				push	ebx
				push	ecx
				push	edi

				// hlt..
				movzx	ecx, I286_IP
				add		ecx, CS_BASE
				call	i286_memoryread
				cmp		al, 0f4h			// hlt
				jne		short nonhlt
				inc		I286_IP
nonhlt:			mov		edi, SS_BASE
				movzx	ebx, I286_SP
				sub		bx, 2
				lea		ecx, [edi + ebx]
				LOAD_I286FLAG(dx)
				and		dh, 0fh
				mov		I286_IFLAG, 0
				call	i286_memorywrite_w
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_CS
				call	i286_memorywrite_w
				sub		bx, 2
				mov		I286_SP, bx
				lea		ecx, [edi + ebx]
				mov		dx, I286_IP
				call	i286_memorywrite_w
				pop		edi
				pop		ecx
				pop		ebx

				xor		eax, eax
				mov		al, cl
				mov		eax, dword ptr I286_MEM[eax*4]
				mov		I286_IP, ax
				shr		eax, 16
				mov		I286_CS, ax
				shl		eax, 4					// make segreg
				mov		CS_BASE, eax
				ret
		}
}

LABEL void removeprefix(void) {

		__asm {
				mov		i286s.prefix, 0
				movzx	eax, I286_DS
				shl		eax, 4
				mov		DS_FIX, eax
				movzx	eax, I286_SS
				shl		eax, 4
				mov		SS_FIX, eax
				ret
		}
}


I286 _reserved(void) {

		__asm {
				INT_NUM(6)
		}
}

I286 _nop(void) {								// 90: nop / bios func

		__asm {
				I286CLOCK(3)
#if 1
				lea		ecx, [ebp + esi - 1]
				cmp		ecx, 0f8000h
				jc		biosend
				cmp		ecx, 100000h
				jnc		biosend

				mov		I286_IP, si
				call	biosfunc
				cmp		al, ah
				je		biosend
				movzx	esi, I286_IP
				movzx	eax, I286_ES
				shl		eax, 4
				mov		ES_BASE, eax
				movzx	ebp, I286_CS
				shl		ebp, 4
				mov		CS_BASE, ebp
				movzx	eax, I286_SS
				shl		eax, 4
				mov		SS_BASE, eax
				mov		SS_FIX, eax
				movzx	eax, I286_DS
				shl		eax, 4
				mov		DS_BASE, eax
				mov		DS_FIX, eax
		biosend:
#endif
				ret
		}
}



I286 add_ea_r8(void) {							// 00: add EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					add		byte ptr I286_REG[eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8(7)
					add		byte ptr I286_MEM[ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					add		al, byte ptr I286_REG[ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		i286_memorywrite
		}
}

I286 add_ea_r16(void) {							// 01: add EA, REG16

		__asm {
				PREPART_EA_REG16(2)
					add		word ptr I286_REG[eax*2], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16(7)
					add		word ptr I286_MEM[ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					add		ax, word ptr I286_REG[ebx*2]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		i286_memorywrite_w
		}
}

I286 add_r8_ea(void) {							// 02: add REG8, EA

		__asm {
				PREPART_REG8_EA(2, 7)
					add		I286_REG[ebx], al
					FLAG_STORE_OF
					ret
		}
}

I286 add_r16_ea(void) {							// 03: add REG16, EA

		__asm {
				PREPART_REG16_EA(2, 7)
					add		I286_REG[ebx*2], ax
					FLAG_STORE_OF
					ret
		}
}

I286 add_al_data8(void) {						// 04: add al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				add		I286_AL, al
				FLAG_STORE_OF
				ret
		}
}

I286 add_ax_data16(void) {						// 05: add ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				add		I286_AX, ax
				FLAG_STORE_OF
				ret
		}
}

I286 push_es(void) {							// 06: push es

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_ES)
		}
}

I286 pop_es(void) {								// 07: pop es

		__asm {
				I286CLOCK(5)
				REGPOP(I286_ES)
				and		eax, 00ffffh
				shl		eax, 4					// make segreg
				mov		ES_BASE, eax
				ret
		}
}

I286 or_ea_r8(void) {							// 08: or EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					or		byte ptr I286_REG[eax], dl
					FLAG_STORE0
					ret
				MEMORY_EA_REG8(7)
					or		byte ptr I286_MEM[ecx], dl
					FLAG_STORE0
					ret
				EXTMEM_EA_REG8
					or		al, byte ptr I286_REG[ebx]
					mov		dl, al
					FLAG_STORE0
					jmp		i286_memorywrite
		}
}

I286 or_ea_r16(void) {							// 09: or EA, REG16

		__asm {
				PREPART_EA_REG16(2)
					or		word ptr I286_REG[eax*2], dx
					FLAG_STORE0
					ret
				MEMORY_EA_REG16(7)
					or		word ptr I286_MEM[ecx], dx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG16
					or		ax, word ptr I286_REG[ebx*2]
					mov		dx, ax
					FLAG_STORE0
					jmp		i286_memorywrite_w
	}
}

I286 or_r8_ea(void) {							// 0A: or REG8, EA

		__asm {
				PREPART_REG8_EA(2, 7)
					or		I286_REG[ebx], al
					FLAG_STORE0
					ret
		}
}

I286 or_r16_ea(void) {							// 0B: or REG16, EA

		__asm {
				PREPART_REG16_EA(2, 7)
					or		I286_REG[ebx*2], ax
					FLAG_STORE0
					ret
		}
}

I286 or_al_data8(void) {						// 0C: or al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				or		I286_AL, al
				FLAG_STORE0
				ret
		}
}

I286 or_ax_data16(void) {						// 0D: or ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				or		I286_AX, ax
				FLAG_STORE0
				ret
		}
}

I286 push_cs(void) {							// 0E: push es

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_CS)
		}
}


I286 adc_ea_r8(void) {							// 10: adc EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					CFLAG_LOAD
					adc		byte ptr I286_REG[eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8(7)
					CFLAG_LOAD
					adc		byte ptr I286_MEM[ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					CFLAG_LOAD
					adc		al, byte ptr I286_REG[ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		i286_memorywrite
		}
}

I286 adc_ea_r16(void) {							// 11: adc EA, REG16

		__asm {
				PREPART_EA_REG16(2)
					CFLAG_LOAD
					adc		word ptr I286_REG[eax*2], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16(7)
					CFLAG_LOAD
					adc		word ptr I286_MEM[ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					CFLAG_LOAD
					adc		ax, word ptr I286_REG[ebx*2]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		i286_memorywrite_w
		}
}

I286 adc_r8_ea(void) {							// 12: adc REG8, EA

		__asm {
				PREPART_REG8_EA(2, 7)
					CFLAG_LOAD
					adc		I286_REG[ebx], al
					FLAG_STORE_OF
					ret
		}
}

I286 adc_r16_ea(void) {							// 13: adc REG16, EA

		__asm {
				PREPART_REG16_EA(2, 7)
					CFLAG_LOAD
					adc		I286_REG[ebx*2], ax
					FLAG_STORE_OF
					ret
		}
}

I286 adc_al_data8(void) {						// 14: adc al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				CFLAG_LOAD
				adc		I286_AL, al
				FLAG_STORE_OF
				ret
		}
}

I286 adc_ax_data16(void) {						// 15: adc ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				CFLAG_LOAD
				adc		I286_AX, ax
				FLAG_STORE_OF
				ret
		}
}

I286 push_ss(void) {							// 16: push ss

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_SS)
		}
}

I286 pop_ss(void) {								// 17: pop ss

		__asm {
				I286CLOCK(5)
				REGPOP(I286_SS)
				and		eax, 00ffffh
				shl		eax, 4					// make segreg
				mov		SS_BASE, eax
				mov		SS_FIX, eax
				cmp		i286s.prefix, 0			// 00/06/24
				je		noprefix
				call	removeprefix
				pop		eax
		noprefix:
				GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op[eax*4]
		}
}

I286 sbb_ea_r8(void) {							// 18: sbb EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					CFLAG_LOAD
					sbb		byte ptr I286_REG[eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8(7)
					CFLAG_LOAD
					sbb		byte ptr I286_MEM[ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					CFLAG_LOAD
					sbb		al, byte ptr I286_REG[ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		i286_memorywrite
		}
}

I286 sbb_ea_r16(void) {							// 19: sbb EA, REG16

		__asm {
				PREPART_EA_REG16(2)
					CFLAG_LOAD
					sbb		word ptr I286_REG[eax*2], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16(7)
					CFLAG_LOAD
					sbb		word ptr I286_MEM[ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					CFLAG_LOAD
					sbb		ax, word ptr I286_REG[ebx*2]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		i286_memorywrite_w
		}
}

I286 sbb_r8_ea(void) {							// 1A: sbb REG8, EA

		__asm {
				PREPART_REG8_EA(2, 7)
					CFLAG_LOAD
					sbb		I286_REG[ebx], al
					FLAG_STORE_OF
					ret
		}
}

I286 sbb_r16_ea(void) {							// 1B: sbb REG16, EA

		__asm {
				PREPART_REG16_EA(2, 7)
					CFLAG_LOAD
					sbb		I286_REG[ebx*2], ax
					FLAG_STORE_OF
					ret
		}
}

I286 sbb_al_data8(void) {						// 1C: sbb al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				CFLAG_LOAD
				sbb		I286_AL, al
				FLAG_STORE_OF
				ret
		}
}

I286 sbb_ax_data16(void) {						// 1D: sbb ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				CFLAG_LOAD
				sbb		I286_AX, ax
				FLAG_STORE_OF
				ret
		}
}

I286 push_ds(void) {							// 1E: push ds

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_DS)
		}
}

I286 pop_ds(void) {								// 1F: pop ds

		__asm {
				I286CLOCK(5)
				REGPOP(I286_DS)
				and		eax, 00ffffh
				shl		eax, 4					// make segreg
				mov		DS_BASE, eax
				mov		DS_FIX, eax
				ret
		}
}

I286 and_ea_r8(void) {							// 20: and EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					and		byte ptr I286_REG[eax], dl
					FLAG_STORE0
					ret
				MEMORY_EA_REG8(7)
					and		byte ptr I286_MEM[ecx], dl
					FLAG_STORE0
					ret
				EXTMEM_EA_REG8
					and		al, byte ptr I286_REG[ebx]
					mov		dl, al
					FLAG_STORE0
					jmp		i286_memorywrite
		}
}

I286 and_ea_r16(void) {							// 21: and EA, REG16

		__asm {
				PREPART_EA_REG16(2)
					and		word ptr I286_REG[eax*2], dx
					FLAG_STORE0
					ret
				MEMORY_EA_REG16(7)
					and		word ptr I286_MEM[ecx], dx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG16
					and		ax, word ptr I286_REG[ebx*2]
					mov		dx, ax
					FLAG_STORE0
					jmp		i286_memorywrite_w
		}
}

I286 and_r8_ea(void) {							// 22: and REG8, EA

		__asm {
				PREPART_REG8_EA(2, 7)
					and		I286_REG[ebx], al
					FLAG_STORE0
					ret
		}
}

I286 and_r16_ea(void) {							// 23: and REG16, EA

		__asm {
				PREPART_REG16_EA(2, 7)
					and		I286_REG[ebx*2], ax
					FLAG_STORE0
					ret
		}
}

I286 and_al_data8(void) {						// 24: and al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				and		I286_AL, al
				FLAG_STORE0
				ret
		}
}

I286 and_ax_data16(void) {						// 25: and ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				and		I286_AX, ax
				FLAG_STORE0
				ret
		}
}

I286 segprefix_es(void) {						// 26: es:

		__asm {
				mov		eax, ES_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op[eax*4]
		}
}

I286 _daa(void) {								// 27: daa

		__asm {
				I286CLOCK(3)
				FLAG_LOAD
				mov		ax, I286_AX
				daa
				mov		I286_AX, ax
				FLAG_STORE
				ret
		}
}

I286 sub_ea_r8(void) {							// 28: sub EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					sub		byte ptr I286_REG[eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8(7)
					sub		byte ptr I286_MEM[ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					sub		al, byte ptr I286_REG[ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		i286_memorywrite
		}
}

I286 sub_ea_r16(void) {							// 29: sub EA, REG16

		__asm {
				PREPART_EA_REG16(2)
					sub		word ptr I286_REG[eax*2], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16(7)
					sub		word ptr I286_MEM[ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					sub		ax, word ptr I286_REG[ebx*2]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		i286_memorywrite_w
		}
}

I286 sub_r8_ea(void) {							// 2A: sub REG8, EA

		__asm {
				PREPART_REG8_EA(2, 7)
					sub		I286_REG[ebx], al
					FLAG_STORE_OF
					ret
		}
}

I286 sub_r16_ea(void) {							// 2B: sub REG16, EA

		__asm {
				PREPART_REG16_EA(2, 7)
					sub		I286_REG[ebx*2], ax
					FLAG_STORE_OF
					ret
		}
}

I286 sub_al_data8(void) {						// 2C: sub al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				sub		I286_AL, al
				FLAG_STORE_OF
				ret
		}
}

I286 sub_ax_data16(void) {						// 2D: sub ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				sub		I286_AX, ax
				FLAG_STORE_OF
				ret
		}
}

I286 segprefix_cs(void) {						// 2E: cs:

		__asm {
				mov		eax, CS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op[eax*4]
		}
}

I286 _das(void) {								// 2F: das

		__asm {
				I286CLOCK(3)
				FLAG_LOAD
				mov		ax, I286_AX
				das
				mov		I286_AX, ax
				FLAG_STORE
				ret
		}
}

I286 xor_ea_r8(void) {							// 30: xor EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					xor		byte ptr I286_REG[eax], dl
					FLAG_STORE0
					ret
				MEMORY_EA_REG8(7)
					xor		byte ptr I286_MEM[ecx], dl
					FLAG_STORE0
					ret
				EXTMEM_EA_REG8
					xor		al, byte ptr I286_REG[ebx]
					mov		dl, al
					FLAG_STORE0
					jmp		i286_memorywrite
		}
}

I286 xor_ea_r16(void) {							// 31: xor EA, REG16

		__asm {
				PREPART_EA_REG16(2)
					xor		word ptr I286_REG[eax*2], dx
					FLAG_STORE0
					ret
				MEMORY_EA_REG16(7)
					xor		word ptr I286_MEM[ecx], dx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG16
					xor		ax, word ptr I286_REG[ebx*2]
					mov		dx, ax
					FLAG_STORE0
					jmp		i286_memorywrite_w
		}
}

I286 xor_r8_ea(void) {							// 32: xor REG8, EA

		__asm {
				PREPART_REG8_EA(2, 7)
					xor		byte ptr I286_REG[ebx], al
					FLAG_STORE0
					ret
		}
}

I286 xor_r16_ea(void) {							// 33: xor REG16, EA

		__asm {
				PREPART_REG16_EA(2, 7)
					xor		word ptr I286_REG[ebx*2], ax
					FLAG_STORE0
					ret
		}
}

I286 xor_al_data8(void) {						// 34: xor al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				xor		I286_AL, al
				FLAG_STORE0
				ret
		}
}

I286 xor_ax_data16(void) {						// 35: xor ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				xor		I286_AX, ax
				FLAG_STORE0
				ret
		}
}

I286 segprefix_ss(void) {						// 36: ss:

		__asm {
				mov		eax, SS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op[eax*4]
		}
}

I286 _aaa(void) {								// 37: aaa

		__asm {
				I286CLOCK(3)
				FLAG_LOAD
				mov		ax, I286_AX
				aaa
				mov		I286_AX, ax
				FLAG_STORE
				ret
		}
}

I286 cmp_ea_r8(void) {							// 38: cmp EA, REG8

		__asm {
				PREPART_EA_REG8(2)
					cmp		byte ptr I286_REG[eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8(6)
					cmp		byte ptr I286_MEM[ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					cmp		al, byte ptr I286_REG[ebx]
					FLAG_STORE_OF
					ret
		}
}

I286 cmp_ea_r16(void) {							// 39: cmp EA, REG16

		__asm {
				PREPART_EA_REG16(2)
				cmp		I286_REG[eax*2], dx
				FLAG_STORE_OF
				ret
				MEMORY_EA_REG16(6)
				cmp		word ptr I286_MEM[ecx], dx
				FLAG_STORE_OF
				ret
				EXTMEM_EA_REG16
				cmp		ax, I286_REG[ebx*2]
				FLAG_STORE_OF
				ret
		}
}

I286 cmp_r8_ea(void) {							// 3A: cmp REG8, EA

		__asm {
				PREPART_REG8_EA(2, 6)
				cmp		I286_REG[ebx], al
				FLAG_STORE_OF
				ret
		}
}

I286 cmp_r16_ea(void) {							// 3B: cmp REG16, EA

		__asm {
				PREPART_REG16_EA(2, 6)
				cmp		I286_REG[ebx*2], ax
				FLAG_STORE_OF
				ret
		}
}

I286 cmp_al_data8(void) {						// 3C: cmp al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				cmp		I286_AL, al
				FLAG_STORE_OF
				ret
		}
}

I286 cmp_ax_data16(void) {						// 3D: cmp ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				cmp		I286_AX, ax
				FLAG_STORE_OF
				ret
		}
}

I286 segprefix_ds(void) {						// 3E: ds:

		__asm {
				mov		eax, DS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op[eax*4]
		}
}

I286 _aas(void) {								// 3F: aas

		__asm {
				I286CLOCK(3)
				FLAG_LOAD
				mov		ax, I286_AX
				aas
				mov		I286_AX, ax
				FLAG_STORE
				ret
		}
}

I286 inc_reg16(void) {							// 40-47: inc reg16

		__asm {
				I286CLOCK(2)
				and		al, 7
				inc		word ptr I286_REG[eax*2]
				FLAG_STORE_NC
				ret
		}
}

I286 dec_reg16(void) {							// 48-4f: dec reg16

		__asm {
				I286CLOCK(2)
				and		al, 7
				dec		word ptr I286_REG[eax*2]
				FLAG_STORE_NC
				ret
		}
}

I286 push_ax(void) {							// 50: push ax

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_AX)
		}
}

I286 push_cx(void) {							// 51: push cx

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_CX)
		}
}

I286 push_dx(void) {							// 52: push dx

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_DX)
		}
}

I286 push_bx(void) {							// 53: push bx

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_BX)
		}
}

I286 push_sp(void) {							// 54: push sp

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_SP)
		}
}

I286 push_bp(void) {							// 55: push bp

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_BP)
		}
}

I286 push_si(void) {							// 56: push si

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_SI)
		}
}

I286 push_di(void) {							// 57: push di

		__asm {
				I286CLOCK(3)
				REGPUSH1(I286_DI)
		}
}

I286 pop_ax(void) {								// 58: pop ax

		__asm {
				I286CLOCK(5)
				REGPOP(I286_AX)
				ret
		}
}

I286 pop_cx(void) {								// 59: pop cx

		__asm {
				I286CLOCK(5)
				REGPOP(I286_CX)
				ret
		}
}

I286 pop_dx(void) {								// 5A: pop dx

		__asm {
				I286CLOCK(5)
				REGPOP(I286_DX)
				ret
		}
}

I286 pop_bx(void) {								// 5B: pop bx

		__asm {
				I286CLOCK(5)
				REGPOP(I286_BX)
				ret
		}
}

I286 pop_sp(void) {								// 5C: pop sp

		__asm {
				I286CLOCK(5)
				movzx	ecx, I286_SP
				add		ecx, SS_BASE
				call	i286_memoryread_w
				mov		I286_SP, ax
				ret
		}
}

I286 pop_bp(void) {								// 5D: pop bp

		__asm {
				I286CLOCK(5)
				REGPOP(I286_BP)
				ret
		}
}

I286 pop_si(void) {								// 5E: pop si

		__asm {
				I286CLOCK(5)
				REGPOP(I286_SI)
				ret
		}
}

I286 pop_di(void) {								// 5F: pop di

		__asm {
				I286CLOCK(5)
				REGPOP(I286_DI)
				ret
		}
}

I286 _pusha(void) {								// 60: pusha

		__asm {
				I286CLOCK(17)
				mov		edi, SS_BASE
				movzx	ebx, I286_SP

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_AX
				call	i286_memorywrite_w

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_CX
				call	i286_memorywrite_w

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_DX
				call	i286_memorywrite_w

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_BX
				call	i286_memorywrite_w

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_SP
				call	i286_memorywrite_w

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_BP
				call	i286_memorywrite_w

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_SI
				call	i286_memorywrite_w

				sub		bx, 2
				mov		I286_SP, bx
				lea		ecx, [edi + ebx]
				mov		dx, I286_DI
				jmp		i286_memorywrite_w
		}
}

I286 _popa(void) {								// 61: popa

		__asm {
				I286CLOCK(19)
				mov		edi, SS_BASE
				movzx	ebx, I286_SP

				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_DI, ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_SI, ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_BP, ax
				add		bx, 4

				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_BX, ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_DX, ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_CX, ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_AX, ax
				add		I286_SP, 16
				ret
		}
}

I286 _bound(void) {

		__asm {
				GET_PCBYTE
				mov		ebx, 6
				cmp		al, 0c0h
				jnc		bountint
				mov		bl, al
				shr		bl, 3
				and		ebx, 7
				I286CLOCK(13)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				call	i286_memoryread_w
				cmp		I286_REG[ebx*2], ax
				jb		bounttrue
				add		ecx, 2
				call	i286_memoryread_w
				cmp		I286_REG[ebx*2], ax
				ja		bounttrue
				ret
bounttrue:		mov		ebx, 5
bountint:		INT_NUM(ebx)
		}
}

I286 _arpl(void) {

		__asm {
				GET_PCBYTE
				xor		eax, eax
				cmp		al, 0c0h
				setc	al
				add		si, ax
				add		ax, 10
				I286CLOCK(eax)
				INT_NUM(6)
		}
}

I286 push_data16(void) {						// 68: push DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				REGPUSH1(ax)
		}
}

I286 imul_reg_ea_data16(void) {					// 69: imul REG, EA, DATA16

		__asm {
				PREPART_REG16_EA(21, 24)
				mov		edx, eax
				GET_PCWORD
				imul	dx
				mov		I286_REG[ebx*2], ax
#if 1												// old
				mov		al, ah
				lahf
				and		ah, 0feh
				and		I286_FLAGL, 0feh
				or		I286_FLAGL, ah
				rcl		al, 1
				adc		dx, 0
				jne		imulnooverflow
				or		I286_FLAG, (O_FLAG or C_FLAG)
imulnooverflow:	ret
#else												// new
				rcl		ah, 1
				rcr		dx, 1
				lahf
				jo		setofcf
				adc		dx, 0
				je		nosetofcf
setofcf:		or		I286_FLAG, (O_FLAG or C_FLAG)
nosetofcf:		and		ah, 0feh
				or		I286_FLAGL, ah
				ret
#endif
		}
}


I286 push_data8(void) {							// 6A: push DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				cbw
				REGPUSH1(ax)
		}
}

I286 imul_reg_ea_data8(void) {					// 6B: imul REG, EA, DATA8

		__asm {
				PREPART_REG16_EA(21, 24)
				mov		edx, eax
				GET_PCBYTE
				cbw
				imul	dx
				mov		I286_REG[ebx*2], ax
#if 1												// old
				mov		al, ah
				lahf
				and		ah, 0feh
				and		I286_FLAGL, 0feh
				or		I286_FLAGL, ah
				rcl		al, 1
				adc		dx, 0
				jne		imulnooverflow
				or		I286_FLAG, (O_FLAG or C_FLAG)
imulnooverflow:	ret
#else												// new
				rcl		ah, 1
				rcr		dx, 1
				lahf
				jo		setofcf
				adc		dx, 0
				je		nosetofcf
setofcf:		or		I286_FLAG, (O_FLAG or C_FLAG)
nosetofcf:		and		ah, 0feh
				or		I286_FLAGL, ah
				ret
#endif
		}
}

I286 _insb(void) {								// 6C: insb

		__asm {
				I286CLOCK(5)
				mov		cx, I286_DX
				call	i286_in
				mov		dl, al
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				STRING_DIR
				add		I286_DI, ax
				jmp		i286_memorywrite
		}
}

I286 _insw(void) {								// 6D: insw

		__asm {
				I286CLOCK(5)
				mov		cx, I286_DX
				call	i286_in_w
				mov		dx, ax
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				STRING_DIRx2
				add		I286_DI, ax
				jmp		i286_memorywrite_w
		}
}

I286 _outsb(void) {								// 6E: outsb

		__asm {
				I286CLOCK(3)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread
				mov		dl, al
				STRING_DIR
				add		I286_SI, ax
				mov		cx, I286_DX
				jmp		i286_out
		}
}

I286 _outsw(void) {								// 6F: outsw

		__asm {
				I286CLOCK(3)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread_w
				mov		dx, ax
				STRING_DIRx2
				add		I286_SI, ax
				mov		cx, I286_DX
				jmp		i286_out_w
		}
}

I286 jo_short(void) {							// 70: jo short

		__asm {
				test	I286_FLAG, O_FLAG
				jne		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jno_short(void) {							// 71: jno short

		__asm {
				test	I286_FLAG, O_FLAG
				je		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jc_short(void) {							// 72: jnae/jb/jc short

		__asm {
				test	I286_FLAG, C_FLAG
				jne		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jnc_short(void) {							// 73: jae/jnb/jnc short

		__asm {
				test	I286_FLAG, C_FLAG
				je		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jz_short(void) {							// 74: je/jz short

		__asm {
				test	I286_FLAG, Z_FLAG
				jne		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jnz_short(void) {							// 75: jne/jnz short

		__asm {
				test	I286_FLAG, Z_FLAG
				je		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jna_short(void) {							// 76: jna/jbe short

		__asm {
				test	I286_FLAG, (Z_FLAG or C_FLAG)
				jne		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 ja_short(void) {							// 77: ja/jnbe short

		__asm {
				test	I286_FLAG, (Z_FLAG or C_FLAG)
				je		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 js_short(void) {							// 78: js short

		__asm {
				test	I286_FLAG, S_FLAG
				jne		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jns_short(void) {							// 79: jns short

		__asm {
				test	I286_FLAG, S_FLAG
				je		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jp_short(void) {							// 7A: jp/jpe short

		__asm {
				test	I286_FLAG, P_FLAG
				jne		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jnp_short(void) {							// 7B: jnp/jpo short

		__asm {
				test	I286_FLAG, P_FLAG
				je		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jl_short(void) {							// 7C: jl/jnge short

		__asm {
				mov		dx, I286_FLAG
				shl		dh, 4
				xor		dl, dh
				js		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jnl_short(void) {							// 7D: jnl/jge short

		__asm {
				mov		dx, I286_FLAG
				shl		dh, 4
				xor		dl, dh
				jns		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jle_short(void) {							// 7E: jle/jng short

		__asm {
				mov		dx, I286_FLAG
				test	dx, Z_FLAG
				jne		flagjump
				shl		dh, 4
				xor		dl, dh
				js		flagjump
				I286CLOCK(3)
				inc		si
				ret
flagjump:		I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 jnle_short(void) {							// 7F: jg/jnle short

		__asm {
				mov		dx, I286_FLAG
				test	dx, Z_FLAG
				jne		notjump
				shl		dh, 4
				xor		dl, dh
				js		notjump
				I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
notjump:		I286CLOCK(3)
				inc		si
				ret
		}
}

I286 calc_ea8_i8(void) {							// 80,82: op EA8, DATA8

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(3)
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				lea		ebx, I286_REG[eax]
				GET_PCBYTE
				jmp		op8xreg8_table[edi*4]
		memory_eareg8:
				I286CLOCK(7)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMWRITEMAX
				jnc		extmem_eareg8
				lea		ebx, I286_MEM[ecx]
				GET_PCBYTE
				jmp		op8xreg8_table[edi*4]
		extmem_eareg8:
				call	i286_memoryread
				mov		dl, al
				push	ecx
				GET_PCBYTE
				pop		ecx
				jmp		op8xext8_table[edi*4]
	}
}

I286 calc_ea16_i16(void) {							// 81: op EA16, DATA16

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 1
				and		edi, 7*4						// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(3)
				and		eax, 7
				lea		ebx, word ptr I286_REG[eax*2]
				GET_PCWORD
				jmp		op8xreg16_table[edi]
		memory_eareg8:
				I286CLOCK(7)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMWRITEMAX
				jnc		extmem_eareg8
				lea		ebx, word ptr I286_MEM[ecx]
				GET_PCWORD
				jmp		op8xreg16_table[edi]
		extmem_eareg8:
				call	i286_memoryread_w
				mov		edx, eax
				push	ecx
				GET_PCWORD
				pop		ecx
				jmp		op8xext16_table[edi]
	}
}

I286 calc_ea16_i8(void) {							// 83: op EA16, DATA8

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(3)
				and		eax, 7
				lea		ebx, I286_REG[eax*2]
				GET_PCBYTE
				cbw
				jmp		op8xreg16_table[edi*4]
		memory_eareg8:
				I286CLOCK(7)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, (I286_MEMWRITEMAX-1)
				jnc		extmem_eareg8
				lea		ebx, I286_MEM[ecx]
				GET_PCBYTE
				cbw
				jmp		op8xreg16_table[edi*4]
		extmem_eareg8:
				call	i286_memoryread_w
				mov		edx, eax
				push	ecx
				GET_PCBYTE
				cbw
				pop		ecx
				jmp		op8xext16_table[edi*4]
	}
}

I286 test_ea_r8(void) {								// 84: test EA, REG8

		__asm {
				PREPART_EA_REG8(2)
				test	I286_REG[eax], dl
				FLAG_STORE0
				ret
				MEMORY_EA_REG8(7)
				test	I286_MEM[ecx], dl
				FLAG_STORE0
				ret
				EXTMEM_EA_REG8
				test	al, I286_REG[ebx]
				FLAG_STORE0
				ret
		}
}

I286 test_ea_r16(void) {							// 85: test EA, REG16

		__asm {
				PREPART_EA_REG16(2)
				test	I286_REG[eax*2], dx
				FLAG_STORE0
				ret
				MEMORY_EA_REG16(6)
				test	word ptr I286_MEM[ecx], dx
				FLAG_STORE0
				ret
				EXTMEM_EA_REG16
				test	ax, I286_REG[ebx*2]
				FLAG_STORE0
				ret
		}
}

I286 xchg_ea_r8(void) {								// 86: xchg EA, REG8

		__asm {
				GET_PCBYTE
				mov		ebx, eax
				shr		ebx, 3
				bt		bx, 2
				rcl		ebx, 1
				and		ebx, 7
				cmp		al, 0c0h
				jc		memory_eareg8
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				I286CLOCK(3)
				mov		dl, I286_REG[ebx]
				xchg	dl, I286_REG[eax]
				mov		I286_REG[ebx], dl
				ret
		memory_eareg8:
				I286CLOCK(5)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMREADMAX
				jae		extmem_eareg8
				mov		dl, I286_REG[ebx]
				xchg	I286_MEM[ecx], dl
				mov		I286_REG[ebx], dl
				ret
		extmem_eareg8:
				call	i286_memoryread
				xchg	al, I286_REG[ebx]
				mov		dl, al
				jmp		i286_memorywrite
		}
}

I286 xchg_ea_r16(void) {							// 87: xchg EA, REG16

		__asm {
				GET_PCBYTE
				mov		ebx, eax
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		memory_eareg16
				and		eax, 7
				I286CLOCK(3)
				mov		dx, I286_REG[ebx*2]
				xchg	dx, I286_REG[eax*2]
				mov		I286_REG[ebx*2], dx
				ret
		memory_eareg16:
				I286CLOCK(5)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, (I286_MEMREADMAX-1)
				jae		extmem_eareg16
				mov		dx, word ptr I286_MEM[ecx]
				xchg	dx, I286_REG[ebx*2]
				mov		word ptr I286_MEM[ecx], dx
				ret
		extmem_eareg16:
				call	i286_memoryread_w
				xchg	ax, I286_REG[ebx*2]
				mov		dx, ax
				jmp		i286_memorywrite_w
		}
}

I286 mov_ea_r8(void) {							// 88: mov EA, REG8

		__asm {
				PREPART_EA_REG8(2)
				mov		I286_REG[eax], dl
				ret
		memory_eareg8:
				I286CLOCK(3)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				mov		dl, I286_REG[ebx]
				jmp		i286_memorywrite
		}
}

I286 mov_ea_r16(void) {							// 89: mov EA, REG16

		__asm {
				PREPART_EA_REG16(2)
				mov		I286_REG[eax*2], dx
				ret
		memory_eareg16:
				I286CLOCK(3)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				mov		dx, I286_REG[ebx*2]
				jmp		i286_memorywrite_w
		}
}

I286 mov_r8_ea(void) {							// 8A: mov REG8, EA

		__asm {
				PREPART_REG8_EA(2, 5)
				mov		I286_REG[ebx], al
				ret
		}
}

I286 mov_r16_ea(void) {							// 8B: add REG16, EA

		__asm {
				PREPART_REG16_EA(2, 5)
				mov		I286_REG[ebx*2], ax
				ret
		}
}

I286 mov_ea_seg(void) {							// 8C: mov EA, segreg

		__asm {
				GET_PCBYTE
				mov		ebx, eax
				shr		ebx, 2
				and		ebx, 3*2
				mov		dx, word ptr I286_SEGREG[ebx]
				cmp		al, 0c0h
				jc		memory_eareg16
				I286CLOCK(2)
				and		eax, 7
				mov		word ptr I286_REG[eax*2], dx
				ret
		memory_eareg16:
				I286CLOCK(3)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				jmp		i286_memorywrite_w
		}
}

I286 lea_r16_ea(void) {							// 8D: lea REG16, EA

		__asm {
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		src_register
				I286CLOCK(3)
				mov		ebx, eax
				shr		ebx, 2
				and		ebx, 7*2
				rol		al, 2
				and		eax, 31
				call	calc_lea[eax*4]
				mov		word ptr I286_REG[ebx], ax
				ret
		src_register:
				INT_NUM(6)
		}
}

I286 mov_seg_ea(void) {							// 8E: mov segrem, EA

		__asm {
				GET_PCBYTE
				mov		ebx, eax
				shr		ebx, 3
				and		ebx, 3
				cmp		ebx, 1
				je		fixcs
				cmp		al, 0c0h
				jc		src_memory
				I286CLOCK(2)
				and		eax, 7
				mov		ax, word ptr I286_REG[eax*2]
				jmp		segset
		src_memory:
				I286CLOCK(5)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				call	i286_memoryread_w
		segset:	mov		word ptr I286_SEGREG[ebx*2], ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		SEG_BASE[ebx*4], eax
				sub		ebx, 2
				jc		segsetr
				mov		SS_FIX[ebx*4], eax
				je		setss
		segsetr:ret

		setss:	cmp		i286s.prefix, 0			// 00/05/13
				je		noprefix
				call	removeprefix
				pop		eax						// eax<-offset removeprefix
noprefix:		GET_PCBYTE
				and		eax, 00ffh
				jmp		i286op[eax*4]

		fixcs:	INT_NUM(6)
		}
}

I286 pop_ea(void) {								// 8F: pop EA

		__asm {
				I286CLOCK(5)
				movzx	ecx, I286_SP
				add		ecx, SS_BASE
				call	i286_memoryread_w
				add		I286_SP, 2
				mov		dx, ax
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		src_register
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				jmp		i286_memorywrite_w
		src_register:
				and		eax, 7
				mov		word ptr I286_REG[eax*2], dx
				ret
		}
}

I286 xchg_ax_reg(void) {						// 91-97: xchg ax, reg16

		__asm {
				I286CLOCK(3)
				and		al, 7
				mov		dx, I286_AX
				xchg	dx, I286_REG[eax*2]
				mov		I286_AX, dx
				ret
		}
}

I286 _cbw(void) {								// 98: cbw

		__asm {
				I286CLOCK(2)
				test	I286_AL, 80h
				setz	I286_AH
				dec		I286_AH
				ret
		}
}

I286 _cwd(void) {								// 99: cwd

		__asm {
				I286CLOCK(2)
				mov		ax, 80h
				test	I286_AH, al
				setz	al
				dec		ax
				mov		I286_DX, ax
				ret
		}
}

I286 call_far(void) {							// 9A: call far

		__asm {
				I286CLOCK(13)
				mov		edi, SS_BASE
				movzx	ebx, I286_SP
				mov		dx, I286_CS
				sub		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memorywrite_w
				GET_PCWORD
				push	eax
				GET_PCWORD
				mov		I286_CS, ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		CS_BASE, eax
				mov		ebp, eax
				pop		edx
				xchg	si, dx
				sub		bx, 2
				mov		I286_SP, bx
				lea		ecx, [edi + ebx]
				jmp		i286_memorywrite_w
		}
}

I286 _wait(void) {								// 9B: wait

		__asm {
				ret
		}
}

I286 _pushf(void) {								// 9C: pushf

		__asm {
				I286CLOCK(3)
				LOAD_I286FLAG(dx)
				and		dh, 0fh
				sub		I286_SP, 2
				movzx	ecx, I286_SP
				add		ecx, SS_BASE
				jmp		i286_memorywrite_w
		}
}

I286 _popf(void) {								// 9D: popf

		__asm {
				I286CLOCK(5)
				REGPOP(I286_FLAG)
				and		I286_FLAG, (0fffh xor I_FLAG)
				and		ax, I_FLAG
				mov		I286_IFLAG, ax
				I286IRQCHECKTERM
		}
}

I286 _sahf(void) {								// 9E: sahf

		__asm {
				I286CLOCK(2)
				mov		al, I286_AH
				mov		I286_FLAGL, al
				ret
		}
}

I286 _lahf(void) {								// 9F: lahf

		__asm {
				I286CLOCK(2)
				mov		al, I286_FLAGL
				mov		I286_AH, al
				ret
		}
}

I286 mov_al_m8(void) {							// A0: mov al, m8

		__asm {
				I286CLOCK(5)
				GET_PCWORD
				xor		ecx, ecx
				mov		cx, ax
				add		ecx, DS_FIX
				call	i286_memoryread
				mov		I286_AL, al
				ret
		}
}

I286 mov_ax_m16(void) {							// A1: mov ax, m16

		__asm {
				I286CLOCK(5)
				GET_PCWORD
				xor		ecx, ecx
				mov		cx, ax
				add		ecx, DS_FIX
				call	i286_memoryread_w
				mov		I286_AX, ax
				ret
		}
}

I286 mov_m8_al(void) {							// A2: mov m8, al

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				mov		dl, I286_AL
				xor		ecx, ecx
				mov		cx, ax
				add		ecx, DS_FIX
				jmp		i286_memorywrite
		}
}

I286 mov_m16_ax(void) {							// A3: mov m16, ax

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				mov		dx, I286_AX
				xor		ecx, ecx
				mov		cx, ax
				add		ecx, DS_FIX
				jmp		i286_memorywrite_w
		}
}

I286 _movsb(void) {								// A4: movsb

		__asm {
				I286CLOCK(5)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread
				mov		dl, al
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				STRING_DIR
				add		I286_SI, ax
				add		I286_DI, ax
				jmp		i286_memorywrite
		}
}

I286 _movsw(void) {								// A5: movsw

		__asm {
				I286CLOCK(5)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread_w
				mov		dx, ax
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				STRING_DIRx2
				add		I286_SI, ax
				add		I286_DI, ax
				jmp		i286_memorywrite_w
		}
}

I286 _cmpsb(void) {								// A6: cmpsb

		__asm {
				I286CLOCK(8)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread
				mov		bl, al
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				call	i286_memoryread
				cmp		bl, al
				FLAG_STORE_OF
				STRING_DIR
				add		I286_SI, ax
				add		I286_DI, ax
				ret
		}
}

I286 _cmpsw(void) {								// A7: cmpsw

		__asm {
				I286CLOCK(8)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread_w
				mov		bx, ax
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				call	i286_memoryread_w
				cmp		bx, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		I286_SI, ax
				add		I286_DI, ax
				ret
		}
}

I286 test_al_data8(void) {						// A8: test al, DATA8

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				test	I286_AL, al
				FLAG_STORE0
				ret
		}
}

I286 test_ax_data16(void) {						// A9: test ax, DATA16

		__asm {
				I286CLOCK(3)
				GET_PCWORD
				test	I286_AX, ax
				FLAG_STORE0
				ret
		}
}

I286 _stosb(void) {								// AA: stosb

		__asm {
				I286CLOCK(3)
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				STRING_DIR
				add		I286_DI, ax
				mov		dl, I286_AL
				jmp		i286_memorywrite
		}
}

I286 _stosw(void) {								// AB: stosw

		__asm {
				I286CLOCK(3)
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				STRING_DIRx2
				add		I286_DI, ax
				mov		dx, I286_AX
				jmp		i286_memorywrite_w
		}
}

I286 _lodsb(void) {								// AC: lodsb

		__asm {
				I286CLOCK(5)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread
				mov		I286_AL, al
				STRING_DIR
				add		I286_SI, ax
				ret
		}
}

I286 _lodsw(void) {								// AD: lodsw

		__asm {
				I286CLOCK(5)
				movzx	ecx, I286_SI
				add		ecx, DS_FIX
				call	i286_memoryread_w
				mov		I286_AX, ax
				STRING_DIRx2
				add		I286_SI, ax
				ret
		}
}

I286 _scasb(void) {								// AE: scasb

		__asm {
				I286CLOCK(7)
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				call	i286_memoryread
				cmp		I286_AL, al
				FLAG_STORE_OF
				STRING_DIR
				add		I286_DI, ax
				ret
		}
}

I286 _scasw(void) {								// AF: scasw

		__asm {
				I286CLOCK(7)
				movzx	ecx, I286_ES
				shl		ecx, 4
				movzx	eax, I286_DI
				add		ecx, eax
				call	i286_memoryread_w
				cmp		I286_AX, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		I286_DI, ax
				ret
		}
}

I286 mov_al_imm(void) {							// B0: mov al, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_AL, al
				ret
		}
}

I286 mov_cl_imm(void) {							// B1: mov cl, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_CL, al
				ret
		}
}

I286 mov_dl_imm(void) {							// B2: mov dl, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_DL, al
				ret
		}
}

I286 mov_bl_imm(void) {							// B3: mov bl, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_BL, al
				ret
		}
}

I286 mov_ah_imm(void) {							// B4: mov ah, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_AH, al
				ret
		}
}

I286 mov_ch_imm(void) {							// B5: mov ch, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_CH, al
				ret
		}
}

I286 mov_dh_imm(void) {							// B6: mov dh, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_DH, al
				ret
		}
}

I286 mov_bh_imm(void) {							// B7: mov bh, imm8

		__asm {
				I286CLOCK(2)
				GET_PCBYTE
				mov		I286_BH, al
				ret
		}
}

I286 mov_ax_imm(void) {							// B8: mov ax, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_AX, ax
				ret
		}
}

I286 mov_cx_imm(void) {							// B9: mov cx, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_CX, ax
				ret
		}
}

I286 mov_dx_imm(void) {							// BA: mov dx, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_DX, ax
				ret
		}
}

I286 mov_bx_imm(void) {							// BB: mov bx, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_BX, ax
				ret
		}
}

I286 mov_sp_imm(void) {							// BC: mov sp, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_SP, ax
				ret
		}
}

I286 mov_bp_imm(void) {							// BD: mov bp, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_BP, ax
				ret
		}
}

I286 mov_si_imm(void) {							// BE: mov si, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_SI, ax
				ret
		}
}

I286 mov_di_imm(void) {							// BF: mov di, imm16

		__asm {
				I286CLOCK(2)
				GET_PCWORD
				mov		I286_DI, ax
				ret
		}
}

I286 shift_ea8_data8(void) {					// C0: shift EA8, DATA8

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(5)
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				lea		ebx, I286_REG[eax]
				GET_PCBYTE
				mov		ecx, eax
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg8cl_table[edi*4]
		memory_eareg8:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMWRITEMAX
				jnc		extmem_eareg8
				lea		ebx, I286_MEM[ecx]
				GET_PCBYTE
				mov		ecx, eax
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg8cl_table[edi*4]
		extmem_eareg8:
				call	i286_memoryread
				mov		edx, eax
				GET_PCBYTE
				mov		ecx, eax
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftext8cl_table[edi*4]
	}
}

I286 shift_ea16_data8(void) {					// C1: shift EA16, DATA8

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg16
				and		eax, 7
				I286CLOCK(5)
				lea		ebx, I286_REG[eax*2]
				GET_PCBYTE
				mov		ecx, eax
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg16cl_table[edi*4]
		memory_eareg16:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, (I286_MEMWRITEMAX-1)
				jnc		extmem_eareg16
				lea		ebx, I286_MEM[ecx]
				GET_PCBYTE
				mov		ecx, eax
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg16cl_table[edi*4]
		extmem_eareg16:
				call	i286_memoryread_w
				mov		edx, eax
				mov		ebx, ecx
				GET_PCBYTE
				mov		ecx, eax
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftext16cl_table[edi*4]
	}
}

I286 ret_near_data16(void) {					// C2: ret near DATA16

		__asm {
				I286CLOCK(11)
				GET_PCWORD
				movzx	ecx, I286_SP
				add		ax, 2
				add		I286_SP, ax
				add		ecx, SS_BASE
				call	i286_memoryread_w
				mov		si, ax
				ret
		}
}

I286 ret_near(void) {							// C3: ret near

		__asm {
				I286CLOCK(11)
				REGPOP(si)
				ret
		}
}

I286 les_r16_ea(void) {							// C4: les REG16, EA

		__asm {

				GET_PCBYTE
				cmp		al, 0c0h
				jnc		src_register
				I286CLOCK(3)
				push	eax
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				pop		edx
				shr		edx, 2
				and		edx, 14
				mov		word ptr I286_REG[edx], ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_ES, ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		ES_BASE, eax
				ret
		src_register:
				INT_NUM(6)
		}
}

I286 lds_r16_ea(void) {							// C5: lds REG16, EA

		__asm {

				GET_PCBYTE
				cmp		al, 0c0h
				jnc		src_register
				I286CLOCK(3)
				push	eax
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				pop		edx
				shr		edx, 2
				and		edx, 14
				mov		word ptr I286_REG[edx], ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_DS, ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		DS_BASE, eax
				mov		DS_FIX, eax
				ret
		src_register:
				INT_NUM(6)
		}
}

I286 mov_ea8_data8(void) {						// C6: mov EA8, DATA8

		__asm {
				GET_PCBYTE
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(2)
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				mov		ebx, eax
				GET_PCBYTE
				mov		byte ptr I286_REG[ebx], al
				ret
		memory_eareg8:
				I286CLOCK(3)
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				GET_PCBYTE
				mov		dx, ax
				lea		ecx, [edi + ebx]
				jmp		i286_memorywrite
		}
}

I286 mov_ea16_data16(void) {					// C7: mov EA16, DATA16

		__asm {
				GET_PCBYTE
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(2)
				and		eax, 7
				lea		ebx, word ptr I286_REG[eax*2]
				GET_PCWORD
				mov		[ebx], ax
				ret
		memory_eareg8:
				I286CLOCK(3)
				rol		al, 2
				and		eax, 31
				call	get_ea[eax*4]
				GET_PCWORD
				mov		dx, ax
				lea		ecx, [edi + ebx]
				jmp		i286_memorywrite_w
		}
}

I286 _enter(void) {								// C8: enter DATA16, DATA8

		__asm {
				mov		edi, SS_BASE
				movzx	ebx, I286_SP
				GET_PCWORD
				push	eax
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_BP
				call	i286_memorywrite_w
				GET_PCBYTE
				and		eax, 1fh
				je		enter0
				dec		eax
				je		enter1
				lea		ecx, [eax*4 + 12]
				I286CLOCK(ecx)
				push	ebp
				movzx	ebp, I286_BP
				mov		I286_BP, bx
		enter_lp:
				push	eax
				sub		bp, 2
				lea		ecx, [edi + ebp]
				call	i286_memoryread_w
				mov		edx, eax
				sub		bx, 2
				lea		ecx, [edi + ebx]
				call	i286_memorywrite_w
				pop		eax
				dec		eax
				jne		enter_lp
				pop		ebp
				pop		eax
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_BP
				sub		bx, ax
				mov		I286_SP, bx
				jmp		i286_memorywrite_w
		enter1:
				I286CLOCK(15)
				mov		dx, bx
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		I286_BP, dx
				pop		eax
				sub		bx, ax
				mov		I286_SP, bx
				jmp		i286_memorywrite_w

		enter0:
				I286CLOCK(11)
				mov		I286_BP, bx
				pop		eax
				sub		bx, ax
				mov		I286_SP, bx
				ret
		}
}

I286 leave(void) {								// C9: leave

		__asm {
				I286CLOCK(5)
				mov		ax, I286_BP
				mov		I286_SP, ax
				REGPOP(I286_BP)
				ret
		}
}

I286 ret_far_data16(void) {						// CA: ret far DATA16

		__asm {
				I286CLOCK(15)
				GET_PCWORD
				mov		edi, SS_BASE
				movzx	ebx, I286_SP
				add		I286_SP, ax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	i286_memoryread_w
				mov		si, ax
				lea		ecx, [edi + ebx]
				call	i286_memoryread_w
				mov		I286_CS, ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		CS_BASE, eax
				mov		ebp, eax
				add		I286_SP, 4
				ret
		}
}

I286 ret_far(void) {							// CB: ret far

		__asm {
				I286CLOCK(15)
				mov		edi, SS_BASE
				movzx	ebx, I286_SP
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	i286_memoryread_w
				mov		si, ax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	i286_memoryread_w
				mov		I286_CS, ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		CS_BASE, eax
				mov		ebp, eax
				mov		I286_SP, bx
				ret
		}
}

I286 int_03(void) {								// CC: int 3

		__asm {
				I286CLOCK(23)
				INT_NUM(3)
		}
}

I286 int_data8(void) {							// CD: int DATA8

		__asm {
				I286CLOCK(23)
				mov		edi, SS_BASE
				movzx	ebx, I286_SP
				sub		bx, 2
				LOAD_I286FLAG(dx)
				mov		I286_IFLAG, 0
				lea		ecx, [edi + ebx]
				call	i286_memorywrite_w
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, I286_CS
				call	i286_memorywrite_w
				GET_PCBYTE
				and		eax, 0ffh
				sub		bx, 2
				mov		I286_SP, bx
				lea		ecx, [edi + ebx]
				mov		dx, si
				mov		eax, dword ptr I286_MEM[eax*4]
				mov		si, ax
				shr		eax, 16
				mov		I286_CS, ax
				shl		eax, 4					// make segreg
				mov		CS_BASE, eax
				mov		ebp, eax
				jmp		i286_memorywrite_w
		}
}

I286 _into(void) {								// CE: into

		__asm {
				test	I286_FLAG, O_FLAG
				jne		intovf
				I286CLOCK(4)
				ret
		intovf:
				I286CLOCK(24)
				INT_NUM(0)
		}
}

I286 _iret(void) {								// CF: iret

		__asm {
				I286CLOCK(31)
				mov		edi, SS_BASE
				movzx	ebx, I286_SP
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	i286_memoryread_w
				mov		si, ax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	i286_memoryread_w
				mov		I286_CS, ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		CS_BASE, eax
				mov		ebp, eax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	i286_memoryread_w
				mov		I286_SP, bx
				mov		dx, ax
				and		dx, not I_FLAG
				and		ax, I_FLAG
				mov		I286_FLAG, dx
				mov		I286_IFLAG, ax
				I286IRQCHECKTERM
		}
}

I286 shift_ea8_1(void) {						// D0: shift EA8, 1

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				I286CLOCK(2)
				mov		ecx, ebx
				jmp		sftreg8_table[edi*4]
		memory_eareg8:
				I286CLOCK(7)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMWRITEMAX
				jnc		extmem_eareg8
				jmp		sftmem8_table[edi*4]
		extmem_eareg8:
				call	i286_memoryread
				mov		edx, eax
				jmp		sftext8_table[edi*4]
	}
}

I286 shift_ea16_1(void) {						// D1: shift EA16, 1

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg16
				I286CLOCK(2)
				and		eax, 7
				jmp		sftreg16_table[edi*4]
		memory_eareg16:
				I286CLOCK(7)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, (I286_MEMWRITEMAX-1)
				jnc		extmem_eareg16
				jmp		sftmem16_table[edi*4]
		extmem_eareg16:
				call	i286_memoryread_w
				mov		edx, eax
				jmp		sftext16_table[edi*4]
	}
}


I286 shift_ea8_cl(void) {						// D2: shift EA8, cl

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(5)
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				lea		ebx, I286_REG[eax]
				movzx	ecx, I286_CL
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg8cl_table[edi*4]
		memory_eareg8:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMWRITEMAX
				jnc		extmem_eareg8
				lea		ebx, I286_MEM[ecx]
				movzx	ecx, I286_CL
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg8cl_table[edi*4]
		extmem_eareg8:
				call	i286_memoryread
				mov		edx, eax
				mov		ebx, ecx
				movzx	ecx, I286_CL
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftext8cl_table[edi*4]
	}
}

I286 shift_ea16_cl(void) {						// D3: shift EA16, cl

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg16
				I286CLOCK(5)
				and		eax, 7
				lea		ebx, I286_REG[eax*2]
				movzx	ecx, I286_CL
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg16cl_table[edi*4]
		memory_eareg16:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, (I286_MEMWRITEMAX-1)
				jnc		extmem_eareg16
				lea		ebx, I286_MEM[ecx]
				movzx	ecx, I286_CL
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftreg16cl_table[edi*4]
		extmem_eareg16:
				call	i286_memoryread_w
				mov		edx, eax
				mov		ebx, ecx
				movzx	ecx, I286_CL
				and		ecx, 31
				I286CLOCK(ecx)
				jmp		sftext16cl_table[edi*4]
	}
}


I286 _aam(void) {								// D4: AAM

		__asm {									// todo: flag !!!
				GET_PCBYTE
#if 0
				mov		ax, I286_AX
				aam
				mov		I286_AX, ax
				FLAG_STORE
				ret
#else
				cmp		al, 0
				je		div0
				I286CLOCK(16)
				mov		cl, al
				movzx	eax, I286_AL
				div		cl
				xchg	al, ah
				mov		I286_AX, ax
				and		I286_FLAGL, not (S_FLAG or Z_FLAG or P_FLAG)
				mov		dh, ah
				and		dh, S_FLAG
				or		ax, ax
				jne		short nzflagsed
				or		dh, Z_FLAG
nzflagsed:		xor		al, ah
				and		eax, 00ffh
				mov		al, iflags[eax]
				and		al, P_FLAG
				or		al, dh
				or		I286_FLAGL, al
				ret
		div0:
				INT_NUM(0)
#endif
		}
}

I286 _aad(void) {								// D5: AAD

		__asm {									// todo: flag !!!
				I286CLOCK(14)
				GET_PCBYTE
#if 0
				mov		ax, I286_AX
				aad
				mov		I286_AX, ax
				FLAG_STORE
#else
				mul		I286_AH
				add		al, I286_AL
				mov		ah, 0
				mov		I286_AX, ax
				and		I286_FLAGL, not (S_FLAG or Z_FLAG or P_FLAG)
				and		eax, 00ffh
				mov		al, iflags[eax]
				and		al, P_FLAG or Z_FLAG
				or		I286_FLAGL, al
#endif
				ret
		}
}

I286 _setalc(void) {							// D6: setalc(80286)

		__asm {
				setnc	I286_AL
				dec		I286_AL
				ret
		}
}

I286 _xlat(void) {								// D7: xlat

		__asm {
				I286CLOCK(5)
				movzx	ecx, I286_AL
				add		cx, I286_BX
				add		ecx, DS_FIX
				call	i286_memoryread
				mov		I286_AL, al
				ret
		}
}

I286 _esc(void) {								// D8-DF: esc

		__asm {
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		ea_reg8
				rol		al, 2
				and		eax, 31
				call	calc_lea[eax*4]
		ea_reg8:
				ret
		}
}

I286 _loopnz(void) {							// E0: loopnz

		__asm {
				dec		I286_CX
				je		loopend
				test	I286_FLAG, Z_FLAG
				jne		loopend
				I286CLOCK(8)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
loopend:		I286CLOCK(4)
				inc		si
				ret
		}
}

I286 _loopz(void) {								// E1: loopz

		__asm {
				dec		I286_CX
				je		loopend
				test	I286_FLAG, Z_FLAG
				je		loopend
				I286CLOCK(8)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
loopend:		I286CLOCK(4)
				inc		si
				ret
		}
}

I286 _loop(void) {								// E2: loop

		__asm {
				dec		I286_CX
				je		loopend
				I286CLOCK(8)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
loopend:		I286CLOCK(4)
				inc		si
				ret
		}
}

I286 _jcxz(void) {								// E3: jcxz

		__asm {
				cmp		I286_CX, 0
				jne		loopend
				I286CLOCK(8)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
loopend:		I286CLOCK(4)
				inc		si
				ret
		}
}

I286 in_al_data8(void) {						// E4: in al, DATA8

		__asm {
				I286CLOCK(5)
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				call	i286_in
				mov		I286_AL, al
				ret
		}
}

I286 in_ax_data8(void) {						// E5: in ax, DATA8

		__asm {
				I286CLOCK(5)
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				call	i286_in_w
				mov		I286_AX, ax
				ret
		}
}

I286 out_data8_al(void) {						// E6: out DATA8, al

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				mov		dl, I286_AL
				jmp		i286_out
			}
}

I286 out_data8_ax(void) {						// E7: out DATA8, ax

		__asm {
				I286CLOCK(3)
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				mov		dx, I286_AX
				jmp		i286_out_w
		}
}

I286 call_near(void) {							// E8: call near

		__asm {
				I286CLOCK(7)
				GET_PCWORD
				mov		dx, si
				add		si, ax
				sub		I286_SP, 2
				movzx	ecx, I286_SP
				add		ecx, SS_BASE
				jmp		i286_memorywrite_w
		}
}

I286 jmp_near(void) {							// E9: jmp near

		__asm {
				I286CLOCK(7)
				GET_PCWORD
				add		si, ax
				ret
		}
}

I286 jmp_far(void) {							// EA: jmp far

		__asm {
				I286CLOCK(11)
				GET_PCWORD
				push	eax
				GET_PCWORD
				mov		I286_CS, ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		CS_BASE, eax
				mov		ebp, eax
				pop		esi
				and		esi, 0x0000ffff
				ret
		}
}

I286 jmp_short(void) {							// EB: jmp short

		__asm {
				I286CLOCK(7)
				GET_PCBYTE
				cbw
				add		si, ax
				ret
		}
}

I286 in_al_dx(void) {							// EC: in al, dx

		__asm {
				I286CLOCK(5)
				mov		cx, I286_DX
				call	i286_in
				mov		I286_AL, al
				ret
		}
}

I286 in_ax_dx(void) {							// ED: in ax, dx

		__asm {
				I286CLOCK(5)
				mov		cx, I286_DX
				call	i286_in_w
				mov		I286_AX, ax
				ret
		}
}

I286 out_dx_al(void) {							// EE: out dx, al

		__asm {
				I286CLOCK(3)
				mov		cx, I286_DX
				mov		dl, I286_AL
				jmp		i286_out
			}
}

I286 out_dx_ax(void) {							// EF: out dx, ax

		__asm {
				I286CLOCK(3)
				mov		cx, I286_DX
				mov		dx, I286_AX
				jmp		i286_out_w
		}
}

I286 _lock(void) {								// F0: lock

		__asm {
				ret
		}
}

I286 _repne(void) {								// F2: repne

		__asm {
				GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repne[eax*4]
		}
}

I286 _repe(void) {								// F3: repe

		__asm {
				GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repe[eax*4]
		}
}

I286 _hlt(void) {								// F4: hlt

		__asm {
				mov		nevent.remainclock, -1
				dec		si
				ret
		}
}

I286 _cmc(void) {								// F5: cmc

		__asm {
				I286CLOCK(2)
				xor		I286_FLAG, C_FLAG
				ret
		}
}

I286 _ope0xf6(void) {							// F6: 

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 1
				and		edi, 7*4
				jmp		ope0xf6_table[edi]
		}
}

I286 _ope0xf7(void) {							// F7: 

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 1
				and		edi, 7*4
				jmp		ope0xf7_table[edi]
		}
}

I286 _clc(void) {								// F8: clc

		__asm {
				I286CLOCK(2)
				and		I286_FLAG, not C_FLAG
				ret
		}
}

I286 _stc(void) {								// F9: stc

		__asm {
				I286CLOCK(2)
				or		I286_FLAG, C_FLAG
				ret
		}
}

I286 _cli(void) {								// FA: cli

		__asm {
				I286CLOCK(2)
				mov		I286_IFLAG, 0
				ret
		}
}

I286 _sti(void) {								// FB: sti

		__asm {
				I286CLOCK(2)
				mov		I286_IFLAG, I_FLAG
				I286IRQCHECKTERM
		}
}

I286 _cld(void) {								// FC: cld

		__asm {
				I286CLOCK(2)
				and		I286_FLAG, not D_FLAG
				ret
		}
}

I286 _std(void) {								// FD: std

		__asm {
				I286CLOCK(2)
				or		I286_FLAG, D_FLAG
				ret
		}
}

I286 _ope0xfe(void) {							// FE: 

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 1
				and		edi, 1*4
				jmp		ope0xfe_table[edi]
		}
}

I286 _ope0xff(void) {							// FF: 

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 1
				and		edi, 7*4
				jmp		ope0xff_table[edi]
		}
}

// -------------------------------------------------------------------------

void (*i286op[])(void) = {
			add_ea_r8,						// 00:	add		EA, REG8
			add_ea_r16,						// 01:	add		EA, REG16
			add_r8_ea,						// 02:	add		REG8, EA
			add_r16_ea,						// 03:	add		REG16, EA
			add_al_data8,					// 04:	add		al, DATA8
			add_ax_data16,					// 05:	add		ax, DATA16
			push_es,						// 06:	push	es
			pop_es,							// 07:	pop		es
			or_ea_r8,						// 08:	or		EA, REGF8
			or_ea_r16,						// 09:	or		EA, REG16
			or_r8_ea,						// 0A:	or		REG8, EA
			or_r16_ea,						// 0B:	or		REG16, EA
			or_al_data8,					// 0C:	or		al, DATA8
			or_ax_data16,					// 0D:	or		ax, DATA16
			push_cs,						// 0E:	push	cs
			_cts,							// 0F:	i286 upper opcode

			adc_ea_r8,						// 10:	adc		EA, REG8
			adc_ea_r16,						// 11:	adc		EA, REG16
			adc_r8_ea,						// 12:	adc		REG8, EA
			adc_r16_ea,						// 13:	adc		REG16, EA
			adc_al_data8,					// 14:	adc		al, DATA8
			adc_ax_data16,					// 15:	adc		ax, DATA16
			push_ss,						// 16:	push	ss
			pop_ss,							// 17:	pop		ss
			sbb_ea_r8,						// 18:	sbb		EA, REG8
			sbb_ea_r16,						// 19:	sbb		EA, REG16
			sbb_r8_ea,						// 1A:	sbb		REG8, EA
			sbb_r16_ea,						// 1B:	sbb		REG16, EA
			sbb_al_data8,					// 1C:	sbb		al, DATA8
			sbb_ax_data16,					// 1D:	sbb		ax, DATA16
			push_ds,						// 1E:	push	ds
			pop_ds,							// 1F:	pop		ds

			and_ea_r8,						// 20:	and		EA, REG8
			and_ea_r16,						// 21:	and		EA, REG16
			and_r8_ea,						// 22:	and		REG8, EA
			and_r16_ea,						// 23:	and		REG16, EA
			and_al_data8,					// 24:	and		al, DATA8
			and_ax_data16,					// 25:	and		ax, DATA16
			segprefix_es,					// 26:	es:
			_daa,							// 27:	daa
			sub_ea_r8,						// 28:	sub		EA, REG8
			sub_ea_r16,						// 29:	sub		EA, REG16
			sub_r8_ea,						// 2A:	sub		REG8, EA
			sub_r16_ea,						// 2B:	sub		REG16, EA
			sub_al_data8,					// 2C:	sub		al, DATA8
			sub_ax_data16,					// 2D:	sub		ax, DATA16
			segprefix_cs,					// 2E:	cs:
			_das,							// 2F:	das

			xor_ea_r8,						// 30:	xor		EA, REG8
			xor_ea_r16,						// 31:	xor		EA, REG16
			xor_r8_ea,						// 32:	xor		REG8, EA
			xor_r16_ea,						// 33:	xor		REG16, EA
			xor_al_data8,					// 34:	xor		al, DATA8
			xor_ax_data16,					// 35:	xor		ax, DATA16
			segprefix_ss,					// 36:	ss:
			_aaa,							// 37:	aaa
			cmp_ea_r8,						// 38:	cmp		EA, REG8
			cmp_ea_r16,						// 39:	cmp		EA, REG16
			cmp_r8_ea,						// 3A:	cmp		REG8, EA
			cmp_r16_ea,						// 3B:	cmp		REG16, EA
			cmp_al_data8,					// 3C:	cmp		al, DATA8
			cmp_ax_data16,					// 3D:	cmp		ax, DATA16
			segprefix_ds,					// 3E:	ds:
			_aas,							// 3F:	aas

			inc_reg16,						// 40:	inc		ax
			inc_reg16,						// 41:	inc		cx
			inc_reg16,						// 42:	inc		dx
			inc_reg16,						// 43:	inc		bx
			inc_reg16,						// 44:	inc		sp
			inc_reg16,						// 45:	inc		bp
			inc_reg16,						// 46:	inc		si
			inc_reg16,						// 47:	inc		di
			dec_reg16,						// 48:	dec		ax
			dec_reg16,						// 49:	dec		cx
			dec_reg16,						// 4A:	dec		dx
			dec_reg16,						// 4B:	dec		bx
			dec_reg16,						// 4C:	dec		sp
			dec_reg16,						// 4D:	dec		bp
			dec_reg16,						// 4E:	dec		si
			dec_reg16,						// 4F:	dec		di

			push_ax,						// 50:	push	ax
			push_cx,						// 51:	push	cx
			push_dx,						// 52:	push	dx
			push_bx,						// 53:	push	bx
			push_sp,						// 54:	push	sp
			push_bp,						// 55:	push	bp
			push_si,						// 56:	push	si
			push_di,						// 57:	push	di
			pop_ax,							// 58:	pop		ax
			pop_cx,							// 59:	pop		cx
			pop_dx,							// 5A:	pop		dx
			pop_bx,							// 5B:	pop		bx
			pop_sp,							// 5C:	pop		sp
			pop_bp,							// 5D:	pop		bp
			pop_si,							// 5E:	pop		si
			pop_di,							// 5F:	pop		di

			_pusha,							// 60:	pusha
			_popa,							// 61:	popa
			_bound,							// 62:	bound
			_arpl,							// 63:	arpl
			_reserved,						// 64:	reserved
			_reserved,						// 65:	reserved
			_reserved,						// 66:	reserved
			_reserved,						// 67:	reserved
			push_data16,					// 68:	push	DATA16
			imul_reg_ea_data16,				// 69:	imul	REG, EA, DATA16
			push_data8,						// 6A:	push	DATA8
			imul_reg_ea_data8,				// 6B:	imul	REG, EA, DATA8
			_insb,							// 6C:	insb
			_insw,							// 6D:	insw
			_outsb,							// 6E:	outsb
			_outsb,							// 6F:	outsw

			jo_short,						// 70:	jo short
			jno_short,						// 71:	jno short
			jc_short,						// 72:	jnae/jb/jc short
			jnc_short,						// 73:	jae/jnb/jnc short
			jz_short,						// 74:	je/jz short
			jnz_short,						// 75:	jne/jnz short
			jna_short,						// 76:	jna/jbe short
			ja_short,						// 77:	ja/jnbe short
			js_short,						// 78:	js short
			jns_short,						// 79:	jns short
			jp_short,						// 7A:	jp/jpe short
			jnp_short,						// 7B:	jnp/jpo short
			jl_short,						// 7C:	jl/jnge short
			jnl_short,						// 7D:	jnl/jge short
			jle_short,						// 7E:	jle/jng short
			jnle_short,						// 7F:	jg/jnle short

			calc_ea8_i8,					// 80:	op		EA8, DATA8
			calc_ea16_i16,					// 81:	op		EA16, DATA16
			calc_ea8_i8,					// 82:	op		EA8, DATA8
			calc_ea16_i8,					// 83:	op		EA16, DATA8
			test_ea_r8,						// 84:	test	EA, REG8
			test_ea_r16,					// 85:	test	EA, REG16
			xchg_ea_r8,						// 86:	xchg	EA, REG8
			xchg_ea_r16,					// 87:	xchg	EA, REG16
			mov_ea_r8,						// 88:	mov		EA, REG8
			mov_ea_r16,						// 89:	mov		EA, REG16
			mov_r8_ea,						// 8A:	mov		REG8, EA
			mov_r16_ea,						// 8B:	add		REG16, EA
			mov_ea_seg,						// 8C:	mov		EA, segreg
			lea_r16_ea,						// 8D:	lea		REG16, EA
			mov_seg_ea,						// 8E:	mov		segrem, EA
			pop_ea,							// 8F:	pop		EA

			_nop,							// 90:	xchg	ax, ax
			xchg_ax_reg,					// 91:	xchg	ax, cx
			xchg_ax_reg,					// 92:	xchg	ax, dx
			xchg_ax_reg,					// 93:	xchg	ax, bx
			xchg_ax_reg,					// 94:	xchg	ax, sp
			xchg_ax_reg,					// 95:	xchg	ax, bp
			xchg_ax_reg,					// 96:	xchg	ax, si
			xchg_ax_reg,					// 97:	xchg	ax, di
			_cbw,							// 98:	cbw
			_cwd,							// 99:	cwd
			call_far,						// 9A:	call far
			_wait,							// 9B:	wait
			_pushf,							// 9C:	pushf
			_popf,							// 9D:	popf
			_sahf,							// 9E:	sahf
			_lahf,							// 9F:	lahf

			mov_al_m8,						// A0:	mov		al, m8
			mov_ax_m16,						// A1:	mov		ax, m16
			mov_m8_al,						// A2:	mov		m8, al
			mov_m16_ax,						// A3:	mov		m16, ax
			_movsb,							// A4:	movsb
			_movsw,							// A5:	movsw
			_cmpsb,							// A6:	cmpsb
			_cmpsw,							// A7:	cmpsw
			test_al_data8,					// A8:	test	al, DATA8
			test_ax_data16,					// A9:	test	ax, DATA16
			_stosb,							// AA:	stosw
			_stosw,							// AB:	stosw
			_lodsb,							// AC:	lodsb
			_lodsw,							// AD:	lodsw
			_scasb,							// AE:	scasb
			_scasw,							// AF:	scasw

			mov_al_imm,						// B0:	mov		al, imm8
			mov_cl_imm,						// B1:	mov		cl, imm8
			mov_dl_imm,						// B2:	mov		dl, imm8
			mov_bl_imm,						// B3:	mov		bl, imm8
			mov_ah_imm,						// B4:	mov		ah, imm8
			mov_ch_imm,						// B5:	mov		ch, imm8
			mov_dh_imm,						// B6:	mov		dh, imm8
			mov_bh_imm,						// B7:	mov		bh, imm8
			mov_ax_imm,						// B8:	mov		ax, imm16
			mov_cx_imm,						// B9:	mov		cx, imm16
			mov_dx_imm,						// BA:	mov		dx, imm16
			mov_bx_imm,						// BB:	mov		bx, imm16
			mov_sp_imm,						// BC:	mov		sp, imm16
			mov_bp_imm,						// BD:	mov		bp, imm16
			mov_si_imm,						// BE:	mov		si, imm16
			mov_di_imm,						// BF:	mov		di, imm16

			shift_ea8_data8,				// C0:	shift	EA8, DATA8
			shift_ea16_data8,				// C1:	shift	EA16, DATA8
			ret_near_data16,				// C2:	ret near DATA16
			ret_near,						// C3:	ret near
			les_r16_ea,						// C4:	les		REG16, EA
			lds_r16_ea,						// C5:	lds		REG16, EA
			mov_ea8_data8,					// C6:	mov		EA8, DATA8
			mov_ea16_data16,				// C7:	mov		EA16, DATA16
			_enter,							// C8:	enter	DATA16, DATA8
			leave,							// C9:	leave
			ret_far_data16,					// CA:	ret far	DATA16
			ret_far,						// CB:	ret far
			int_03,							// CC:	int		3
			int_data8,						// CD:	int		DATA8
			_into,							// CE:	into
			_iret,							// CF:	iret

			shift_ea8_1,					// D0:	shift EA8, 1
			shift_ea16_1,					// D1:	shift EA16, 1
			shift_ea8_cl,					// D2:	shift EA8, cl
			shift_ea16_cl,					// D3:	shift EA16, cl
			_aam,							// D4:	AAM
			_aad,							// D5:	AAD
			_setalc,						// D6:	setalc (80286)
			_xlat,							// D7:	xlat
			_esc,							// D8:	esc
			_esc,							// D9:	esc
			_esc,							// DA:	esc
			_esc,							// DB:	esc
			_esc,							// DC:	esc
			_esc,							// DD:	esc
			_esc,							// DE:	esc
			_esc,							// DF:	esc

			_loopnz,						// E0:	loopnz
			_loopz,							// E1:	loopz
			_loop,							// E2:	loop
			_jcxz,							// E3:	jcxz
			in_al_data8,					// E4:	in		al, DATA8
			in_ax_data8,					// E5:	in		ax, DATA8
			out_data8_al,					// E6:	out		DATA8, al
			out_data8_ax,					// E7:	out		DATA8, ax
			call_near,						// E8:	call near
			jmp_near,						// E9:	jmp near
			jmp_far,						// EA:	jmp far
			jmp_short,						// EB:	jmp short
			in_al_dx,						// EC:	in		al, dx
			in_ax_dx,						// ED:	in		ax, dx
			out_dx_al,						// EE:	out		dx, al
			out_dx_ax,						// EF:	out		dx, ax

			_lock,							// F0:	lock
			_lock,							// F1:	lock
			_repne,							// F2:	repne
			_repe,							// F3:	repe
			_hlt,							// F4:	hlt
			_cmc,							// F5:	cmc
			_ope0xf6,						// F6:	
			_ope0xf7,						// F7:	
			_clc,							// F8:	clc
			_stc,							// F9:	stc
			_cli,							// FA:	cli
			_sti,							// FB:	sti
			_cld,							// FC:	cld
			_std,							// FD:	std
			_ope0xfe,						// FE:	
			_ope0xff,						// FF:	
};

// ----------------------------------------------------------------- repe

I286 repe_segprefix_es(void) {

		__asm {
				mov		eax, ES_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repe[eax*4]
		}
}

I286 repe_segprefix_cs(void) {

		__asm {
				mov		eax, CS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repe[eax*4]
		}
}

I286 repe_segprefix_ss(void) {

		__asm {
				mov		eax, SS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repe[eax*4]
		}
}

I286 repe_segprefix_ds(void) {

		__asm {
				mov		eax, DS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repe[eax*4]
		}
}

void (*i286op_repe[])(void) = {
			add_ea_r8,						// 00:	add		EA, REG8
			add_ea_r16,						// 01:	add		EA, REG16
			add_r8_ea,						// 02:	add		REG8, EA
			add_r16_ea,						// 03:	add		REG16, EA
			add_al_data8,					// 04:	add		al, DATA8
			add_ax_data16,					// 05:	add		ax, DATA16
			push_es,						// 06:	push	es
			pop_es,							// 07:	pop		es
			or_ea_r8,						// 08:	or		EA, REGF8
			or_ea_r16,						// 09:	or		EA, REG16
			or_r8_ea,						// 0A:	or		REG8, EA
			or_r16_ea,						// 0B:	or		REG16, EA
			or_al_data8,					// 0C:	or		al, DATA8
			or_ax_data16,					// 0D:	or		ax, DATA16
			push_cs,						// 0E:	push	cs
			_cts,							// 0F:	i286 upper opcode

			adc_ea_r8,						// 10:	adc		EA, REG8
			adc_ea_r16,						// 11:	adc		EA, REG16
			adc_r8_ea,						// 12:	adc		REG8, EA
			adc_r16_ea,						// 13:	adc		REG16, EA
			adc_al_data8,					// 14:	adc		al, DATA8
			adc_ax_data16,					// 15:	adc		ax, DATA16
			push_ss,						// 16:	push	ss
			pop_ss,							// 17:	pop		ss
			sbb_ea_r8,						// 18:	sbb		EA, REG8
			sbb_ea_r16,						// 19:	sbb		EA, REG16
			sbb_r8_ea,						// 1A:	sbb		REG8, EA
			sbb_r16_ea,						// 1B:	sbb		REG16, EA
			sbb_al_data8,					// 1C:	sbb		al, DATA8
			sbb_ax_data16,					// 1D:	sbb		ax, DATA16
			push_ds,						// 1E:	push	ds
			pop_ds,							// 1F:	pop		ds

			and_ea_r8,						// 20:	and		EA, REG8
			and_ea_r16,						// 21:	and		EA, REG16
			and_r8_ea,						// 22:	and		REG8, EA
			and_r16_ea,						// 23:	and		REG16, EA
			and_al_data8,					// 24:	and		al, DATA8
			and_ax_data16,					// 25:	and		ax, DATA16
			repe_segprefix_es,				// 26:	repe es:
			_daa,							// 27:	daa
			sub_ea_r8,						// 28:	sub		EA, REG8
			sub_ea_r16,						// 29:	sub		EA, REG16
			sub_r8_ea,						// 2A:	sub		REG8, EA
			sub_r16_ea,						// 2B:	sub		REG16, EA
			sub_al_data8,					// 2C:	sub		al, DATA8
			sub_ax_data16,					// 2D:	sub		ax, DATA16
			repe_segprefix_cs,				// 2E:	repe cs:
			_das,							// 2F:	das

			xor_ea_r8,						// 30:	xor		EA, REG8
			xor_ea_r16,						// 31:	xor		EA, REG16
			xor_r8_ea,						// 32:	xor		REG8, EA
			xor_r16_ea,						// 33:	xor		REG16, EA
			xor_al_data8,					// 34:	xor		al, DATA8
			xor_ax_data16,					// 35:	xor		ax, DATA16
			repe_segprefix_ss,				// 36:	repe ss:
			_aaa,							// 37:	aaa
			cmp_ea_r8,						// 38:	cmp		EA, REG8
			cmp_ea_r16,						// 39:	cmp		EA, REG16
			cmp_r8_ea,						// 3A:	cmp		REG8, EA
			cmp_r16_ea,						// 3B:	cmp		REG16, EA
			cmp_al_data8,					// 3C:	cmp		al, DATA8
			cmp_ax_data16,					// 3D:	cmp		ax, DATA16
			repe_segprefix_ds,				// 3E:	repe ds:
			_aas,							// 3F:	aas

			inc_reg16,						// 40:	inc		ax
			inc_reg16,						// 41:	inc		cx
			inc_reg16,						// 42:	inc		dx
			inc_reg16,						// 43:	inc		bx
			inc_reg16,						// 44:	inc		sp
			inc_reg16,						// 45:	inc		bp
			inc_reg16,						// 46:	inc		si
			inc_reg16,						// 47:	inc		di
			dec_reg16,						// 48:	dec		ax
			dec_reg16,						// 49:	dec		cx
			dec_reg16,						// 4A:	dec		dx
			dec_reg16,						// 4B:	dec		bx
			dec_reg16,						// 4C:	dec		sp
			dec_reg16,						// 4D:	dec		bp
			dec_reg16,						// 4E:	dec		si
			dec_reg16,						// 4F:	dec		di

			push_ax,						// 50:	push	ax
			push_cx,						// 51:	push	cx
			push_dx,						// 52:	push	dx
			push_bx,						// 53:	push	bx
			push_sp,						// 54:	push	sp
			push_bp,						// 55:	push	bp
			push_si,						// 56:	push	si
			push_di,						// 57:	push	di
			pop_ax,							// 58:	pop		ax
			pop_cx,							// 59:	pop		cx
			pop_dx,							// 5A:	pop		dx
			pop_bx,							// 5B:	pop		bx
			pop_sp,							// 5C:	pop		sp
			pop_bp,							// 5D:	pop		bp
			pop_si,							// 5E:	pop		si
			pop_di,							// 5F:	pop		di

			_pusha,							// 60:	pusha
			_popa,							// 61:	popa
			_bound,							// 62:	bound
			_arpl,							// 63:	arpl
			_reserved,						// 64:	reserved
			_reserved,						// 65:	reserved
			_reserved,						// 66:	reserved
			_reserved,						// 67:	reserved
			push_data16,					// 68:	push	DATA16
			imul_reg_ea_data16,				// 69:	imul	REG, EA, DATA16
			push_data8,						// 6A:	push	DATA8
			imul_reg_ea_data8,				// 6B:	imul	REG, EA, DATA8
			rep_insb,						// 6C:	rep insb
			rep_insw,						// 6D:	rep insw
			rep_outsb,						// 6E:	rep outsb
			rep_outsb,						// 6F:	rep outsw

			jo_short,						// 70:	jo short
			jno_short,						// 71:	jno short
			jc_short,						// 72:	jnae/jb/jc short
			jnc_short,						// 73:	jae/jnb/jnc short
			jz_short,						// 74:	je/jz short
			jnz_short,						// 75:	jne/jnz short
			jna_short,						// 76:	jna/jbe short
			ja_short,						// 77:	ja/jnbe short
			js_short,						// 78:	js short
			jns_short,						// 79:	jns short
			jp_short,						// 7A:	jp/jpe short
			jnp_short,						// 7B:	jnp/jpo short
			jl_short,						// 7C:	jl/jnge short
			jnl_short,						// 7D:	jnl/jge short
			jle_short,						// 7E:	jle/jng short
			jnle_short,						// 7F:	jg/jnle short

			calc_ea8_i8,					// 80:	op		EA8, DATA8
			calc_ea16_i16,					// 81:	op		EA16, DATA16
			calc_ea8_i8,					// 82:	op		EA8, DATA8
			calc_ea16_i8,					// 83:	op		EA16, DATA8
			test_ea_r8,						// 84:	test	EA, REG8
			test_ea_r16,					// 85:	test	EA, REG16
			xchg_ea_r8,						// 86:	xchg	EA, REG8
			xchg_ea_r16,					// 87:	xchg	EA, REG16
			mov_ea_r8,						// 88:	mov		EA, REG8
			mov_ea_r16,						// 89:	mov		EA, REG16
			mov_r8_ea,						// 8A:	mov		REG8, EA
			mov_r16_ea,						// 8B:	add		REG16, EA
			mov_ea_seg,						// 8C:	mov		EA, segreg
			lea_r16_ea,						// 8D:	lea		REG16, EA
			mov_seg_ea,						// 8E:	mov		segrem, EA
			pop_ea,							// 8F:	pop		EA

			_nop,							// 90:	xchg	ax, ax
			xchg_ax_reg,					// 91:	xchg	ax, cx
			xchg_ax_reg,					// 92:	xchg	ax, dx
			xchg_ax_reg,					// 93:	xchg	ax, bx
			xchg_ax_reg,					// 94:	xchg	ax, sp
			xchg_ax_reg,					// 95:	xchg	ax, bp
			xchg_ax_reg,					// 96:	xchg	ax, si
			xchg_ax_reg,					// 97:	xchg	ax, di
			_cbw,							// 98:	cbw
			_cwd,							// 99:	cwd
			call_far,						// 9A:	call far
			_wait,							// 9B:	wait
			_pushf,							// 9C:	pushf
			_popf,							// 9D:	popf
			_sahf,							// 9E:	sahf
			_lahf,							// 9F:	lahf

			mov_al_m8,						// A0:	mov		al, m8
			mov_ax_m16,						// A1:	mov		ax, m16
			mov_m8_al,						// A2:	mov		m8, al
			mov_m16_ax,						// A3:	mov		m16, ax
			rep_movsb,						// A4:	rep movsb
			rep_movsw,						// A5:	rep movsw
			repe_cmpsb,						// A6:	repe cmpsb
			repe_cmpsw,						// A7:	repe cmpsw
			test_al_data8,					// A8:	test	al, DATA8
			test_ax_data16,					// A9:	test	ax, DATA16
			rep_stosb,						// AA:	rep stosw
			rep_stosw,						// AB:	rep stosw
			rep_lodsb,						// AC:	rep lodsb
			rep_lodsw,						// AD:	rep lodsw
			repe_scasb,						// AE:	repe scasb
			repe_scasw,						// AF:	repe scasw

			mov_al_imm,						// B0:	mov		al, imm8
			mov_cl_imm,						// B1:	mov		cl, imm8
			mov_dl_imm,						// B2:	mov		dl, imm8
			mov_bl_imm,						// B3:	mov		bl, imm8
			mov_ah_imm,						// B4:	mov		ah, imm8
			mov_ch_imm,						// B5:	mov		ch, imm8
			mov_dh_imm,						// B6:	mov		dh, imm8
			mov_bh_imm,						// B7:	mov		bh, imm8
			mov_ax_imm,						// B8:	mov		ax, imm16
			mov_cx_imm,						// B9:	mov		cx, imm16
			mov_dx_imm,						// BA:	mov		dx, imm16
			mov_bx_imm,						// BB:	mov		bx, imm16
			mov_sp_imm,						// BC:	mov		sp, imm16
			mov_bp_imm,						// BD:	mov		bp, imm16
			mov_si_imm,						// BE:	mov		si, imm16
			mov_di_imm,						// BF:	mov		di, imm16

			shift_ea8_data8,				// C0:	shift	EA8, DATA8
			shift_ea16_data8,				// C1:	shift	EA16, DATA8
			ret_near_data16,				// C2:	ret near DATA16
			ret_near,						// C3:	ret near
			les_r16_ea,						// C4:	les		REG16, EA
			lds_r16_ea,						// C5:	lds		REG16, EA
			mov_ea8_data8,					// C6:	mov		EA8, DATA8
			mov_ea16_data16,				// C7:	mov		EA16, DATA16
			_enter,							// C8:	enter	DATA16, DATA8
			leave,							// C9:	leave
			ret_far_data16,					// CA:	ret far	DATA16
			ret_far,						// CB:	ret far
			int_03,							// CC:	int		3
			int_data8,						// CD:	int		DATA8
			_into,							// CE:	into
			_iret,							// CF:	iret

			shift_ea8_1,					// D0:	shift EA8, 1
			shift_ea16_1,					// D1:	shift EA16, 1
			shift_ea8_cl,					// D2:	shift EA8, cl
			shift_ea16_cl,					// D3:	shift EA16, cl
			_aam,							// D4:	AAM
			_aad,							// D5:	AAD
			_setalc,						// D6:	setalc (80286)
			_xlat,							// D7:	xlat
			_esc,							// D8:	esc
			_esc,							// D9:	esc
			_esc,							// DA:	esc
			_esc,							// DB:	esc
			_esc,							// DC:	esc
			_esc,							// DD:	esc
			_esc,							// DE:	esc
			_esc,							// DF:	esc

			_loopnz,						// E0:	loopnz
			_loopz,							// E1:	loopz
			_loop,							// E2:	loop
			_jcxz,							// E3:	jcxz
			in_al_data8,					// E4:	in		al, DATA8
			in_ax_data8,					// E5:	in		ax, DATA8
			out_data8_al,					// E6:	out		DATA8, al
			out_data8_ax,					// E7:	out		DATA8, ax
			call_near,						// E8:	call near
			jmp_near,						// E9:	jmp near
			jmp_far,						// EA:	jmp far
			jmp_short,						// EB:	jmp short
			in_al_dx,						// EC:	in		al, dx
			in_ax_dx,						// ED:	in		ax, dx
			out_dx_al,						// EE:	out		dx, al
			out_dx_ax,						// EF:	out		dx, ax

			_lock,							// F0:	lock
			_lock,							// F1:	lock
			_repne,							// F2:	repne
			_repe,							// F3:	repe
			_hlt,							// F4:	hlt
			_cmc,							// F5:	cmc
			_ope0xf6,						// F6:	
			_ope0xf7,						// F7:	
			_clc,							// F8:	clc
			_stc,							// F9:	stc
			_cli,							// FA:	cli
			_sti,							// FB:	sti
			_cld,							// FC:	cld
			_std,							// FD:	std
			_ope0xfe,						// FE:	
			_ope0xff,						// FF:	
};

// ----------------------------------------------------------------- repne

I286 repne_segprefix_es(void) {

		__asm {
				mov		eax, ES_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repne[eax*4]
		}
}

I286 repne_segprefix_cs(void) {

		__asm {
				mov		eax, CS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repne[eax*4]
		}
}

I286 repne_segprefix_ss(void) {

		__asm {
				mov		eax, SS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repne[eax*4]
		}
}

I286 repne_segprefix_ds(void) {

		__asm {
				mov		eax, DS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		i286op_repne[eax*4]
		}
}

void (*i286op_repne[])(void) = {
			add_ea_r8,						// 00:	add		EA, REG8
			add_ea_r16,						// 01:	add		EA, REG16
			add_r8_ea,						// 02:	add		REG8, EA
			add_r16_ea,						// 03:	add		REG16, EA
			add_al_data8,					// 04:	add		al, DATA8
			add_ax_data16,					// 05:	add		ax, DATA16
			push_es,						// 06:	push	es
			pop_es,							// 07:	pop		es
			or_ea_r8,						// 08:	or		EA, REGF8
			or_ea_r16,						// 09:	or		EA, REG16
			or_r8_ea,						// 0A:	or		REG8, EA
			or_r16_ea,						// 0B:	or		REG16, EA
			or_al_data8,					// 0C:	or		al, DATA8
			or_ax_data16,					// 0D:	or		ax, DATA16
			push_cs,						// 0E:	push	cs
			_cts,							// 0F:	i286 upper opcode

			adc_ea_r8,						// 10:	adc		EA, REG8
			adc_ea_r16,						// 11:	adc		EA, REG16
			adc_r8_ea,						// 12:	adc		REG8, EA
			adc_r16_ea,						// 13:	adc		REG16, EA
			adc_al_data8,					// 14:	adc		al, DATA8
			adc_ax_data16,					// 15:	adc		ax, DATA16
			push_ss,						// 16:	push	ss
			pop_ss,							// 17:	pop		ss
			sbb_ea_r8,						// 18:	sbb		EA, REG8
			sbb_ea_r16,						// 19:	sbb		EA, REG16
			sbb_r8_ea,						// 1A:	sbb		REG8, EA
			sbb_r16_ea,						// 1B:	sbb		REG16, EA
			sbb_al_data8,					// 1C:	sbb		al, DATA8
			sbb_ax_data16,					// 1D:	sbb		ax, DATA16
			push_ds,						// 1E:	push	ds
			pop_ds,							// 1F:	pop		ds

			and_ea_r8,						// 20:	and		EA, REG8
			and_ea_r16,						// 21:	and		EA, REG16
			and_r8_ea,						// 22:	and		REG8, EA
			and_r16_ea,						// 23:	and		REG16, EA
			and_al_data8,					// 24:	and		al, DATA8
			and_ax_data16,					// 25:	and		ax, DATA16
			repne_segprefix_es,				// 26:	repne es:
			_daa,							// 27:	daa
			sub_ea_r8,						// 28:	sub		EA, REG8
			sub_ea_r16,						// 29:	sub		EA, REG16
			sub_r8_ea,						// 2A:	sub		REG8, EA
			sub_r16_ea,						// 2B:	sub		REG16, EA
			sub_al_data8,					// 2C:	sub		al, DATA8
			sub_ax_data16,					// 2D:	sub		ax, DATA16
			repne_segprefix_cs,				// 2E:	repne cs:
			_das,							// 2F:	das

			xor_ea_r8,						// 30:	xor		EA, REG8
			xor_ea_r16,						// 31:	xor		EA, REG16
			xor_r8_ea,						// 32:	xor		REG8, EA
			xor_r16_ea,						// 33:	xor		REG16, EA
			xor_al_data8,					// 34:	xor		al, DATA8
			xor_ax_data16,					// 35:	xor		ax, DATA16
			repne_segprefix_ss,				// 36:	repne ss:
			_aaa,							// 37:	aaa
			cmp_ea_r8,						// 38:	cmp		EA, REG8
			cmp_ea_r16,						// 39:	cmp		EA, REG16
			cmp_r8_ea,						// 3A:	cmp		REG8, EA
			cmp_r16_ea,						// 3B:	cmp		REG16, EA
			cmp_al_data8,					// 3C:	cmp		al, DATA8
			cmp_ax_data16,					// 3D:	cmp		ax, DATA16
			repne_segprefix_ds,				// 3E:	repne ds:
			_aas,							// 3F:	aas

			inc_reg16,						// 40:	inc		ax
			inc_reg16,						// 41:	inc		cx
			inc_reg16,						// 42:	inc		dx
			inc_reg16,						// 43:	inc		bx
			inc_reg16,						// 44:	inc		sp
			inc_reg16,						// 45:	inc		bp
			inc_reg16,						// 46:	inc		si
			inc_reg16,						// 47:	inc		di
			dec_reg16,						// 48:	dec		ax
			dec_reg16,						// 49:	dec		cx
			dec_reg16,						// 4A:	dec		dx
			dec_reg16,						// 4B:	dec		bx
			dec_reg16,						// 4C:	dec		sp
			dec_reg16,						// 4D:	dec		bp
			dec_reg16,						// 4E:	dec		si
			dec_reg16,						// 4F:	dec		di

			push_ax,						// 50:	push	ax
			push_cx,						// 51:	push	cx
			push_dx,						// 52:	push	dx
			push_bx,						// 53:	push	bx
			push_sp,						// 54:	push	sp
			push_bp,						// 55:	push	bp
			push_si,						// 56:	push	si
			push_di,						// 57:	push	di
			pop_ax,							// 58:	pop		ax
			pop_cx,							// 59:	pop		cx
			pop_dx,							// 5A:	pop		dx
			pop_bx,							// 5B:	pop		bx
			pop_sp,							// 5C:	pop		sp
			pop_bp,							// 5D:	pop		bp
			pop_si,							// 5E:	pop		si
			pop_di,							// 5F:	pop		di

			_pusha,							// 60:	pusha
			_popa,							// 61:	popa
			_bound,							// 62:	bound
			_arpl,							// 63:	arpl
			_reserved,						// 64:	reserved
			_reserved,						// 65:	reserved
			_reserved,						// 66:	reserved
			_reserved,						// 67:	reserved
			push_data16,					// 68:	push	DATA16
			imul_reg_ea_data16,				// 69:	imul	REG, EA, DATA16
			push_data8,						// 6A:	push	DATA8
			imul_reg_ea_data8,				// 6B:	imul	REG, EA, DATA8
			rep_insb,						// 6C:	rep insb
			rep_insw,						// 6D:	rep insw
			rep_outsb,						// 6E:	rep outsb
			rep_outsb,						// 6F:	rep outsw

			jo_short,						// 70:	jo short
			jno_short,						// 71:	jno short
			jc_short,						// 72:	jnae/jb/jc short
			jnc_short,						// 73:	jae/jnb/jnc short
			jz_short,						// 74:	je/jz short
			jnz_short,						// 75:	jne/jnz short
			jna_short,						// 76:	jna/jbe short
			ja_short,						// 77:	ja/jnbe short
			js_short,						// 78:	js short
			jns_short,						// 79:	jns short
			jp_short,						// 7A:	jp/jpe short
			jnp_short,						// 7B:	jnp/jpo short
			jl_short,						// 7C:	jl/jnge short
			jnl_short,						// 7D:	jnl/jge short
			jle_short,						// 7E:	jle/jng short
			jnle_short,						// 7F:	jg/jnle short

			calc_ea8_i8,					// 80:	op		EA8, DATA8
			calc_ea16_i16,					// 81:	op		EA16, DATA16
			calc_ea8_i8,					// 82:	op		EA8, DATA8
			calc_ea16_i8,					// 83:	op		EA16, DATA8
			test_ea_r8,						// 84:	test	EA, REG8
			test_ea_r16,					// 85:	test	EA, REG16
			xchg_ea_r8,						// 86:	xchg	EA, REG8
			xchg_ea_r16,					// 87:	xchg	EA, REG16
			mov_ea_r8,						// 88:	mov		EA, REG8
			mov_ea_r16,						// 89:	mov		EA, REG16
			mov_r8_ea,						// 8A:	mov		REG8, EA
			mov_r16_ea,						// 8B:	add		REG16, EA
			mov_ea_seg,						// 8C:	mov		EA, segreg
			lea_r16_ea,						// 8D:	lea		REG16, EA
			mov_seg_ea,						// 8E:	mov		segrem, EA
			pop_ea,							// 8F:	pop		EA

			_nop,							// 90:	xchg	ax, ax
			xchg_ax_reg,					// 91:	xchg	ax, cx
			xchg_ax_reg,					// 92:	xchg	ax, dx
			xchg_ax_reg,					// 93:	xchg	ax, bx
			xchg_ax_reg,					// 94:	xchg	ax, sp
			xchg_ax_reg,					// 95:	xchg	ax, bp
			xchg_ax_reg,					// 96:	xchg	ax, si
			xchg_ax_reg,					// 97:	xchg	ax, di
			_cbw,							// 98:	cbw
			_cwd,							// 99:	cwd
			call_far,						// 9A:	call far
			_wait,							// 9B:	wait
			_pushf,							// 9C:	pushf
			_popf,							// 9D:	popf
			_sahf,							// 9E:	sahf
			_lahf,							// 9F:	lahf

			mov_al_m8,						// A0:	mov		al, m8
			mov_ax_m16,						// A1:	mov		ax, m16
			mov_m8_al,						// A2:	mov		m8, al
			mov_m16_ax,						// A3:	mov		m16, ax
			rep_movsb,						// A4:	rep movsb
			rep_movsw,						// A5:	rep movsw
			repne_cmpsb,					// A6:	repne cmpsb
			repne_cmpsw,					// A7:	repne cmpsw
			test_al_data8,					// A8:	test	al, DATA8
			test_ax_data16,					// A9:	test	ax, DATA16
			rep_stosb,						// AA:	rep stosw
			rep_stosw,						// AB:	rep stosw
			rep_lodsb,						// AC:	rep lodsb
			rep_lodsw,						// AD:	rep lodsw
			repne_scasb,					// AE:	repne scasb
			repne_scasw,					// AF:	repne scasw

			mov_al_imm,						// B0:	mov		al, imm8
			mov_cl_imm,						// B1:	mov		cl, imm8
			mov_dl_imm,						// B2:	mov		dl, imm8
			mov_bl_imm,						// B3:	mov		bl, imm8
			mov_ah_imm,						// B4:	mov		ah, imm8
			mov_ch_imm,						// B5:	mov		ch, imm8
			mov_dh_imm,						// B6:	mov		dh, imm8
			mov_bh_imm,						// B7:	mov		bh, imm8
			mov_ax_imm,						// B8:	mov		ax, imm16
			mov_cx_imm,						// B9:	mov		cx, imm16
			mov_dx_imm,						// BA:	mov		dx, imm16
			mov_bx_imm,						// BB:	mov		bx, imm16
			mov_sp_imm,						// BC:	mov		sp, imm16
			mov_bp_imm,						// BD:	mov		bp, imm16
			mov_si_imm,						// BE:	mov		si, imm16
			mov_di_imm,						// BF:	mov		di, imm16

			shift_ea8_data8,				// C0:	shift	EA8, DATA8
			shift_ea16_data8,				// C1:	shift	EA16, DATA8
			ret_near_data16,				// C2:	ret near DATA16
			ret_near,						// C3:	ret near
			les_r16_ea,						// C4:	les		REG16, EA
			lds_r16_ea,						// C5:	lds		REG16, EA
			mov_ea8_data8,					// C6:	mov		EA8, DATA8
			mov_ea16_data16,				// C7:	mov		EA16, DATA16
			_enter,							// C8:	enter	DATA16, DATA8
			leave,							// C9:	leave
			ret_far_data16,					// CA:	ret far	DATA16
			ret_far,						// CB:	ret far
			int_03,							// CC:	int		3
			int_data8,						// CD:	int		DATA8
			_into,							// CE:	into
			_iret,							// CF:	iret

			shift_ea8_1,					// D0:	shift EA8, 1
			shift_ea16_1,					// D1:	shift EA16, 1
			shift_ea8_cl,					// D2:	shift EA8, cl
			shift_ea16_cl,					// D3:	shift EA16, cl
			_aam,							// D4:	AAM
			_aad,							// D5:	AAD
			_setalc,						// D6:	setalc (80286)
			_xlat,							// D7:	xlat
			_esc,							// D8:	esc
			_esc,							// D9:	esc
			_esc,							// DA:	esc
			_esc,							// DB:	esc
			_esc,							// DC:	esc
			_esc,							// DD:	esc
			_esc,							// DE:	esc
			_esc,							// DF:	esc

			_loopnz,						// E0:	loopnz
			_loopz,							// E1:	loopz
			_loop,							// E2:	loop
			_jcxz,							// E3:	jcxz
			in_al_data8,					// E4:	in		al, DATA8
			in_ax_data8,					// E5:	in		ax, DATA8
			out_data8_al,					// E6:	out		DATA8, al
			out_data8_ax,					// E7:	out		DATA8, ax
			call_near,						// E8:	call near
			jmp_near,						// E9:	jmp near
			jmp_far,						// EA:	jmp far
			jmp_short,						// EB:	jmp short
			in_al_dx,						// EC:	in		al, dx
			in_ax_dx,						// ED:	in		ax, dx
			out_dx_al,						// EE:	out		dx, al
			out_dx_ax,						// EF:	out		dx, ax

			_lock,							// F0:	lock
			_lock,							// F1:	lock
			_repne,							// F2:	repne
			_repe,							// F3:	repe
			_hlt,							// F4:	hlt
			_cmc,							// F5:	cmc
			_ope0xf6,						// F6:	
			_ope0xf7,						// F7:	
			_clc,							// F8:	clc
			_stc,							// F9:	stc
			_cli,							// FA:	cli
			_sti,							// FB:	sti
			_cld,							// FC:	cld
			_std,							// FD:	std
			_ope0xfe,						// FE:	
			_ope0xff,						// FF:	
};


// --------------------------------------------------------------------------

I286 v30_reserved(void) {

		__asm {
				ret
		}
}

I286 v30pop_ss(void) {							// 17: pop ss

		__asm {
				I286CLOCK(5)
				REGPOP(I286_SS)
				and		eax, 00ffffh
				shl		eax, 4					// make segreg
				mov		SS_BASE, eax
				mov		SS_FIX, eax
				cmp		i286s.prefix, 0			// 00/06/24
				je		noprefix
				call	removeprefix
				pop		eax
		noprefix:
				GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op[eax*4]
		}
}

I286 v30segprefix_es(void) {					// 26: es:

		__asm {
				mov		eax, ES_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op[eax*4]
		}
}

I286 v30segprefix_cs(void) {					// 2E: cs:

		__asm {
				mov		eax, CS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op[eax*4]
		}
}

I286 v30segprefix_ss(void) {					// 36: ss:

		__asm {
				mov		eax, SS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op[eax*4]
		}
}

I286 v30segprefix_ds(void) {					// 3E: ds:

		__asm {
				mov		eax, DS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op[eax*4]
		}
}

I286 v30push_sp(void) {							// 54: push sp

		__asm {
				I286CLOCK(3)
				sub		I286_SP, 2
				movzx	ecx, I286_SP
				mov		edx, ecx
				add		ecx, SS_BASE
				jmp		i286_memorywrite_w
		}
}

I286 v30pop_sp(void) {							// 5C: pop sp

		__asm {
				I286CLOCK(5)
				REGPOP(I286_SP)
				ret
		}
}

I286 v30mov_seg_ea(void) {						// 8E: mov segrem, EA

		__asm {
				GET_PCBYTE
				mov		ebx, eax
				shr		ebx, 3
				and		ebx, 3
				cmp		ebx, 1
				je		segsetr
				cmp		al, 0c0h
				jc		src_memory
				I286CLOCK(2)
				and		eax, 7
				mov		ax, word ptr I286_REG[eax*2]
				jmp		segset
		src_memory:
				I286CLOCK(5)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				call	i286_memoryread_w
		segset:	mov		word ptr I286_SEGREG[ebx*2], ax
				and		eax, 0000ffffh
				shl		eax, 4					// make segreg
				mov		SEG_BASE[ebx*4], eax
				sub		ebx, 2
				jc		segsetr
				mov		SS_FIX[ebx*4], eax
				je		setss
		segsetr:ret

		setss:	cmp		i286s.prefix, 0			// 00/05/13
				je		noprefix
				call	removeprefix
				pop		eax						// eax<-offset removeprefix
noprefix:		GET_PCBYTE
				and		eax, 00ffh
				jmp		v30op[eax*4]
		}
}

I286 v30_pushf(void) {							// 9C: pushf

		__asm {
				I286CLOCK(3)
				LOAD_I286FLAG(dx)
				or		dh, 0f0h
				sub		I286_SP, 2
				movzx	ecx, I286_SP
				add		ecx, SS_BASE
				jmp		i286_memorywrite_w
		}
}

I286 v30_popf(void) {							// 9D: popf

		__asm {
				I286CLOCK(5)
				REGPOP(I286_FLAG)
				and		I286_FLAG, (0fffh xor I_FLAG)
				or		I286_FLAG, 0f000h
				and		ax, I_FLAG
				mov		I286_IFLAG, ax
				I286IRQCHECKTERM
		}
}

I286 v30shift_ea8_data8(void) {					// C0: shift EA8, DATA8

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(5)
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				lea		ebx, I286_REG[eax]
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				and		ecx, 255
				I286CLOCK(ecx)
				jmp		sftreg8v30_table[edi*4]

		memory_eareg8:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMWRITEMAX
				jnc		extmem_eareg8
				lea		ebx, I286_MEM[ecx]
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				I286CLOCK(ecx)
				jmp		sftreg8v30_table[edi*4]
		extmem_eareg8:
				call	i286_memoryread
				mov		edx, eax
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				I286CLOCK(ecx)
				jmp		sftext8v30_table[edi*4]
	}
}

I286 v30shift_ea16_data8(void) {				// C1: shift EA16, DATA8

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg16
				and		eax, 7
				I286CLOCK(5)
				lea		ebx, I286_REG[eax*2]
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				I286CLOCK(ecx)
				jmp		sftreg16v30_table[edi*4]
		memory_eareg16:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, (I286_MEMWRITEMAX-1)
				jnc		extmem_eareg16
				lea		ebx, I286_MEM[ecx]
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				I286CLOCK(ecx)
				jmp		sftreg16v30_table[edi*4]
		extmem_eareg16:
				call	i286_memoryread_w
				mov		edx, eax
				mov		ebx, ecx
				GET_PCBYTE
				xor		ecx, ecx
				mov		cl, al
				I286CLOCK(ecx)
				jmp		sftext16v30_table[edi*4]
	}
}


I286 v30shift_ea8_cl(void) {					// D2: shift EA8, cl

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg8
				I286CLOCK(5)
				bt		ax, 2
				rcl		eax, 1
				and		eax, 7
				lea		ebx, I286_REG[eax]
				movzx	ecx, I286_CL
				I286CLOCK(ecx)
				jmp		sftreg8v30_table[edi*4]
		memory_eareg8:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, I286_MEMWRITEMAX
				jnc		extmem_eareg8
				lea		ebx, I286_MEM[ecx]
				movzx	ecx, I286_CL
				I286CLOCK(ecx)
				jmp		sftreg8v30_table[edi*4]
		extmem_eareg8:
				call	i286_memoryread
				mov		edx, eax
				mov		ebx, ecx
				movzx	ecx, I286_CL
				I286CLOCK(ecx)
				jmp		sftext8v30_table[edi*4]
	}
}

I286 v30shift_ea16_cl(void) {					// D3: shift EA16, cl

		__asm {
				GET_PCBYTE
				mov		edi, eax
				shr		edi, 3
				and		edi, 7							// opcode
				cmp		al, 0c0h
				jc		memory_eareg16
				I286CLOCK(5)
				and		eax, 7
				lea		ebx, I286_REG[eax*2]
				movzx	ecx, I286_CL
				I286CLOCK(ecx)
				jmp		sftreg16v30_table[edi*4]
		memory_eareg16:
				I286CLOCK(8)
				rol		al, 2
				and		eax, 31
				call	calc_ea_dst[eax*4]
				cmp		ecx, (I286_MEMWRITEMAX-1)
				jnc		extmem_eareg16
				lea		ebx, I286_MEM[ecx]
				movzx	ecx, I286_CL
				I286CLOCK(ecx)
				jmp		sftreg16v30_table[edi*4]
		extmem_eareg16:
				call	i286_memoryread_w
				mov		edx, eax
				mov		ebx, ecx
				movzx	ecx, I286_CL
				I286CLOCK(ecx)
				jmp		sftext16v30_table[edi*4]
	}
}


I286 v30_aam(void) {							// D4: AAM

		__asm {
				GET_PCBYTE
				mov		ax, I286_AX
				aam
				mov		I286_AX, ax
				FLAG_STORE
				ret
		}
}

I286 v30_aad(void) {							// D5: AAD

		__asm {
				I286CLOCK(14)
				GET_PCBYTE
				mov		ax, I286_AX
				aad
				mov		I286_AX, ax
				FLAG_STORE
				ret
		}
}

I286 v30_repne(void) {							// F2: repne

		__asm {
				GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repne[eax*4]
		}
}

I286 v30_repe(void) {							// F3: repe

		__asm {
				GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repe[eax*4]
		}
}


void (*v30op[])(void) = {
			add_ea_r8,						// 00:	add		EA, REG8
			add_ea_r16,						// 01:	add		EA, REG16
			add_r8_ea,						// 02:	add		REG8, EA
			add_r16_ea,						// 03:	add		REG16, EA
			add_al_data8,					// 04:	add		al, DATA8
			add_ax_data16,					// 05:	add		ax, DATA16
			push_es,						// 06:	push	es
			pop_es,							// 07:	pop		es
			or_ea_r8,						// 08:	or		EA, REGF8
			or_ea_r16,						// 09:	or		EA, REG16
			or_r8_ea,						// 0A:	or		REG8, EA
			or_r16_ea,						// 0B:	or		REG16, EA
			or_al_data8,					// 0C:	or		al, DATA8
			or_ax_data16,					// 0D:	or		ax, DATA16
			push_cs,						// 0E:	push	cs
			_cts,							// 0F:	i286 upper opcode

			adc_ea_r8,						// 10:	adc		EA, REG8
			adc_ea_r16,						// 11:	adc		EA, REG16
			adc_r8_ea,						// 12:	adc		REG8, EA
			adc_r16_ea,						// 13:	adc		REG16, EA
			adc_al_data8,					// 14:	adc		al, DATA8
			adc_ax_data16,					// 15:	adc		ax, DATA16
			push_ss,						// 16:	push	ss
			v30pop_ss,						// 17:	pop		ss
			sbb_ea_r8,						// 18:	sbb		EA, REG8
			sbb_ea_r16,						// 19:	sbb		EA, REG16
			sbb_r8_ea,						// 1A:	sbb		REG8, EA
			sbb_r16_ea,						// 1B:	sbb		REG16, EA
			sbb_al_data8,					// 1C:	sbb		al, DATA8
			sbb_ax_data16,					// 1D:	sbb		ax, DATA16
			push_ds,						// 1E:	push	ds
			pop_ds,							// 1F:	pop		ds

			and_ea_r8,						// 20:	and		EA, REG8
			and_ea_r16,						// 21:	and		EA, REG16
			and_r8_ea,						// 22:	and		REG8, EA
			and_r16_ea,						// 23:	and		REG16, EA
			and_al_data8,					// 24:	and		al, DATA8
			and_ax_data16,					// 25:	and		ax, DATA16
			v30segprefix_es,				// 26:	es:
			_daa,							// 27:	daa
			sub_ea_r8,						// 28:	sub		EA, REG8
			sub_ea_r16,						// 29:	sub		EA, REG16
			sub_r8_ea,						// 2A:	sub		REG8, EA
			sub_r16_ea,						// 2B:	sub		REG16, EA
			sub_al_data8,					// 2C:	sub		al, DATA8
			sub_ax_data16,					// 2D:	sub		ax, DATA16
			v30segprefix_cs,				// 2E:	cs:
			_das,							// 2F:	das

			xor_ea_r8,						// 30:	xor		EA, REG8
			xor_ea_r16,						// 31:	xor		EA, REG16
			xor_r8_ea,						// 32:	xor		REG8, EA
			xor_r16_ea,						// 33:	xor		REG16, EA
			xor_al_data8,					// 34:	xor		al, DATA8
			xor_ax_data16,					// 35:	xor		ax, DATA16
			v30segprefix_ss,				// 36:	ss:
			_aaa,							// 37:	aaa
			cmp_ea_r8,						// 38:	cmp		EA, REG8
			cmp_ea_r16,						// 39:	cmp		EA, REG16
			cmp_r8_ea,						// 3A:	cmp		REG8, EA
			cmp_r16_ea,						// 3B:	cmp		REG16, EA
			cmp_al_data8,					// 3C:	cmp		al, DATA8
			cmp_ax_data16,					// 3D:	cmp		ax, DATA16
			v30segprefix_ds,				// 3E:	ds:
			_aas,							// 3F:	aas

			inc_reg16,						// 40:	inc		ax
			inc_reg16,						// 41:	inc		cx
			inc_reg16,						// 42:	inc		dx
			inc_reg16,						// 43:	inc		bx
			inc_reg16,						// 44:	inc		sp
			inc_reg16,						// 45:	inc		bp
			inc_reg16,						// 46:	inc		si
			inc_reg16,						// 47:	inc		di
			dec_reg16,						// 48:	dec		ax
			dec_reg16,						// 49:	dec		cx
			dec_reg16,						// 4A:	dec		dx
			dec_reg16,						// 4B:	dec		bx
			dec_reg16,						// 4C:	dec		sp
			dec_reg16,						// 4D:	dec		bp
			dec_reg16,						// 4E:	dec		si
			dec_reg16,						// 4F:	dec		di

			push_ax,						// 50:	push	ax
			push_cx,						// 51:	push	cx
			push_dx,						// 52:	push	dx
			push_bx,						// 53:	push	bx
			v30push_sp,						// 54:	push	sp
			push_bp,						// 55:	push	bp
			push_si,						// 56:	push	si
			push_di,						// 57:	push	di
			pop_ax,							// 58:	pop		ax
			pop_cx,							// 59:	pop		cx
			pop_dx,							// 5A:	pop		dx
			pop_bx,							// 5B:	pop		bx
			v30pop_sp,						// 5C:	pop		sp
			pop_bp,							// 5D:	pop		bp
			pop_si,							// 5E:	pop		si
			pop_di,							// 5F:	pop		di

			_pusha,							// 60:	pusha
			_popa,							// 61:	popa
			_bound,							// 62:	bound
			v30_reserved,					// 63:	reserved
			v30_reserved,					// 64:	reserved
			v30_reserved,					// 65:	reserved
			v30_reserved,					// 66:	reserved
			v30_reserved,					// 67:	reserved
			push_data16,					// 68:	push	DATA16
			imul_reg_ea_data16,				// 69:	imul	REG, EA, DATA16
			push_data8,						// 6A:	push	DATA8
			imul_reg_ea_data8,				// 6B:	imul	REG, EA, DATA8
			_insb,							// 6C:	insb
			_insw,							// 6D:	insw
			_outsb,							// 6E:	outsb
			_outsb,							// 6F:	outsw

			jo_short,						// 70:	jo short
			jno_short,						// 71:	jno short
			jc_short,						// 72:	jnae/jb/jc short
			jnc_short,						// 73:	jae/jnb/jnc short
			jz_short,						// 74:	je/jz short
			jnz_short,						// 75:	jne/jnz short
			jna_short,						// 76:	jna/jbe short
			ja_short,						// 77:	ja/jnbe short
			js_short,						// 78:	js short
			jns_short,						// 79:	jns short
			jp_short,						// 7A:	jp/jpe short
			jnp_short,						// 7B:	jnp/jpo short
			jl_short,						// 7C:	jl/jnge short
			jnl_short,						// 7D:	jnl/jge short
			jle_short,						// 7E:	jle/jng short
			jnle_short,						// 7F:	jg/jnle short

			calc_ea8_i8,					// 80:	op		EA8, DATA8
			calc_ea16_i16,					// 81:	op		EA16, DATA16
			calc_ea8_i8,					// 82:	op		EA8, DATA8
			calc_ea16_i8,					// 83:	op		EA16, DATA8
			test_ea_r8,						// 84:	test	EA, REG8
			test_ea_r16,					// 85:	test	EA, REG16
			xchg_ea_r8,						// 86:	xchg	EA, REG8
			xchg_ea_r16,					// 87:	xchg	EA, REG16
			mov_ea_r8,						// 88:	mov		EA, REG8
			mov_ea_r16,						// 89:	mov		EA, REG16
			mov_r8_ea,						// 8A:	mov		REG8, EA
			mov_r16_ea,						// 8B:	add		REG16, EA
			mov_ea_seg,						// 8C:	mov		EA, segreg
			lea_r16_ea,						// 8D:	lea		REG16, EA
			v30mov_seg_ea,					// 8E:	mov		segrem, EA
			pop_ea,							// 8F:	pop		EA

			_nop,							// 90:	xchg	ax, ax
			xchg_ax_reg,					// 91:	xchg	ax, cx
			xchg_ax_reg,					// 92:	xchg	ax, dx
			xchg_ax_reg,					// 93:	xchg	ax, bx
			xchg_ax_reg,					// 94:	xchg	ax, sp
			xchg_ax_reg,					// 95:	xchg	ax, bp
			xchg_ax_reg,					// 96:	xchg	ax, si
			xchg_ax_reg,					// 97:	xchg	ax, di
			_cbw,							// 98:	cbw
			_cwd,							// 99:	cwd
			call_far,						// 9A:	call far
			_wait,							// 9B:	wait
			v30_pushf,						// 9C:	pushf
			v30_popf,						// 9D:	popf
			_sahf,							// 9E:	sahf
			_lahf,							// 9F:	lahf

			mov_al_m8,						// A0:	mov		al, m8
			mov_ax_m16,						// A1:	mov		ax, m16
			mov_m8_al,						// A2:	mov		m8, al
			mov_m16_ax,						// A3:	mov		m16, ax
			_movsb,							// A4:	movsb
			_movsw,							// A5:	movsw
			_cmpsb,							// A6:	cmpsb
			_cmpsw,							// A7:	cmpsw
			test_al_data8,					// A8:	test	al, DATA8
			test_ax_data16,					// A9:	test	ax, DATA16
			_stosb,							// AA:	stosw
			_stosw,							// AB:	stosw
			_lodsb,							// AC:	lodsb
			_lodsw,							// AD:	lodsw
			_scasb,							// AE:	scasb
			_scasw,							// AF:	scasw

			mov_al_imm,						// B0:	mov		al, imm8
			mov_cl_imm,						// B1:	mov		cl, imm8
			mov_dl_imm,						// B2:	mov		dl, imm8
			mov_bl_imm,						// B3:	mov		bl, imm8
			mov_ah_imm,						// B4:	mov		ah, imm8
			mov_ch_imm,						// B5:	mov		ch, imm8
			mov_dh_imm,						// B6:	mov		dh, imm8
			mov_bh_imm,						// B7:	mov		bh, imm8
			mov_ax_imm,						// B8:	mov		ax, imm16
			mov_cx_imm,						// B9:	mov		cx, imm16
			mov_dx_imm,						// BA:	mov		dx, imm16
			mov_bx_imm,						// BB:	mov		bx, imm16
			mov_sp_imm,						// BC:	mov		sp, imm16
			mov_bp_imm,						// BD:	mov		bp, imm16
			mov_si_imm,						// BE:	mov		si, imm16
			mov_di_imm,						// BF:	mov		di, imm16

			v30shift_ea8_data8,				// C0:	shift	EA8, DATA8
			v30shift_ea16_data8,			// C1:	shift	EA16, DATA8
			ret_near_data16,				// C2:	ret near DATA16
			ret_near,						// C3:	ret near
			les_r16_ea,						// C4:	les		REG16, EA
			lds_r16_ea,						// C5:	lds		REG16, EA
			mov_ea8_data8,					// C6:	mov		EA8, DATA8
			mov_ea16_data16,				// C7:	mov		EA16, DATA16
			_enter,							// C8:	enter	DATA16, DATA8
			leave,							// C9:	leave
			ret_far_data16,					// CA:	ret far	DATA16
			ret_far,						// CB:	ret far
			int_03,							// CC:	int		3
			int_data8,						// CD:	int		DATA8
			_into,							// CE:	into
			_iret,							// CF:	iret

			shift_ea8_1,					// D0:	shift EA8, 1
			shift_ea16_1,					// D1:	shift EA16, 1
			v30shift_ea8_cl,				// D2:	shift EA8, cl
			v30shift_ea16_cl,				// D3:	shift EA16, cl
			v30_aam,						// D4:	AAM
			v30_aad,						// D5:	AAD
			_xlat,							// D6:	xlat (8086/V30)
			_xlat,							// D7:	xlat
			_esc,							// D8:	esc
			_esc,							// D9:	esc
			_esc,							// DA:	esc
			_esc,							// DB:	esc
			_esc,							// DC:	esc
			_esc,							// DD:	esc
			_esc,							// DE:	esc
			_esc,							// DF:	esc

			_loopnz,						// E0:	loopnz
			_loopz,							// E1:	loopz
			_loop,							// E2:	loop
			_jcxz,							// E3:	jcxz
			in_al_data8,					// E4:	in		al, DATA8
			in_ax_data8,					// E5:	in		ax, DATA8
			out_data8_al,					// E6:	out		DATA8, al
			out_data8_ax,					// E7:	out		DATA8, ax
			call_near,						// E8:	call near
			jmp_near,						// E9:	jmp near
			jmp_far,						// EA:	jmp far
			jmp_short,						// EB:	jmp short
			in_al_dx,						// EC:	in		al, dx
			in_ax_dx,						// ED:	in		ax, dx
			out_dx_al,						// EE:	out		dx, al
			out_dx_ax,						// EF:	out		dx, ax

			_lock,							// F0:	lock
			_lock,							// F1:	lock
			v30_repne,						// F2:	repne
			v30_repe,						// F3:	repe
			_hlt,							// F4:	hlt
			_cmc,							// F5:	cmc
			_ope0xf6,						// F6:	
			_ope0xf7,						// F7:	
			_clc,							// F8:	clc
			_stc,							// F9:	stc
			_cli,							// FA:	cli
			_sti,							// FB:	sti
			_cld,							// FC:	cld
			_std,							// FD:	std
			_ope0xfe,						// FE:	
			_ope0xff,						// FF:	
};

// ----------------------------------------------------------------- repe

I286 v30repe_segprefix_es(void) {

		__asm {
				mov		eax, ES_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repe[eax*4]
		}
}

I286 v30repe_segprefix_cs(void) {

		__asm {
				mov		eax, CS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repe[eax*4]
		}
}

I286 v30repe_segprefix_ss(void) {

		__asm {
				mov		eax, SS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repe[eax*4]
		}
}

I286 v30repe_segprefix_ds(void) {

		__asm {
				mov		eax, DS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repe[eax*4]
		}
}

void (*v30op_repe[])(void) = {
			add_ea_r8,						// 00:	add		EA, REG8
			add_ea_r16,						// 01:	add		EA, REG16
			add_r8_ea,						// 02:	add		REG8, EA
			add_r16_ea,						// 03:	add		REG16, EA
			add_al_data8,					// 04:	add		al, DATA8
			add_ax_data16,					// 05:	add		ax, DATA16
			push_es,						// 06:	push	es
			pop_es,							// 07:	pop		es
			or_ea_r8,						// 08:	or		EA, REGF8
			or_ea_r16,						// 09:	or		EA, REG16
			or_r8_ea,						// 0A:	or		REG8, EA
			or_r16_ea,						// 0B:	or		REG16, EA
			or_al_data8,					// 0C:	or		al, DATA8
			or_ax_data16,					// 0D:	or		ax, DATA16
			push_cs,						// 0E:	push	cs
			_cts,							// 0F:	i286 upper opcode

			adc_ea_r8,						// 10:	adc		EA, REG8
			adc_ea_r16,						// 11:	adc		EA, REG16
			adc_r8_ea,						// 12:	adc		REG8, EA
			adc_r16_ea,						// 13:	adc		REG16, EA
			adc_al_data8,					// 14:	adc		al, DATA8
			adc_ax_data16,					// 15:	adc		ax, DATA16
			push_ss,						// 16:	push	ss
			v30pop_ss,						// 17:	pop		ss
			sbb_ea_r8,						// 18:	sbb		EA, REG8
			sbb_ea_r16,						// 19:	sbb		EA, REG16
			sbb_r8_ea,						// 1A:	sbb		REG8, EA
			sbb_r16_ea,						// 1B:	sbb		REG16, EA
			sbb_al_data8,					// 1C:	sbb		al, DATA8
			sbb_ax_data16,					// 1D:	sbb		ax, DATA16
			push_ds,						// 1E:	push	ds
			pop_ds,							// 1F:	pop		ds

			and_ea_r8,						// 20:	and		EA, REG8
			and_ea_r16,						// 21:	and		EA, REG16
			and_r8_ea,						// 22:	and		REG8, EA
			and_r16_ea,						// 23:	and		REG16, EA
			and_al_data8,					// 24:	and		al, DATA8
			and_ax_data16,					// 25:	and		ax, DATA16
			v30repe_segprefix_es,			// 26:	repe es:
			_daa,							// 27:	daa
			sub_ea_r8,						// 28:	sub		EA, REG8
			sub_ea_r16,						// 29:	sub		EA, REG16
			sub_r8_ea,						// 2A:	sub		REG8, EA
			sub_r16_ea,						// 2B:	sub		REG16, EA
			sub_al_data8,					// 2C:	sub		al, DATA8
			sub_ax_data16,					// 2D:	sub		ax, DATA16
			v30repe_segprefix_cs,			// 2E:	repe cs:
			_das,							// 2F:	das

			xor_ea_r8,						// 30:	xor		EA, REG8
			xor_ea_r16,						// 31:	xor		EA, REG16
			xor_r8_ea,						// 32:	xor		REG8, EA
			xor_r16_ea,						// 33:	xor		REG16, EA
			xor_al_data8,					// 34:	xor		al, DATA8
			xor_ax_data16,					// 35:	xor		ax, DATA16
			v30repe_segprefix_ss,			// 36:	repe ss:
			_aaa,							// 37:	aaa
			cmp_ea_r8,						// 38:	cmp		EA, REG8
			cmp_ea_r16,						// 39:	cmp		EA, REG16
			cmp_r8_ea,						// 3A:	cmp		REG8, EA
			cmp_r16_ea,						// 3B:	cmp		REG16, EA
			cmp_al_data8,					// 3C:	cmp		al, DATA8
			cmp_ax_data16,					// 3D:	cmp		ax, DATA16
			v30repe_segprefix_ds,			// 3E:	repe ds:
			_aas,							// 3F:	aas

			inc_reg16,						// 40:	inc		ax
			inc_reg16,						// 41:	inc		cx
			inc_reg16,						// 42:	inc		dx
			inc_reg16,						// 43:	inc		bx
			inc_reg16,						// 44:	inc		sp
			inc_reg16,						// 45:	inc		bp
			inc_reg16,						// 46:	inc		si
			inc_reg16,						// 47:	inc		di
			dec_reg16,						// 48:	dec		ax
			dec_reg16,						// 49:	dec		cx
			dec_reg16,						// 4A:	dec		dx
			dec_reg16,						// 4B:	dec		bx
			dec_reg16,						// 4C:	dec		sp
			dec_reg16,						// 4D:	dec		bp
			dec_reg16,						// 4E:	dec		si
			dec_reg16,						// 4F:	dec		di

			push_ax,						// 50:	push	ax
			push_cx,						// 51:	push	cx
			push_dx,						// 52:	push	dx
			push_bx,						// 53:	push	bx
			v30push_sp,						// 54:	push	sp
			push_bp,						// 55:	push	bp
			push_si,						// 56:	push	si
			push_di,						// 57:	push	di
			pop_ax,							// 58:	pop		ax
			pop_cx,							// 59:	pop		cx
			pop_dx,							// 5A:	pop		dx
			pop_bx,							// 5B:	pop		bx
			v30pop_sp,						// 5C:	pop		sp
			pop_bp,							// 5D:	pop		bp
			pop_si,							// 5E:	pop		si
			pop_di,							// 5F:	pop		di

			_pusha,							// 60:	pusha
			_popa,							// 61:	popa
			_bound,							// 62:	bound
			v30_reserved,					// 63:	reserved
			v30_reserved,					// 64:	reserved
			v30_reserved,					// 65:	reserved
			v30_reserved,					// 66:	reserved
			v30_reserved,					// 67:	reserved
			push_data16,					// 68:	push	DATA16
			imul_reg_ea_data16,				// 69:	imul	REG, EA, DATA16
			push_data8,						// 6A:	push	DATA8
			imul_reg_ea_data8,				// 6B:	imul	REG, EA, DATA8
			rep_insb,						// 6C:	rep insb
			rep_insw,						// 6D:	rep insw
			rep_outsb,						// 6E:	rep outsb
			rep_outsb,						// 6F:	rep outsw

			jo_short,						// 70:	jo short
			jno_short,						// 71:	jno short
			jc_short,						// 72:	jnae/jb/jc short
			jnc_short,						// 73:	jae/jnb/jnc short
			jz_short,						// 74:	je/jz short
			jnz_short,						// 75:	jne/jnz short
			jna_short,						// 76:	jna/jbe short
			ja_short,						// 77:	ja/jnbe short
			js_short,						// 78:	js short
			jns_short,						// 79:	jns short
			jp_short,						// 7A:	jp/jpe short
			jnp_short,						// 7B:	jnp/jpo short
			jl_short,						// 7C:	jl/jnge short
			jnl_short,						// 7D:	jnl/jge short
			jle_short,						// 7E:	jle/jng short
			jnle_short,						// 7F:	jg/jnle short

			calc_ea8_i8,					// 80:	op		EA8, DATA8
			calc_ea16_i16,					// 81:	op		EA16, DATA16
			calc_ea8_i8,					// 82:	op		EA8, DATA8
			calc_ea16_i8,					// 83:	op		EA16, DATA8
			test_ea_r8,						// 84:	test	EA, REG8
			test_ea_r16,					// 85:	test	EA, REG16
			xchg_ea_r8,						// 86:	xchg	EA, REG8
			xchg_ea_r16,					// 87:	xchg	EA, REG16
			mov_ea_r8,						// 88:	mov		EA, REG8
			mov_ea_r16,						// 89:	mov		EA, REG16
			mov_r8_ea,						// 8A:	mov		REG8, EA
			mov_r16_ea,						// 8B:	add		REG16, EA
			mov_ea_seg,						// 8C:	mov		EA, segreg
			lea_r16_ea,						// 8D:	lea		REG16, EA
			mov_seg_ea,						// 8E:	mov		segrem, EA
			pop_ea,							// 8F:	pop		EA

			_nop,							// 90:	xchg	ax, ax
			xchg_ax_reg,					// 91:	xchg	ax, cx
			xchg_ax_reg,					// 92:	xchg	ax, dx
			xchg_ax_reg,					// 93:	xchg	ax, bx
			xchg_ax_reg,					// 94:	xchg	ax, sp
			xchg_ax_reg,					// 95:	xchg	ax, bp
			xchg_ax_reg,					// 96:	xchg	ax, si
			xchg_ax_reg,					// 97:	xchg	ax, di
			_cbw,							// 98:	cbw
			_cwd,							// 99:	cwd
			call_far,						// 9A:	call far
			_wait,							// 9B:	wait
			v30_pushf,						// 9C:	pushf
			v30_popf,						// 9D:	popf
			_sahf,							// 9E:	sahf
			_lahf,							// 9F:	lahf

			mov_al_m8,						// A0:	mov		al, m8
			mov_ax_m16,						// A1:	mov		ax, m16
			mov_m8_al,						// A2:	mov		m8, al
			mov_m16_ax,						// A3:	mov		m16, ax
			rep_movsb,						// A4:	rep movsb
			rep_movsw,						// A5:	rep movsw
			repe_cmpsb,						// A6:	repe cmpsb
			repe_cmpsw,						// A7:	repe cmpsw
			test_al_data8,					// A8:	test	al, DATA8
			test_ax_data16,					// A9:	test	ax, DATA16
			rep_stosb,						// AA:	rep stosw
			rep_stosw,						// AB:	rep stosw
			rep_lodsb,						// AC:	rep lodsb
			rep_lodsw,						// AD:	rep lodsw
			repe_scasb,						// AE:	repe scasb
			repe_scasw,						// AF:	repe scasw

			mov_al_imm,						// B0:	mov		al, imm8
			mov_cl_imm,						// B1:	mov		cl, imm8
			mov_dl_imm,						// B2:	mov		dl, imm8
			mov_bl_imm,						// B3:	mov		bl, imm8
			mov_ah_imm,						// B4:	mov		ah, imm8
			mov_ch_imm,						// B5:	mov		ch, imm8
			mov_dh_imm,						// B6:	mov		dh, imm8
			mov_bh_imm,						// B7:	mov		bh, imm8
			mov_ax_imm,						// B8:	mov		ax, imm16
			mov_cx_imm,						// B9:	mov		cx, imm16
			mov_dx_imm,						// BA:	mov		dx, imm16
			mov_bx_imm,						// BB:	mov		bx, imm16
			mov_sp_imm,						// BC:	mov		sp, imm16
			mov_bp_imm,						// BD:	mov		bp, imm16
			mov_si_imm,						// BE:	mov		si, imm16
			mov_di_imm,						// BF:	mov		di, imm16

			v30shift_ea8_data8,				// C0:	shift	EA8, DATA8
			v30shift_ea16_data8,			// C1:	shift	EA16, DATA8
			ret_near_data16,				// C2:	ret near DATA16
			ret_near,						// C3:	ret near
			les_r16_ea,						// C4:	les		REG16, EA
			lds_r16_ea,						// C5:	lds		REG16, EA
			mov_ea8_data8,					// C6:	mov		EA8, DATA8
			mov_ea16_data16,				// C7:	mov		EA16, DATA16
			_enter,							// C8:	enter	DATA16, DATA8
			leave,							// C9:	leave
			ret_far_data16,					// CA:	ret far	DATA16
			ret_far,						// CB:	ret far
			int_03,							// CC:	int		3
			int_data8,						// CD:	int		DATA8
			_into,							// CE:	into
			_iret,							// CF:	iret

			shift_ea8_1,					// D0:	shift EA8, 1
			shift_ea16_1,					// D1:	shift EA16, 1
			v30shift_ea8_cl,				// D2:	shift EA8, cl
			v30shift_ea16_cl,				// D3:	shift EA16, cl
			v30_aam,						// D4:	AAM
			v30_aad,						// D5:	AAD
			_xlat,							// D6:	xlat (8086/V30)
			_xlat,							// D7:	xlat
			_esc,							// D8:	esc
			_esc,							// D9:	esc
			_esc,							// DA:	esc
			_esc,							// DB:	esc
			_esc,							// DC:	esc
			_esc,							// DD:	esc
			_esc,							// DE:	esc
			_esc,							// DF:	esc

			_loopnz,						// E0:	loopnz
			_loopz,							// E1:	loopz
			_loop,							// E2:	loop
			_jcxz,							// E3:	jcxz
			in_al_data8,					// E4:	in		al, DATA8
			in_ax_data8,					// E5:	in		ax, DATA8
			out_data8_al,					// E6:	out		DATA8, al
			out_data8_ax,					// E7:	out		DATA8, ax
			call_near,						// E8:	call near
			jmp_near,						// E9:	jmp near
			jmp_far,						// EA:	jmp far
			jmp_short,						// EB:	jmp short
			in_al_dx,						// EC:	in		al, dx
			in_ax_dx,						// ED:	in		ax, dx
			out_dx_al,						// EE:	out		dx, al
			out_dx_ax,						// EF:	out		dx, ax

			_lock,							// F0:	lock
			_lock,							// F1:	lock
			v30_repne,						// F2:	repne
			v30_repe,						// F3:	repe
			_hlt,							// F4:	hlt
			_cmc,							// F5:	cmc
			_ope0xf6,						// F6:	
			_ope0xf7,						// F7:	
			_clc,							// F8:	clc
			_stc,							// F9:	stc
			_cli,							// FA:	cli
			_sti,							// FB:	sti
			_cld,							// FC:	cld
			_std,							// FD:	std
			_ope0xfe,						// FE:	
			_ope0xff,						// FF:	
};

// ----------------------------------------------------------------- repne

I286 v30repne_segprefix_es(void) {

		__asm {
				mov		eax, ES_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repne[eax*4]
		}
}

I286 v30repne_segprefix_cs(void) {

		__asm {
				mov		eax, CS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repne[eax*4]
		}
}

I286 v30repne_segprefix_ss(void) {

		__asm {
				mov		eax, SS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repne[eax*4]
		}
}

I286 v30repne_segprefix_ds(void) {

		__asm {
				mov		eax, DS_BASE
				mov		DS_FIX, eax
				mov		SS_FIX, eax
				bts		i286s.prefix, 0
				jc		fixed
				push	offset removeprefix
		fixed:	GET_PCBYTE
				and		eax, 0ffh
				jmp		v30op_repne[eax*4]
		}
}

void (*v30op_repne[])(void) = {
			add_ea_r8,						// 00:	add		EA, REG8
			add_ea_r16,						// 01:	add		EA, REG16
			add_r8_ea,						// 02:	add		REG8, EA
			add_r16_ea,						// 03:	add		REG16, EA
			add_al_data8,					// 04:	add		al, DATA8
			add_ax_data16,					// 05:	add		ax, DATA16
			push_es,						// 06:	push	es
			pop_es,							// 07:	pop		es
			or_ea_r8,						// 08:	or		EA, REGF8
			or_ea_r16,						// 09:	or		EA, REG16
			or_r8_ea,						// 0A:	or		REG8, EA
			or_r16_ea,						// 0B:	or		REG16, EA
			or_al_data8,					// 0C:	or		al, DATA8
			or_ax_data16,					// 0D:	or		ax, DATA16
			push_cs,						// 0E:	push	cs
			_cts,							// 0F:	i286 upper opcode

			adc_ea_r8,						// 10:	adc		EA, REG8
			adc_ea_r16,						// 11:	adc		EA, REG16
			adc_r8_ea,						// 12:	adc		REG8, EA
			adc_r16_ea,						// 13:	adc		REG16, EA
			adc_al_data8,					// 14:	adc		al, DATA8
			adc_ax_data16,					// 15:	adc		ax, DATA16
			push_ss,						// 16:	push	ss
			v30pop_ss,						// 17:	pop		ss
			sbb_ea_r8,						// 18:	sbb		EA, REG8
			sbb_ea_r16,						// 19:	sbb		EA, REG16
			sbb_r8_ea,						// 1A:	sbb		REG8, EA
			sbb_r16_ea,						// 1B:	sbb		REG16, EA
			sbb_al_data8,					// 1C:	sbb		al, DATA8
			sbb_ax_data16,					// 1D:	sbb		ax, DATA16
			push_ds,						// 1E:	push	ds
			pop_ds,							// 1F:	pop		ds

			and_ea_r8,						// 20:	and		EA, REG8
			and_ea_r16,						// 21:	and		EA, REG16
			and_r8_ea,						// 22:	and		REG8, EA
			and_r16_ea,						// 23:	and		REG16, EA
			and_al_data8,					// 24:	and		al, DATA8
			and_ax_data16,					// 25:	and		ax, DATA16
			v30repne_segprefix_es,			// 26:	repne es:
			_daa,							// 27:	daa
			sub_ea_r8,						// 28:	sub		EA, REG8
			sub_ea_r16,						// 29:	sub		EA, REG16
			sub_r8_ea,						// 2A:	sub		REG8, EA
			sub_r16_ea,						// 2B:	sub		REG16, EA
			sub_al_data8,					// 2C:	sub		al, DATA8
			sub_ax_data16,					// 2D:	sub		ax, DATA16
			v30repne_segprefix_cs,			// 2E:	repne cs:
			_das,							// 2F:	das

			xor_ea_r8,						// 30:	xor		EA, REG8
			xor_ea_r16,						// 31:	xor		EA, REG16
			xor_r8_ea,						// 32:	xor		REG8, EA
			xor_r16_ea,						// 33:	xor		REG16, EA
			xor_al_data8,					// 34:	xor		al, DATA8
			xor_ax_data16,					// 35:	xor		ax, DATA16
			v30repne_segprefix_ss,			// 36:	repne ss:
			_aaa,							// 37:	aaa
			cmp_ea_r8,						// 38:	cmp		EA, REG8
			cmp_ea_r16,						// 39:	cmp		EA, REG16
			cmp_r8_ea,						// 3A:	cmp		REG8, EA
			cmp_r16_ea,						// 3B:	cmp		REG16, EA
			cmp_al_data8,					// 3C:	cmp		al, DATA8
			cmp_ax_data16,					// 3D:	cmp		ax, DATA16
			v30repne_segprefix_ds,			// 3E:	repne ds:
			_aas,							// 3F:	aas

			inc_reg16,						// 40:	inc		ax
			inc_reg16,						// 41:	inc		cx
			inc_reg16,						// 42:	inc		dx
			inc_reg16,						// 43:	inc		bx
			inc_reg16,						// 44:	inc		sp
			inc_reg16,						// 45:	inc		bp
			inc_reg16,						// 46:	inc		si
			inc_reg16,						// 47:	inc		di
			dec_reg16,						// 48:	dec		ax
			dec_reg16,						// 49:	dec		cx
			dec_reg16,						// 4A:	dec		dx
			dec_reg16,						// 4B:	dec		bx
			dec_reg16,						// 4C:	dec		sp
			dec_reg16,						// 4D:	dec		bp
			dec_reg16,						// 4E:	dec		si
			dec_reg16,						// 4F:	dec		di

			push_ax,						// 50:	push	ax
			push_cx,						// 51:	push	cx
			push_dx,						// 52:	push	dx
			push_bx,						// 53:	push	bx
			v30push_sp,						// 54:	push	sp
			push_bp,						// 55:	push	bp
			push_si,						// 56:	push	si
			push_di,						// 57:	push	di
			pop_ax,							// 58:	pop		ax
			pop_cx,							// 59:	pop		cx
			pop_dx,							// 5A:	pop		dx
			pop_bx,							// 5B:	pop		bx
			v30pop_sp,						// 5C:	pop		sp
			pop_bp,							// 5D:	pop		bp
			pop_si,							// 5E:	pop		si
			pop_di,							// 5F:	pop		di

			_pusha,							// 60:	pusha
			_popa,							// 61:	popa
			_bound,							// 62:	bound
			v30_reserved,					// 63:	reserved
			v30_reserved,					// 64:	reserved
			v30_reserved,					// 65:	reserved
			v30_reserved,					// 66:	reserved
			v30_reserved,					// 67:	reserved
			push_data16,					// 68:	push	DATA16
			imul_reg_ea_data16,				// 69:	imul	REG, EA, DATA16
			push_data8,						// 6A:	push	DATA8
			imul_reg_ea_data8,				// 6B:	imul	REG, EA, DATA8
			rep_insb,						// 6C:	rep insb
			rep_insw,						// 6D:	rep insw
			rep_outsb,						// 6E:	rep outsb
			rep_outsb,						// 6F:	rep outsw

			jo_short,						// 70:	jo short
			jno_short,						// 71:	jno short
			jc_short,						// 72:	jnae/jb/jc short
			jnc_short,						// 73:	jae/jnb/jnc short
			jz_short,						// 74:	je/jz short
			jnz_short,						// 75:	jne/jnz short
			jna_short,						// 76:	jna/jbe short
			ja_short,						// 77:	ja/jnbe short
			js_short,						// 78:	js short
			jns_short,						// 79:	jns short
			jp_short,						// 7A:	jp/jpe short
			jnp_short,						// 7B:	jnp/jpo short
			jl_short,						// 7C:	jl/jnge short
			jnl_short,						// 7D:	jnl/jge short
			jle_short,						// 7E:	jle/jng short
			jnle_short,						// 7F:	jg/jnle short

			calc_ea8_i8,					// 80:	op		EA8, DATA8
			calc_ea16_i16,					// 81:	op		EA16, DATA16
			calc_ea8_i8,					// 82:	op		EA8, DATA8
			calc_ea16_i8,					// 83:	op		EA16, DATA8
			test_ea_r8,						// 84:	test	EA, REG8
			test_ea_r16,					// 85:	test	EA, REG16
			xchg_ea_r8,						// 86:	xchg	EA, REG8
			xchg_ea_r16,					// 87:	xchg	EA, REG16
			mov_ea_r8,						// 88:	mov		EA, REG8
			mov_ea_r16,						// 89:	mov		EA, REG16
			mov_r8_ea,						// 8A:	mov		REG8, EA
			mov_r16_ea,						// 8B:	add		REG16, EA
			mov_ea_seg,						// 8C:	mov		EA, segreg
			lea_r16_ea,						// 8D:	lea		REG16, EA
			mov_seg_ea,						// 8E:	mov		segrem, EA
			pop_ea,							// 8F:	pop		EA

			_nop,							// 90:	xchg	ax, ax
			xchg_ax_reg,					// 91:	xchg	ax, cx
			xchg_ax_reg,					// 92:	xchg	ax, dx
			xchg_ax_reg,					// 93:	xchg	ax, bx
			xchg_ax_reg,					// 94:	xchg	ax, sp
			xchg_ax_reg,					// 95:	xchg	ax, bp
			xchg_ax_reg,					// 96:	xchg	ax, si
			xchg_ax_reg,					// 97:	xchg	ax, di
			_cbw,							// 98:	cbw
			_cwd,							// 99:	cwd
			call_far,						// 9A:	call far
			_wait,							// 9B:	wait
			v30_pushf,						// 9C:	pushf
			v30_popf,						// 9D:	popf
			_sahf,							// 9E:	sahf
			_lahf,							// 9F:	lahf

			mov_al_m8,						// A0:	mov		al, m8
			mov_ax_m16,						// A1:	mov		ax, m16
			mov_m8_al,						// A2:	mov		m8, al
			mov_m16_ax,						// A3:	mov		m16, ax
			rep_movsb,						// A4:	rep movsb
			rep_movsw,						// A5:	rep movsw
			repne_cmpsb,					// A6:	repne cmpsb
			repne_cmpsw,					// A7:	repne cmpsw
			test_al_data8,					// A8:	test	al, DATA8
			test_ax_data16,					// A9:	test	ax, DATA16
			rep_stosb,						// AA:	rep stosw
			rep_stosw,						// AB:	rep stosw
			rep_lodsb,						// AC:	rep lodsb
			rep_lodsw,						// AD:	rep lodsw
			repne_scasb,					// AE:	repne scasb
			repne_scasw,					// AF:	repne scasw

			mov_al_imm,						// B0:	mov		al, imm8
			mov_cl_imm,						// B1:	mov		cl, imm8
			mov_dl_imm,						// B2:	mov		dl, imm8
			mov_bl_imm,						// B3:	mov		bl, imm8
			mov_ah_imm,						// B4:	mov		ah, imm8
			mov_ch_imm,						// B5:	mov		ch, imm8
			mov_dh_imm,						// B6:	mov		dh, imm8
			mov_bh_imm,						// B7:	mov		bh, imm8
			mov_ax_imm,						// B8:	mov		ax, imm16
			mov_cx_imm,						// B9:	mov		cx, imm16
			mov_dx_imm,						// BA:	mov		dx, imm16
			mov_bx_imm,						// BB:	mov		bx, imm16
			mov_sp_imm,						// BC:	mov		sp, imm16
			mov_bp_imm,						// BD:	mov		bp, imm16
			mov_si_imm,						// BE:	mov		si, imm16
			mov_di_imm,						// BF:	mov		di, imm16

			v30shift_ea8_data8,				// C0:	shift	EA8, DATA8
			v30shift_ea16_data8,			// C1:	shift	EA16, DATA8
			ret_near_data16,				// C2:	ret near DATA16
			ret_near,						// C3:	ret near
			les_r16_ea,						// C4:	les		REG16, EA
			lds_r16_ea,						// C5:	lds		REG16, EA
			mov_ea8_data8,					// C6:	mov		EA8, DATA8
			mov_ea16_data16,				// C7:	mov		EA16, DATA16
			_enter,							// C8:	enter	DATA16, DATA8
			leave,							// C9:	leave
			ret_far_data16,					// CA:	ret far	DATA16
			ret_far,						// CB:	ret far
			int_03,							// CC:	int		3
			int_data8,						// CD:	int		DATA8
			_into,							// CE:	into
			_iret,							// CF:	iret

			shift_ea8_1,					// D0:	shift EA8, 1
			shift_ea16_1,					// D1:	shift EA16, 1
			v30shift_ea8_cl,				// D2:	shift EA8, cl
			v30shift_ea16_cl,				// D3:	shift EA16, cl
			v30_aam,						// D4:	AAM
			v30_aad,						// D5:	AAD
			_xlat,							// D6:	xlat (8086/V30)
			_xlat,							// D7:	xlat
			_esc,							// D8:	esc
			_esc,							// D9:	esc
			_esc,							// DA:	esc
			_esc,							// DB:	esc
			_esc,							// DC:	esc
			_esc,							// DD:	esc
			_esc,							// DE:	esc
			_esc,							// DF:	esc

			_loopnz,						// E0:	loopnz
			_loopz,							// E1:	loopz
			_loop,							// E2:	loop
			_jcxz,							// E3:	jcxz
			in_al_data8,					// E4:	in		al, DATA8
			in_ax_data8,					// E5:	in		ax, DATA8
			out_data8_al,					// E6:	out		DATA8, al
			out_data8_ax,					// E7:	out		DATA8, ax
			call_near,						// E8:	call near
			jmp_near,						// E9:	jmp near
			jmp_far,						// EA:	jmp far
			jmp_short,						// EB:	jmp short
			in_al_dx,						// EC:	in		al, dx
			in_ax_dx,						// ED:	in		ax, dx
			out_dx_al,						// EE:	out		dx, al
			out_dx_ax,						// EF:	out		dx, ax

			_lock,							// F0:	lock
			_lock,							// F1:	lock
			v30_repne,						// F2:	repne
			v30_repe,						// F3:	repe
			_hlt,							// F4:	hlt
			_cmc,							// F5:	cmc
			_ope0xf6,						// F6:	
			_ope0xf7,						// F7:	
			_clc,							// F8:	clc
			_stc,							// F9:	stc
			_cli,							// FA:	cli
			_sti,							// FB:	sti
			_cld,							// FC:	cld
			_std,							// FD:	std
			_ope0xfe,						// FE:	
			_ope0xff,						// FF:	
};
